*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE F C T R M (NDIM,POINT,NOMFCT,TYPFCT,NODONA,TYDONA 
     *                         ,TYPRAS,MCASSO,IST,RST,CST,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Oct.89)
* Derniere modification (D.Martin) le 8 Nov. 89
*  
* Calcul d'un coefficient variable d'un terme au point POINT
*  
*** Arguments ***  
* NDIM  : dimension d'espace (dimension de POINT)  
* POINT : tableau des coordonnees du point 
* NOMFCT: nom de la donnee FONCTION
* TYPFCT: type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA: nom de la donnee (constante ou tableau) associee a la fonction
* TYDONA: type de la donnee associee a la fonction ('CONSTANTE','TABLEAU') 
* TYPRAS: type de la constante ou du tableau associe ('REEL','COMPLEXE',...)
* MCASSO: adresse de la constante associee ou du tableau associe
*         dans le super-tableau du bon type (donne par TYPRAS) 
* IST   : super-tableau entier 
* RST   : super-tableau reel
* CST   : super-tableau complexe
* RESULT: valeur de la fonction dans le cas TYPFCT='REEL'  
* CESULT: idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS 
      INTEGER       IST(*),NDIM,MCASSO 
      REAL          POINT(*),RST(*),RESULT(*) 
      COMPLEX       CST(*),CESULT(*),SLXHLM
*
      REAL          CORM(3)
      COMPLEX       K,IK,E,D1EM(3),D1EP(3),D2EMP(9)
      CHARACTER CHAINE*120,NAMDON*16,NAMFCT*16 
      COMMON/FORMAH/CHAINE 
      EQUIVALENCE (NAMDON,CHAINE(89:89)),(NAMFCT,CHAINE(105:105))
      DATA CORM/0.,0.,0./  
*
      IF(NOMFCT(:5).EQ.'DPHIN') THEN
*  
*        Fonction potentiel incident EXP(i*K*x)
*
         IF(TYPRAS(:4).EQ.'REEL') THEN 
            K=RST(MCASSO)
         ELSE IF(TYPRAS(:4).EQ.'COMP') THEN
            K=CST(MCASSO)
         END IF
         DO 1 IDIM=1,NDIM
1           CESULT(IDIM)=0.
         IK=(0.,1.)*K
         CESULT(1)=-IK*EXP(IK*POINT(1))
*
      ELSE IF(NOMFCT(:6).EQ.'SOLEXA') THEN
*
         CESULT(1)=SLXHLM(RST(MCASSO),POINT)
*
      ELSE 
         CALL BAISE(' *Fctrm* Nom de fonction inconnu') 
      END IF
                                                                    END *Fctrm*
