*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                               PROGRAM ESSAI
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Derniere modification : G.Vial (20 Janvier 2008)
*
        CHARACTER     AST
        INTEGER       MOTMXR,NBCHMX
        REAL          RST
        PARAMETER    (MOTMXR=50000000,NBCHMX=80000)
        COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)
        CHARACTER*6  TYPCST,CHARAC
        INTEGER      NTIERE
        COMPLEX      COMPLE, PRSOCA
        

        INTEGER NIV = 1

        CALL INITIE (NBCHMX,MOTMXR)
        CALL LCGEOM
        CALL LCDIRE
        CALL LCDONN
        CALL NUMNEU
        CALL CPTDOM
 
*       Calcul des termes elements-finis sur les domaines
        CALL CALKEF
        CALL CHRONO (' Calculs Elements Finis',6)

*       Resolution par gradient conjugue
        CALL T1TERM('FSCMB',1,'0','SOLNUM',1,NIV)
                
        CALL GCJ ('RIGID',1,'FSCMB',1,' ',0,1E-12,1000,'SOLNUM',1,1)

*       Post-traitement
*......... affichage de la difference avec la solution exacte
        CALL DFTERM ('SOLEXA',1,'SOLNUM',1,NIV)
        CALL T2TERM ('SOLNUM',1,'-','SOLEXA',1,'DIFF',1,10)
        CALL PRTERM ('DIFF',1,10,8)       
*......... calcul de la moyenne sur Omega
        CALL T1TERM('FSCMB',1,'1','UN',1,NIV)
        CALL PSTERM('S','FSCMB',1,'UN',1,PROSCA,NIV)
        WRITE (*,*)'Integrale de FSCMB  : ',REAL(PROSCA)
        CALL PSTERM('S','SOLNUM',1,'B',1,PROSCA,NIV)
        WRITE (*,*)'Integrale de SOLNUM : ',REAL(PROSCA)
*
*......... on retranche la valeur moyenne pour avoir la solution recherchee
*
        CALL PUTCST ('VALMOY',TYPCST,NTIERE,REAL(PROSCA),COMPLE,CHARAC)
        CALL T1TERM('SOLNUM',1,'1','MOYENN',1,NIV)
        CALL AXTERM('MOYENN',1,'VALMOY','MOYENN',1,NIV)
        CALL T2TERM('SOLNUM',1,'-','MOYENN',1,'SOLNUM',1,NIV)      
        CALL DFTERM ('SOLEXA',1,'SOLNUM',1,NIV)  
*......... preparation graphique pour medit
        CALL GBEGIN ('OUTPUT1','2D','medit')
        CALL GHEADR ('OUTPUT1','solnum',' ')
        CALL GBODYR ('OUTPUT1','SOLNUM',1,'Omega')
        CALL GEND ()

        CALL GBEGIN ('OUTPUT2','2D','medit')
        CALL GHEADR ('OUTPUT2','solexa',' ')
        CALL GBODYR ('OUTPUT2','SOLEXA',1,'Omega')
        CALL GEND ()

*       FIN 
        CALL CHRONO(' FIN DE L''EXECUTION ',6) 
        CALL BYE('c''est fini')

        END
