*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                               PROGRAM ESSAI
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Derniere modification : G.Vial (20 Janvier 2008)
*
        CHARACTER     AST
        INTEGER       MOTMXR,NBCHMX
        REAL          RST
        COMPLEX       PROSCA
        PARAMETER    (MOTMXR=50000000,NBCHMX=80000)
        COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)

        INTEGER NIV = 0

        CALL INITIE (NBCHMX,MOTMXR)
        CALL LCGEOM
        CALL LCDIRE
        CALL LCDONN
        CALL NUMNEU
        CALL CPTDOM
 
*       Calcul des termes elements-finis sur les domaines
        CALL CALKEF
        CALL CHRONO (' Calculs Elements Finis',6)
*       Assemblage de  l'operateur
        CALL ASMTRM ('RIGN',1,NIV);                 
*       Resolution par Choleski ( L Lt )
        CALL FALLT  ('RIGN',1,'PROFIL',1,NIV)
        CALL FASV   ('PROFIL',1,'FSCMB',1,'SOLNUM',1,NIV)

*       Post-traitement
*......... affichage de la difference avec la solution exacte
        CALL DFTERM ('SOLEXA',1,'SOLNUM',1,NIV)
        CALL T2TERM ('SOLNUM',1,'-','SOLEXA',1,'DIFF',1,10)
        CALL PRTERM ('DIFF',1,10,8)       
*......... calcul de la moyenne sur Omega
        CALL T1TERM('FSCMB',1,'1','UN',1,NIV)
        CALL PSTERM('S','FSCMB',1,'UN',1,PROSCA,NIV)
        WRITE (*,*)'Integrale de FSCMB  : ',REAL(PROSCA)
        CALL PSTERM('S','SOLNUM',1,'B',1,PROSCA,NIV)
        WRITE (*,*)'Integrale de SOLNUM : ',REAL(PROSCA)
*......... preparation graphique pour medit
        CALL GBEGIN ('OUTPUT1','2D','medit')
        CALL GHEADR ('OUTPUT1','solnum',' ')
        CALL GBODYR ('OUTPUT1','SOLNUM',1,'Omega')
        CALL GEND ()

        CALL GBEGIN ('OUTPUT2','2D','medit')
        CALL GHEADR ('OUTPUT2','solexa',' ')
        CALL GBODYR ('OUTPUT2','SOLEXA',1,'Omega')
        CALL GEND ()

*       FIN        
        CALL CHRONO(' FIN DE L''EXECUTION ',6) 
        CALL BYE('c''est fini')

        END