*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM  (NDIM,POINT,NOMFCT,TYPFCT,NODONA,TYDONA
     &                  ,TYPRAS,MCASSO,IST,RST,CST,RESULT,CESULT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier/Mars 1999)
* Derniere modification : D.Martin (8 Mars 1999)  
*
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,IST(*),MCASSO
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL          NORMAL(2),CALCUL(2)
*----------------------------------------------------------------
      IF (NOMFCT(1:6).EQ.'SOLEXA') THEN
*        Solution exacte
         CALL SOLEXA (POINT,RESULT)
      ELSEIF (NOMFCT(1:5).EQ.'SECMB') THEN
*        Rot rot E - Grad Div E + E
         CALL OPERAE (POINT,RESULT)
      ELSEIF (NOMFCT(1:4).EQ.'-rot') THEN
*        rot E
         CALL ROTE   (POINT,RESULT(1))
         RESULT(1)=-RESULT(1)
      ELSEIF (NOMFCT(1:3).EQ.'Div') THEN
*        Div E
         CALL DIVE   (POINT,RESULT(1))
      ELSEIF (NOMFCT(1:3).EQ.'EsN') THEN
**       Uniquement sur le carre [0,1]x[0,1]
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=-1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
           NORMAL(1)=0.
            NORMAL(2)=1.
         ENDIF
         write(*,*) 'Fctrm ',NOMFCT,',',NORMAL(1),NORMAL(2)
     &,POINT(3),POINT(4),POINT(5)
         CALL SOLEXA (POINT,CALCUL)
         RESULT(1)=PROSCA(2,CALCUL,NORMAL)
       ELSEIF (NOMFCT(1:3).EQ.'EvN') THEN
**       Uniquement sur le carre [0,1]x[0,1]
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=-1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
            NORMAL(1)=0.
            NORMAL(2)=1.
         ENDIF
         write(*,*) 'Fctrm ',NOMFCT,',',NORMAL(1),NORMAL(2)
     &,POINT(3),POINT(4),POINT(5)
         CALL SOLEXA (POINT,CALCUL)
         CALL TVECTT (2,'RE',1,NORMAL,CST,2,'RE',1,CALCUL,CST
     &                 ,'RE',1,RESULT,CESULT)
      ELSE
         CALL BAISE  ('*Fctrm (Cev2d)* '
     &               //'Nom de fonction inconnue : '//NOMFCT(1:6))
      ENDIF
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SOLEXA (POINT,E)
      REAL POINT(*),E(*)
      E(1)=EXP(POINT(1))
      E(2)=EXP(POINT(2))
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OPERAE (POINT,F)
      REAL POINT(*),F(*)
      F(1)=0.
      F(2)=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROTE (POINT,ROT)
      REAL POINT(*),ROT
      ROT=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DIVE (POINT,DIV)
      REAL POINT(*),DIV
      DIV=EXP(POINT(1))+EXP(POINT(2))
      END
