*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM  (NDIM,POINT,NOMFCT,TYPFCT,NODONA,TYDONA
     &                  ,TYPRAS,MCASSO,IST,RST,CST,RESULT,CESULT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2001)
* Derniere modification : D.Martin (23 Janvier 2001)
*
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,IST(*),MCASSO
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL          S,K,NORMAL(2),CALCUL(2),R,ROROT(2),GRADIV(2)
*----------------------------------------------------------------
      R=SQRT(POINT(1)*POINT(1)+POINT(2)*POINT(2))
*
      IF (NOMFCT(1:6).EQ.'SOLEXA') THEN
*        Solution exacte
         CALL SOLEXA (POINT,RESULT)
      ELSEIF (NOMFCT(1:5).EQ.'SECMB') THEN
*        Rot rot E - S Grad Div E + K E
         S=RST(MCASSO)
         K=RST(MCASSO+1)
         CALL ROROTE (POINT,ROROT)
         CALL GRDIVE (POINT,GRADIV)
         CALL SOLEXA (POINT,RESULT)
         RESULT(1)=ROROT(1)-S*GRADIV(1)+K*RESULT(1)
         RESULT(2)=ROROT(2)-S*GRADIV(2)+K*RESULT(2)
      ELSEIF (NOMFCT(1:4).EQ.'-rot') THEN
*        rot E
         CALL ROTE   (POINT,RESULT(1))
         RESULT(1)=-RESULT(1)
      ELSEIF (NOMFCT(1:3).EQ.'Div') THEN
*        Div E
         CALL DIVE   (POINT,RESULT(1))
      ELSEIF (NOMFCT(1:3).EQ.'EsN') THEN
**       Uniquement sur la couronne circulaire 0 < theta < PI/2
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=POINT(1)/R
            NORMAL(2)=POINT(2)/R
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=-1
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
            NORMAL(1)=-POINT(1)/R
            NORMAL(2)=-POINT(2)/R
         ENDIF
         CALL SOLEXA (POINT,CALCUL)
         RESULT(1)=PROSCA(2,CALCUL,NORMAL)
       ELSEIF (NOMFCT(1:3).EQ.'EvN') THEN
**       Uniquement sur la couronne circulaire 0 < theta < PI/2
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=POINT(1)/R
            NORMAL(2)=POINT(2)/R
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=-1
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
            NORMAL(1)=-POINT(1)/R
            NORMAL(2)=-POINT(2)/R
         ENDIF
         CALL SOLEXA (POINT,CALCUL)
         CALL TVECTT (2,'RE',1,NORMAL,CST,2,'RE',1,CALCUL,CST
     &                 ,'RE',1,RESULT,CESULT)
      ELSE
         CALL BAISE  ('*Fctrm (MaxWell2dcouronne)* '
     &               //'Nom de fonction inconnue : '//NOMFCT(1:6))
      ENDIF
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SOLEXA (POINT,E)
      REAL POINT(*),E(*)
      E(1)=EXP(POINT(1))
      E(2)=EXP(POINT(2))
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROTE (POINT,ROT)
      REAL POINT(*),ROT
      ROT=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROROTE (POINT,ROROT)
      REAL POINT(*),ROROT(2)
      ROROT(1)=0.
      ROROT(2)=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DIVE (POINT,DIV)
      REAL POINT(*),DIV
      DIV=EXP(POINT(1))+EXP(POINT(2))
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GRDIVE(POINT,GRADIV)
      REAL POINT(*),GRADIV(2)
      GRADIV(1)=EXP(POINT(1))
      GRADIV(2)=EXP(POINT(2))
      END
