      FUNCTION CHOSOU (NBBUTN,XBUTON,YBUTON,NUMREP,NBFICH,COMBIN,NBFEN,
     &                 ACTIFS,NBCOL,FENMEN,FENDES)

C- Fonction : Choix a la souris. Ya qu'a cliquer sur le mulot :-)
C-
C- Entree :
C-    NBBUTN Nombre de boutons du menu
C-    XBUTON,YBUTON :  Coordonnees X et Y des boutons
C-    NUMREP : Type de representation
C-    NBFICH : Nombre de fichiers
C-    COMBIN : Combinaison des fichiers
C-    NBFEN : Nombre de fenetres
C-    ACTIFS : Choix actifs ou non  
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    FENMEN : Unite PGPLOT associe a la fenetre de menu
C-    FENDES : Unite PGPLOT associe a la fenetre de dessins
C-
C- Sortie : -
C-
C- Local :
C-    IBIDON  : Variable bidon pour fonctions PGPLOT
C-    PGCURS : Lit la position de la souris
C-    XSOURI,YSOURI : Coordonnnes de la souris
C-    XMIN,XMAX,YMIN,YMAX : Zone de lecture de la souris
C-    CSOURI : Bouton de la souris 
C-
C- Derniere modif : 21 JUN 2000

      INTEGER CHOSOU,NBBUTN,NUMREP,NBFICH,NBFEN,NBCOL,FENMEN,FENDES
      INTEGER IBIDON,PGCURS,I
      LOGICAL COMBIN,ACTIFS(*)
      REAL XBUTON(*),YBUTON(*),XSOURI,YSOURI
      REAL XMIN,XMAX,YMIN,YMAX
      CHARACTER CSOURI

C- Rappel : le bouton gauche renvoie 'A', le milieu 'D' et le droit 'X'

      CALL PGSLCT (FENMEN)
C- On eteint les boutons
C- On ecrit en gris les inactifs
      DO 10 I=1,NBBUTN
         CALL PGSCI (3)
         IF (ACTIFS(I)) CALL PGSCI (1)
10    CALL PGCIRC (XBUTON(I),YBUTON(I),0.32)

C- On passe en rouge pour la suite
      CALL PGSCI (2)

C- On recrit en rouge le bouton correspondant a NUMREP
C- sauf en multi-fenetrage avec un fichier ou une combinaison 
      IF (((NBFICH.EQ.1.OR.COMBIN).AND.(NBFEN.EQ.1)).OR.
     &    (NBFICH.NE.1.AND..NOT.COMBIN)) 
     &   CALL PGCIRC (XBUTON(NUMREP),YBUTON(NUMREP),0.26)

C- Si les couleurs sont actives on ecrit en rouge 
C- le bouton correspondant au nombre de couleurs
C- On teste juste le premier
      IF (ACTIFS(9)) THEN
         IF (NBCOL.EQ.32) THEN
            CALL PGCIRC (XBUTON(9),YBUTON(9),0.26)
         ELSEIF (NBCOL.EQ.64) THEN
            CALL PGCIRC (XBUTON(10),YBUTON(10),0.26)
         ELSEIF (NBCOL.EQ.128) THEN
            CALL PGCIRC (XBUTON(11),YBUTON(11),0.26)
         ELSE
            CALL PGCIRC (XBUTON(12),YBUTON(12),0.26)
         ENDIF
      ENDIF

C- On choisit un bouton
20    IBIDON=PGCURS(XSOURI,YSOURI,CSOURI)
C-    Sortie de secours
      IF (CSOURI.EQ.'X') STOP
      DO 30 I=1,NBBUTN
         XMIN=XBUTON(I)-0.35
         XMAX=XBUTON(I)+0.35
         YMIN=YBUTON(I)-0.35
         YMAX=YBUTON(I)+0.35
         IF (XSOURI.GE.XMIN.AND.XSOURI.LE.XMAX.AND.
     &       YSOURI.GE.YMIN.AND.YSOURI.LE.YMAX.AND.ACTIFS(I)) THEN
            CHOSOU=I
C- On allume le bouton choisit
            CALL PGCIRC (XBUTON(I),YBUTON(I),0.26)
            CALL PGSLCT (FENDES)
            RETURN
         ENDIF   
30    CONTINUE
      GOTO 20

      END
