      SUBROUTINE DEFACT (NBBUTN,NUMREP,NBFICH,COMBIN,NBFEN,ACTIFS)

C- Fonction : Quels-sont les choix actifs 
C-
C- Entree :
C-    NBBUTN Nombre de boutons du menu
C-    NUMREP : Type de representation
C-    NBFICH : Nombre de fichiers
C-    COMBIN : Combinaison des fichiers
C-    NBFEN : Nombre de fenetres (i.e multifenetrage ou non)
C-
C- Sortie : -
C-    ACTIFS : Choix actifs ou non 
C-
C- Local :
C-
C- Derniere modif : 21 JUN 2000

      INTEGER NBBUTN,NUMREP,NBFICH,NBFEN,I
      LOGICAL COMBIN,ACTIFS(*)

C- Initialisation
      DO 10 I=1,NBBUTN
10    ACTIFS(I)=.FALSE.
C- Seuls les choix 7 et 8 sont toujours vrais
      ACTIFS(7)=.TRUE.
      ACTIFS(8)=.TRUE.

C- Le choix 6 n'est possible que si NBFICH=1 ou COMBIN
      IF (NBFICH.EQ.1.OR.COMBIN) ACTIFS(6)=.TRUE.

C- Si on est en multi-fenetrage avec un seul fichier, 
C- on a pas d'autre choix puisque les 4 NUMREP sont 
C- affichees em meme temps
      IF (NBFEN.GT.1.AND.(NBFICH.EQ.1.OR.COMBIN)) RETURN

C- Choix des representations
      DO 20 I=1,4
20    ACTIFS(I)=.TRUE.

C- Maillage, changement de couleurs et Z en NUMREP>1
      IF (NUMREP.GT.1) THEN
         ACTIFS(5)=.TRUE.
         DO 30 I=9,14
30       ACTIFS(I)=.TRUE.
      ENDIF

C- Largeur de trace uniquement en NUMREP=2
      IF (NUMREP.EQ.2) THEN
         DO 40 I=15,16
40       ACTIFS(I)=.TRUE.
      ENDIF
 
C- Les choix 3D nes ont disponibles qu'en NUMREP=4 et NBFEN=1
      IF (NUMREP.EQ.4.AND.NBFEN.EQ.1) THEN
         DO 50 I=17,NBBUTN
50       ACTIFS(I)=.TRUE.
      ENDIF

      END
