      SUBROUTINE DESCAS (NUMREP,NBPTS,XP,YP,ZP,VALPRJ)

C- Fonction : Dessin d'une case elementaire 
C-
C- Entree :
C-    NUMREP : Type de representation
C-    NBPTS : Nombre de points
C-    XP,YP,ZP : Coordonnees des sommets de la case
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie -
C-
C- Local :
C-    XC,YC : Coordonnnes du polynome trace
C-
C- Derniere modif : 8 AVR 1999
       
      INTEGER NUMREP,NBPTS,I
      REAL XP(*),YP(*),ZP(*),VALPRJ(*)
      REAL XC(5),YC(5)

      IF (NUMREP.LT.4) THEN
         CALL PGPOLY (NBPTS,XP,YP)
      ELSE
         DO 10 I=1,NBPTS
10       CALL PROJEC (XP(I),YP(I),ZP(I),VALPRJ,XC(I),YC(I))
         CALL PGPOLY(NBPTS,XC,YC)
      ENDIF

      END
