      SUBROUTINE LIRRES (NBFIMX,IFICH,NBPTS,Z,ZMIN,ZMAX)

C- Fonction : Lire les Z des sommets dans le fichier resultats
C-            On calcule en meme temps ZMIN et ZMAX
C-
C- Entree :
C-    NBFIMX : Nombre maximum de fichiers   
C-    IFICH : Indice de fichiers
C-    NBPTS : Nombre de points
C-
C- Sortie :
C-    Z : Tableau des coordonnees Z des noeuds
C-    ZMIN,ZMAX : Min et max des Z
C-
C- Derniere modif : 8 AVR 1999

      INTEGER NBFIMX,IFICH,NBPTS(*),I
      REAL Z(NBFIMX,*),ZMIN, ZMAX

C- On saute les 5 premieres lignes
      DO 10 I=1,5
10    READ (21,*) 

      DO 20 I=1,NBPTS(IFICH)
         READ (21,*) Z(IFICH,I)
         ZMIN = MIN(ZMIN,Z(IFICH,I))
         ZMAX = MAX(ZMAX,Z(IFICH,I))
20    CONTINUE

      END
