      SUBROUTINE MULFEN (NBFEN)

C- Fonction : Eclatement de la fenetre de dessin en plusieurs fenetres 
C-
C- Entree :
C-    NBFEN : Nombre de fenetres
C-
C- Sortie : -
C-
C- Derniere modif : 28 NOV 2000
C-
C- Notes : 
C-    Si NBFEN =  7,8,9,  on ouvre 3 x 3
C-                5 ou 6    . .    3 x 2
C-                3 ou 4    . .    2 x 2 
C-                     2    . .    1 x 2 
            
      INTEGER NBFEN
      
      IF (NBFEN.GT.6) THEN
         CALL PGSUBP (3,3) 
      ELSEIF (NBFEN.GT.4) THEN
         CALL PGSUBP (3,2)
      ELSEIF (NBFEN.GT.2) THEN
         CALL PGSUBP (2,2)
      ELSE
         CALL PGSUBP (1,2)
      ENDIF

      END
