      SUBROUTINE PROJEC (X,Y,Z,VALPRJ,XP,YP)

C- Fonction : Calcul de la projection du point [X,Y,Z] 
C-
C- Entree :
C-    X,Y,Z : Coordonnees d'un point
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie :
C-    XP,YP : Projection du point [X,Y,Z]
C-
C- Local :
C-    XO,YO,ZO : Coordonnees du point [X,Y,Z] dasn le repere lie a 
C-               l'obervateur
C-
C- Derniere modif : 20 JUN 2000

      REAL X,Y,Z,VALPRJ(*),XP,YP,XO,YO,ZO

      XO = -X*SIN(VALPRJ(4)) + Y*COS(VALPRJ(4))
      YO = -X*COS(VALPRJ(4))*SIN(VALPRJ(3)) - Y*SIN(VALPRJ(4))
     &     *SIN(VALPRJ(3)) + Z*COS(VALPRJ(3))
      ZO = -X*COS(VALPRJ(4))*COS(VALPRJ(3)) - Y*SIN(VALPRJ(4))
     & *COS(VALPRJ(3)) - Z*SIN(VALPRJ(3)) + VALPRJ(2)

      XP = VALPRJ(5)*XO/ZO + VALPRJ(6) 
      YP = VALPRJ(5)*YO/ZO + VALPRJ(7)

      END

