q=2;
nb=4;
n=4*nb;

figure(2)
clf
hold on
plot([0,0],[0.5,1],'k--',[0,0],[0.5,1],'co-')
legend('Domaine','Maillage')
t=[0:1/q:1];
x=t;
xx=zeros(2,9);
phi=pi/n;
a=1;
ka=.5;
alpha=tan(phi);
col='rbg';
col='ccc';
i=0;
nommail='mail.lina';
fid=fopen(nommail,'wt');
fprintf(fid,' TITRE 1\n');
fprintf(fid,[' Maillage en ',num2str(nb),' quadrangles courbes\n']);
fprintf(fid,[' FORMAT DE LECTURE DES COORDONNEES''(2E21.15)''\n']);
fprintf(fid,['                   DE LA NUMEROTATION GLOBALE''(',num2str((q+1)^2),'I5)''\n']);
fprintf(fid,'                   SANS COMMENTAIRE\n');
fprintf(fid,' DESCRIPTION GLOBALE DU MAILLAGE\n');
fprintf(fid,'    VARIABLES D''''ESPACE  ''X'' ''Y''\n');
fprintf(fid,['    NOMBRE D''''ELEMENTS  ',num2str(nb),'\n']);
fprintf(fid,[' BLOC DE TYPE GEOMETRIQUE QU0',num2str(q),' : ',num2str(nb),' ELEMENTS\n']);
nmax=0;
xx1=[];
xx2=[];


for theta=phi:2*phi:pi/2,
k=0;
i=i+1;
for y=0:1/q:1, 
k=k+1;
    
    X=(2*x-1).*a*tan(phi)*(ka+y*(1-ka));
    Y=(ka+y*(1-ka));
    x1=X;
    xm=a*tan(phi)*(ka+y*(1-ka));
    rap=a/cos(phi);
    x2ex=sqrt(((ka+y*(1-ka))*a/cos(phi)).^2-x1.^2);
%   DEGRE 0 :
    x2=Y; 
%    x2=x2ex;
 x2=x2*ones(1,q+1);
    if (q==1)
    x2=x2*ones(1,q+1);
    end
%   DEGRE 2    
    if (q>1)
%    x2=x2+alpha*(X+xm).*(xm-X)/(2*xm);
%   DEGRE 4
    end
    if (q>3)

%    [df2,ii]=max(abs(x2-x2ex));
%     x2=x2-df2*((X+xm).*(xm-X)).^2/(((X(ii)+xm).*(xm-X(ii))).^2);


    end
%   DEGRE 6
    if (q>5)
%     [df4,ii]=max(abs(x2-x2ex));
    
%     x2=x2-df4*X.^2.*((X+xm).*(xm-X)).^2./(X(ii).*(X(ii)+xm).*(xm-X(ii))).^2;
%    x2=x2-df4*((X+xm).*(xm-X)).^3./((X(ii)+xm).*(xm-X(ii))).^3;
    
    end


    x1=x1/rap;
    x2=x2/rap;
    xx1=[xx1,x1];
    xx2=[xx2,x2];
     if q==1
          if k==1
	        ord=[4,1];
	  elseif k==2
	        ord=[3,2];  
	  end
     elseif q==2
          if k==1 
   	  	ord=[4,8,1];
   	  elseif k==2
   	     ord=[7,9,5];
   	  elseif k==3
   	     ord=[3 6 2];
   	  end	
     elseif q==3
          if k==1
	     ord=[4,8,12,1];
	  elseif k==2
	     ord=[11,16,13,5];
	  elseif k==3
	     ord=[7,15,14,9];
	  elseif k==4
	     ord=[3,10,6,2];
	  end
     elseif q==4
     	  if k==1 
   	  	ord=[4,8,12,16,1];
   	  elseif k==2
   	     ord=[15,20,24,17,5];
   	  elseif k==3
   	     ord=[11,23,25,21,9];
	  elseif k==4
	     ord=[7,19,22,18,13];
	  elseif k==5
	     ord=[3,14,10,6,2];
   	  end	
     elseif q==6
          if k==1
	        ord=[4,8,12,16,20,24,1];
	  elseif k==2
	        ord=[23,28,32,36,40,25,5];
	  elseif k==3
	        ord=[19,39,44,48,41,29,9];
          elseif k==4
	        ord=[15,35,47,49,45,33,13];
	  elseif k==5
	        ord=[11,31,43,46,42,37,17];
	  elseif k==6
	        ord=[7,27,38,34,30,26,21];
	  elseif k==7
	        ord=[3,22,18,14,10,6,2];
	  end	
     end
     for j=1:length(x),
     [xx(1,ord(j)),ii]=max([x1(j)*cos(theta)+x2(j)*sin(theta),0]);
     [xx(2,ord(j)),ii]=max([x2(j)*cos(theta)-x1(j)*sin(theta),0]);
     end
     
     
figure(2)
plot(x1*cos(theta)+x2*sin(theta),x2*cos(theta)-x1*sin(theta),[col(mod(i,3)+1),'o-'])
    hold on
end

for j=0:q,
for k=1:q+1,
     fprintf(fid,' ');
     fprintf(fid,[num2str(xx(1,(q+1)*j+k),'%20.14E'),' ']);
     fprintf(fid,[num2str(xx(2,(q+1)*j+k),'%20.14E'),' ']);
     fprintf(fid,'\n');
end

end
if (i==1)
   if (q==1)
   ood=[3,4,2,1];
   nmax=4;
   elseif (q==2) 
   ood=[7,9,3,1,8,6,2,4,5];
   nmax=9;
   elseif (q==3)
   ood=[13,16,4,1,14,12,3,5,15,8,2,9,10,11,7,6];
   nmax=16;
   elseif (q==4)
   ood=[21,25,5,1,22,20,4,6,23,15,3,11,24,10,2,16,17,19,9,7,18,14,8,12,13];
   nmax=25;
   elseif (q==6)
   ood=[43,49,7,1,44,42,6,8,45,35,5,15,46,28,4,22,47,21,3,29,48,14,2,36];
   ood=[ood,37,41,13,9,38,34,12,16,39,27,11,23,40,20,10,30];
   ood=[ood,31,33,19,17,32,26,18,24,25];
   nmax=49;
   end
   fprintf(fid,[' ',num2str(ood,' %1.4i'),'\n']);
else
   str=' ';
   for h=1:(q+1)^2,
      str=[str,num2str(nmax-q-1+ood(h),'%1.4i'),' '];
   end   

   fprintf(fid,[str,'\n']);
   nmax=nmax+q*(q+1);
end
end
axis square;
fprintf(fid,' DOMAINE ''Omegaint''\n');
for i=1:nb,
fprintf(fid,['E ',num2str(i),' ']);
end
fprintf(fid,'\n DOMAINE ''Gamma''\n');
for i=1:nb,
fprintf(fid,['E ',num2str(i),' A 2 ']);
end
fprintf(fid,'\n DOMAINE ''GammaN''\n');
for i=1:nb,
fprintf(fid,['E ',num2str(i),' A 4 ']);
end
fprintf(fid,['E ',num2str(1),' A 3 ']);
fprintf(fid,['E ',num2str(nb),' A 1 ']);
fprintf(fid,'\n FIN\n');
fclose(fid);
plot(cos([0:.01:pi/2]),sin([0:.01:pi/2]),'k-');
plot(.5*cos([0:.01:pi/2]),.5*sin([0:.01:pi/2]),'k--');
for tt=0:2*phi:pi/2
plot([.5,1]*sin(tt),[.5,1]*cos(tt),'c')
end
for tt=0:pi/2:pi/2
plot([.5,1]*sin(tt),[.5,1]*cos(tt),'k--')
end

nbr=ones(1,q+1);
cq=[];
R=xx1.^2+xx2.^2;
for i=1:length(t),
   cq=[cq,R(1+i*(q+1))*nbr];
end;
dq=[];
cq=sort(cq);
for i=1:nb,
   dq=[dq,cq];
end
norm(dq-R)
