*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE AGRAND (NOMTB,NIVETB,NWARTI)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Mars 1988)
* Derniere modification : D.Martin (30 Aout 2000)
* Version 1.0.2
*  
* Agrandir la taille d'un tableau existant en memoire centrale
*  
*-- Arguments --  
* NOMTB   Nom du tableau a agrandir
* NIVETB  Son niveau
* NWARTI  Sa nouvelle taille
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NOMTB*(*)
      INTEGER   NIVETB,NWARTI
*
      INTEGER   IPRINT,IRANG,ITYPTB,MCADRS,MSADRS,NBARTI,NBMO,NBCEF
     &         ,NBMOTS,NBCAR,NIP
      CHARACTER PRFXAS*8
*
      INCLUDE 'ALLOC'
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)
  
*     Recherche des caracteristiques du tableau
      CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IRANG 
     &            ,ITYPTB,MCADRS,MSADRS,NBARTI)
*
      IF (IRANG.LE.0)  CALL ERTBAL (1,'*Agrand*',NOMTB,NIVETB)
      IF (MCADRS.LE.0) CALL ERTBAL (4,'*Agrand*',NOMTB,NIVETB)   
      IF (NWARTI.EQ.NBARTI) RETURN
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS (NIP),NIP=1,0,-1)
     &                                     ,NOMTB,NIVETB,ITYPTB,NBARTI
      CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMO,NBCEF) 
      CALL TBLONG (NCPMMA,ITYPTB,NWARTI,NBMOTS,NBCAR)
*
      IF (TBDCST(4).EQ.TBDCST(3)-1) THEN
         CALL DEPLAC
         CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IRANG  
     &               ,ITYPTB,MCADRS,MSADRS,NBARTI)
      ENDIF
*
      IF (NWARTI.GT.NBARTI) THEN
*        Il faut recopier au bout du super-tableau, et d'abord 
*        s'y assurer sur la place disponible
         CALL ASSURC (ITYPTB,NBCAR,NBMOTS,*99991)
*        Recopie du tableau NOMTB a la premiere adresse disponible dans
*        le super-tableau convenable. Mais il faut pouvoir enregistrer 
*        un trou de plus
         CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IRANG  
     &               ,ITYPTB,MCADRS,MSADRS,NBARTI)
         CALL RECOPI (ITYPTB,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,MCADRS,NWARTI
     &               ,TBDCST(5),TBDCST(9))
      ELSE 
*        Il faut en fait reduire la taille du tableau en creant un trou
*        de plus dans la partie complementaire 
         CALL REDUCT (ITYPTB,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,MCADRS,NWARTI
     &               ,TBDCST(5),TBDCST(9))
      ENDIF
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS (NIP),NIP=1,0,-1)
     &                                     ,NOMTB,NIVETB,ITYPTB,NWARTI
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>Agrand ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12)
10001 FORMAT(A,A,'<Agrand ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   
99991 CALL ERTBAL (8,'*Agrand*',NOMTB,NIVETB)
                                                                    END !Agrand
