*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASSURC (ITYP,NBCAR,NBMOTS,*) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1988)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version 1.0.1
*  
* S'assurer de la place disponible dans un super-tableau 
*  
*-- Arguments --  
* ITYP    Type du super tableau vise
* NBCAR   Nombre de caracteres a loger dans AST
* NBMOTS  Nombre de mots a loger dans RST  
*  (*)    Retour pour remise en cause agrandissement demande
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITYP,NBCAR,NBMOTS
*
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8
      INTEGER RESTE,IPRINT,IMPERR,NEXT,NBINDX,NBINDI,IENCOR,NIP
      LOGICAL ENOUGH
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)
      IMPERR=TBDCST(17)
*  
      IF (ITYP.GE.1.AND.ITYP.LE.4) THEN 
         NEXT=TBDCST(11)
         NBINDX=TBDCST(2)  
         NBINDI=NBMOTS 
         ENOUGH=NBINDI.LE.TBDCST(10)
         RESTE=TBDCST(10)
         IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                   ,RESTE,' mots',NBINDI,' mots'
      ELSEIF (ITYP.GT.10) THEN 
         NEXT=TBDCST(7)
         NBINDX=TBDCST(1)  
         NBINDI=NBCAR  
         ENOUGH=NBINDI.LE.TBDCST(6)
         RESTE=TBDCST(6)
         IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                   ,RESTE,' car.',NBINDI,' car.'
      ELSEIF (ITYP.EQ.0) THEN  
         NEXT=1
         NBINDX=-1 
         NBINDI=0  
         ENOUGH=.FALSE.
         RESTE=0 
      ENDIF
      IF ((NEXT-1+NBINDI).GT.NBINDX) THEN
*        Il n'y a pas assez de place disponible au bout du super-tableau
*        concerne pour l'agrandissement demande, on le comprime
*        Test sur l'interet de la realisation des sauvegardes differees
*        Realisation des sauvegardes differees eventuelles dans AST et 
*        RST selon ITYP et NBINDI  
         IF (.NOT.ENOUGH) THEN  
10          CALL CPRSSV (ITYP,NBINDI,IENCOR)
            IF (IENCOR.EQ.1) THEN
*              Il faut deja comprimer car le nombre de trous crees 
*              a la place des tableaux sauves saturent les tables  
               CALL CPRSTR (ITYP)
               GOTO 10
            ENDIF  
         ENDIF 
*        Compression des trous dans AST et RST selon ITYP. 
         CALL CPRSTR (ITYP) 
*        Verification avec des tailles eventuellement remises a jour
         IF (ITYP.GT.0) THEN
            IF (ITYP.GT.10.AND.NBINDI.GT.TBDCST(6)) THEN
               WRITE(IMPERR,90001) NBINDI,'car.',TBDCST(6) ,'car.','AST'  
     &                 ,'NBCHMX',NBINDI-TBDCST(6) ,'cars',PRFXAS (0)
               RETURN 1
            ELSEIF (NBINDI.GT.TBDCST(10)) THEN 
               WRITE(IMPERR,90001) NBINDI,'mots',TBDCST(10),'mots','RST' 
     &                 ,'MOTMXR',NBINDI-TBDCST(10),'mots',PRFXAS (0)
               RETURN 1
            ENDIF 
         ENDIF 
      ENDIF
*      IF (IPRINT.GT.0) THEN
*         IF(ITYP.GE.1.AND.ITYP.LE.4) THEN
*            WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
*     &                          ,TBDCST(10),' mots',NBMOTS,' mots'
*         ELSEIF (ITYP.GT.10) THEN
*            WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
*     &                          ,TBDCST(6) ,' car.',NBCAR,' car.'
*         ENDIF
*      ENDIF
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>Assurc',T39,', reste:',I12,A,', demande :',I12,A)
10001 FORMAT(A,A,'<Assurc',T39,', reste:',I12,A,', demande :',I12,A)
90001 FORMAT(/' *Assurc* La compression ne satisfait pas la demande'
     &/'          de place memoire de ',I12,' ',A,'.'
     &/'          La place disponible n''est que de ',I12,' ',A
     &,' dans ',A,'.'
     &/'          Veuillez agrandir ',A,' d''au moins ',I12,' '
     &,A,'.',A)
                                                                    END !Assurc
