*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CPRSTR(ITYP)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (1988) 
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Suppression de tous les TROUS de l'un des super-tableaux ou des deux 
*  
* ITYP Type du super-tableau cible de la compression
*      les deux si : ITYP.EQ.0
*      RST seul si : ITYP.GE.1.AND.LE.4  
*      AST seul si : ITYP.GT.10  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITYP
*
      INCLUDE 'ALLOC'  
*  
      CHARACTER NOMTB*6,PRFXAS*8
*-----------------------------------------------------------------------
      NBCHMX=TBDCST(1) 
      MOTMXR=TBDCST(2) 
      NBTBMX=TBDCST(3) 
      NBTABL=TBDCST(4) 
      ITBNTB=TBDCST(5) 
      NBTRAS=TBDCST(8) 
      IDSCTB=TBDCST(9) 
      NBTRRS=TBDCST(12)
      IPRINT=TBDCST(16)
      IMPERR=TBDCST(17)
*  
      NTROUA=0 
      NEWADA=0 
      NTROUR=0 
      NEWADR=0 
      NBTROU=0 
*  
*     Boucle sur les tableaux
      IANMTB=0
      IADCTB=0  
      DO 100 ITABL=1,NBTABL
*        Attention TBNMTB et TBDCTB sont susceptibles de changer de
*        place durant la boucle, on les emploient donc dans l'absolu
*        des super tableaux.
         NDNMTB=ITBNTB-1+IANMTB  
         DO 23 ICAR=1,NBCHNT
23          NOMTB(ICAR:ICAR)=AST(NDNMTB+ICAR)  
         NDDCTB=IDSCTB-1+IADCTB 
         CALL GETATR(IST(NDDCTB+1),ITYPTB,NIVETB,MCADDR,MSADDR,NBARTI)
         MCADRS=ABS(MCADDR)
         IAGETB=(MCADRS-1)/MOTMXR
         MCADRS=MCADRS-IAGETB*MOTMXR
         IF (NOMTB.EQ.'TROUMC') THEN
            IF ((ITYP.GT.10.OR.ITYP.EQ.0).AND.ITYPTB.GT.10) THEN
*              Le tableau courant est un trou a comprimer dans AST 
               NTROUA=NTROUA+1 
               NBTROU=NTROUA+NTROUR
*              Initialisation des nouvelles adresses dans AST avec 
*              celle du 1er trou rencontre 
               IF(NEWADA.EQ.0) NEWADA=MCADRS
            ELSEIF ((  ITYP.GE.0.AND.ITYP  .LE.4).AND. 
     &              (ITYPTB.GE.1.AND.ITYPTB.LE.4)     ) THEN
*              Le tableau courant est un trou a comprimer dans RST 
               NTROUR=NTROUR+1 
               NBTROU=NTROUA+NTROUR
*              Initialisation des nouvelles adresses dans RST avec 
*              celle du 1er trou rencontre 
               IF (NEWADR.EQ.0) NEWADR=MCADRS
            ELSE
*              Le tableau courant est un trou dans AST ou RST, dont le type
*              n'est pas a comprimer; mais le rang de ce trou doit diminuer
               NDMNEW=NDNMTB-NBCHNT*NBTROU 
               DO 27 ICAR=1,NBCHNT 
27                AST(NDMNEW+ICAR)=NOMTB(ICAR:ICAR)
               NDCNEW=NDDCTB-NBPART*NBTROU 
               CALL PUTATR(ITYPTB,NIVETB,MCADDR,MSADDR,NBARTI
     &                    ,IST(NDDCTB+1-NBPART*NBTROU))
            ENDIF  
         ELSE  
            NWADRS=MCADDR  
            IF ((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.
     &          (ITYP.GE.0.AND.ITYP.LE.4).AND.NEWADR.NE.0) THEN
               NBMOTS=NBARTI
               IF (ITYPTB.EQ.3.OR.ITYPTB.EQ.4) NBMOTS=2*NBARTI  
               IF (NEWADR.GT.MCADRS.AND.MCADRS.NE.0) THEN
                  CALL BAISE('Erreur ---> CPRSTR <--- NEWADR Incorrect')
*                       -----  
               ENDIF
*              On rippe le tableau courant dans RST sauf si le tableau 
*              n'est pas en memoire centrale
               IF (MCADRS.NE.0) THEN
                  IF ((ITYPTB.EQ.3.OR.ITYPTB.EQ.4).AND. 
     &                (MOD(NEWADR,2).EQ.0)) THEN
                     NEWADR=NEWADR+1
                     TBDCST(24)=TBDCST(24)+1
                  ENDIF
                  DO 30 I=1,NBMOTS 
30                   RST(NEWADR-1+I)=RST(MCADRS-1+I)
               ENDIF
               IF (NOMTB.EQ.'TBDCTB') THEN  
                  TBDCST(9)=NEWADR 
                  IDSCTB=NEWADR
                  NDDCTB=IDSCTB-1+IADCTB 
               ELSEIF (NOMTB.EQ.'TBDCST') THEN 
                  CALL BAISE ('Erreur ---> CPRSTR <--- TBDCST n''est '//
     &                  'plus en 1ere position, ce n''est pas possible')
               ENDIF
               NWADRS=NEWADR+MOTMXR*IAGETB 
               IF(MCADRS.EQ.0) NWADRS=0
               IF(MCADRS.NE.0) NEWADR=NEWADR+NBMOTS
            ELSEIF (ITYPTB.GT.10.AND.(ITYP.GT.10.OR.ITYP.EQ.0).
     &              AND.NEWADA.NE.0) THEN
               NBCAR=((NBARTI*(ITYPTB-10)-1)/NCPMMA+1)*NCPMMA  
               IF (NEWADA.GT.MCADRS.AND.MCADRS.NE.0) THEN
                  CALL BAISE('Erreur ---> CPRSTR <--- NEWADA Incorrect')
               ENDIF
*              On rippe le tableau courant dans AST
               IF(MCADRS.NE.0) THEN
                  DO 50 I=1,NBCAR  
50                   AST(NEWADA-1+I)=AST(MCADRS-1+I)
               ENDIF
               IF(NOMTB.EQ.'TBNMTB') THEN  
                  TBDCST(5)=NEWADA 
                  ITBNTB=NEWADA
                  NDNMTB=ITBNTB-1+IANMTB 
               ENDIF
               NWADRS=NEWADA+MOTMXR*IAGETB 
               IF(MCADRS.EQ.0) NWADRS=0
               IF(MCADRS.NE.0) NEWADA=NEWADA+NBCAR 
            ENDIF 
*           Le rang du tableau courant doit diminuer de NBTROU, si 
*           NBTROU sont ecrases
            NDCNEW=NDDCTB  
            IF(NBTROU.NE.0) THEN
               NDMNEW=NDNMTB-NBCHNT*NBTROU 
               DO 53 ICAR=1,NBCHNT 
53                AST(NDMNEW+ICAR)=AST(NDNMTB+ICAR)
               NDCNEW=NDDCTB-NBPART*NBTROU 
               IST(NDCNEW+1)=IST(NDDCTB+1) 
               IST(NDCNEW+2)=IST(NDDCTB+2) 
               IST(NDCNEW+3)=SIGN(NWADRS,MCADDR)
               IST(NDCNEW+4)=IST(NDDCTB+4) 
               IST(NDCNEW+5)=IST(NDDCTB+5)
            ENDIF
         ENDIF
         IANMTB=IANMTB+NBCHNT
         IADCTB=IADCTB+NBPART
100   CONTINUE 
*     Verifications sur la disparition des trous
      IF ((NTROUA.NE.NBTRAS.AND.(ITYP.EQ.0.OR.ITYP.GT.10)).OR.  
     &    (NTROUR.NE.NBTRRS.AND.(ITYP.GE.0.AND.ITYP.LE.4))) THEN
         WRITE(IMPERR,10000) NBTROU,NTROUA,NBTRAS,NTROUR,NBTRRS
         CALL BAISE('Erreur ---> CPRSTR <--- ,Compression incorrecte') 
      ENDIF
      IF (NBTROU.EQ.0) RETURN
*  
*     remise a jour du tableau TBDCST  
      TBDCST(4)=NBTABL-NBTROU  
      IF (NEWADR.NE.0) THEN 
*        Les mot perdus sont contenus dans NEWADR  
         TBDCST(10)=MOTMXR-NEWADR+1
         TBDCST(11)=NEWADR 
         TBDCST(12)=0  
      ENDIF
      IF (NEWADA.NE.0) THEN 
         TBDCST(6)=NBCHMX-NEWADA+1 
         TBDCST(7)=NEWADA  
         TBDCST(8)=0
      ENDIF
*     remise a zero des memoires liberees dans les tables de description
      NDNMTB=ITBNTB-1+NBCHNT*(NBTABL-NBTROU)
      NDDCTB=IDSCTB-1+NBPART*(NBTABL-NBTROU)
      DO 206 ITABL=NBTABL-NBTROU+1,NBTBMX  
         DO 203 ICAR=1,NBCHNT  
 203        AST(NDNMTB+ICAR)=' '
         DO 204 INUM=1,NBPART  
 204        IST(NDDCTB+INUM)=0 
         NDNMTB=NDNMTB+NBCHNT  
 206     NDDCTB=NDDCTB+NBPART  
*-----------------------------------------------------------------------
      IF (IPRINT.GT.0) THEN 
         IF (ITYP.EQ.0) THEN
            WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),'RST ET AST'
         ELSEIF (ITYP.GE.1.AND.ITYP.LE.4) THEN
            WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),'RST'
         ELSEIF (ITYP.GT.10) THEN
            WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),'AST'
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10000 FORMAT(T11,'Le nombre de trous comprimes est different du nombre'
     &       ,' de trous existants'/
     &       T21,'nombre total de trous              : ',T65,I5/
     &       T21,'nombre de trous comprimes dans AST : ',T65,I5/
     &       T21,'nombre de trous presents  dans AST : ',T65,I5/
     &       T21,'nombre de trous comprime  dans RST : ',T65,I5/
     &       T21,'nombre de trous presents  dans RST : ',T65,I5)
10002 FORMAT(A,A,'<CprsTr Compression des trous dans ',A)
                                                                    END !Cprstr
