*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MISEAJ (IND,TBNMTB,TBDCTB,NOMTB,ITYPTB,NIVETB  
     &                  ,MCADRS,MSADRS,NBARTI,NBMOTS,NBCAR,IRTROU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 88)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Mise a jour des tableaux de description de tableaux lors de la creation
* de tableau ou de la recherche d'un tableau (en M.S.)
*  
* IND    indice de Creation (IND=0) ou de recherche (IND.NE.0)
*        (si IND.NE.0 , IND est le rang du tableau )  
* TBNMTB tableau des noms de tableaux 
* TBDCTB tableau des indices de descriptions de tableaux  
* NOMTB  nom du tableau
* ITYPTB type du tableau  
* NIVETB niveau du tableau
* MSADRS adresse du tableau en memoire secondaire 
* NBARTI longueur en articles du tableau  
* NBMOTS longueur en mots 
* NBCAR  longueur en caracteres si il y a lieu
* IRTROU rang du trou qui va etre occuppe par le tableau cree ou  
*        retrouve( si IRTROU.EQ.0 le tableau est place au bout)  
* MCADRS adresse du tableau (cree ou restaure) en memoire 
*        centrale comptee en articles 
* IND    en  sortie, rang du tableau  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'
*
      INTEGER   IND,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI,NBMOTS,NBCAR,IRTROU
      CHARACTER TBNMTB(NBCHNT,*),NOMTB*(*)
      INTEGER   TBDCTB(*) 
*

      CHARACTER PRFXAS*8,NOMTAB*6
*-----------------------------------------------------------------------
      NBTABL=TBDCST(4) 
      NCDISP=TBDCST(6) 
      NXFRMO=TBDCST(7) 
      LGDISP=TBDCST(10)
      NXTADR=TBDCST(11)
      IPRINT=TBDCST(16)
      IMPERR=TBDCST(17)
*     IF (IPRINT.GT.0) WRITE(IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
*  
*     Definition de la nouvelle adresse du tableau 
*  
      MCADRS=NXFRMO
      IF(ITYPTB.LE.4) MCADRS=NXTADR
      IRTR=1+NBPART*(IRTROU-1) 
      IF(IRTROU.GT.0) THEN 
         CALL GETATR(TBDCTB(IRTR),ITYP,NIVE,MCADRS,MSAD,NBMO)  
         IF(ITYPTB.GT.10) THEN 
            TBDCST(6)=NCDISP-NBCAR 
         ELSE IF(ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN 
            IF(ITYPTB.GE.3.AND.MOD(MCADRS,2).EQ.0) THEN
               MCADRS=MCADRS+1 
               TBDCST(24)=TBDCST(24)+1 
               LGDISP=LGDISP-1 
            END IF 
            TBDCST(10)=LGDISP-NBMOTS
         END IF
      ELSE 
         IF(ITYPTB.GT.10) THEN 
            TBDCST(7)=NXFRMO+NBCAR 
            TBDCST(6)=NCDISP-NBCAR 
         ELSE IF(ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN 
            IF(ITYPTB.GE.3.AND.MOD(MCADRS,2).EQ.0) THEN
               MCADRS=MCADRS+1 
               TBDCST(24)=TBDCST(24)+1 
               NXTADR=NXTADR+1 
               LGDISP=LGDISP-1 
            END IF 
            TBDCST(11)=NXTADR+NBMOTS
            TBDCST(10)=LGDISP-NBMOTS
         END IF
      END IF
*  
      IF(IND.EQ.0) THEN
*       Cas d'une Creation 
         IND=NBTABL+1  
         CALL PUTATR (ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     *               ,TBDCTB(1+NBPART*NBTABL))
         CALL RIPCHN(TBNMTB(1,1),TBDCST(4),NBCHNT,NOMTB)
         IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) TBDCST(21)=TBDCST(21)+NBMOTS  
         IF (IPRINT.GT.0) WRITE(IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                                       ,NOMTB,NIVETB,'creation'
      ELSE 
*        Cas d'une restauration en memoire centrale
         IF(ITYPTB.GE.1.AND.ITYPTB.LE.4) TBDCST(22)=TBDCST(22)-NBMOTS  
*        Echange eventuel de rang avec le trou qui recoit le tableau
*        afin de conserver l'ordre des adresses croissantes dans la
*        description des tableaux  
         IF(IRTROU.EQ.0) THEN  
*           Il n'y a pas de trou, le tableau est place a la fin
*           son ancien rang IND disparait, les rangs de tout les
*           tableaux qui etaient situes apres lui diminuent de 1
*           Le nombre de tableaux ne change globalement pas.
            IDEB=NBPART*(IND-1)
            DO 44 ITABL=IND,NBTABL-1
               DO 40 ICAR=1,NBCHNT 
40                TBNMTB(ICAR,ITABL)=TBNMTB(ICAR,ITABL+1)  
               DO 41 I=1,NBPART
41                TBDCTB(IDEB+I)=TBDCTB(IDEB+NBPART+I) 
               IDEB=IDEB+NBPART
44          CONTINUE
*           Le rang du tableau devient le rang le plus grand car il a  
*           la plus haute adresse (sauf si il l'est deja ...)  
            IDEB=NBPART*(NBTABL-1) 
            TBDCTB(IDEB+3)=MCADRS  
            IF(IND.NE.NBTABL) THEN 
               IBIDON=0
               CALL RIPCHN (TBNMTB(1,NBTABL),IBIDON,NBCHNT,NOMTB)
               CALL PUTATR (ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI  
     *                     ,TBDCTB(IDEB+1))
            END IF 
*           en sortie  
            IND=NBTABL 
         ELSE  
*           Il y a un trou du bon type de rang IRTROU  
            IF(((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.(ITYP.GT.10)).OR.
     *      ((ITYP.GE.1.AND.ITYP.LE.4).AND.(ITYPTB.GT.10)))
     *      WRITE(IMPERR,1002) NOMTB,NIVETB,PRFXAS (0)
            IF(ITYP.GE.3.AND.ITYP.LE.4) NBMO=2*NBMO
            IF(ITYP.GT.10) THEN
               NBMO=((ITYP-10)*NBMO-1)/NCPMMA+1
            END IF 
            IF(NBMO.EQ.NBMOTS) THEN
*              Le tableau tient exactement dans le trou, son rang  
*              s'echange simplement avec celui du trou, le trou disparait  
*              Il y a globalement un tableau de moins ...  
               IBIDON=0
               CALL RIPCHN (TBNMTB(1,IRTROU),IBIDON,NBCHNT,NOMTB)
               CALL PUTATR (ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI  
     *                     ,TBDCTB(IRTR)) 
*              son ancien rang IND disparait, les rangs de tout les
*              tableaux qui etaient situes apres lui diminuent de 1
               IDEB=NBPART*(IND-1) 
               DO 64 ITABL=IND,NBTABL-1
                  DO 60 ICAR=1,NBCHNT  
60                   TBNMTB(ICAR,ITABL)=TBNMTB(ICAR,ITABL+1)
                  DO 61 I=1,NBPART 
61                   TBDCTB(IDEB+I)=TBDCTB(IDEB+NBPART+I)  
64                IDEB=IDEB+NBPART 
*              Il y a un tableau de moins, en l'occurrence le trou 
               TBDCST(4)=NBTABL-1  
               DO 72 ICAR=1,NBCHNT 
72                TBNMTB(ICAR,NBTABL)=' '  
               IDEB=NBPART*(NBTABL-1)  
               DO 74 INUM=1,5  
                  IDEB=IDEB+1  
74                TBDCTB(IDEB)=0
*              Les niveaux superieurs des trous crees par la suite sont
*              diminues de 1
               IF(ITYP.GE.1.AND.ITYP.LE.4) THEN
                  TBDCST(12)=TBDCST(12)-1  
                  DO 80 ITAB=1,NBTABL  
                     ITB=NBPART*(ITAB-1)
                     IT=TBDCTB(ITB+1)  
                     NI=TBDCTB(ITB+2)  
                     DO 78 ICAR=1,NBCHNT
78                      NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITAB)
                     IF (NOMTAB(:6).EQ.'TROUMC'.AND.IT.EQ.ITYP
     &                  .AND.NI.GT.NIVE) THEN
                        TBDCTB(ITB+2)=NI-1 
                     END IF
80                CONTINUE 
               ELSE IF(ITYP.GT.10) THEN
                  TBDCST(8)=TBDCST(8)-1
                  DO 90 ITAB=1,NBTABL  
                     ITB=NBPART*(ITAB-1)
                     IT=TBDCTB(ITB+1)  
                     NI=TBDCTB(ITB+2)  
                     DO 88 ICAR=1,NBCHNT
88                      NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITAB)
                     IF (NOMTAB(:6).EQ.'TROUMC'.AND.IT.EQ.ITYP 
     &                  .AND.NI.GT.NIVE) THEN
                        TBDCTB(ITB+2)=NI-1 
                     END IF
90                CONTINUE 
               END IF  
*              en sortie
               IND=IRTROU  
            ELSE
*              Le tableau est plus petit que le trou, le trou devient  
*              un trou plus petit  
               IF(IND.GT.IRTROU) THEN  
*                 On modifie les caracteristiques du trou ,qui devient 
*                 le trou residuel 
                  IF(ITYP.GE.1.AND.ITYP.LE.4) THEN 
                     NBART=NBMO-NBMOTS 
                     IF(ITYP.EQ.3.OR.ITYP.EQ.4) NBART=NBART/2  
                     CALL PUTATR (ITYP,NIVE,MCADRS+NBMOTS,0,NBART
     *                           ,TBDCTB(IRTR))  
                  ELSE IF(ITYP.GT.10) THEN 
                     NBART=((NBMO-NBMOTS)*NCPMMA)/(ITYP-10)
                     CALL PUTATR (ITYP,NIVE,MCADRS+NBMOTS*NCPMMA,0
     *                           ,NBART,TBDCTB(IRTR))  
                  END IF
*                 son ancien rang IND disparait, les rangs de tout les 
*                 tableaux qui etaient situes avant lui augmentent de 1
*                 a partir de IRTROU
*                 Le nombre de tableaux ne change globalement pas. 
                  IDEB=NBPART*(IND-1)  
                  DO 104 ITABL=IND,IRTROU+1,-1 
                     DO 100 ICAR=1,NBCHNT  
100                     TBNMTB(ICAR,ITABL)=TBNMTB(ICAR,ITABL-1)
                     DO 101 I=1,NBPART 
101                     TBDCTB(IDEB+I)=TBDCTB(IDEB-NBPART+I)
104               IDEB=IDEB-NBPART 
*                 Le rang du tableau peut alors s'echanger avec celui du trou  
                  IBIDON=0 
                  CALL RIPCHN (TBNMTB(1,IRTROU),IBIDON,NBCHNT,NOMTB)
                  CALL PUTATR (ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     *                        ,TBDCTB(IRTR))
*                 en sortie
                  IND=IRTROU
               ELSE
*                 son ancien rang IND disparait, les rangs de tout les 
*                 tableaux qui etaient situes apres lui diminuent de 1 
*                 jusqu'a IRTROU-1 
*                 Le nombre de tableaux n'est globalement pas change.  
                  IDEB=NBPART*(IND-1)  
                  DO 114 ITABL=IND,IRTROU-1
                     DO 110 ICAR=1,NBCHNT  
110                      TBNMTB(ICAR,ITABL)=TBNMTB(ICAR,ITABL+1)
                     DO 111 I=1,NBPART 
111                     TBDCTB(IDEB+I)=TBDCTB(IDEB+NBPART+I)
                     IDEB=IDEB+NBPART  
114               CONTINUE 
*                 Le rang du tableau peut alors s'echanger avec celui  
*                 situe juste avant le trou
                  IBIDON=0 
                  CALL RIPCHN (TBNMTB(1,IRTROU-1),IBIDON,NBCHNT,NOMTB)  
                  CALL PUTATR (ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     *                        ,TBDCTB(IRTR-5))
*                 Les parametres du trou residuel sont modifies
                  IF(ITYP.GE.1.AND.ITYP.LE.4) THEN 
                     NBART=NBMO-NBMOTS 
                     IF(ITYP.EQ.3.OR.ITYP.EQ.4) NBART=NBART/2  
                     CALL PUTATR (ITYP,NIVE,MCADRS+NBMOTS,0,NBART
     *                           ,TBDCTB(IRTR))
                  ELSE IF(ITYP.GT.10) THEN 
                     NBART=((NBMO-NBMOTS)*NCPMMA)/(ITYP-10)
                     CALL PUTATR (ITYP,NIVE,MCADRS+NBMOTS*NCPMMA,0
     *                           ,NBART,TBDCTB(IRTR))
                  END IF
*                 en sortie
                  IND=IRTROU-1 
               END IF  
            END IF 
         END IF
         IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     *                                        ,NOMTB,NIVETB,'recherche'
      END IF
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>MiseAJ')
10001 FORMAT(A,A,'<MiseAJ ',A,T32,'/',I6
     &,T39,', Tables mises a jour pour la ',A)
1002  FORMAT(' Erreur sur le type du trou utilise pour reintroduire' 
     &,A,'/',I6,' en memoire centrale',A)
                                                                    END !MiseAj
