*******************************************************************************
      SUBROUTINE STSTAT (IMPPAL)
*******************************************************************************
* Derniere modification (O.DeBayser) le 10 Avril 96
*  
* Statistiques sur l'utilisation des super-tableaux numeriques
*
*-- Argument --
* IMPPAL unite logique d'impression
*******************************************************************************
      INTEGER IMPPAL
      INCLUDE 'ALLOC'
*
      INTEGER IPRINT,IMPERR,I,MOTACT
*  
*     TBDCST(10)           varient dans
*     TBDCST(18 A 24)         ''           Stinit  
*     TBDCST(18)              ''           Tbcree  
*     TBDCST(21)              ''           Miseaj et Recopi
*     TBDCST(22)              ''           Sauvtb(+) et Miseaj(-)  
*     TBDCST(19 et 20)        ''           Tbopen  
*     TBDCST(23)              ''           Tbtuer et Recopi
*     TBDCST(24)              ''           Cprstr et Miseaj
*     TBDCST(33 et 34)        ''           Tampon  
*  
*     TBDCST(24) : Mots perdus pour respecter les imparites d'adresse  
*     imposees par les equivalences des tableaux complexe ou double
*     precision avec RST
*  
      IPRINT=TBDCST(16)
      IMPERR=TBDCST(17)
      IF(IMPPAL.EQ.0) THEN 
         IMPPAL=IMPERR 
         IF(IPRINT.GT.0) IMPPAL=IPRINT 
      ENDIF
      IF(IPRINT.GT.0) WRITE(IPRINT,*) ' *StStat*'  
      WRITE(IMPPAL,999)  TBDCST(2),TBDCST(10)  
      WRITE(IMPPAL,1000) (TBDCST(I),I=18,24)
      WRITE(IMPPAL,1001) (TBDCST(I),I=33,34)
*     Calcul du bilan des mots crees,tues,sauves, ... etc  
*     I---------------I-------------I------------I------------I---------------I
*       Mots presents   Mots perdus   Mots sauves   Mots tues   Mots restants  
*  
*     .-----------------------MOTTOT-------------------------->
*                                   <------MOTSAV+MOTTUE------.
*            = 
*  
*     .---------------------------------MOTMXR-------------------------------->
*                                   <-----------------LGDISP------------------.
      MOTACT=TBDCST(21)-(TBDCST(22)+TBDCST(23))
      MOTACT=MOTACT-(TBDCST(2)-TBDCST(10)) 
      IF(MOTACT.NE.0) WRITE(IMPPAL,1002) MOTACT
      IF(IPRINT.GT.0) WRITE(IPRINT,*) ' *StStat* Sortie'
      RETURN
999   FORMAT(T11,'Taille du super-tableau :',T50,I9/
     *       T11,'Taille disponible :',T50,I9) 
1000  FORMAT(T11,'Nombre de creation de tableau :',t50,i9/ 
     *       t11,'Nombre de lecture :',t50,i9/ 
     *       t11,'Nombre d''ecritures :',t50,i9/
     *       t11,'Nombre total de mots crees :',t50,i9/
     *       t11,'Nombre total de mots sauvegardes :',t50,i9/  
     *       t11,'Nombre total de mots tues :',t50,i9/ 
     *       t11,'Nombre de mots perdus :',t50,i9) 
1001  format(t11,'Nombre de retours de tableau tampon :',t50,i9/
     *       t11,'Nombre d''envois en tableau tampon :',t50,i9)
1002  format(t2,'Tiens , le total de mots crees moins le total des mots'
     *         ,' tues ou sauves et moins le nombre de mots presents'  
     *         ,' est differend de zero'/t2,'il vaut ',I12)
      END  
