*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TAILTR (NBMOTS,ITYPTB,RANGTR,TBNMTB,TBDCTB)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Juillet 1988)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Recherche d'un trou susceptible de contenir NBMOTS d'un type convenable 
*  
*-- Arguments d'entree --
* NBMOTS  Taille recherchee dans AST ou RST selon ITYPTB 
* ITYPTB  Type du super tableau vise 
* TBNMTB  Tableau des noms de tableaux
* TBDCTB  Tableau de description des tableaux
*-- Argument de sortie --
* RANGTR  Rang du trou convenable dans l'ensemble des tableaux  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
      CHARACTER TBNMTB(*)
      INTEGER   NBMOTS,ITYPTB,TBDCTB(*),RANGTR
*
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8,NOMTB*6
      INTEGER NIP
*-----------------------------------------------------------------------
      NBTABL=TBDCST(4) 
      IPRINT=TBDCST(16)
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
      IADCTB=1
      IANMTB=1
*  
      IF (ITYPTB.LE.10) THEN
         DO 2 RANGTR=1,NBTABL
            DO 1 ICAR=1,NBCHNT
               NOMTB(ICAR:)=TBNMTB(IANMTB)
1              IANMTB=IANMTB+1
            IF (NOMTB.EQ.'TROUMC') THEN
               CALL GETATR (TBDCTB(IADCTB),ITYP,NIVE,MCAD,MSAD,NBMO) 
               IF(ITYP.LE.10) THEN
                  IF (ITYP.GE.3) NBMO=2*NBMO 
                  NBMONC=NBMOTS 
                  IF ((ITYPTB.GE.3).AND.MOD(MCAD,2).EQ.0)NBMONC=NBMOTS+1
                  IF (NBMO.GE.NBMONC) GOTO 90000  
               ENDIF  
            ENDIF 
2        IADCTB=IADCTB+NBPART 
      ELSE
         DO 4 RANGTR=1,NBTABL
            DO 3 ICAR=1,NBCHNT
               NOMTB(ICAR:)=TBNMTB(IANMTB)
3              IANMTB=IANMTB+1
            IF (NOMTB.EQ.'TROUMC') THEN
               CALL GETATR (TBDCTB(IADCTB),ITYP,NIVE,MCAD,MSAD,NBMO) 
               IF (ITYP.GT.10) THEN 
                  NBMO=(((ITYP-10)*NBMO-1)/NCPMMA+1)*NCPMMA
                  NBMONC=NBMOTS*NCPMMA
                  IF (NBMO.GE.NBMONC) GOTO 90000 
               ENDIF  
            ENDIF 
4        IADCTB=IADCTB+NBPART
      ENDIF

*     Pas de trou adequat  
      RANGTR=0  
      IF (IPRINT.GT.0) WRITE(IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1)
      RETURN
90000 IF (IPRINT.GT.0) WRITE(IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                                   ,RANGTR,NBMO,' mots'
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>TailTr')
10001 FORMAT(A,A,'<TailTr Trou trouve au rang ',I5,',',I12,A)
10002 FORMAT(A,A,'<TailTr Pas de trou de taille convenable')
                                                                    END !TailTr

