*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBADRS (NOMTB,NIVETB,MCADRS,CODEOU,CODEIN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.de Bayser (1988)
* Derniere modification : D.Martin (04 Fevrier 1997)
* Version 1.0.1
*  
* Fournit l'adresse d'un tableau en memoire centrale
*  
*-- Arguments d'entree --
* NOMTB  nom du tableau
* NIVETB niveau du tableau
* CODEIN caractere d'entree pour tester ou non l'existence d'un tableau  
*-- Arguments de sortie --
* MCADRS adresse du tableau en memoire centrale
* CODEOU caractere de code de retour si CODEIN a une valeur adequate ('!')
*        = ' ' --> retour normal  
*        = 'R' --> le tableau est sauvegarde (TBRECH) 
*        = 'C' --> le tableau n'existe pas (TBCREE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CODEIN,CODEOU,NOMTB
      INTEGER       NIVETB,MCADRS
*
      INCLUDE 'ALLOC'
*
      CHARACTER     PRFXAS*8
      INTEGER       IEME,ITYPTB,MSADRS,NBARTI,IPRINT,NIP
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)
      CODEOU=' '
*
*     Recherche du rang et des caracteristiques du tableau
*
      CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9))
     &            ,IEME,ITYPTB,MCADRS,MSADRS,NBARTI)
      IF (IEME.LE.0) GOTO 99998
*
*     Le tableau existe
*
      CODEOU=' '
      IF (MCADRS.LE.0) GOTO 99999
*
*     Le tableau existe et reside en memoire centrale, son adresse :
*
      IF (ITYPTB.EQ.3.OR.ITYPTB.EQ.4) MCADRS=(MCADRS-1)/2+1
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10001)
     &   (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB,ITYPTB,NBARTI,MCADRS
      RETURN
*-----------------------------------------------------------------------
10001 FORMAT(A,A,'<TbAdrs ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12,T64,', Ad',I12)
10002 FORMAT(A,A,'>TbAdrs ',A,T32,'/',I6,T41,A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99998 CODEOU='C'
      IF (CODEIN.EQ.'!') RETURN  
      IF (IPRINT.GT.0) WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1)
     &                                     ,NOMTB,NIVETB,'non trouve !'
      CALL ERTBAL (1,'*TbAdrs*',NOMTB,NIVETB)
99999 CODEOU='R'
      IF (CODEIN.EQ.'!') RETURN 
      CALL ERTBAL (2,'*TbAdrs*',NOMTB,NIVETB)
                                                                    END !Tbadrs
