*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBGONL(NCPMMA,ITYPTB,NBMOTS,NBCAR,NBARTI) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 90)
* Derniere modification (O.DeBayser) le 30 Mars 90 
*  
* Calcul la longueur d'un tableau en article selon le type et  
* la longueur en mots ou en caracteres 
*  
*** Arguments ***  
* NCPMMA: nombre de caracteres par mot 
* ITYPTB: numero de type du tableau (=1,2,3,4 ou > 10) 
* NBMOTS: nombre de mots qu'occupe le tableau  
* NBCAR : nombre de caracteres du tableau qu'occupe le tableau 
* NBARTI: nombre d'articles du tableau 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPMMA,ITYPTB,NBMOTS,NBCAR,NBARTI
*-----------------------------------------------------------------------
      NBARTI=NBMOTS
      IF (ITYPTB.GT.10) THEN
          NBARTI=(NCPMMA*((NBCAR-1)/NCPMMA+1))/(ITYPTB-10) 
      ELSEIF (ITYPTB.GE.3.AND.ITYPTB.LE.4) THEN
          NBARTI=NBMOTS/2  
      ENDIF
                                                                    END !TbGonl
