*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBRANG (NOMTB,NIVETB,TBNMTB,TBDCTB,IEME,ITYPTB 
     &                  ,MCADRS,MSADRS,NBARTI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1988)
* Derniere modification : D.Martin (15 Decembre 1997)
* Recherche du rang d'un tableau dans le tableau des noms de tableau
* et de ses caracteristiques
*  
*-- Arguments d'entree  --
* NOMTB   Nom du tableau
* NIVETB  Niveau du tableau
* TBNMTB  Tableau des noms de tableaux 
* TBDCTB  Tableau des indices de description de tableaux
*-- Arguments de sortie --
* IEME    Rang du tableau si il existe, 0 s'il n'existe pas
* ITYPTB  Type du tableau (entier,reel,double precision, complexe,character*x) 
* MCADRS  Adresse en memoire centrale  
* MSADRS  Adresse en memoire secondaire
* NBARTI  Longueur en articles du tableau  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'
*
      INTEGER     NIVETB,TBDCTB(*),IEME,ITYPTB,MCADRS,MSADRS,NBARTI
      CHARACTER   TBNMTB(*),NOMTB*(*)
*
      INTEGER KELCHN,NBTABL,NXTABL,IAD,NIVTAB
*-----------------------------------------------------------------------
      NBTABL=TBDCST(4) 
      NXTABL=0 
      IAD=1
1     NXTABL=NXTABL+1  
      IF (NXTABL.GT.NBTABL) GOTO 2 
*  
*     Recherche du tableau suivant portant le meme nom 
*  
      IEME=KELCHN (NOMTB,TBNMTB(IAD),NBTABL-NXTABL+1,NBCHNT)            !Utilite
      IF (IEME.GT.0) THEN
         IEME=NXTABL+IEME-1
*  
*        Caracteristiques du tableau trouve
         IAD=1+NBPART*(IEME-1) 
         CALL GETATR (TBDCTB(IAD),ITYPTB,NIVTAB,MCADRS,MSADRS,NBARTI)
         IF (NIVETB.EQ.NIVTAB) RETURN
         NXTABL=IEME
         IAD=1+NBCHNT*NXTABL
         GOTO 1
      ENDIF
*  
*     On a pas trouve le tableau NOMTB de niveau NIVETB
2     IEME=0
                                                                    END !Tbrang
