*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBRECH (NOMTB,NIVETB,NBARTI,CODEOU,CODEIN)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Mars.88)
* Derniere modification : D.Martin (04 Fevrier 1998)
* Version 1.0.1
*  
* Recherche d'un tableau et retour de son adresse en M.C.
*  
*-- Arguments d'entree --
* NOMTB   Nom du tableau
* NIVETB  Niveau du tableau
* CODEIN  ???????????????? 
*-- Arguments de sortie --
* NBARTI  Longueur en articles du tableau  
* CODEOU  Caractere de code de retour :
*          = ' ' --> retour normal 
*          = 'C' --> le tableau n'existe pas (faire TBCREE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER CODEIN,CODEOU,NOMTB*(*)
      INTEGER   NIVETB,NBARTI
*  
      INCLUDE 'ALLOC'
*  
      CHARACTER PRFXAS*8
      INTEGER IPRINT,IEME,ITYPTB,MCADRS,MSADRS,NBMOTS,NBCAR,IRTROU
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)

*     Recherche du rang et des caracteristiques du tableau
      CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IEME
     &            ,ITYPTB,MCADRS,MSADRS,NBARTI)
      IF (IEME.LE.0) GOTO 99998
      CODEOU=' '
*     Si le tableau est en M.C. (a l'etat de sauvegarde differee)  
*     On redresse eventuellement le signe de l'adresse ... et c'est tout
      IF (MCADRS.LT.0) IST(TBDCST(9)+NBPART*(IEME-1)+2)=-MCADRS
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                                     ,NOMTB,NIVETB,ITYPTB,NBARTI
*
      IF (MCADRS.NE.0) RETURN
*  
*     Le tableau n'est pas en memoire centrale 
*
      CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
*     Recherche d'un trou du bon type susceptible de contenir le tableau
      CALL TAILTR (NBMOTS,ITYPTB,IRTROU,AST(TBDCST(5)),IST(TBDCST(9)))
      IF (IRTROU.EQ.0) THEN 
*        Sinon recherche de la taille neccessaire a la fin du  
*        super-tableau adequat 
         IF (TBDCST(4).EQ.TBDCST(3)-1) CALL DEPLAC  
*        Assurance sur la place disponible dans les super tableaux 
         CALL ASSURC (ITYPTB,NBCAR,NBMOTS,*99999)
         CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IEME
     &               ,ITYPTB,MCADRS,MSADRS,NBARTI)
         IF (IEME.LE.0) GOTO 99998 
      ENDIF
      CALL MISEAJ (IEME,AST(TBDCST(5)),IST(TBDCST(9)),NOMTB,ITYPTB  
     &            ,NIVETB,MCADRS,MSADRS,NBARTI,NBMOTS,NBCAR,IRTROU)
      IF (NBMOTS.GT.TBDCST(25)) THEN
*        Entree du tableau a partir d'un fichier a acces direct
         CALL TBOPEN (NOMTB,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI  
     &               ,AST(TBDCST(5)),IST(TBDCST(9)),'ENTREE')
      ELSE 
*        Retour du systeme de fichier acces direct longueur variable
*        par l'intermediaire d'un tableau tampon
         CALL TAMPON (NOMTB,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI  
     &               ,AST(TBDCST(5)),IST(TBDCST(9)),'ENTREE')
      ENDIF
*  
      IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                                     ,NOMTB(1:NBCHNT),NIVETB,IEME
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>TbRech ',A,T32,'/',I6,:,T39,', Type',I3
     &,T48,', Lg',I12)
10001 FORMAT(A,A,'<TbRech ',A,T32,'/',I6,' reintro. en M.C. au rang'
     &,I5)
10002 FORMAT(A,A,'>TbRech ',A,T32,'/',I6,T41,A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99998 CODEOU='C'
      IF (CODEIN.EQ.'!') RETURN
      IF (IPRINT.GT.0)
     &   WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                      ,'non trouve !'
      CALL ERTBAL (1,'*TbRech*',NOMTB,NIVETB)
99999 IF (IPRINT.GT.0)
     &   WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                       ,'place insuffisante !'
      CALL ERTBAL (5,'*TbRech*',NOMTB,NIVETB)  
                                                                    END !Tbrech
