*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBTUER (NOMTB,NIVETB)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Novembre 1988)
* Derniere modification : D.Martin (25 Avril 2001)
* Version 1.0.3
*  
* Suppression d'un tableau en le remplacant par un trou
*  
*-- Arguments --  
* NOMTB  Nom du tableau
* NIVETB Niveau du tableau
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTB 
      INTEGER       NIVETB
*
      INCLUDE 'ALLOC'  
* 
      CHARACTER PRFXAS*8
      INTEGER  ITBNTB,IDSCTB,IPRINT,IRANG,ITYPTB,MCADRS,MSADRS,NBARTI
     &        ,NBMOTS,NBCAR,NIVTRO,IBIDON,IDSTRO,NBTABL,J
*-----------------------------------------------------------------------
      ITBNTB=TBDCST(5) 
      IDSCTB=TBDCST(9)
      IPRINT=TBDCST(16)  
*     recherche du rang et des caracteristiques du tableau 
      CALL TBRANG (NOMTB,NIVETB,AST(ITBNTB),IST(IDSCTB),IRANG
     &            ,ITYPTB,MCADRS,MSADRS,NBARTI)
      IF (IRANG.LE.0) THEN
*         CALL STIMPR (6)
         CALL WATBAL (3,'*Tbtuer*',NOMTB,NIVETB)
      ENDIF
      IF (IPRINT.GT.0) THEN
         WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                       ,ITYPTB,NBARTI,MCADRS
      ENDIF
*  
      IF (MCADRS.NE.0) THEN 
*        Le tableau est en memoire centrale :
*        La place recuperee est comptabilisee dans les trous
         CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
         IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN
*           Nombre de mots disponibles dans RST
            TBDCST(10)=TBDCST(10)+NBMOTS
*           Nombre de trous dans RST
            TBDCST(12)=TBDCST(12)+1
            NIVTRO=TBDCST(12)
*
            TBDCST(23)=TBDCST(23)+NBMOTS
         ELSEIF (ITYPTB.GT.10) THEN
*           Nombre de caracteres disponibles dans AST
            TBDCST(6)=TBDCST(6)+NBCAR
*           Nombre de trous dans AST
            TBDCST(8)=TBDCST(8)+1  
            NIVTRO=TBDCST(8)
         ENDIF
         IBIDON=0  
*        Le tableau tue est remplace par un trou
         CALL RIPCHN (AST(ITBNTB+NBCHNT*(IRANG-1)),IBIDON,NBCHNT
     &               ,'TROUMC')
         IDSTRO=IDSCTB+NBPART*(IRANG-1)
         MCADRS=ABS(MCADRS)
         CALL PUTATR (ITYPTB,NIVTRO,MCADRS,0,NBARTI,IST(IDSTRO))
      ELSE 
*        Le tableau est en M.S. :
*        Il n'y a pas de place a recuperer en M.C.
*        on comprime simplement le nombre de tableaux
         NBTABL=TBDCST(4)  
         NBTABL=NBTABL-1
         DO 1 J=ITBNTB+NBCHNT*(IRANG-1),ITBNTB-1+NBCHNT*NBTABL 
1           AST(J)=AST(J+NBCHNT)
         DO 2 J=IDSCTB+NBPART*(IRANG-1),IDSCTB-1+NBPART*NBTABL 
2           IST(J)=IST(J+NBPART)
         TBDCST(4)=NBTABL  
      ENDIF
*
      IF (IPRINT.GT.0)
     &   WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                       ,ITYPTB,NBARTI
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>TbTuer ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12,T64,', Ad',I12)
10001 FORMAT(A,A,'<Tbtuer ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12,T79,' -> assassine')
                                                                    END !Tbtuer
