*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GREEN (TYNOYO,TABCSG,CORP,CORM,E,TABASS)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Octobre 1994)
* Derniere modification : O.DeBayser (10 Avril 1996)
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      COMPLEX AK,CANU,TABCSG(*),E(*),TABASS(*) 
      REAL    ANU,CHAMP,CORP(*),CORM(*)
*  
      AK   =TABASS(1)
      ANU  =REAL(TABCSG(1))
      CANU =     TABCSG(1)
      CHAMP=REAL(TABCSG(2))
* 
      IF(CHAMP.EQ.1.) THEN
*        Cas de la fonction de Green du pb de la resistance de vagues bidim.
*        G1(x,y) = 1/2*PI*Log(|MP|/|M'P|)
*                 -1/2*PI*exp(nu*Z)*(E1(nu*Z)+E1(nu*Zb))
*                 +i/2*(1-sign(x))*exp(nu*Z)
*                 -i/2*(1-sign(x))*exp(nu*Zb)
         CALL GRW2D  (TYNOYO,ANU,CORM,CORP,E(1),E(2),E(4),E(6))
      ELSE IF(CHAMP.EQ.2.) THEN
*        Cas de la fonction de green du pb. de diffraction auxiliaire
*        G2(x,y)=G1(x,y)+i*exp(nu*Z)
         CALL GRW2A  (TYNOYO,ANU,CORM,CORP,E(1),E(2),E(4),E(6))
*        En fait G2 est equivalent a la fonction de Green du mouvement
*        sur la houle bidim. (../appl-houle2d/ghoule.f),
*        bien que reprogramme differement.
*        CALL GHOUL2 (TYNOYO,ANU,CORM,CORP,E(1),E(2),E(4),E(6))
      ELSE IF(CHAMP.EQ.3.) THEN
*        Cas de la fonction de green du pb. de diffraction auxiliaire
*        G2(x,y)=G1(x,y)+i*exp(nu*Z), nu complexe
         CALL GRW2AC (TYNOYO,CANU,CORM,CORP,E(1),E(2),E(4),E(6))
      ELSE
         CALL BAISE 
     *     ('*Green* La variable "Champ" doit etre fixee a 1.,2. ou 3.')
      ENDIF
                                                                    END !Green
