*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMADI (NMTERM,NVTERM,ITTERM,NVDSMB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1992)
* Derniere modification : D.Martin & L.Landure(31 Aout 2000)
* Version 1.0.1
*  
* Report des coefficients diagonaux des termes de la structure d'assemblage 
* de niveau NVDSMB dans le resultat NMTERM
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme assemble
* NVTERM son niveau
* ITTERM son type de declaration
* NVDSMB siveau de la structure d'assemblage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NVTERM,ITTERM,NVDSMB
      CHARACTER*(*) NMTERM
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      INTEGER  INTDON,INTTYP
      INTEGER  ADTERM,INTREL,INTCOM,LGRIPP,NBLIAV,INCL,NBLIGN
     &        ,MCLIGN,NVNURL,MCNELI
     &        ,MCDSMB,LGETRD,NBLOCC,INCTRD,NBLOCL
     &        ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERA,IADTRM
     &        ,MCCONU,NCPINL,INTRP,NBT,LIG,NULIG,NXLIGN,NCATR1
     &        ,MCDONN,ITYDON,NIVDON,ITYPDO,MCCSTE,INCSTE
     &        ,MCMTRM,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &        ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML
     &        ,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVITR,MCTERM,MCTERA
      REAL          RRRRRR
      COMPLEX       CCCCCC
      EQUIVALENCE  (RRRRRR,CCCCCC)
      CHARACTER     ERCODE*120,CHAINE*16
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(105:105),CHAINE)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Dsmadi*')
*
      INTREL= INTTYP ('REEL')
      INTCOM= INTTYP ('COMPLEXE')
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$DSMBL',NVDSMB,MCDSMB)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDSMB),LGETRD,NBLOCC,INCTRD,NBLOCL)             !utilite
      LGRIPP=LGETRD
      NBLIAV=0
*
      DO 100 INCL=1,MIN (NBLOCC,NBLOCL)
         CALL TBAR4  (ERCODE,'$SDTRM',  1   ,MCDTRM,'#OMTRM',1,MCMTRM
     &                      ,'$DSMBL',NVDSMB,MCDSMB,'#NCONU',1,MCCONU)
*        Recherches des tableaux pour l'inconnue en ligne
         NUTERA=IST(MCDSMB+LGRIPP)
         NVNURL=IST(MCDSMB+LGRIPP+4)
         IF (NUTERA.LE.0) THEN
            CALL TBRR1  (ERCODE,'#GNEDO',NVNURL,MCLIGN)
            CALL TBAR1  (ERCODE,'#GNEDO',NVNURL,MCLIGN)
            NBLIGN=IST(MCLIGN+1)
         ELSE
            IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
            CALL GETTRM  (IST(IADTRM)  ,NIVTRM,ITYPTR,ITYCAL,NUKALE
     &                   ,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC,NBNECO
     &                   ,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INDSTK
     &                   ,NVSTOK,NVCOOR,IATRDO,NIVITR)                  !sdexplo
*           IST(MCDSMB+LGRIPP+5)=NVCOOR
            CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)           !utilite
            IF (NCPINL.GT.1) NVNUML=NVDUML
            CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,CHAINE)              !utilite
            CALL TBRR4  (ERCODE
     &           ,CHAINE(1:NCHTRM),NIVTRM,MCTERA, NMTERM ,NVTERM,MCTERM
     &           ,   '#GNEDO'    ,NVNUML,MCNELI,'#GNEDO',NVNURL,MCLIGN)
            CALL TBAR4  (ERCODE
     &           ,CHAINE(1:NCHTRM),NIVTRM,MCTERA, NMTERM ,NVTERM,MCTERM
     &           ,   '#GNEDO'    ,NVNUML,MCNELI,'#GNEDO',NVNURL,MCLIGN)
            IF (NUDONN.NE.NDFDON) THEN
               CCCCCC=0.
               CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
               IF (ITYDON.EQ.INTDON ('CONSTANTE').AND.NIVDON.GT.0) THEN !utilite
                  IF (ITYPDO.EQ.INTREL) THEN
                     CALL TBAR1  (ERCODE,'$RCSTE',1,MCCSTE)
                     RRRRRR=RST(MCCSTE+NIVDON)
                  ELSEIF (ITYPDO.EQ.INTCOM) THEN
                     CALL TBAR1  (ERCODE,'$CCSTE',1,MCCSTE)
                     CCCCCC=CST(MCCSTE+NIVDON)
                  ELSEIF (ITYPDO.EQ.INTTYP ('ENTIER'))   THEN           !utilite
                     CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
                     INCSTE=IST(MCCSTE+NIVDON)
                     RRRRRR=FLOAT(INCSTE)
                     IF (INCSTE.EQ.1) NUDONN=0
                  ENDIF
               ELSE
                  NUDONN=NDFDON
               ENDIF
            ENDIF
*
*           Coefficients diagonaux
            NBLIGN=IST(MCLIGN+1)
            NBNELI=IST(MCNELI+1)
            NXLIGN=1
            ADTERM=MCTERM-1+NBLIAV
            IF (NUDONN.NE.NDFDON) THEN
*              Cas avec une donnee constante
               IF (ITTERM.EQ.INTCOM) THEN
                  IF (ITYPTR.EQ.INTCOM) THEN
                     DO 144 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        CST(ADTERM+LIG)=CCCCCC*CST(MCTERA-1+NULIG)
144                  CONTINUE
                  ELSEIF (ITYPTR.EQ.INTREL) THEN
                     DO 142 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        CST(ADTERM+LIG)=CCCCCC*RST(MCTERA-1+NULIG)
142                  CONTINUE
                  ENDIF
               ELSEIF (ITTERM.EQ.INTREL) THEN
                  IF (ITYPTR.EQ.INTREL) THEN
                     DO 122 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        RST(ADTERM+LIG)=RRRRRR*RST(MCTERA-1+NULIG)
122                  CONTINUE
                  ELSEIF (ITYPTR.EQ.INTCOM) THEN
                     DO 124 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        RST(ADTERM+LIG)=CCCCCC*CST(MCTERA-1+NULIG)
124                  CONTINUE
                  ENDIF
               ENDIF
            ELSE
               IF (ITTERM.EQ.INTCOM) THEN
                  IF (ITYPTR.EQ.INTCOM) THEN
                     DO 244 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        CST(ADTERM+LIG)=CST(MCTERA-1+NULIG)
244                  CONTINUE
                  ELSEIF (ITYPTR.EQ.INTREL) THEN
                     DO 242 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        CST(ADTERM+LIG)=RST(MCTERA-1+NULIG)
242                  CONTINUE
                  ENDIF
               ELSEIF (ITTERM.EQ.INTREL) THEN
                  IF (ITYPTR.EQ.INTREL) THEN
                     DO 222 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        RST(ADTERM+LIG)=RST(MCTERA-1+NULIG)
222                  CONTINUE
                  ELSEIF (ITYPTR.EQ.INTCOM) THEN
                     DO 224 LIG=1,NBLIGN
                        CALL DICOTO (NXLIGN,NBNELI,IST(MCNELI+2)
     &                              ,IST(MCLIGN+1+LIG),NULIG,*99991)    !utilite
                        NXLIGN=NULIG+1
                        RST(ADTERM+LIG)=CST(MCTERA-1+NULIG)
224                  CONTINUE
                  ENDIF
               ENDIF
            ENDIF
*
            CALL TBSAVE (CHAINE(:NCHTRM),NIVTRM)
            CALL TBSAVE ('#GNEDO',NVNUML)
         ENDIF
         CALL TBSAVE ('#GNEDO',NVNURL)
         NBLIAV=NBLIAV+NBLIGN
100      LGRIPP=LGRIPP+(NBLOCL+1)*INCTRD
*
      CALL PRFXMJ (-1,'*Dsmadi*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL ENCLER (NUTERA,ERCODE(NCATR1+1:NCATR1+4))
      CALL BAISE  ('Assemblage pour le terme '//ERCODE(1:NCATR1)
     &//'. Un coefficient diagonal n''est pas retrouve pour le terme No'
     &//ERCODE(NCATR1+1:NCATR1+4))
                                                                    END !Dsmadi
