*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMALI (MCRESU,ITTERM,MCLIGN,NUINCL,NXLIGN,NUDRPL
     &                  ,LGCUAV,MCNELI,MCPLAL,MCPLIL,MCTERM,ITYPTR
     &                  ,MCCSTE,ITYPDO,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1992)
* Derniere modification : D.Martin (28 Juin 2000)
* Version 1.0.1
*  
* Report des termes de la structure d'assemblage de niveau NVASMB  
* dans le resultat NMTRMR pour une inconnue en ligne
*  
*-- Arguments d'entree -- 
* MCRESU adresse du resultat
* ITTERM type (REEL ou COMPLEXE) du resultat
* MCLIGN adresse de la numerotation commune en ligne
* NUINCL rang de l'inconnue en ligne = nombre d'inconnue en colonne
* NXLIGN tableau des numeros de premiere colonne a parcourir
* NUDRPL tableau des numeros de derniere plage de la ligne
* LGCUAV tableau des longueurs cumulees avant la ligne en cours
* MCNELI tableau des adresses de la numerotation en ligne du terme
* MCPLAL tableau des adresses du tableau de derniere plage de la ligne
* MCPLIL tableau des adresses du tableau de debut et longueur de plage
* MCTERM tableau des adresse des termes a assembler
* ITYPTR tableau des types des termes a assembler
* MCCSTE tableau des adresses des constantes reelles
* ITYPDO tableau des types des constantes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MCRESU,ITTERM,MCLIGN,NUINCL,NXLIGN(*),NUDRPL(*),LGCUAV(*)
     &       ,MCNELI(*),MCPLAL(*),MCPLIL(*),MCTERM(*),ITYPTR(*)
     &       ,MCCSTE(*),ITYPDO(*),IST(*)
      REAL    RST(*)
      COMPLEX CST(*)
*
      CHARACTER TYPINT*4,TYTERM*4
      INTEGER   NBLIGN,MCLIGG,LIGNE,NUGLOL,NUINCC,MCNELL,MOOUBM,NULIG
     &         ,LGCUAP,MCCUAV,NBCOEF
*-----------------------------------------------------------------------
      TYTERM=TYPINT (ITTERM)                                            !utilite
*
      NBLIGN=IST(MCLIGN-1)
      MCLIGG=MCLIGN-1
*
      DO 2 LIGNE=1,NBLIGN
*
         MCLIGG=MCLIGG+1
         NUGLOL=IST(MCLIGG)
*
         DO 1 NUINCC=1,NUINCL
*
            MCNELL=MCNELI(NUINCC)
            IF (MCNELL.GT.0) THEN
               CALL DICOTO (NXLIGN(NUINCC),IST(MCNELL-1),IST(MCNELL)
     &                     ,NUGLOL,NULIG,*1)                            !utilite
               NXLIGN(NUINCC)=NULIG+1
               MOOUBM=0
               IF (NUINCC.EQ.NUINCL) THEN
*                 Le terme 'diagonal' est BiMorse
                  MOOUBM=1
                  IF (NULIG.EQ.1) GOTO 1
               ENDIF
               NUDRPL(NUINCC)=IST(MCPLAL(NUINCC)-1+NULIG-MOOUBM)
               LGCUAP        =0
               IF (NUDRPL(NUINCC).GT.0)
     &         LGCUAP        =IST(MCPLIL(NUINCC)+2*NUDRPL(NUINCC)-1)
               MCCUAV        =MCTERM(NUINCC)+LGCUAV(NUINCC)
               NBCOEF        =LGCUAP-LGCUAV(NUINCC)
               LGCUAV(NUINCC)=LGCUAP
               IF (MCCSTE(NUINCC).NE.0) THEN
                  CALL TEQAT  (NBCOEF,TYPINT(ITYPTR(NUINCC)),MCCUAV,RST
     &                        ,CST,TYPINT(ITYPDO(NUINCC)),MCCSTE(NUINCC)
     &                        ,IST,RST,CST,TYTERM,MCRESU,RST,CST)       !utilite
               ELSE
                  CALL TDANST (NBCOEF,TYPINT(ITYPTR(NUINCC)),MCCUAV
     &                        ,IST,RST,CST,TYTERM,MCRESU,IST,RST,CST)   !utilite
               ENDIF
               MCRESU=MCRESU+NBCOEF
            ENDIF
*
1        CONTINUE
*
2     CONTINUE
                                                                    END !Dsmali
