*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSVTRI (SDSMBL,INCDSM,NBTRAS,WORKTB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (28 Novembre 1997)
* Version 1.0.0
*
* Tri de la structure SDSMBL par ordre croissant des numeros d'inconnues
*
*-- Arguments --
* SDSMBL structure a trier
* INCDSM nombre de mots par item de cette structure
* NBTRAS nombre d'items de cette structure
* WORKTB tableau de travail (longueur utile: INCDSM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   INCDSM,SDSMBL(INCDSM,*),NBTRAS,WORKTB(*)
*
      INTEGER   NUTRAS,NUTRAJ,K
*-----------------------------------------------------------------------
*
*     Tri sur les inconnues
*
      DO 5 NUTRAS=2,NBTRAS
         DO 1 K=1,INCDSM
            WORKTB(K)=SDSMBL(K,NUTRAS)
1        CONTINUE
         DO 3 NUTRAJ=NUTRAS-1,1,-1
            IF (WORKTB(3).LT.SDSMBL(3,NUTRAJ)) THEN
               DO 2 K=1,INCDSM
                  SDSMBL(K,NUTRAJ+1)=SDSMBL(K,NUTRAJ)
                  SDSMBL(K,NUTRAJ)=WORKTB(K)
2              CONTINUE
            ELSE
               GOTO 5
            ENDIF
3        CONTINUE
5     CONTINUE
                                                                    END !DsVtri

