*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PTTERM (NMTRM1,NVTRM1,NOMDOM,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 1995)
* Derniere modification : D.Martin (9 Avril 2002)
* Version 1.0.1
*  
* Creation d'un terme projection tangentielle d'un terme vectoriel 
* sur un domaine : n^(E^n)=E-(E.n).n
*  
*-- Arguments d'entree -- 
* NMTRM1,NVTRM1 Nom et niveau du terme d'entree vectoriel
* NOMDOM nom du domaine geometrique ou l'on calcule le terme
* NMTRM2,NVTRM2 Nom et niveau du terme resultat scalaire
* NIVIMP Niveau d'impression du terme resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRM1,NOMDOM,NMTRM2
      INTEGER       NVTRM1,NVTRM2,NIVIMP
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PtTerm*')
      CALL PJTERM ('t',NMTRM1,NVTRM1,NOMDOM,NMTRM2,NVTRM2,NIVIMP)
      CALL PRFXMJ (-1,'*PtTerm*')
      END
