*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASCORN (NDIM,NBNEEL,IRGNEC,CORNEL,CORNED)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1989)
* Derniere modification : D.Martin (12 Novembre 1999)
*  
* Report des coordonnees des noeuds dans un element dans le tableau
* des coordonnees des noeuds d'un domaine
*  
*-- Arguments --
* NDIM   dimension d'espace
* NBNEEL nombre de noeuds de l'element (ou la face ou l'arete de l'elt.)
* IRGNEC tableau des rangs des noeuds de l'element dans le domaine
* CORNEL coordonnees des noeuds sur l'element (ou la face ou l'arete de l'elt.)
* CORNED coordonnees des noeuds sur le domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NBNEEL,IRGNEC(*)
      REAL    CORNEL(NDIM,*),CORNED(NDIM,*)
*
      INTEGER NEEL,NOEUD,IDIM
*-----------------------------------------------------------------------
      DO 2 NEEL=1,NBNEEL
         NOEUD=IRGNEC(NEEL)
         DO 1 IDIM=1,NDIM  
            CORNED(IDIM,NOEUD)=CORNEL(IDIM,NEEL)
1        CONTINUE
2     CONTINUE
                                                                    END !Ascorn
