*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SAVTRM (TYKL,NXDODO,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (15 septembre 2006)
* Version 2
*  
* Sauvegarde de tous les tableaux des termes du domaine de calcul  
* de meme type ('ELFINI', 'MATELM', 'VALNOD', 'C.ESSE', 'C.TRAN', ...)
*  
*-- Arguments --  
* TYKL   type des termes a sauvegarder
* NXDODO adresse relative (-1) du domaine de calcul dans #TERDO
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYKL
      INTEGER       NXDODO,IMPFCH
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      CHARACTER     PRFXAS*8,TYPINT*9,YKLINT*6,STOIND*7,SYMIND*14
      INTEGER       INTDON,INTTYP,INTYKL
      INTEGER       MCDONN,MCMDON,LGEDON,NBDONN,INCDON,NCHDON,ITYDON
     &             ,NIVDON,ITYPDO,ITYDOA,NIVDOA
      INTEGER       MCTRDO,LGERDO,NBDOMK,INCRDO,NCHDOM,IDTRDO,NBTRDO
     &             ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,LETERM,ADTERM,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN       
     &             ,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &             ,NVDUML,NBLIGN,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO
     &             ,NIVIMP,NCATRM,INTDTA,INTDFO
      CHARACTER     ERCODE*120,NOMTRM*16,NODONA*16,READRE,THETR1*16
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(97:97),READRE),(ERCODE(105:105),NOMTRM)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Savtrm*')
*
      CALL TBAR5  (ERCODE,'#OMTRM',1,MCMTRM,'#TERDO',1,MCTRDO
     &                   ,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN
     &                   ,'#OMDON',1,MCMDON)                     
      READRE='N'
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !sdexplo
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !sdexplo
*
      INTDTA = INTDON ('TABLEAU')
      INTDFO = INTDON ('FONCTION')
*
      IDTRDO=NXDODO+INCRDO
      NBTRDO=IST(MCTRDO-2+IDTRDO)
*
      DO 1 LETERM=1,NBTRDO 
         IF (READRE.EQ.'Y')
     &   CALL TBAR3(ERCODE,'#OMTRM',1,MCMTRM,'#TERDO',1,MCTRDO
     &                    ,'$SDTRM',1,MCDTRM)
         NUTERM=IST(MCTRDO-1+IDTRDO+LETERM)  
         IF (NUTERM.LE.0) GOTO 1
         ADTERM=LGETRM+INCTRM*(NUTERM-1)
*
*        Attributs du terme
*
         CALL GETTRM (IST(MCDTRM+ADTERM),NIVTRM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR         
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INDSTK,NVNUMS,NVCORC,IATRDO,NIVIMP)               !sdexplo
*
         IF (ITYCAL.EQ.INTYKL(TYKL(1:6)).AND.NUKALE.GT.0) THEN          !utilite
            CALL PUTTRM (IST(MCDTRM+ADTERM),NIVTRM
     &                  ,ITYPTR,ITYCAL,-NUKALE,NUDONN,ITYSYM,IPTDIR
     &                  ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &                  ,NUINCL,NVDUML,NBLIGN,NVNUML
     &                  ,INDSTK,NVNUMS,NVCORC,IATRDO,NIVIMP)            !sdexplo
*
            CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NOMTRM)              !utilite
*
*           Sauvegarde d'un eventuel tableau associe
*
            IF (NUDONN.GT.0) THEN
*              Caracteristiques de la donnee associee au terme
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !sdexplo
               CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NODONA)           !utilite
               IF (ITYDON.EQ.INTDTA) THEN
*                  Cas d'une donnee tableau affectee : son nom ?
                   CALL TBSAVE (NODONA(1:NCHDON),NIVDON)
               ELSEIF (ITYDON.EQ.INTDFO) THEN
*                  Cas d'une donnee fonction affectee : 
*                  La fonction a-t-elle un donnee associee ?
                   IF (NIVDON.GT.0) THEN
*                     Caracteristiques de la donnee associee a la donnee fonction
                      CALL SDEXCO (NIVDON,IST(MCDONN)
     &                            ,ITYDOA,NIVDOA,ITYPDO)                !sdexplo
                      IF (ITYDOA.EQ.INTDTA) THEN
*                        Cas d'une donnee tableau associee : son nom ?
                         CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NODONA) !utilite
                         CALL TBSAVE (NODONA(1:NCHDON),NIVDOA)
                      ENDIF
                   ENDIF
               ENDIF
            ENDIF
*
            IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
                CALL PRNTRM (NOMTRM(1:NCHTRM),NIVTRM,THETR1,NCATRM)
                 IF (TYKL(1:6).EQ.'VALNOD'.OR.TYKL(1:6).EQ.'C.ESSE'
     &           .OR.TYKL(1:6).EQ.'C.TRAN'
     &           .OR.NUINCC.EQ.NDFINC.OR.NUINCL.EQ.NDFINC) THEN
                   WRITE (IMPPAL,10000) PRFXAS (1),THETR1(1:NCATRM)
     &                                 ,YKLINT(ITYCAL),TYPINT(ITYPTR)
                ELSEIF (ITYSYM.EQ.0) THEN
                   WRITE (IMPPAL,10000) PRFXAS (1),THETR1(1:NCATRM)
     &                                 ,YKLINT(ITYCAL),TYPINT(ITYPTR)
     &                                 ,STOIND(INDSTK)
                ELSE
                   WRITE (IMPPAL,10000) PRFXAS (1),THETR1(1:NCATRM)
     &                                 ,YKLINT(ITYCAL),TYPINT(ITYPTR)
     &                                 ,STOIND(INDSTK),SYMIND(ITYSYM)
                ENDIF
            ENDIF
*
*           On evite d'imprimer les termes 'Condition essentielle' ou
*           'Condition de transmission' homogenes et les termes
*           de type 'CARACTERE'.
*
            IF (ITYPTR.LE.INTTYP ('CARACTERE')
     &    .AND.(.NOT.(NUDONN.EQ.0.AND.
     &         (TYKL(1:6).EQ.'C.ESSE'.OR.TYKL(1:6).EQ.'C.TRAN')))) THEN
               IF (NIVIMP.GT.0) THEN
                  CALL PRTERM (NOMTRM(1:NCHTRM),NIVTRM,NIVIMP,IMPFCH)   !prsd
                  READRE='Y'
               ENDIF
               CALL TBSAVE (NOMTRM(1:NCHTRM),NIVTRM)
            ENDIF
         ENDIF
1     CONTINUE
      CALL PRFXMJ (-1,'*Savtrm*')
*-----------------------------------------------------------------------
10000 FORMAT(T5,A8,' Terme ',A,' de type ',A,', ',A,:,', ',A:,', ',A)
                                                                    END !Savtrm
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Version 2 : D.Martin (15 septembre 2006)
* - La sauvegarde des tableaux affectes au termes est incorporee
* Version 1 : D.Martin (13 Decembre 1999)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
