*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFRPFB (KELFIN,LGFCIN,LGDFIN,KELFOU,LGFCOU,LGDFOU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 1988)
* Derniere modification : D.Martin (11 Janvier 1995)
* Version 1.0.0
*  
* Reports des attributs de calculs de fonctions de base de
* l'interpolation 'OU' dans les attributs de l'interpolation 'IN' 
* Ce sous-programme n'est appele qu'en cas d'egalite de 2 interpolations  
*  
*-- Arguments d'entree -- 
* KELFIN indicateur de calcul des fonctions de base pour l'interpolation 'IN'  
* LGFCIN longueur du tableau des fonctions de base pour l'interpolation 'IN'
* LGDFIN longueur du tab. des derivees des fonc. de base pour l'inter. 'IN'
* KELFOU,LGFCOU,LGDFOU Idem pour l'interpolation 'OUT' 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFIN,KELFOU
      INTEGER       LGFCIN,LGDFIN,LGFCOU,LGDFOU
*
      INTEGER       I
*-----------------------------------------------------------------------
      DO 1 I=1,3
         IF (KELFOU(I:I).EQ.'Y') KELFIN(I:I)='Y'
1     CONTINUE
      KELFOU(1:3)='NNN'
      KELFOU(4:4)=KELFIN(4:4)  
      LGFCIN=MAX (LGFCIN,LGFCOU)
      LGFCOU=0 
      LGDFIN=MAX (LGDFIN,LGDFOU)
      LGDFOU=0 
                                                                    END !EfRpfb

