*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SACHA (NDIM,NBCNVE,VARIAB,CORGLO,NBDLEL,COREL,IAFACE 
     &                 ,NUDLFA,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Octobre 1989) 
* Derniere modification : D.Martin (28 Mai 1999)
* Version 1.0.0
*  
* DISTribution des coordonnees dans un 'ELement' d'un domaine (!)
*  
*-- Arguments --  
* NDIM   dimension d'espace
* NBCNVE nombre de caracteres par nom de variable d'espace
* VARIAB tableau des noms de variables d'espace
* CORGLO tableau des coordonnees des points du maillage elt par elt.  
* NBDLEL nombre de points dans l'element en cours 
* COREL  tableau des coordonnees des points du domaine elt par elt.
* IAFACE on travaille sur une face (IAFACE=1) ou non (IAFACE=0)
* NUDLFA tableau de numerotation locale sur la face (cas IAFACE=1)
* NIVIMP niveau d'impression (pas d'impression si nul)
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      INTEGER   NDIM,NBCNVE,NBDLEL,IAFACE,NUDLFA(*),NIVIMP,IMPFCH
      REAL      CORGLO(NDIM,*),COREL(NDIM,*)
      CHARACTER VARIAB(NBCNVE,*)
*
      CHARACTER MAFOR*120
      INTEGER   MUNDIM,NBCHAR,I,ID,IDIM        
      COMMON/FORMAH/MAFOR  
*-----------------------------------------------------------------------
      DO 2 I=1,NBDLEL
         ID=I
         IF (IAFACE.NE.0) ID=NUDLFA(I)
         DO 1 IDIM=1,NDIM  
           COREL(IDIM,I)=CORGLO(IDIM,ID)
1        CONTINUE
2     CONTINUE  
      IF (NIVIMP.LE.0) RETURN
*-----------------------------------------------------------------------
      MUNDIM=NDIM+1+(-1)**NDIM 
      NBCHAR=MIN(9,NBCNVE) 
*
      MAFOR='('//CHAR(MUNDIM+48)//'('' Point '','//CHAR(NDIM+48)//'(TR2,
     &'//CHAR(NBCHAR+48)//'A3,TR'//CHAR(56-NBCHAR)//'),''  *'',:))'
      WRITE(IMPFCH,FMT=MAFOR) (((VARIAB(ID,IDIM),ID=1,NBCNVE)
     &,IDIM=1,NDIM),I=1,MIN(MUNDIM,NBDLEL))
      MAFOR(3:)='(I5,TR3,'//CHAR(NDIM+48)//'E12.5,'' *''))' 
      WRITE(IMPFCH,FMT=MAFOR) (I,(COREL(IDIM,I),IDIM=1,NDIM),I=1,NBDLEL)
                                                                    END !Sacha
