*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLDLTR (NGNECO,NBNELI,NGNELI,NULAPL,IPLAGE
     &                  ,ITYPTR,MCTERM,NBNEFR,NGNEFR
     &                  ,NBNERE,NGNERE,MCTREL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1992)
* Derniere modification (D.Martin) le 23 Septembre 1994
*  
* Constitution d'un terme de relevement compacte  MORSE
* cas du domaine de relevement en ligne
*  
*-- Arguments d'entree --
* NGNECO numeros globaux des noeuds pour l'interpolation en colonne
* NBNELI nombre de lignes du terme dont on extrait le relevement
* NBNELI,NGNELI nombre et numeros globaux des noeuds pour l'interpol. en ligne 
* NULAPL,IPLAGE tableaux de compactage Morse ligne ou Bimorse inf ou sup 
* ITYPTR Indice de type (REEL ou COMPLEXE) du terme
* MCTERM adresse du terme en m.c. du terme dont on extrait le relevement
* NBNEFR,NGNEFR nombre et numeros globaux des noeuds de la front. de relevement
* NBNERE,NGNERE nombre et numeros globaux des noeuds en colonne du terme releve
* NGNERE numeros globaux des noeuds du terme releve
* MCTREL adresse du terme releve en m.c.
* RST,CST, quolifichets habituels  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NGNECO(*),NBNELI,NGNELI(*),NULAPL(*),IPLAGE(2,*)
     &             ,ITYPTR,MCTERM,NBNEFR,NGNEFR(*),NBNERE,NGNERE(*)
     &             ,MCTREL 
      REAL          RST(*) 
      COMPLEX       CST(*) 
*-----------------------------------------------------------------------
      NEXT=1  
      LGCUAV=0 
      NDEBPL=1 
      LGCURV=MCTREL
*
      IF (ITYPTR.EQ.INTTYP ('REEL')) THEN                               !Utilite
         DO 22 INERE=1,NBNERE
            CALL DICOTO (NEXT,NBNELI,NGNELI,NGNERE(INERE),INELI,*99999) !Utilite
            NEXT=INELI+1
            NDEBPL=1
            LGCUAV=0
            IF (INELI.GT.1) THEN
               NDEBPL=NULAPL(INELI-1)+1
               LGCUAV=IPLAGE(2,NDEBPL-1)
            ENDIF
            NFINPL=NULAPL(INELI)
            NXFRON=1
            DO 21 NUMPLA=NDEBPL,NFINPL
               LGPLAG=IPLAGE(2,NUMPLA)-LGCUAV
               KOLDEB=IPLAGE(1,NUMPLA)  
               DO 20 KOLON=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (NXFRON,NBNEFR,NGNEFR,NGNECO(KOLON),NEFRON
     &                                                             ,*20)!Utilite
                  NXFRON=NEFRON+1
                  RST(LGCURV)=RST(MCTERM+LGCUAV)
                  LGCURV=LGCURV+1
20                LGCUAV=LGCUAV+1
21          CONTINUE
22       CONTINUE
      ELSE
         DO 42 INERE=1,NBNERE
            CALL DICOTO (NEXT,NBNELI,NGNELI,NGNERE(INERE),INELI,*99999) !Utilite
            NEXT=INELI+1
            NDEBPL=1
            LGCUAV=0
            IF (INELI.GT.1) THEN
               NDEBPL=NULAPL(INELI-1)+1
               LGCUAV=IPLAGE(2,NDEBPL-1)
            ENDIF
            NFINPL=NULAPL(INELI)
            NXFRON=1
            DO 41 NUMPLA=NDEBPL,NFINPL
               LGPLAG=IPLAGE(2,NUMPLA)-LGCUAV
               KOLDEB=IPLAGE(1,NUMPLA)  
               DO 40 KOLON=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (NXFRON,NBNEFR,NGNEFR,NGNECO(KOLON),NEFRON
     &                                                             ,*40)!Utilite
                  NXFRON=NEFRON+1
                  CST(LGCURV)=CST(MCTERM+LGCUAV)
                  LGCURV=LGCURV+1
40                LGCUAV=LGCUAV+1
41          CONTINUE
42       CONTINUE
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 CALL BAISE  (' *Rldltr* Le numero global NGNERE(INERE) doit se '     
     &                      //'trouver dans la numerotation en ligne ') !Utilite
                                                                    END !Rldltr
