*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLMORS (NGNECO,NBNELI,NGNELI,NULAPL,IPLAGE
     &                  ,NBNEFR,NGNEFR,NBNERE,NGNERE
     &                  ,NBPLAR,NULAPR,IPLAGR,CODERR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1992)
* Derniere modification (D.Martin) le 13 Juillet 1997
*  
* Creation des tables de compactage MORSE d'un terme de relevement
* a partir de celles d'un terme de volume
*  
*-- Arguments d'entree -- 
* NGNECO numerotation des noeuds en colonne du terme de volume
* NBNELI nombre de noeuds en ligne du terme de volume
* NGNELI numerotation des noeuds en ligne du terme de volume 
* NULAPL,IPLAGE tables de compactage du terme de volume  
* NBNEFR nombre de noeuds en ligne de la frontiere
* NGNEFR numerotation des noeuds en ligne de la frontiere
* NBNERE nombre de noeuds en colonne du domaine releve
* NGNERE numerotation des noeuds en colonne du domaine releve
*-- Arguments de sortie --
* NBPLAR nombre de plages du terme releve  
* NULAPR,IPLAGR tables de compactage du terme releve
* CODERR code de retour en cas de depassement du nombre max. de plages    
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NGNECO(*),NBNELI,NGNELI(*),NULAPL(*),IPLAGE(2,*)  
     &             ,NBNEFR,NGNEFR(*),NBNERE,NGNERE(*)
     &             ,NBPLAR,NULAPR(*),IPLAGR(2,*),CODERR
*-----------------------------------------------------------------------
      LGCUAV=0 
      NDEBPL=1 
      LGCURV=0 
      NBPLAX=NBPLAR
      NBPLAR=0 
*  
      NXFRON=1 
      DO 4 INELI=1,NBNELI  
         NFINPL=NULAPL(INELI)
         CALL DICOTO (NXFRON,NBNEFR,NGNEFR,NGNELI(INELI),NEFRON,*3)     !Utilite
*        Dans le terme releve seules sont retenues les lignes correspondant
*        a des noeuds du domaine relevant
         NXFRON=NEFRON+1
*        Report de toutes les positions des coeff. de la ligne correspondant
*        a des noeuds de la numerotation en colonne du domaine releve.
         NUCSAV=1 
         NUCOAV=-1
*  
         DO 2 NUMPLA=NDEBPL,NFINPL  
            KOLDEB=IPLAGE(1,NUMPLA)
            LGCUAP=IPLAGE(2,NUMPLA)
*           DO 1 KOLON=KOLDEB,MIN(KOLDEB+LGCUAP-LGCUAV-1,NBNERE) 
            DO 1 KOLON=KOLDEB,KOLDEB+LGCUAP-LGCUAV-1 
               NGCOL=NGNECO(KOLON)
               CALL DICOTO (NUCSAV,NBNERE,NGNERE,NGCOL,NUCS,*1)         !Utilite
               NUCSAV=NUCS+1
               IF (NUCS.GT.NUCOAV+1) THEN  
*                 Changement de ligne ou de plage dans la somme
                  NBPLAR=NBPLAR+1
                  IF (NBPLAR.GT.NBPLAX) GOTO 9999 
                  IPLAGR(1,NBPLAR)=NUCS
               ENDIF
               LGCURV=LGCURV+1
               IPLAGR(2,NBPLAR)=LGCURV 
               NUCOAV=NUCS
1           CONTINUE
            LGCUAV=LGCUAP
2        CONTINUE 
         NULAPR(NEFRON)=NBPLAR 
3        LGCUAV=IPLAGE(2,NFINPL)
         NDEBPL=NFINPL+1
4     CONTINUE
      RETURN
9999  CODERR=NEFRON
      RETURN
                                                                    END !Rlmors
