*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXXQD (NDMDOM,NUSCHQ,NBPTQ,POIDS,COORQ,DEXACT)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1988)
* Derniere modification : D.Martin (14 juin 2004)
* Version 1
*
* Procedure 'Vide' pour un oubli de procedure de type ElemQD
*
*-- Variables d'entree --
* NDMDOM dimension de la formule
* NUSCHQ numero (conventionnel) du schema de quadrature
*
*-- Variables en sortie --
* NBPTQ  nombre de points du schema de quadrature
* POIDQ  tableau des poids du schema de quadrature
* COORQ  tableau des coordonnees des points de quadrature
* DEXACT degre de precision de la formule (pour impression)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER     NDMDOM,NUSCHQ,NBPTQ,DEXACT
      REAL        POIDS(*),COORQ(NDMDOM,*)
*
      CHARACTER*3 NUNAME
*-----------------------------------------------------------------------
      CALL ENCLER (NUSCHQ,NUNAME)
      CALL BAISE  ('Vous avez oublie le sous-programme '
     &//'HEXXQD pour la formule de quadrature de numero '
     &//NUNAME//'.')
                                                                    END !HEXXQD
