*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PR202F (NUFACE,NUTYFA,NBNEFA,NUNEFA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Numerotation locale des noeuds d'une face de l'element de reference
* Hexaedre de Lagrange (ordre 2, serendipity) a 15 noeuds
*
*-- Arguments --
* NUARET numero de la face
* NUTYFA numero de type de la face (numero de type de l'element 2d associe)
* NBNEFA nombre de noeuds de la face
* NUNEFA tableau des numeros locaux des noeuds de la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUFACE,NUTYFA,NBNEFA,NUNEFA(*)
*-----------------------------------------------------------------------
      IF (NUFACE.EQ.1) THEN
         NUNEFA(1)=1
         NUNEFA(2)=3
         NUNEFA(3)=2
         NUNEFA(4)=9
         NUNEFA(5)=8
         NUNEFA(6)=7
         NUTYFA=2102
         NBNEFA=6
      ELSEIF (NUFACE.EQ.2) THEN
         NUNEFA(1)=1
         NUNEFA(2)=2
         NUNEFA(3)=5
         NUNEFA(4)=4
         NUNEFA(5)=7
         NUNEFA(6)=14
         NUNEFA(7)=10
         NUNEFA(8)=13
         NUTYFA=2012
         NBNEFA=8
      ELSEIF (NUFACE.EQ.3) THEN
         NUNEFA(1)=2
         NUNEFA(2)=3
         NUNEFA(3)=6
         NUNEFA(4)=5
         NUNEFA(5)=8
         NUNEFA(6)=15
         NUNEFA(7)=11
         NUNEFA(8)=14
         NUTYFA=2012
         NBNEFA=8
      ELSEIF (NUFACE.EQ.4) THEN
         NUNEFA(1)=3
         NUNEFA(2)=1
         NUNEFA(3)=4
         NUNEFA(4)=6
         NUNEFA(5)=9
         NUNEFA(6)=13
         NUNEFA(7)=12
         NUNEFA(8)=15
         NUTYFA=2012
         NBNEFA=8
      ELSEIF (NUFACE.EQ.5) THEN
         NUNEFA(1)=4
         NUNEFA(2)=5
         NUNEFA(3)=6
         NUNEFA(4)=10
         NUNEFA(5)=11
         NUNEFA(6)=12
         NUTYFA=2102
         NBNEFA=6
      ENDIF
*
                                                                    END !Pr22fa
