*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLKCO (K,NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (23 janvier 2000)
* Version 1.0.1
*  
* Coordonnees des noeuds de l'element de reference 
* Prisme de Lagrange d'ordre 2 k
*
*-- Arguments --
* K      pour prisme d'ordre k
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER K,NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER I ,L,IP6,IP9,IP12
*-----------------------------------------------------------------------
      CORLOC(1,1)=1.
      CORLOC(2,1)=0.
      CORLOC(3,1)=0.
      CORLOC(1,2)=0.
      CORLOC(2,2)=1.
      CORLOC(3,2)=0.
      CORLOC(1,3)=0.
      CORLOC(2,3)=0.
      CORLOC(3,3)=0.
      CORLOC(1,4)=1.
      CORLOC(2,4)=0.
      CORLOC(3,4)=1.
      CORLOC(1,5)=0.
      CORLOC(2,5)=1.
      CORLOC(3,5)=1.
      CORLOC(1,6)=0.
      CORLOC(2,6)=0.
      CORLOC(3,6)=1.
      IF (K.EQ.2) THEN
         CORLOC(1,7)=.5
         CORLOC(2,7)=.5
         CORLOC(1,8)=.0
         CORLOC(2,8)=.5
         CORLOC(1,9)=.5
         CORLOC(2,9)=.0
         DO 2 I=1,3
            IP12=I+12
            IP9=I+9
            IP6=I+6
            CORLOC(3,IP6)=0.
            CORLOC(3,IP12)=.5
            CORLOC(3,IP9)=1.
            DO 1 L=1,2
               CORLOC(L,IP12)=CORLOC(L,I)
               CORLOC(L,IP9)=CORLOC(L,IP6)
1           CONTINUE
2        CONTINUE
         DO 4 I=16,18
            CORLOC(3,I)=.5
            DO 3 L=1,2
               CORLOC(L,I)=CORLOC(L,I-9)
3           CONTINUE
4        CONTINUE
      ENDIF
                                                                    END !Prlkco
