*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TELKCO (K,NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*  
* Coordonnees des noeuds de l'element de reference 
* Tetraedre de Lagrange d'ordre k
*
*-- Arguments --
* K      pour tetraedre de type k
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER K,NDIM
      REAL    CORLOC(NDIM,*) 
*-----------------------------------------------------------------------
      CORLOC(1,1) = 1.
      CORLOC(2,1) = 0.
      CORLOC(3,1) = 0.
      CORLOC(1,2) = 0.
      CORLOC(2,2) = 1.
      CORLOC(3,2) = 0.
      CORLOC(1,3) = 0.
      CORLOC(2,3) = 0.
      CORLOC(3,3) = 1.
      CORLOC(1,4) = 0.
      CORLOC(2,4) = 0.
      CORLOC(3,4) = 0.  
      IF (K.EQ.2) THEN
         CORLOC(1,5) =.5
         CORLOC(2,5) = 0.
         CORLOC(3,5) = 0.
         CORLOC(1,6) = 0.
         CORLOC(2,6) =.5
         CORLOC(3,6) = 0.
         CORLOC(1,7) = 0.
         CORLOC(2,7) = 0.
         CORLOC(3,7) =.5
         CORLOC(1,8) = 0.
         CORLOC(2,8) =.5
         CORLOC(3,8) =.5
         CORLOC(1,9) =.5
         CORLOC(2,9) = 0.
         CORLOC(3,9) =.5
         CORLOC(1,10)=.5
         CORLOC(2,10)=.5
         CORLOC(3,10)= 0.
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Telkco
