*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TETR (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (18 Novembre 2000)
* Version 1.0.2
*  
*-- Variable d'entree --
* TYPE: k < 2  --> Tetraedre de Lagrange P0 a (k+3)(k+2)(k+1)/6 noeuds
*       22     --> Tetraedre de Lagrange P2 a 10 noeuds
*  
*-- Variable en sortie -- cf. cartouche de commentaire dans ELemNb
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEFX,NBDLFX
     &       ,NBNEAX,NBDLAX
*-----------------------------------------------------------------------
      LAGHER=0 
      CLASSE=0
      IF (TYPE.LE.2) THEN
         NBNEAX=TYPE+1
         NBDLAX=NBNEAX
         NBNEFX=(NBNEAX*(NBNEAX+1))/2
         NBDLFX=NBNEFX
         NBNEEL=(NBNEAX*(NBNEAX+1)*(NBNEAX+2))/6
         NBDLEL=NBNEEL
      ELSEIF (TYPE.EQ.202) THEN
         NBNEEL=10
         NBDLEL=NBNEEL
         NBNEFX=6 
         NBDLFX=NBNEFX
         NBNEAX=3 
         NBDLAX=NBNEAX
      ELSE
         CALL TETRXX (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &               ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
      ENDIF
                                                                    END !Tetr
