*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TETRNE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (18 Novembre 2000)
* Version 1.0.2
*  
*-- Variable d'entree --
* TYPE 0    --> Tetraedre de Lagrange P0 a 1 noeud
*      1    --> Tetraedre de Lagrange P1 a 4 noeuds
*      2/22 --> Tetraedre de Lagrange P2 a 10 noeuds
*  
*-- Variables en sortie --
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEFACE nombre de noeuds sur les faces non situes sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,NESOME,NEARET,NEFACE,NEINTE
*
*-----------------------------------------------------------------------
      NESOME=4
      NEFACE=0
      NEARET=0
      NEINTE=0
      IF (TYPE.EQ.0) THEN
         NESOME=0
         NEINTE=1
      ELSEIF (TYPE.EQ.1) THEN  
         RETURN
      ELSEIF (TYPE.EQ.2.OR.TYPE.EQ.202) THEN
         NEARET=6
      ELSE
         CALL ERELEM (15,'*TetrNe*',TYPE)
      ENDIF
                                                                    END !TetrNe
