*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR203P (NBLMP1,NBPOP1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (9 juin 2001)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Construction des tableaux de correspondance des numerotations locales
* entre elements triangulaires P1+bulleP3 et elements triangulaires P1.

*-- Arguments de sortie --
* NBLMP1 nombre de triangles P1 construits (ici 3)
* NBPOP1 tableau de correspondance entre triangles P1 et triangle P1+bulleP3
*        NBPOP1 (s,t) = numero dans le triangle Pk du sommet s du triangle t
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBLMP1,NBPOP1(3,*)
*----------------------------------------------------------------------
      NBLMP1=3
      NBPOP1(1,1) = 1
      NBPOP1(2,1) = 2
      NBPOP1(3,1) = 4
      NBPOP1(1,2) = 2
      NBPOP1(2,2) = 3
      NBPOP1(3,2) = 4
      NBPOP1(1,3) = 3
      NBPOP1(2,3) = 1
      NBPOP1(3,3) = 4
      END

