*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASPLOC (IDLHRM,ITYPTR,MCTERM,MCPLOC,NNEITL,NBNEUL
     &                  ,NBDLDO,NBFDEV,NUNEFA,NDLINL,IRGNDL,NULINE
     &                  ,NCPINL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Avril 1992)
* Derniere modification: D.Martin (10 Juillet 1997)
*
* Pre-Assemblage d'un terme element finis localise
*
*-- Arguments --
* ITYPTR: Type de declaration du terme
* MCTERM: Adresse du terme assemble
* MCPLOC: Adresse de la matrice elementaire
* COLLIG: Indicateur de rangement dans le terme assemble
* NBNEFA: Nombre de d.l. par face d'element
* NBDLDO: Nombre de d.l. element finis du terme
* NBFDEV: nombre de d.l. spectraux du terme
* NUNEFA: Correspondance noeud de face , noeud dans l'element en ligne
* NDLINL: Nombre de d.l. par noeud dans l'element en ligne
* IRGNDL: tableau des rangs des noeuds en ligne de l'element
* IDLHRM: Indice de presence de d.l. element finis de Hermitte
* NULINE: tableau des numeros des premiers d.l. de chaque noeud
* NCPINL: Nombre de composantes de l'inconnue en ligne
* RST,CST Super tableau habituel
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IDLHRM,ITYPTR,MCTERM,MCPLOC,NNEITL,NBNEUL,NBDLDO,NBFDEV
     &       ,NUNEFA(*),NDLINL(*),IRGNDL(*),NULINE(*),NCPINL
      COMPLEX CST(*)
      REAL    RST(*)
*
      INTEGER INTTYP,IACCOF,IAPLOC,INEL,INEUL,IDEB,NBDLIL,IDLL,IATERM
*-----------------------------------------------------------------------
      IACCOF=MCPLOC
      IF (ITYPTR.EQ.INTTYP ('COMPLEXE')) THEN
         DO 44 INEL=1,NNEITL
            INEUL=INEL
            IF (NNEITL.NE.NBNEUL) INEUL=NUNEFA(INEL)
            NBDLIL=1
            IDEB=IRGNDL(INEUL)
            IF (IDLHRM.GT.0) THEN
               NBDLIL=NDLINL(INEUL)
               IDEB=NULINE(IDEB)
            ENDIF
            DO 43 IDLL=IDEB,IDEB+NBDLIL*NCPINL-1
               IAPLOC=IACCOF
               IATERM=MCTERM+IDLL-1
               DO 41 K=1,NBFDEV
                  CST(IATERM)=CST(IATERM)+CST(IAPLOC)
                  IATERM=IATERM+NBDLDO
                  IAPLOC=IAPLOC+NNEITL
41             CONTINUE
               IACCOF=IACCOF+1
43          CONTINUE
44       CONTINUE
      ELSE
         DO 24 INEL=1,NNEITL
            INEUL=INEL
            IF (NNEITL.NE.NBNEUL) INEUL=NUNEFA(INEL)
            NBDLIL=1
            IDEB=IRGNDL(INEUL)
            IF (IDLHRM.GT.0) THEN
               NBDLIL=NDLINL(INEUL)
               IDEB=NULINE(IDEB)
            ENDIF
            DO 23 IDLL=IDEB,IDEB+NBDLIL*NCPINL-1
               IAPLOC=IACCOF
               IATERM=MCTERM+IDLL-1
               DO 21 K=1,NBFDEV
                  RST(IATERM)=RST(IATERM)+RST(IAPLOC)
                  IATERM=IATERM+NBDLDO
                  IAPLOC=IAPLOC+NNEITL
21             CONTINUE
               IACCOF=IACCOF+1
23          CONTINUE
24       CONTINUE
      ENDIF
                                                                    END !Asploc
