*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLNUNS (L,NBSOMT,NBSOMX,NUGSOL,NGNESO
     &                  ,NBNEEX,NGNEEL,NBTNEU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin  (Octobre 1995) 
* Derniere modification : D.Martin (23 Octobre 1995)
* Version 1.0.0
*  
* Numerotation globale des noeuds sommets d'un element
*
*-- Arguments --
* L      numero de l'element en cours
* NBSOMT nombre de sommets de l'element
* NBSOMX nombre max. de sommets dans un element du maillage
* NUGSOL numerotation globale des sommets du maillage
* NGNESO tableau de numerotation des noeuds sommets du maillage
* NBNEEX nombre max. de noeuds dans un element du maillage
* NGNEEL tableau de numerotation des noeuds des elements du maillage
* NBTNEU nombre de noeuds du maillage (pour l'interpolation en cours)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER L,NBSOMT,NBSOMX,NUGSOL(NBSOMX,*),NGNESO(*)
     &       ,NBNEEX,NGNEEL(NBNEEX,*),NBTNEU
*
      INTEGER NELOCA,NEGLOB,NUGLOB
*-----------------------------------------------------------------------
*
*     Numerotation globale des noeuds sommets de l'element
*
      DO 11 NELOCA=1,NBSOMT
         NEGLOB = NUGSOL(NELOCA,L)
         NUGLOB = NGNESO(NEGLOB)
         IF (NUGLOB.GT.0) THEN
            NGNEEL(NELOCA,L) = NUGLOB 
         ELSE
            NUGLOB = NGNEEL(NELOCA,L)
            IF (NUGLOB.LE.0) THEN
               NBTNEU = NBTNEU+1
               NUGLOB = NBTNEU
            ENDIF
            NGNESO(NEGLOB)   = NUGLOB
            NGNEEL(NELOCA,L) = NUGLOB
         ENDIF
11    CONTINUE
                                                                    END !GlnuNs
