*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDLTRI (NBTPTG,NBTEL,NBPTEX,MXDEG,ADVOIS,NEVOIS
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (30 juin 2002)
* Version 2.0.0
*
* Classement de NEVOIS par degre croissant
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   NBTPTG,NBTEL,NBPTEX,MXDEG,ADVOIS(*),NEVOIS(*)
     &         ,NIVIMP,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER   NGI,ADRVOI,IDLVOI,NGJ,ADRVOJ,JDLVOI,NGK,KDLVOI,NBVOIS
     &        ,JDEG,MDEG,NBIMP
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Rdlvoi*')
*
*     Boucle sur les noeuds
*
      DO 5 NGI=1,NBTPTG
         ADRVOI=ADVOIS(NGI)
         NBVOIS=NEVOIS(ADRVOI)
*
*        Classement des noeuds voisins du noeud NGI par degre croissant
*
         DO 3 IDLVOI=1,NBVOIS-1
            MDEG=MXDEG+1
*
            DO 1 JDLVOI=IDLVOI,NBVOIS
               NGJ=NEVOIS(ADRVOI+JDLVOI)
               JDEG=NEVOIS(ADVOIS(NGJ))
               IF (JDEG.LT.MDEG) THEN
                  KDLVOI=JDLVOI
                  MDEG=JDEG
               ENDIF
1           CONTINUE
            IF (MDEG.EQ.MXDEG+1) THEN
               WRITE (*,*) 'NGI =',NGI,' IDLVOI =',IDLVOI,' MDEG =',MDEG
               WRITE (*,*) NBVOIS,' voisins :'
               WRITE (*,*) (NEVOIS(NGK),NGK=ADRVOI+1,ADRVOI+NBVOIS)
               CALL BAISE  ('*RDlTri* Degre maximum incorrect')
            ENDIF
*
*           Echange du noeud courant et du noeud de plus petit degre
*           parmi les voisins du noeud NGI courant
            NGK                  =NEVOIS(ADRVOI+KDLVOI)
            NEVOIS(ADRVOI+KDLVOI)=NEVOIS(ADRVOI+IDLVOI)
            NEVOIS(ADRVOI+IDLVOI)=NGK
3        CONTINUE
5     CONTINUE
*
*     Verification
      DO 9 NGI=1,NBTPTG
         ADRVOI=ADVOIS(NGI)
         NBVOIS=NEVOIS(ADRVOI)
         ADRVOI=ADRVOI+1
         KDLVOI=NEVOIS(ADRVOI)
         DO 7 IDLVOI=1,NBVOIS-1
           JDLVOI=KDLVOI
           ADRVOI=ADRVOI+1
           KDLVOI=NEVOIS(ADRVOI)
           IF (NEVOIS(ADVOIS(JDLVOI)).GT.NEVOIS(ADVOIS(KDLVOI)))
     &        CALL BAISE  ('*RDlTri* Incoherence dans la numerotation')
7        CONTINUE
9     CONTINUE
      CALL PRFXMJ (-1,'*Rdlvoi*')
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.9) RETURN
*-----------------------------------------------------------------------
*     Impressions
      IF (NIVIMP.GT.0) WRITE (IMPFCH,10000) PRFXAS(0)
      NBIMP=10*NIVIMP
      IF (NIVIMP.GE.10) NBIMP=NBTPTG
      DO 9000 NGI=1,NBIMP
         ADRVOI=ADVOIS(NGI)
         WRITE (IMPFCH,10001) NGI
     &            ,(NEVOIS(ADRVOJ),ADRVOJ=ADRVOI,ADRVOI+NEVOIS(ADRVOI))
9000  CONTINUE
10000 FORMAT(/A8,'>*RDlTri* Impression (2) de NEVOIS',/
     &'  Noeud  NbVoisins  Listes des noeuds voisins')
10001 FORMAT(I6,' : ',I6,' voisins',/(20I10))
                                                                    END !RDlTri
