*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M2UTYP (NBDODS,ADRDOM,INCNDO,MIXTE,NBNEDS,NBELDS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification : D.Martin (15 Aout 2002)
* Version 1.0.4
*
* NBDODS nombre de domaines du dessin
* ADRDOM adresse des caracteristiques d'un domaine du dessin
* INCNDO nombre de caracteristiques d'un domaine du dessin
* MIXTE  indicateur de type d'elements differents dans le dessin
* NBNEDS nombre de noeuds du dessin
* NBELDS nombre d'elements du dessin
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER       NBDODS,ADRDOM,INCNDO,NBNEDS,NBELDS
      CHARACTER*(*) MIXTE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCINDS,NUTYPE,NUDOMD,NUDOMG,NUDOMK,NXLIST,NBELDO
     &             ,NBNEDO,INTERP,NDMDOM,NDMDOE,NBELD1
     &             ,LGGNDO,MCGNDO,LGSTEL,MCLIST,MCBLOK,NUTYLE
     &             ,NUTYAV,NUFAAV,NUF,NUEL,LAGHER,KCLASS,NBNEEL,NBDLEL
     &             ,NUTGEO,NUTYFA,NBNEFA,NBDLFA,NUNEFA(100),NUDLFA,ELDO
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      NUTYPE=0
      NBNEDS=0
      NBELDS=0
      DO 5 NUDOMD=1,NBDODS
         CALL TBAR1  (ERCODE,'$InfDS',1,MCINDS)
         NUDOMG=IST(ADRDOM  +MCINDS)
         NUDOMK=IST(ADRDOM+1+MCINDS)
         NXLIST=IST(ADRDOM+2+MCINDS)
         NBELDO=IST(ADRDOM+4+MCINDS)
         NBNEDO=IST(ADRDOM+5+MCINDS)
         INTERP=IST(ADRDOM+6+MCINDS)
         NDMDOM=IST(ADRDOM+7+MCINDS)
         NDMDOE=NDIM
*
         ADRDOM=ADRDOM+INCNDO
         NBNEDS=NBNEDS+NBNEDO
         NBELDS=NBELDS+NBELDO
*
         CALL TBRR2  (ERCODE,'#RGNDO',NUDOMK,LGGNDO
     &                      ,'#ISTEL',NUDOMG,LGSTEL)
         IF (NBBBLK.GE.2) CALL TBRR1  (ERCODE,'#LOKEL',1,MCBLOK)
         CALL TBAR2  (ERCODE,'#RGNDO',NUDOMK,MCGNDO
     &                      ,'#ISTEL',NUDOMG,MCLIST)
         MCBLOK=MCLIST
         IF (NBBBLK.GE.2) CALL TBAR1  (ERCODE,'#LOKEL',1,MCBLOK)
*
*        Boucle sur les elements du domaine
         NUTYAV=0
         NUFAAV=0
         NUF=0
         DO 1 ELDO=1,NBELDO
            CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MCLIST),IST(MCBLOK)
     &                  ,NUTGEO,INTERP,NUEL,NUTYAV,NUTYLE,LAGHER
     &                  ,KCLASS,NBNEEL,NBDLEL,NUF,NUFAAV,NUTYFA
     &                  ,NBNEFA,NBDLFA,NUNEFA,NUDLFA,0,IMPSDR)          !sdexplo
            IF (ELDO.EQ.1) THEN
               NUTYPE=NUTYLE
            ELSEIF (NUTYPE.NE.NUTYLE) THEN
               MIXTE='MIXTE'
               NUTYPE=NUTYLE
            ENDIF
*
1        CONTINUE
         CALL TBSAVE ('#ISTEL',NUDOMG)
         CALL TBSAVE ('#RGNDO',NUDOMK)
*
5     CONTINUE


                                                                    END !M2uTyp
