*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCPARA (MOI,NBEUX,NBPROC,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & L.Anne (Mai 1997) 
* Derniere modification : D.Martin (30 Juin 1997)
*  
* Prise en compte d'un calcul sur machines paralleles
*  
* MOI    numero du processeur courant
* NBEUX  nombre de processeurs voisins du proc. courant
* NBPROC nombre de processeurs
* NIVIMP,IMPMES quincaillerie habituelle
*
*-- Mots-cles de la directive 'PARALLELE' --
*  
* PARALLELE 
*     [NOMBRE DE] PROCESSEURS &I
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          MOI,NBEUX,NBPROCNIVIMP,IMPMES
*
      CHARACTER        TEXT*4,TEXTE*80
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,IMPNIV
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   /REDCOM/TEXT(20)
      COMMON/FORMAH/MOTLU  
      EQUIVALENCE     (TEXTE,TEXT(1))
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcPara*')                                        !Utilite
*
      IMPNIV=NIVIMP
      IF (IMPMES.LE.0) IMPNIV=0
1     CALL REDLE                                                        !Redlec
      IF (IRE.NE.3) CALL REDERR (13,' ')                                !Redlec
      IF (TEXT(1).EQ.'NOMB') GOTO 1
      IF (TEXTE(1:10).NE.'PROCESSEUR') CALL REDERR (4,'PROCESSEURS')    !Redlec
            CALL REDLE                                                  !Redlec
      IF (IRE.NE.1) CALL REDERR (11,' ')                                !Redlec
      IF (IMPNIV.NE.0) WRITE (IMPMES,10001) NFIX
      NBPROC=NFIX
*
      CALL BAISE ('Calcul parallele non disponible ici.')               !Utilite
999   CALL PRFXMJ (-1,'*LcPara*')                                       !Utilite
*-----------------------------------------------------------------------
10000 FORMAT(T2,A8,'Lecture de la sous-directive : ',A)
10001 FORMAT(T6,A8,T56,' , suivi de nombre : ',I12)
10002 FORMAT(T6,A8,T56,' , suivi de nombre : ',E12.4)
10003 FORMAT(T6,A8,T56,' , suivi du mot : ',A)
                                                                    END !LcPara
