*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INTGNM (NUMBER)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1999)
* Derniere modification : D.Martin (9 Septembre 2001)
* Version 1.0.1
*
* Nom de l'integrand de numero NUMBER ('?' si non trouve)
* Name of integrand number NUMBER ('?' if not found)
*
*-- Arguments --
* NUMBER numero de l'integrand (integrand number)
*
*-- Definitions --
* NGRINT nombre de groupe d'integrands
* NBINGR nombre d'integrands dans un groupe (cumule avec les groupes precedents)
* NBCAGR nombre de caracteres des noms d'integrands des groupes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) INTGNM
      INTEGER       NUMBER
*
      INTEGER       NBINTA,NBINTG,NBINTK,NBCARG,KLI,NWMBER
      CHARACTER     CPLOUC*120
      COMMON/ONSEPA/CPLOUC
*
      INCLUDE 'intgroups.h'
*-----------------------------------------------------------------------
      NBINTA=0
      NBINTG=0
      INTGNM='?'
      DO 1 KLI=1,NGRINT
*
         NBINTG=NBINGR(KLI)-NBINTA
         NBINTK=NBINTA+NBINTG
         NBCARG=NBCAGR(KLI)
         IF (NBCARG.GT.0) THEN
*
            IF (NUMBER.LE.NBINTK) THEN
*
               CPLOUC=NMINGR (KLI)
               NWMBER=NUMBER-NBINTA
               INTGNM=CPLOUC(1+NBCARG*(NWMBER-1):NBCARG*(NWMBER))
               RETURN
            ENDIF
*
         ENDIF
         NBINTA=NBINTK
*
1     CONTINUE
                                                                    END !IntgNm
