*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRINTG (NOMINT,NBLIGP,NBCOLP,NBCOLO
     &                  ,REOUCO,RCOEFF,CCOEFF,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1988)
* Derniere modification : D.Martin (15 Janvier 2001)
* Version 1.0.1
*  
* Impression d'une matrice elementaire a inconnues scalaires
*  
*-- Arguments --
* NOMINT chaine de caracteres definissant l'integrale elementaire
* NBLIGP premiere dimension du tableau RCOEFF (stocke 'a la fortran')
*        = Nombre de lignes de la matrice elementaire
* NBCOLP nombre de colonnes de la matrice elementaire
* NBCOLO =0 impression de la partie triangulaire inferieure, =NBCOLP sinon
* RCOEFF tableau contenant la matrice elementaire transposee, cas reelle
* CCOEFF tableau contenant la matrice elementaire transposee, cas complexe
* IMPFCH numero du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINT,REOUCO
      INTEGER       NBLIGP,NBCOLP,NBCOLO,IMPFCH
      REAL          RCOEFF(NBLIGP,*)
      COMPLEX       CCOEFF(NBLIGP,*)
*
      INTEGER       J,I
*-----------------------------------------------------------------------
      IF (REOUCO(1:1).EQ.'R') THEN
         WRITE(IMPFCH,10020) NOMINT,(J,J=1,NBCOLP)
         DO 1002 I=1,NBLIGP
            WRITE (IMPFCH,10021) I
     &           ,(RCOEFF(I,J),J=1,MAX(NBCOLO,MIN(I,NBCOLP)))
1002     CONTINUE
      ELSEIF (REOUCO(1:1).EQ.'C') THEN
         WRITE (IMPFCH,10040) NOMINT,(J,J=1,NBCOLP)
         DO 1004 I=1,NBLIGP
            WRITE (IMPFCH,10041) I
     &           ,(CCOEFF(I,J),J=1,MAX(NBCOLO,MIN(I,NBCOLP)))
1004     CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10020 FORMAT(T6,'Integrand ',A/
     &T16,10('j=',I4,:,TR5)/(T10,'...   ',10('j=',I4,:,TR5)))
10021 FORMAT(T4,'i=',I4,' : ',10E11.4,:/(T10,'...',10E11.4,:))
10040 FORMAT(T6,'Integrand ',A,/T10,5('j=',I4,15('-'),:,TR1),
     &/(T10,'...   ',5('j=',I2,15('-'),:,TR3)))  
10041 FORMAT(T4,'i=',SS,I4,' : ',5(SS,E11.4,SP,E10.4,'*i'),:  
     &/(T10,'...',5(SS,E11.4,SP,E10.4,'*i'),:))
                                                                    END !Printg
