*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCINTG (NUINTG,NIVIMP,IMPMES)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.DeBayser (Fevrier 1989) 
* Derniere modification : D.Martin (29 Juin 1997)
* Version 1.0.0
*  
* LeCture du nom de l'INTeGrand pour un terme 'element fini'
*  
*-- Arguments d'entree -- 
* NIVIMP niveau d'impression des directives
* IMPMES unite d'impression des messages  
*-- Argument de sortie -- 
* NUINTG numero de l'integrand
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NUINTG,NIVIMP,IMPMES
*  
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80
      INTEGER          INTGKL
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcIntg*')
*  
1     CALL REDLE
      IF (TEXTE(1:4).EQ.'TYPE') GOTO 1
      IF (IRE.NE.4) CALL REDERR (14,' ')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &   WRITE (IMPMES,10004) '*Lcintg*',NCAR,TEXTE(1:NCAR)
      NUINTG=INTGKL (TEXTE(1:NCAR))                                     !integra
      CALL REDLE
*  
      CALL PRFXMJ (-1,'*LcIntg*')
*-----------------------------------------------------------------------
10004 FORMAT(T12,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
                                                                    END !LcIntg
