*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCSYME  (ISYM,NDIM,VARIAB,NBCNVE,ISYMGR,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (Novembre 1989) 
* Derniere modification : D.Martin (29 Juin 1997)
* Version # 1.0.0
*  
* LeCture de la nature des SYMEtries ou Antisymetries  
*  
*-- Arguments d'entree -- 
* ISYM   vaut 2 si on a lu SYMETRIE, 1 si on a lu ANTISYMETRIE
* NDIM   dimension d'espace
* VARIAB tableau des noms des variables d'espace  
* NBCNVE nombre de caracteres par nom de variable d'espace
* IMPMES unite d'impression des messages  
*-- Argument de sortie -- 
* ISYMGR: Indice des symetries declarees
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- Mots-cles de la Directive SYMETRIE ou ANTISYMETRIE --
*  
*           ( + <SYMETRIE/ANTISYMETRIE> EN (LA) (VARIABLE) &C  )
*           ==> pas de symetrie par defaut 
*  
*-- Codage du parametre ISYMGR -- 
* La puissance de 10 indique la variable d'espace rangee de G a D  
* Le poids correspondant indique si c'est : Symetrique     2
*                                           Antisymetrique 1
*                                           Rien           0
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    VARIAB(*)
      INTEGER          ISYM,NDIM,NBCNVE,ISYMGR,NIVIMP,IMPMES
*
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,NUVAR,KELCHN
      CHARACTER        TEXTE*80 
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Lcsyme*')
1     CALL REDLE
      IF (IRE.NE.4) GOTO 99999 
      NUVAR=KELCHN (TEXTE(1:NCAR),VARIAB,NDIM,NBCNVE)                   !Utilite
      IF (NUVAR.EQ.0) GOTO 99999
      IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &    WRITE (IMPMES,10004) '*Lcsyme*',NCAR,TEXTE(1:NCAR)
      ISYMGR=ISYMGR+(10**(NDIM-NUVAR))*ISYM
      GOTO 1  
99999 CALL PRFXMJ (-1,'*Lcsyme*')  
*-----------------------------------------------------------------------
10004 FORMAT(T2,A8,T56,' , suivi de la chaine (*',I2,') : ',A) 
                                                                    END !Lcsyme
