*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECDESG (NUMFIC,NDIM,NMVARE,NBCNVE,NBTEL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification (D.Martin) le 27 Mars 1996
*
* Ecriture de la description globale du maillage 
* (noms des variables d'espaces, nombre d'elements)
*
*-- Arguments --
* NUMFIC numero d'unite logique du fichier de maillage
* NDIM   dimension d'espace
* NMVARE tableau des caracteres contenant les noms des variables d'espace
* NBCNVE nombre de caracteres par nom de variable d'espace
* NBTEL  nombre d'elements
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     NMVARE(*)
      INTEGER       NUMFIC,NDIM,NBCNVE,NBTEL
*
      CHARACTER     ERCODE *120,QUOTE
      INTEGER       I,J
      COMMON/FORMAH/ERCODE
      DATA          QUOTE/''''/
*-----------------------------------------------------------------------
*     WRITE (NUMFIC,*) '*'
*     WRITE (NUMFIC,*) '*** Description du maillage ***'
*     WRITE (NUMFIC,*) '*'
      WRITE (NUMFIC,*) 'DESCRIPTION GLOBALE DU MAILLAGE'
*
      WRITE (NUMFIC,*) '   VARIABLES D',QUOTE,QUOTE,'ESPACE '
     &,(' ',QUOTE,(NMVARE(I),I=1+NBCNVE*(J-1),1+NBCNVE*J-1),QUOTE
     &,J=1,NDIM)
*
      WRITE (NUMFIC,*) '   NOMBRE D',QUOTE,QUOTE,'ELEMENTS',NBTEL
*-----------------------------------------------------------------------
                                                                    END !EcDesg
