*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECFORM (NUMFIC,FORMAC,FORMAN,AVESAN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (27 Mars 1996)
* Version 1.0.0
*
* Ecriture des mots cles de la directives FORMAT DE LECTURE
*
*-- Arguments --
* NUMFIC numero d'unite logique du fichier de maillage
* FORMAC format de lecture des coordonnees
* FORMAN format de lecture de la geometrie
* AVESAN 'AVEC' ou 'SANS' commentaire dans le fichier de maillage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) FORMAC,FORMAN,AVESAN
      INTEGER       NUMFIC
*
      CHARACTER     ERCODE *120,QUOTE
      INTEGER       LG
      COMMON/FORMAH/ERCODE
      DATA          QUOTE/''''/
*-----------------------------------------------------------------------
      LG=LEN(FORMAC)
      ERCODE=FORMAC
      WRITE (NUMFIC,10000) 'FORMAT DE LECTURE','DES COORDONNEES '
     &,QUOTE,ERCODE(1:LG),QUOTE
*
      LG=LEN(FORMAN)
      ERCODE=FORMAN
      WRITE (NUMFIC,10001) 'DE LA NUMEROTATION GLOBALE '
     &,QUOTE,ERCODE(1:LG),QUOTE
*
      IF (AVESAN(1:1).EQ.'A') WRITE (NUMFIC,10001) 'AVEC COMMENTAIRE'
      IF (AVESAN(1:1).EQ.'S') WRITE (NUMFIC,10001) 'SANS COMMENTAIRE'
*-----------------------------------------------------------------------
10000 FORMAT(T2,A,T20,A,A1,A,A1)
10001 FORMAT(T20,A,A1,A,A1)
                                                                    END !EcForm
