*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDCOOR (ULMAIL,FORMAC,NDIM,NBPTS,L,CORPTL,COMENT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1987)
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Lecture des COORdonnees des Points d'un element
*  
*-- Arguments d'entree --
* ULMAIL unite de lecture des donnees du maillage
* FORMAC format de lecture des coordonnees
* NDIM   dimension d'espace
* NBPTS  nombre de points de l'element
* L      numero de l'element dans le maillage
* COMENT lecture ou non du commentaire precedant les coordonnees
*-- Argument de sortie --
* CORPTL(IDM,IDL) tableau des coordonnees
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FORMAC
      INTEGER       ULMAIL,NDIM,NBPTS,L
      REAL          CORPTL(NDIM,*)
      LOGICAL       COMENT
*
      INTEGER       IDM,IPOINT
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdCoor*')
*     Lecture eventuelle d'une ligne commentaire 
      IF (COMENT) READ (ULMAIL,*)
*
      IF (FORMAC(1:3).EQ.'(*)'.OR.FORMAC(1:1).EQ.'*') THEN
         READ (ULMAIL,*,END=10,ERR=11)
     &        ((CORPTL(IDM,IPOINT),IDM=1,NDIM),IPOINT=1,NBPTS)
      ELSE
         READ (ULMAIL,FMT=FORMAC,END=10,ERR=11)
     &        ((CORPTL(IDM,IPOINT),IDM=1,NDIM),IPOINT=1,NBPTS)
      ENDIF
      CALL PRFXMJ (-1,'*RdCoor*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10    CALL ENCLER (L,FORMAC(1:5))
      CALL ENCLER (ULMAIL,FORMAC(6:10))
      CALL ENCLER (NBPTS,FORMAC(11:12))
      CALL BAISE  (' Erreur de lecture des coordonnees de l''element '
     &//FORMAC(1:5)//'('//FORMAC(11:12)//' points) sur l''unite '
     &//FORMAC(6:10))
11    CALL ENCLER (L,FORMAC(1:5))
      CALL ENCLER (ULMAIL,FORMAC(6:10))
      CALL BAISE  (' Fin de fichier dans la lecture des coordonnees'
     &//' de l''element '//FORMAC(1:5)//' sur l''unite '//FORMAC(6:10))
                                                                    END !RdCoor
