*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GREEN (TYNOYO,TABCSG,CORP,CORM,E,TABASS)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)
* Derniere modification (D.Martin) le 14 juin 1994
*
* Calcul de la fonction de Green en un couple de point (P,M)
*
*-- Arguments d'entree --
* TYNOYO type de calcul du noyau
*        'DIRICHLET' calcul de G(M,P), dG/dxm(M,P)
*        'NEUMANN'   calcul de dG/dxp(M,P), d2G/dxpdxm(M,P)
*        'FOURIER'   calcul de G(M,P), dG/dxm(M,P), dG/dxp(M,P), d2G/dxpdxm(M,P)
* TABCSG tableau contenant les valeurs necessaires au calcul (constante(s), ..)
* CORP   coordonnees du point P
* CORM   coordonnees du point M (source)
* E      tableau recepteur de la valeur de la fonction de Green,
*        de ses derivees par aux coordonnees de P et M
*        et dans le cas 'FOURIER' ou 'NEUMANN' de ses derivees secondes croisees
* TABASS tableau associe servant a vehiculer n'importe qu'elle information
*        son contenu est a l'entiere discretion de l'utilisateur.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      COMPLEX       TABCSG(*),E(*),TABASS(*)
      REAL          CORP(*),CORM(*)
*-----------------------------------------------------------------------
      CALL BAISE  (' <Modeles/Green> Vous avez oublie de fournir la proc
     &edure ''utilisateur'' : ''GREEN'' ')                              !Utilite
                                                                    END !Green

