*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MOATRL (IANOP5,NOP5,IAMAIL,MAIL,MAIC,NCACAR
     &                  ,NCGE,NMAE,NDSDE,NNO,NTYE,NTALIR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1993)
* Derniere modification : D.Martin (2 Mars 1995)
* Version 1.0.0
*
* Recherche des attributs d'un element dans le tableau NOP5 d'une NOPO 
* ou les tableaux MAIC et MAIL d'une structure MAIL
*
*-- Arguments d'entree --
* IANOP5 adresse de l'element dans le tableau NOP5 (i.e. NCGE=NOP5(IANOP5))
*        est actualise en sortie et pointe sur le tableau des numeros globaux
*        des noeuds de l'element (i.e. NNO=NOP5(IANOP5-1)
* NOP5   tableau NOP5 a son adresse initiale
* IAMAIL adresse de l'element dans le tableau MAIL (i.e. NEL=MAIL(IAMAIL))
*        est actualise en sortie et pointe sur le tableau des numeros globaux
*        des noeuds de l'element (i.e. NNO=NOP5(IAMAIL-1)
* MAIL   tableau MAIL a son adresse initiale
* MAIC   tableau MAIC a son adresse initiale
* NCACAR
*-- Arguments de sortie --
* NCGE   numero de code geometrique Modulef de l'element
* NMAE   longueur du tableau des nuemros de reference de l'element
* NDSDE  numero de sous-domaine de l'element
* NNO    nombre de noeuds de l'element
* NTYE   numero de type de l'element dans une structure MAIL
* NTALIR nombre de tableau associes dans une structure MAIL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IANOP5,NOP5(*),IAMAIL,MAIC(*),MAIL(*),NCACAR
     &       ,NCGE,NMAE,NDSDE,NNO,NTYE,NTALIR
*
      INTEGER NUEL
*-----------------------------------------------------------------------
      IF (IANOP5.GT.0) THEN
*
         NTYE  =0
         NCGE  =NOP5(IANOP5)   
         NMAE  =NOP5(IANOP5+1) 
         NDSDE =NOP5(IANOP5+2)
         NTALIR=0
         IANOP5=IANOP5+4   
         NNO   =NOP5(IANOP5-1)
*
      ELSEIF (IAMAIL.GT.0) THEN
*
         NUEL  =MAIL(IAMAIL)
         NTYE  =MAIL(IAMAIL+1)
         NCGE  =MAIC(NTYE)   
         NMAE  =MAIL(IAMAIL+2)
         NDSDE =MAIL(IAMAIL+3)
         NTALIR=MAIL(IAMAIL+4)   
         IAMAIL=IAMAIL+6
         IF(NCACAR.NE.0) IAMAIL=IAMAIL+1
         NNO   =MAIL(IAMAIL-1)
*
      ENDIF
                                                                    END !MoAtrL
