*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NME2MO (TYPE,NBNOEU,NULOMO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)  
* Derniere modification : D.Martin (26 Avril 1993)
* Version 1.0.0
*   
* Passage de la numerotation locale 'Melina' d'un element a la numerotation 
* locale 'Modulef' en fonction du type d'un element MELINA   
*
* TYPE   chaine de caracteres definissant le type Melina
* NBNOEU nombre de noeuds de l'element
* NULOMO numeros locaux des noeuds dans l'element Modulef
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBNOEU,NULOMO(*)
*   
      INTEGER       NHEXAE(27),NPRISM(18),I
      DATA NHEXAE/1,2,3,4,5,6,7,8,9,10,11,12,17,18,19,20,13,14,15,16,   
     *           21,23,25,26,22,24,27/  
      DATA NPRISM/1,2,3,4,5,6,7,8,9,13,14,15,10,11,12,17,18,16/ 
*-----------------------------------------------------------------------
      IF(TYPE(:2).EQ.'HE') THEN
         DO 3000 I=1,NBNOEU   
3000        NULOMO(I)=NHEXAE(I)   
      ELSE IF(TYPE(:2).EQ.'PR') THEN 
         DO 3100 I=1,NBNOEU   
3100        NULOMO(I)=NPRISM(I)  
      ELSE IF(TYPE(:2).EQ.'TE') THEN 
         DO 3200 I=1,NBNOEU   
3200        NULOMO(I)=I
      ELSE IF(TYPE(:2).EQ.'QU'.OR.TYPE(:2).EQ.'TR') THEN   
         DO 2000 I=1,NBNOEU   
2000        NULOMO(I)=I  
      ELSE IF(TYPE(:2).EQ.'SE') THEN
         DO 1000 I=1,NBNOEU
1000        NULOMO(I)=I
      END IF 
                                                                    END !NMe2Mo
