*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDREFE (AST,IST,NDIM,NBDOMG,NCHDOM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin 
* Derniere modification : D.Martin (30 Novembre 1999)
* Version 1.0.0
* 
* Construction des numero de references de Modulef
* en vue de la creation d'une Structure de donnees "NOPO".  
*   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     AST(*)
      INTEGER       IST(*),NDIM,NBDOMG,NCHDOM
*
      INTEGER       NUREF,NDSD,IDOM,MCLIST,MCMDOM,MCREFE,NDMDOM,NBELDO
     *             ,NXLIST,NBNEEX,NBDLEX,NBNEFX,NBDLFX,I
      CHARACTER     ERCODE*120,MODREF*8
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(113:113),MODREF)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdRefe*')
*
1     WRITE (*,*) '> Modifier les numeros de sous-domaines et de '
      WRITE (*,*) '> reference, affectes par defaut dans l''ordre'
      WRITE (*,*) '> des numeros de domaine ? (oui/non)'
      READ  (*,'(A)') MODREF
      IF(MODREF(1:1).EQ.'o'.OR.MODREF(1:1).EQ.'O'.OR.MODREF(1:1).EQ.'y')
     & MODREF='Y'
      NUREF=0  
      NDSD =0  
*
      IF (MODREF(1:1).NE.'Y') THEN
         DO 5  IDOM=1,NBDOMG
            CALL TBRR1  (ERCODE,'#ISTEL',IDOM,MCLIST)
            CALL TBAR2  (ERCODE,'#ISTEL',IDOM,MCLIST,'#urefe',0,MCREFE)
            CALL EXLIST (IST(MCLIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &                  ,NBNEEX,NBDLEX,NBNEFX,NBDLFX)                   !sdexplo
            IF (NDMDOM.EQ.NDIM) THEN
               NDSD=NDSD+1
               IST(MCREFE-1+IDOM)=NDSD
            ELSE
               NUREF=NUREF+1
               IST(MCREFE-1+IDOM)=NUREF
           ENDIF
5        CONTINUE
      ELSE
         DO 10 IDOM=1,NBDOMG
            CALL TBRR1  (ERCODE,'#ISTEL',IDOM,MCLIST)
            CALL TBAR3  (ERCODE,'#ISTEL',IDOM,MCLIST,'#urefe',0,MCREFE
     &                         ,'#OMDOM',1   ,MCMDOM)
            CALL EXLIST (IST(MCLIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &                  ,NBNEEX,NBDLEX,NBNEFX,NBDLFX)                   !sdexplo
9           IF (NDMDOM.EQ.NDIM) THEN
               IF (NDIM.EQ.3) WRITE(*,10000) 'sous-domaine','volumique'
     &           ,(AST(I),I=MCMDOM+(IDOM-1)*NCHDOM,MCMDOM+IDOM*NCHDOM-1)
               IF (NDIM.EQ.2) WRITE(*,10000) 'sous-domaine','surfacique'
     &           ,(AST(I),I=MCMDOM+(IDOM-1)*NCHDOM,MCMDOM+IDOM*NCHDOM-1)
            ELSEIF (NDMDOM.EQ.2) THEN
                  WRITE(*,10000) 'reference','surfacique'
     &           ,(AST(I),I=MCMDOM+(IDOM-1)*NCHDOM,MCMDOM+IDOM*NCHDOM-1)
            ELSEIF (NDMDOM.EQ.1) THEN
               WRITE(*,10000) 'reference','lineique'
     &           ,(AST(I),I=MCMDOM+(IDOM-1)*NCHDOM,MCMDOM+IDOM*NCHDOM-1)
            ELSEIF (NDMDOM.EQ.0) THEN
               WRITE (*,10000) 'reference','ponctuel'
     &           ,(AST(I),I=MCMDOM+(IDOM-1)*NCHDOM,MCMDOM+IDOM*NCHDOM-1)     
            ENDIF
            READ (*,*,ERR=9) IST(MCREFE-1+IDOM)
10       CONTINUE
      ENDIF
*
      CALL TBAR1  (ERCODE,'#OMDOM',1,MCMDOM)
      WRITE(*,*) '> Numeros de sous-domaines ou de references choisis :'
      WRITE(*,*) '  -------------------------------------------------'
      DO 20 IDOM=1,NBDOMG
      WRITE (*,10010) IST(MCREFE-1+IDOM)
     &               ,(AST(I),I=MCMDOM,MCMDOM+NCHDOM-1)
      MCMDOM=MCMDOM+NCHDOM
20    CONTINUE
      WRITE (*,*) '> Les modifier ? (oui/non)'
      WRITE (*,*) ' '
      READ (*,'(A)') MODREF
      IF(MODREF(1:1).EQ.'o'.OR.MODREF(1:1).EQ.'O'.OR.MODREF(1:1).EQ.'y') 
     & MODREF='Y'
      IF (MODREF(1:1).EQ.'Y') GOTO 1
      CALL PRFXMJ (-1,'*RdRefe*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10000 FORMAT(T2,'Donner le numero de ',A,' du domaine ',A,' : ',50(A1))
10010 FORMAT(T4,'Numero : ',I4,'  pour le domaine ',50(A1))
                                                                    END !RdRefe
