*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M L 2 P L (TYPMAT,NBNELI,NBNECO,NULAPL,IPLAGE  
     *                                           ,MCTBML,MCTPLE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 92)  
* Derniere modification (O.DeBayser) le 15 Mai 1992
*  
*     Transformation d'une matrice stockee compactee bimorse  en une  
*     matrice pleine (i.e. dans son stockage 'naturel' : decompactage) 
*            BML2PL -> BiMorse L(triangle inferieur) 'To' PLein
*  
*** Arguments ***  
* TYPMAT: Type de declaration de la matrice
* NBNELI: Nombre de noeuds 'en ligne' de la matrice
* NBNECO: Nombre de noeuds 'en colonne' de la matrice 
* NULAPL: tableau des numeros de derniere des lignes
* IPLAGE: tableau des numeros de debut de plage et des longueurs cumulees  
* MCTBML: Adresse dde L(inf) de la matrice stockee sous forme 'BiMorse'  
* MCTPLE: Adresse de la matrice decompactee
* RST,CST Super-tableaux habituels
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPMAT
      INTEGER       NULAPL(*),IPLAGE(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
* 
      NUDRPL=0 
      LIOUC1=1
      LGCUMU=0
      MCBB=MCTBML
      MCPP=MCTPLE-1+NBNECO  
*
      IF(TYPMAT(1:1).EQ.'C') THEN
*        Parcours des noeuds 'en ligne' de la matrice 
         DO 11 LIOUCO=2,NBNELI  
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIOUC1)
            IF(NUDRPL.GE.NUPRPL) THEN
*              Numero de colonne du premier coefficient de la ligne
               KOLON1=IPLAGE(1,NUPRPL)
*              Adresse du premier coeff. de la ligne dans le resultat
               MCP1=MCPP+KOLON1
               DO 10 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGE(1,NUPLA)
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  MCP   =MCP1+KOLDEB-KOLON1
                  DO 10 KOLON=KOLDEB,KOLFIN
                     CST(MCP)=CST(MCBB)
                     MCBB=MCBB+1
10                   MCP=MCP+1
            END IF
            MCPP=MCPP+NBNECO
11          LIOUC1=LIOUCO
      ELSE
*        Parcours des noeuds 'en ligne' de la matrice 
         DO 21 LIOUCO=2,NBNELI  
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIOUC1)
            IF(NUDRPL.GE.NUPRPL) THEN
*              Numero de colonne du premier coefficient de la ligne
               KOLON1=IPLAGE(1,NUPRPL)
*              Adresse du premier coeff. de la ligne
               MCP1=MCPP+KOLON1
               DO 20 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGE(1,NUPLA)
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  MCP   =MCP1+KOLDEB-KOLON1
                  DO 20 KOLON=KOLDEB,KOLFIN
                     RST(MCP)=RST(MCBB)
                     MCBB=MCBB+1
20                   MCP=MCP+1
            END IF
            MCPP=MCPP+NBNECO
21          LIOUC1=LIOUCO
      ENDIF
*
                                                                    END *BmL2Pl*
