*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE C M P C A T (INTPLA,NBNELI,NULAPL,IPLAGE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1989)
* Derniere modification (D.Martin) le 10 Fevrier 1992
*   
*   Concatenation des plages dont la distance est inferieure ou egal a INTPLA   
*   
*** Arguments ***   
* INTPLA: Interplage pour laquelle on concatene les plages  
* NBNELI: Nombre de lignes de la matrice
* NULAPL: Tableau des numeros de derniere plage de chaque ligne 
* IPLAGE: Pointeurs des plages  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPL(*),IPLAGE(2,*) 
*   
*     Recherche des plages susceptibles d'etre concatenees  
*   
      NUMPL1=1  
      NBPLVR=0  
      LOCUPL=0
      LENPLU=0
      LIGNAC=0
      NBPLAJ=NULAPL(NBNELI)
      DO 1 I=1,NBNELI   
         NUMPL2=NULAPL(I)  
         NULAPL(I)=NULAPL(I)-NBPLVR 
         DO 2 NUMPLA=NUMPL1,NUMPL2-1
            LGPLAG=IPLAGE(2,NUMPLA)-LOCUPL  
            IGNACE=IPLAGE(1,NUMPLA+1)-(IPLAGE(1,NUMPLA)+LGPLAG) 
            IF(IGNACE.GT.INTPLA) THEN
*              mise a jour pour la plage NUMPLA
               IPLAGE(2,NUMPLA)=IPLAGE(2,NUMPLA)+LENPLU
               LENPLU=LENPLU+LIGNAC
               LIGNAC=0
            ELSE
*              La plage NUMPLA+1 prend les attributs de la plage NUMPLA 
               IPLAGE(2,NUMPLA+1)=IPLAGE(2,NUMPLA+1)+IGNACE 
               IPLAGE(1,NUMPLA+1)=IPLAGE(1,NUMPLA)  
*              La plage NUMPLA est la NBPLVR-ieme plage a virer 
               NBPLVR=NBPLVR+1 
*              Changement provisoire de signification  de IPLAGE(1,...)
*              pour les plages supprimees
               IPLAGE(1,NUMPLA)=NBPLVR  
               IPLAGE(2,NUMPLA)=0   
               NULAPL(I)=NULAPL(I)-1
               LGPLAG=0 
               LIGNAC=LIGNAC+IGNACE
            ENDIF
2           LOCUPL=LOCUPL+LGPLAG
1        NUMPL1=NUMPL2+1
*   
*     Suppression des NBPLVR plages concatenees avec leur suivante  
*   
      NUMPLA=0  
3     NUMPLA=NUMPLA+1   
      IF(NUMPLA.GT.NBPLAJ) GO TO 99999  
      IF(IPLAGE(2,NUMPLA).GT.0) GO TO 3 
4     NBPLVR=IPLAGE(1,NUMPLA)   
5     NUMPLA=NUMPLA+1   
      IF(NUMPLA.GT.NBPLAJ) GO TO 99999  
      IF(IPLAGE(2,NUMPLA).EQ.0) GO TO 4 
      IPLAGE(1,NUMPLA-NBPLVR)=IPLAGE(1,NUMPLA)  
      IPLAGE(2,NUMPLA-NBPLVR)=IPLAGE(2,NUMPLA)  
      GO TO 5   
99999 CONTINUE  
                                                                    END *CmpCat*
