*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE N2DLPR (NCPINC,NCPINL,NBNELI,NBNECO,LENV,NBLIDL,LENVDL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 93)  
* Derniere modification (O.DeBayser) le 18 Janvier 1993  
*  
* Creation du tableau de stockage PROFIL en d.l. pour une inconnue
* vectorielle a partir du tableau de stockage PROFIL en noeud
*  
*** Arguments d'entree ***
* NCPINC nombre de composantes de l'inconnue vectorielle en colonne
* NCPINL nombre de composantes de l'inconnue vectorielle en ligne
* NBNELI nombre de lignes en noeud
* NBNECO nombre de colonnes en noeud
* LENV   adresse du 1er coef. non nul de la ligne
* NBLIDL nombre de lignes en noeud
* LENVDL adresse des 1er coef. non nuls de la ligne en d.l. vectoriel
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPINC,NCPINL,NBNELI,NBNECO,LENV(*),NBLIDL,LENVDL(*)
*
      INTEGER IADL, IDLV,LENVAV,LIGNE,IANE,LGLIGN
*-----------------------------------------------------------------------
      IADL=1
*
*     Lignes supplementaires correspondant aux d.l. du premier noeud en ligne
      DO 10 IDLV=2,NCPINL
         LENVDL(IDLV-1)=IADL
         IADL=IADL+IDLV-1
10    CONTINUE
*
      NBLIDL=NCPINL
      LENVAV=LENV(1) 
*
*     Les lignes supplementaires correspondant aux d.l. des noeuds en ligne
*     ne contenant que des coeff. diagonaux (en noeud) sont prises en compte
*
      DO 20 LIGNE=2,NBNELI
         IANE  =LENV(LIGNE)
         LGLIGN=IANE-LENVAV
         DO 18 IDLV=1,NCPINL
            LENVDL(NBLIDL)=IADL
            NBLIDL=NBLIDL+1
            IADL=IADL+LGLIGN*NCPINC+IDLV-1
18       CONTINUE
         LENVAV=IANE
20    CONTINUE
      LENVDL(NBLIDL)=IADL
                                                                    END !N2DlPr
