*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  PL2BML (LIOUCO,COOULI,BMORSE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992) 
* Derniere modification : D.Martin (8 Novembre 1999)
*  
* Construction de la table de stockage Bi-Morse inferieure (resp. superieure)
* d'une matrice stockee pleine (non necessairement carree).
*  
*-- Arguments --
* LIOUCO nombre de lignes (resp. colonnes)
* COOULI nombre de colonnes (resp. lignes)
* BMORSE tableau contenant la structure Bi-Morse inferieure (resp. superieure)
*        a construire a partir de l'adresse contenant le nombre de lignes
*        (resp. colonnes)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER LIOUCO,COOULI,BMORSE(*)
*
      INTEGER ADRS,I,LGCUAV
*-----------------------------------------------------------------------
*     Nombre de lignes (resp. colonnes)
      BMORSE(1)=LIOUCO
*     Numero des dernieres plages de chaque ligne (resp. colonne)
      DO 1 ADRS=2,LIOUCO
         BMORSE(ADRS)=ADRS-1
1     CONTINUE
*     Numero de colonne (resp. ligne) de debut de plage et adresse
*     du dernier coefficient de chaque plage. 
      LGCUAV=1
      DO 2 I=2,LIOUCO
         BMORSE(ADRS)  =1
         BMORSE(ADRS+1)=LGCUAV
         ADRS          =ADRS+2
         LGCUAV        =LGCUAV+MIN(COOULI,I)
2     CONTINUE
                                                                    END !Pl2Bml
