*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PLVC (NBLIGM,NBCOLM,TYMATR,MCMATR
     &                ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993) 
* Derniere modification : D.Martin (30 octobre 1998)
*  
* Produit AxV d'une matrice A pleine (stockee 'a la Fortran') par un vecteur,
* une colonne ou une ligne d'une matrice 
* 
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* NBLIGM nombre de lignes de la matrice 
* NBCOLM nombre de colonnes de la matrice 
* TYMATR type (reel ou complexe) de la matrice
* MCMATR adresse dans le super-tableau de type adequat de la matrice  
* TYVECT type (reel ou complexe) du vecteur operande  
* MCVECT adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU type (reel ou complexe) du vecteur resultat  
* MCRESU adresse du vecteur resultat dans le super-tableau adequat
* RST,CST super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      INTEGER       NBLIGM,NBCOLM,MCMATR,MCVECT,MCRESU
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER       INCMAC,INCMAL,ADMAT1,ADMATR,ADRESU,LIGNE,ADVECT
      REAL          RSOM
      COMPLEX       CSOM
*-----------------------------------------------------------------------
      ADMAT1=MCMATR
      ADRESU=MCRESU
*     Increment dans la matrice pour changement de colonne et de ligne
      INCMAC=NBLIGM
      INCMAL=1
*  
      IF (TYMATR(1:1).EQ.'R') THEN
*  
         IF (TYVECT(1:1).EQ.'R') THEN
            IF (TYRESU(1:1).EQ.'R') THEN 
               DO 222 LIGNE=1,NBLIGM
                  RSOM=0.
                  ADMATR=ADMAT1 
                  DO 221 ADVECT=MCVECT,MCVECT-1+NBCOLM
                     RSOM=RSOM+RST(ADMATR)*RST(ADVECT)
                     ADMATR=ADMATR+INCMAC
221               CONTINUE
                  ADMAT1=ADMAT1+INCMAL
                  RST(ADRESU)=RSOM
                  ADRESU=ADRESU+1
222            CONTINUE 
            ELSE
               DO 224 LIGNE=1,NBLIGM
                  CSOM=0.
                  ADMATR=ADMAT1  
                  DO 223 ADVECT=MCVECT,MCVECT-1+NBCOLM
                     CSOM=CSOM+RST(ADMATR)*RST(ADVECT)
                     ADMATR=ADMATR+INCMAC
223               CONTINUE
                  ADMAT1=ADMAT1+INCMAL  
                  CST(ADRESU)=CSOM
                  ADRESU=ADRESU+1
224            CONTINUE
            ENDIF
         ELSE  
            IF (TYRESU(1:1).NE.'C') GOTO 90002 
            DO 244 LIGNE=1,NBLIGM
               CSOM=0.
               ADMATR=ADMAT1  
               DO 243 ADVECT=MCVECT,MCVECT-1+NBCOLM
                  CSOM=CSOM+RST(ADMATR)*CST(ADVECT)
                  ADMATR=ADMATR+INCMAC
243            CONTINUE
               ADMAT1=ADMAT1+INCMAL
               CST(ADRESU)=CSOM  
               ADRESU=ADRESU+1
244         CONTINUE 
         ENDIF
      ELSE  
         IF (TYRESU(1:1).NE.'C') GOTO 90002
         IF (TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=1,NBLIGM
               CSOM=0.
               ADMATR=ADMAT1  
               DO 443 ADVECT=MCVECT,MCVECT-1+NBCOLM
                  CSOM=CSOM+CST(ADMATR)*CST(ADVECT)  
                  ADMATR=ADMATR+INCMAC 
443            CONTINUE
               ADMAT1=ADMAT1+INCMAL
               CST(ADRESU)=CSOM  
               ADRESU=ADRESU+1
444         CONTINUE 
         ELSE  
            DO 424 LIGNE=1,NBLIGM
               CSOM=0.
               ADMATR=ADMAT1  
               DO 420 ADVECT=MCVECT,MCVECT-1+NBCOLM
                  CSOM=CSOM+CST(ADMATR)*RST(ADVECT)  
                  ADMATR=ADMATR+INCMAC 
420              CONTINUE
               ADMAT1=ADMAT1+INCMAL
               CST(ADRESU)=CSOM  
               ADRESU=ADRESU+1
424         CONTINUE 
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90002 CALL BAISE  ('Incompatibilite entre les types reel et complexe'
     &//' des operandes et le type REEL du resultat')
                                                                    END !Plvc
