*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE P R U V C (NBLIGN,NBCOLO,UENV,TYMATR,MCU  
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)  
* Derniere modification (D.Martin) le 16 Juil. 91
*  
*   Produit UxV d'une matrice U strictement triangulaire superieure
*   stockee sous forme 'Profil' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.  
*  
*** Arguments d'entree *** 
* NBLIGN: nombre de lignes de la matrice U
* NBCOLO: nombre de colonnes de la matrice U
* UENV  : tableau des pointeurs du profil superieur
* TYMATR: Type (reel ou complexe) de la matrice
* MCU   : adresse dans le super-tab. de type adhoc de la partie triang. sup 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       UENV(*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*
*
      MC=MCU
      DO 1 KOLON=2,NBCOLO
         MCNX=MCU-1+UENV(KOLON)  
         NBCOF=MCNX-MC
         IF(NBCOF.GT.0) THEN
            LIGNE=MIN(KOLON,NBLIGN)-NBCOF
*                 --- (Dans le cas d'une matrice rectangulaire)
            CALL TPLUAT(NBCOF,TYRESU,LIGNE,RST(MCRESU),CST(MCRESU)      !Utilite
     *                       ,TYVECT,KOLON,IST,RST(MCVECT),CST(MCVECT)  !Utilite
     *                       ,TYMATR,1     ,RST(MC)   ,CST(MC)          !Utilite
     *                       ,TYRESU,LIGNE,RST(MCRESU),CST(MCRESU))     !Utilite
         END IF
         MC=MCNX
1     CONTINUE
                                                                    END *PrUVc*
