*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRASBL (NVDSMB,NUTRMR,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (16 decembre 1998)
*  
* Impression des termes d'une structure d'assemblage multi-inconnues $DSMBL
*  
*-- Arguments d'entree -- 
* NVDSMB niveau de la structure d'assemblage
* NUTRMR numero du terme resultat
* NIVIMP niveau d'impression du terme assemble 
* IMPFCH numero d'unite logique de fichier d'impression
*-- Structure $DSMBL
* $DSMBL(1)=LGETRD (=4)
*       (2)=NBLOCC nombre de termes en colonne
*       (3)=INCTRD (=5) nb. de caracteristiques par terme de la structure
*       (4)=NBLOCL nombre de termes en ligne
* puis pour chaque terme de la structure ( . = LGETRD+INCTRD*(NUTRAS-1))
*       (.)   NUTERM numero du terme
*       (.+1) numero de l'inconnue en colonne du terme
*       (.+2) numero de l'inconnue en ligne du terme
*       (.+3) niveau de la numerotation en colonne du terme
*       (.+4) niveau de la numerotation en ligne du terme
*       (.+5) case de travail
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NVDSMB,NUTRMR,NIVIMP,IMPFCH
* 
      INCLUDE 'ALLOC'  
* 
      INTEGER   ADDSMB,MCDSMB,LGEDSM,INCDSM,NBLOCC,NBLOCL,NUBOEX,NUBOIN
     &         ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCMTRM,ADMTRM,NUTERM
     &         ,LRIPEX,NVTERM,NCATR1
      INTEGER   NIVTRM(10)
      CHARACTER THETR1*16,PRFXAF*8
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'$DSMBL',NVDSMB,MCDSMB)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTRMR,ERCODE(1:NCHTRM))
      NVTERM=IST(MCDTRM+LGETRM+INCTRM*(NUTRMR-1))
      CALL PRNTRM (ERCODE(1:NCHTRM),NVTERM,THETR1,NCATR1)
      IF (IMPFCH.GT.0) 
     &   WRITE (IMPFCH,10000) PRFXAF ( ),THETR1(1:NCATR1),NVDSMB
      IF (NBLOCC.LE.10) THEN
      LRIPEX=LGEDSM
      DO 9 NUBOEX=1,NBLOCL
         ADDSMB=MCDSMB+LRIPEX
         ADMTRM=1
         DO 1 NUBOIN=0,NBLOCC-1
            NUTERM=IST(ADDSMB)
            IF (NUTERM.GT.0) THEN
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM
     &                     ,ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM))
               NIVTRM(NUBOIN+1)=IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
            ELSE
               ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM)='$vide$'
               NIVTRM(NUBOIN+1)=-9999999
            ENDIF
            ADMTRM=ADMTRM+NCHTRM
            ADDSMB=ADDSMB+INCDSM*NBLOCL
1        CONTINUE
         WRITE (IMPFCH,10003) ('--------',NUBOIN=1,NBLOCC)
         WRITE (IMPFCH,10002) (ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM)
     &                                 ,NUBOIN=0,NBLOCC-1)
         WRITE (IMPFCH,10004) (NIVTRM(NUBOIN),NUBOIN=1,NBLOCC)
         LRIPEX=LRIPEX+INCDSM
9     CONTINUE
      WRITE (IMPFCH,10003)    ('--------',NUBOIN=1,NBLOCC)
      ENDIF
      ADDSMB=MCDSMB+LGEDSM
      DO 12 NUBOEX=1,NBLOCC
         DO 11 NUBOIN=1,NBLOCL
            NUTERM=IST(ADDSMB)
            IF (NUTERM.GT.0) THEN
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(1:NCHTRM))
               NVTERM=IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
               CALL PRNTRM (ERCODE(1:NCHTRM),NVTERM,THETR1,NCATR1)
               WRITE (IMPFCH,10001) THETR1(1:NCATR1),ADDSMB-MCDSMB+1
     &                             ,IST(ADDSMB+1),IST(ADDSMB+2)
     &                             ,IST(ADDSMB+3),IST(ADDSMB+4)
               IF (NIVIMP.GE.5)
     &            CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPFCH)
            ELSE
               WRITE (IMPFCH,10001) '$vide$',ADDSMB-MCDSMB+1
            ENDIF
            ADDSMB=ADDSMB+INCDSM
11       CONTINUE
12    CONTINUE   
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,'>*Prasbl* Structure de l''assemblage multi-inconnu'
     &,'e du terme ',A,/T20,'Structure d''assemblage de niveau ',I4/)
10001 FORMAT(/T9,'Terme ',A16,' / Ad ',I4
     &/,:,T9,'Inconnues     ',I4,TR7,I4,/,T9,'Numerotations ',I4,TR7,I4)
10002 FORMAT (T9,'|',10(' ',A6,' |',:))
10003 FORMAT (T9,'|',10(A8,'|',:))
10004 FORMAT (T9,'|',10(I7,' |',:))
                                                                    END !Prasbl
