*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLIBM (LIOUCO,L1,L2,NCPINC,NCPINL,NBCOLO,NUDRPL,IADFIN
     &                  ,NULAPL,IPLAGL,TYPE,MCD,MCL,RST,CST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991)
* Derniere modification : D.Martin (19 mai 2005)
* Version 1.4
*
* Impression d'un groupe de lignes d'une matrice 'BiMorse' inf. ou sup.
*
*-- Arguments --
* LIOUCO indicateur de ligne ('Lig.') ou colonne ('Col.')
* L1,L2  premiere et derniere plage du groupe de lignes/colonnes
* NBCOLO numero de colonne/ligne a ne pas depasser
* NUDRPL numero de la derniere plage precedent la ligne/colonne L1
* IADFIN adresse relative precedent la ligne/colonne L1 (=-1 si L1=1)
* NCPINC nombre de d.l. par noeud en colonne/ligne  (pour un stockage en noeuds)
* NCPINL nombre de d.l. par noeud en ligne/colonne
* NULAPL table des derniere plage en ligne/colonne
* IPLAGL table des descripteurs de plage
* TYPE   type de la declaration de la matrice
* MCD    adresse de la diagonale dans le super tableau du bon type 
* MCL    adresse du profil inferieur/superieur dans le super tableau du bon type
* RST,CST super-tableaux ... habituels
* IMPFCH unite logique d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIOUCO*4,TYPE
      INTEGER       L1,L2,NBCOLO,NUDRPL,IADFIN,NCPINC,NCPINL
     &             ,NULAPL(*),IPLAGL(2,*),MCD,MCL,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LIGNE,LINE,LGLIGN,NUPRPL,IADDEB,IADFFN,NUPRPI,NUDRPI
     &             ,MCDD,NBPLAI,NCFSSD,LGCUAP,ICP,I,LL1
*-----------------------------------------------------------------------
      NCFSSD=MAX (1,MIN (NCPINC,NCPINL))
      IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
      LIGNE=L1
      LL1=L1
      IF (TYPE(1:1).EQ.'R') THEN
         IF (NCPINC*NCPINL.EQ.1) THEN
            IF (L1.EQ.1) THEN
               LL1=L1+1
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
               WRITE (IMPFCH,10020) RST(MCD)
            ENDIF
            DO 20 LIGNE=LL1,L2
*               IF (NUDRPL.GE.NUPRPL) NUPRPL=NUDRPL+1
               NUPRPL=NUDRPL+1
               IADDEB=IADFIN+1
               NUDRPL=NULAPL(LIGNE-1)
               IADFIN=-1
               IF (NUDRPL.GT.0) IADFIN=IPLAGL(2,NUDRPL)-1
               IF (LIGNE.LE.NBCOLO) THEN
                  IF (IADDEB.GT.IADFIN) THEN
                     WRITE (IMPFCH,10003) LIOUCO,LIGNE,'diag seul'
                  ELSE
                     WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                        ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL,'et diag'
                  ENDIF
                  WRITE (IMPFCH,10020) 
     &                 (RST(I),I=MCL+IADDEB,MCL+IADFIN),RST(MCD-1+LIGNE)
               ELSE
                  WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                  ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL
                  WRITE (IMPFCH,10020) 
     &                  (RST(I),I=MCL+IADDEB,MCL+IADFIN)
               ENDIF
20          CONTINUE
         ELSE
            IF (L1.EQ.1) THEN
               LL1=L1+1
               LINE=1
               WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
               WRITE (IMPFCH,10020) RST(MCD)
               MCDD=MCD+1
               IADDEB=0
               IADFFN=0
               DO 21 LIGNE=2,NCPINL
                  WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                  ,IADDEB+1,IADFFN+1
                  WRITE (IMPFCH,10020) 
     &                  (RST(I),I=MCL+IADDEB,MCL+IADFFN),RST(MCDD)
                  MCDD=MCDD+1
                  IADDEB=IADFFN+1
                  IADFFN=IADFFN+LIGNE
21             CONTINUE
            ENDIF
            LIGNE=1+NCPINL*(LL1-1)
            MCDD=MCD+LIGNE-1
            DO 25 LINE=LL1,L2
*               IF (NUDRPL.GE.NUPRPL) NUPRPL=NUDRPL+1
               NUPRPL=NUDRPL+1
               IADDEB=(IADFIN+1)*NCPINC*NCPINL+MIN(LINE-1,NBCOLO)*NCFSSD
               NUDRPL=NULAPL(LINE-1)
               LGCUAP=0
               IF (NUDRPL.GT.0) LGCUAP=IPLAGL(2,NUDRPL)
               IADFIN=IADDEB+(LGCUAP-IADFIN-1)*NCPINC-1
               LGLIGN=IADFIN-IADDEB+1
               IF (LINE.LE.NBCOLO) THEN
                  NUPRPI=NUPRPL
                  NUDRPI=NUDRPL
                  DO 22 ICP=1,NCPINL
                     WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                     ,IADDEB+1,IADFIN+1,NUPRPI,NUDRPI,'et diag'
                     WRITE (IMPFCH,10020) 
     &                     (RST(I),I=MCL+IADDEB,MCL+IADFIN),RST(MCDD)
                     LIGNE=LIGNE+1
                     MCDD=MCDD+1
                     NUPRPI=-999999999
                     NUDRPI=NUPRPI
                     IADDEB=IADFIN+1
                     LGLIGN=LGLIGN+1
                     IADFIN=IADFIN+LGLIGN
22                CONTINUE
               ELSE
                  NUPRPI=NUPRPL
                  NUDRPI=NUDRPL
                  DO 23 ICP=1,NCPINL
                     WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                     ,IADDEB+1,IADFIN+1,NUPRPI,NUDRPI
                     WRITE (IMPFCH,10020)
     &                      (RST(I),I=MCL+IADDEB,MCL+IADFIN)
                     LIGNE=LIGNE+1
                     NUPRPI=-999999999
                     NUDRPI=NUPRPI
                     IADDEB=IADFIN+1
                     IADFIN=IADFIN+LGLIGN
23                CONTINUE
               ENDIF
               IADFIN=LGCUAP-1
25          CONTINUE
         ENDIF
      ELSE
         IF (NCPINC*NCPINL.EQ.1) THEN
            IF (L1.EQ.1) THEN
               LL1=L1+1
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
               WRITE (IMPFCH,10040) CST(MCD)
            ENDIF
            DO 40 LIGNE=LL1,L2
               NUPRPL=NUDRPL+1
               IADDEB=IADFIN+1
               NUDRPL=NULAPL(LIGNE-1)
               IADFIN=-1
               IF (NUDRPL.GT.0) IADFIN=IPLAGL(2,NUDRPL)-1
               IF (LIGNE.LE.NBCOLO) THEN
                  IF (IADDEB.GT.IADFIN) THEN
                     WRITE (IMPFCH,10003) LIOUCO,LIGNE,'diag seul'
                  ELSE
                     WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                 ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL,'et diag.'
                  ENDIF
                  WRITE (IMPFCH,10040)
     &                 (CST(I),I=MCL+IADDEB,MCL+IADFIN),CST(MCD-1+LIGNE)
               ELSE
                  WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                  ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL
                  WRITE (IMPFCH,10040)
     &                  (CST(I),I=MCL+IADDEB,MCL+IADFIN)
               ENDIF
40          CONTINUE
         ELSE
            IF (L1.EQ.1) THEN
               LL1=L1+1
               LINE=1
               WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
               WRITE (IMPFCH,10040) CST(MCD)
               MCDD=MCD+1
               IADDEB=0
               IADFFN=0
               DO 41 LIGNE=2,NCPINL
                  WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                 ,IADDEB+1,IADFFN+1
                  WRITE (IMPFCH,10040)
     &                  (CST(I),I=MCL+IADDEB,MCL+IADFFN),CST(MCDD)
                  MCDD=MCDD+1
                  IADDEB=IADFFN+1
                  IADFFN=IADFFN+LIGNE
41             CONTINUE
            ENDIF
            LIGNE=1+NCPINL*(LL1-1)
            MCDD=MCD-1+LIGNE
            DO 45 LINE=LL1,L2
               NUPRPL=NUDRPL+1
               IADDEB=(IADFIN+1)*NCPINC*NCPINL+MIN(LINE-1,NBCOLO)*NCFSSD
               NUDRPL=NULAPL(LINE-1)
               NBPLAI=NUDRPL-NUPRPL+1
               LGCUAP=0
               IF (NUDRPL.GT.0) LGCUAP=IPLAGL(2,NUDRPL)
               IADFIN=IADDEB+(LGCUAP-IADFIN-1)*NCPINC-1
               LGLIGN=IADFIN-IADDEB+1
               IF (LINE.LE.NBCOLO) THEN
                  NUPRPI=NUPRPL
                  NUDRPI=NUDRPL
                  DO 42 ICP=1,NCPINL
                     WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                     ,IADDEB+1,IADFIN+1,NUPRPI,NUDRPI,'et diag.'
                     WRITE (IMPFCH,10040)
     &                      (CST(I),I=MCL+IADDEB,MCL+IADFIN),CST(MCDD)
                     LIGNE=LIGNE+1
                     MCDD=MCDD+1
                     NUPRPI=0
                     NUDRPI=0
                     IADDEB=IADFIN+1
                     LGLIGN=LGLIGN+1
                     IADFIN=IADFIN+LGLIGN
42                CONTINUE
               ELSE
                  NUPRPI=NUPRPL
                  NUDRPI=NUDRPL
                  DO 43 ICP=1,NCPINL
                     WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                     ,IADDEB+1,IADFIN+1,NUPRPI,NUDRPI
                     WRITE (IMPFCH,10040)
     &                     (CST(I),I=MCL+IADDEB,MCL+IADFIN)
                     LIGNE=LIGNE+1
                     NUPRPI=0
                     NUDRPI=0
                     IADDEB=IADFIN+1
                     IADFIN=IADFIN+LGLIGN
43                CONTINUE
               ENDIF
               IADFIN=LGCUAP-1
45          CONTINUE
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10020 FORMAT((T14,10(E10.4,' ')))
10040 FORMAT((T14,5(SS,E10.4,SP,E10.4,'*i ')))
10001 FORMAT(T14,A4,I6,:,' '
     &,'(adresses ',I10,' a ',I10,') ',:,'(plages',I8,' a ',I8,') ',:,A)
10003 FORMAT(T14,A4,I6,:,' ',A)
10002 FORMAT(T14,A4,I6,', noeud',I6,:,' '
     &,'(adresses ',I10,' a ',I10,') ',:,'(plages',I8,' a ',I8,') ',:,A)
                                                                    END !PrLiBm
