*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMANL (LIOUCO,NUMEL,TYPE,MCA,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification : D.Martin (3 Octobre 1997)
*
* Impression (partielle) d'une matrice stockee sous forme 'Nume-Ligne'
*
*-- Arguments --
* LIOUCO 'Lig.' ou 'Col.'
* NUMEL  structure definissant la structure 'Morse-L' ou 'Morse-C' de la matrice
* TYPE   type REEL ou COMPLEXE de la matrice
* MCA    adresse de la matrice dans le super-tableau de type TYPE
* RST,CST super-tableau version REELLE et COMPLEXE
* NIVIMP niveau d'impression du terme
*        NIVIMP = I, 0 < I < 10 ==> impression des NIVIMP premieres
*        et dernieres lignes
*        NIVIMP > 9 ==> impression de la matrice en totalite ligne par ligne
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE,LIOUCO
      INTEGER       NUMEL(*),MCA,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBLINE,NBPRL1,NBPRL2,IADFIN
*-----------------------------------------------------------------------
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
*
      NBLINE=NUMEL(1)
      IADFIN=0
      NBPRL1=NBLINE
      IF (NIVIMP.LE.9) NBPRL1=MIN (NIVIMP,NBPRL1)
      WRITE (IMPFCH,10000) PRFXAF (),'>*PrMaNl*'
*
      CALL PRLINL (LIOUCO,1,NBPRL1,IADFIN,NUMEL(3)
     &            ,NUMEL(NBLINE+4),TYPE,MCA,RST,CST,IMPFCH)             !PrSd
      NBPRL2=MAX(NBPRL1,NBLINE-NBPRL1)
      IF (NBPRL1.LT.NBLINE.AND.NBPRL2.GT.NBPRL1+1)
     &   WRITE (IMPFCH,10000) '   ..........'
*
      IADFIN=NUMEL(3+NBPRL2)
      CALL PRLINL (LIOUCO,NBPRL2+1,NBLINE,IADFIN,NUMEL(3)
     &            ,NUMEL(NBLINE+4),TYPE,MCA,RST,CST,IMPFCH)             !PrSd
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,A)
                                                                    END !PrMaNl
