*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMAPL (NBLINE,NBCOLO,NCPINC,NCPINL,INCRC,INCRL,TYPE
     &                  ,MCA,RST,CST,NIVIMP,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1
*  
* Impression ligne par ligne i) d'une matrice pleine rangee ligne par ligne
*                           ii) d'une matrice pleine rangee colonne par colonne
*                               ('a la fortran')
*-- Arguments --  
* NBLINE nombre de ligne de la matrice
* NBCOLO nombre de colonne de la matrice
* NCPINC nombre de composantes de l'inconnue en colonne
* NCPINL nombre de composantes de l'inconnue en ligne
* INCRC  increment dans le pointeur d'adresse pour changer de ligne
*        i) = nombre de coeff. par ligne
*       ii) = 1
* INCRL  increment pour changer de colonne dans la ligne
*        i) = 1
*       ii) = nombre de coeff. par colonne
* TYPE   type (REEL ou COMPLEXE) de la matrice
* MCA    adresse de la matrice dans le super-tableau du bon type
* RST,CST super-tableaux version reelle ou complexe
* NIVIMP niveau d'impression (impression partielle du terme)
*         NIVIMP < 10 impression des NIVIMP premieres lignes
*                     et des NIVIMP dernieres lignes de la matrice 
*         NIVIMP > 9 impression de toutes les lignes de la matrice 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLINE,NBCOLO,NCPINC,NCPINL,INCRC,INCRL,MCA
     &             ,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBPRL1,NBPRL2,MCFIRS,LONGUE,MCLAST,I,LIGNE
*-----------------------------------------------------------------------
      IF (NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
*
      NBPRL1=NBLINE
      IF (NIVIMP.LE.9) NBPRL1=MIN(NIVIMP,NBPRL1)
      MCFIRS=MCA
      LONGUE=NBCOLO*NCPINC*INCRL
      WRITE (IMPFCH,10000) PRFXAF ( )//'>*PrMaPl*'
*
      IF (TYPE(1:1).EQ.'R') THEN
         DO 20 LIGNE=1,NBPRL1*NCPINL
            MCLAST=MCFIRS+LONGUE-INCRL
            WRITE (IMPFCH,10000) '  Ligne',LIGNE 
            WRITE (IMPFCH,10002) (RST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
 20      CONTINUE
         NBPRL2=MAX(NBPRL1,NBLINE-NBPRL1)
         IF (NBPRL1.LT.NBLINE.AND.NBPRL2.GT.NBPRL1+1)
     &      WRITE (IMPFCH,10000) '   ..........' 
         MCFIRS=MCA+NBPRL2*NCPINL*INCRC  
         DO 21 LIGNE=NBPRL2*NCPINL+1,NBLINE*NCPINL
            MCLAST=MCFIRS-INCRL+LONGUE
            WRITE (IMPFCH,10000) '  Ligne',LIGNE 
            WRITE (IMPFCH,10002) (RST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
 21      CONTINUE
      ELSEIF (TYPE(1:1).EQ.'C') THEN
         DO 40 LIGNE=1,NBPRL1*NCPINL
            MCLAST=MCFIRS+LONGUE-INCRL
            WRITE (IMPFCH,10000) '  Ligne',LIGNE
            WRITE (IMPFCH,10004) (CST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
 40      CONTINUE
         NBPRL2=MAX(NBPRL1,NBLINE-NBPRL1)
         IF (NBPRL1.LT.NBLINE.AND.NBPRL2.GT.NBPRL1+1)
     &      WRITE(IMPFCH,10000) '  ..........' 
         MCFIRS=MCA+NBPRL2*NCPINL*INCRC 
         DO 41 LIGNE=NBPRL2*NCPINL+1,NBLINE*NCPINL
            MCLAST=MCFIRS-INCRL+LONGUE
            WRITE (IMPFCH,10000) '  Ligne',LIGNE 
            WRITE (IMPFCH,10004) (CST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
 41      CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,I6)
10002 FORMAT((T14,10(E10.4,' ')))
10004 FORMAT((T14,5(SS,E10.4,SP,E10.4,'*i ')))
                                                                    END !PrMaPl
