*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMATR (NOMTRM,NIVTRM,NBLIGN,NIVIMP,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1989)
* Derniere modification : D.Martin (13 Fevrier 1998) 
*  
* Impression d'une matrice pleine par ligne
*  
*-- Arguments --  
* NOMTRM nom du tableau contenant la matrice  
* NIVTRM niveau du tableau contenant la matrice
* NBLIGN nombre de ligne de la matrice
* NIVIMP niveau d'impression (impression partielle du terme)  
*        NIVIMP < 10 impression des NIVIMP premieres lignes
*                    et des NIVIMP dernieres lignes de la matrice 
*        NIVIMP > 9 impression de toutes les lignes de la matrice 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NOMTRM*(*)
      INTEGER   NIVTRM,NBLIGN,NIVIMP,IMPFCH
*
      INCLUDE 'ALLOC'
*
      INTEGER   LGTERM,ITYPTR,MCTERM,NBCOLO,NBCOEF,LIGNE,I,NCATR1
      CHARACTER ERCODE*120,TYPINT*4,PRFXAF*8,THETR1*16
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      IF (NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
      CALL TBRR1  (ERCODE,NOMTRM,NIVTRM,LGTERM) 
      CALL TBTYPE (NOMTRM,NIVTRM,ITYPTR) 
      CALL TBAR1  (ERCODE,NOMTRM,NIVTRM,MCTERM) 
*
      CALL PRNTRM (NOMTRM,NIVTRM,THETR1,NCATR1)
      NBCOLO=LGTERM/NBLIGN
      NBCOEF=NIVIMP*NBCOLO
      IF (TYPINT (ITYPTR).EQ.'REEL') THEN
         WRITE (IMPFCH,1000) PRFXAF ( ),'reel',THETR1(1:NCATR1)
     &                      ,NBLIGN,NBCOLO,NIVIMP
         IF (NIVIMP.GE.10.OR.2*NIVIMP.GE.NBLIGN) THEN
            DO 10 LIGNE=1,NBLIGN
               WRITE (IMPFCH,10000) LIGNE
               WRITE (IMPFCH,10001) 
     &               (RST(I),I=MCTERM,MCTERM+LGTERM-1,NBLIGN)
10             MCTERM=MCTERM+1 
         ELSE  
            WRITE (IMPFCH,10003) NBCOEF,'premiers'  
            DO 20 LIGNE=1,NIVIMP
               WRITE (IMPFCH,10000) LIGNE
               WRITE (IMPFCH,10001) 
     &               (RST(I),I=MCTERM,MCTERM+NBCOEF-1,NBLIGN)
20             MCTERM=MCTERM+1 
            MCTERM=MCTERM+NBLIGN-2*NIVIMP  
            WRITE (IMPFCH,10003) NBCOEF,'derniers'  
            DO 30 LIGNE=1,NIVIMP
               WRITE (IMPFCH,10000) LIGNE+NBLIGN-NIVIMP 
               WRITE (IMPFCH,10001) 
     &               (RST(I),I=MCTERM,MCTERM+NBCOEF-1,NBLIGN)
30             MCTERM=MCTERM+1 
         END IF
      ELSEIF (TYPINT (ITYPTR).EQ.'COMP') THEN
         WRITE (IMPFCH,1000) PRFXAF ( ),'complexe',THETR1(1:NCATR1)
     &                      ,NBLIGN,NBCOLO,NIVIMP
         IF (NIVIMP.GE.10.OR.2*NIVIMP.GE.NBLIGN) THEN
            DO 50 LIGNE=1,NBLIGN
               WRITE (IMPFCH,10000) LIGNE
               WRITE (IMPFCH,10002) 
     &               (CST(I),I=MCTERM,MCTERM+LGTERM-1,NBLIGN)
50             MCTERM=MCTERM+1 
         ELSE  
            WRITE (IMPFCH,10003) NBCOEF,'premiers'  
            DO 60 LIGNE=1,NIVIMP
               WRITE (IMPFCH,10000) LIGNE
               WRITE (IMPFCH,10002) 
     &               (CST(I),I=MCTERM,MCTERM+NBCOEF-1,NBLIGN)
60             MCTERM=MCTERM+1 
            MCTERM=MCTERM+NBLIGN-2*NIVIMP  
            WRITE (IMPFCH,10003) NBCOEF,'derniers'  
            DO 70 LIGNE=1,NIVIMP
               WRITE (IMPFCH,10000) LIGNE+NBLIGN-NIVIMP 
               WRITE (IMPFCH,10002) 
     &               (CST(I),I=MCTERM,MCTERM+NBCOEF-1,NBLIGN)
70             MCTERM=MCTERM+1 
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
1000  FORMAT(/T2,A8,' Terme ',A,' ',A,' (',I6,' lignes et '
     &,I6,' colonnes - impression de niveau ',I2,')')
10000 FORMAT(T2,'Ligne # ',I6) 
10001 FORMAT((T2,10(E10.4,' '))) 
10002 FORMAT((T2,5(SS,E10.4,SP,E10.4,'*i ')))
10003 FORMAT(T2,I5,' ',A,' coefficients')
                                                                    END !PrMatr
