*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNOMS (NOMNOM,NVMNOM,NBCNOM,NBNOMS,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification D.Martin (23 Octobre 1999)
*  
* Impression d'un tableau de noms (de domaine, de donnee, de terme, ...)
*  
*-- Arguments d'entree -- 
* NOMNOM nom du tableau des noms 
* NVMNOM niveau du tableau des noms  
* NBCNOM nombre de caracteres par nom du tableau 
* NBNOMS nombre de noms de tableau
* IMPFCH numero d'unite logique d'impression 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMNOM
      INTEGER       NVMNOM,NBCNOM,NBNOMS,IMPFCH
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCMNOM,NB,I,J,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
      CHARACTER     CCCHEN*120,PRFXAS*8
      COMMON/ONSEPA/CCCHEN 
*-----------------------------------------------------------------------
      IF (IMPFCH.LE.0) RETURN
      CALL PRFXMJ (1,'*PrNoms*')
*  
      CALL TBAR1  (CCCHEN,NOMNOM,NVMNOM,MCMNOM)
*  
      NB=80/(NBCNOM+2) 
      CCCHEN='((T21,!!(!!A1,'', '')))' 
      CALL ENCLER (NB,CCCHEN(7:8))                                      !utilite
      CALL ENCLER (NBCNOM,CCCHEN(10:11))                                !utilite
      IF (NIVESP.LE.1) WRITE (IMPFCH,10000) '        ',NOMNOM,NVMNOM 
      IF (NIVESP.GT.1) WRITE (IMPFCH,10000) PRFXAS (1),NOMNOM,NVMNOM
      WRITE (IMPFCH,CCCHEN) 
     &  ((AST(MCMNOM+I*NBCNOM+J),J=0,NBCNOM-1),I=0,NBNOMS-1)
*  
      IF (NOMNOM(:6).EQ.'#OMTRM') THEN  
*  
*        Pour le tableau des noms de termes on imprime aussi les niveaux
*
         CALL TBAR1  (CCCHEN,'$SDTRM',1,MCDTRM)
         CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
         MCDTRM=MCDTRM+LGETRM
*
         CCCHEN='((T21,!!(I!!,'', '')))'
         CALL ENCLER (NB,CCCHEN(7:8))                                   !utilite
         CALL ENCLER (NBCNOM,CCCHEN(11:12))                             !utilite
         WRITE (IMPFCH,10001)
         WRITE (IMPFCH,CCCHEN)  
     &                   (IST(I),I=MCDTRM,MCDTRM-1+NBTERM*INCTRM,INCTRM)
      ENDIF
      CALL PRFXMJ (-1,'*PrNoms*')
*-----------------------------------------------------------------------  
10000 FORMAT(T2,A,'>*Prnoms* Tableau de noms ',A,',niveau ',I3)  
10001 FORMAT(T20,' Niveaux des termes')
                                                                    END !PrNoms
