*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNOTR (LGTERM,TYPE,MCTERM,RST,CST,NIVIMP,IMPFCH) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)
* Derniere modification (D.Martin) le 19 Juin 1997 
*  
* Impression d'un tableau sans les caracteristiques d'un terme
*  
*-- Arguments --  
* LGTERM longueur du tableau  
* TYPE   type REEL ou COMPLEXE de la matrice
* MCTERM adresse du tableau dans le super-tableau de type TYPE
* RST,CST super-tableau version REELLE et COMPLEXE
* NIVIMP niveau d'impression (impression partielle ou totale du terme)  
*         NIVIMP < 10 impression des 10*NIVIMP premiers coefficients
*                     et des 10*NIVIMP derniers coefficients
*         NIVIMP > 9 impression de tous les coefficients
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       LGTERM,MCTERM,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       ADRTRM,NBCOEF,I
*-----------------------------------------------------------------------
      ADRTRM=MCTERM
      IF (NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
      WRITE (IMPFCH,10000) '>PrNoTr'
      NBCOEF=10*NIVIMP 
      IF (TYPE(1:1).EQ.'R') THEN
         IF (NIVIMP.GE.10.OR.2*NBCOEF.GE.LGTERM) THEN
            WRITE (IMPFCH,10002) (RST(I),I=ADRTRM,ADRTRM+LGTERM-1)
         ELSE  
            WRITE (IMPFCH,10003) NBCOEF,'premiers'  
            WRITE (IMPFCH,10002) (RST(I),I=ADRTRM,ADRTRM+NBCOEF-1)  
            ADRTRM=ADRTRM+LGTERM-1 
            WRITE (IMPFCH,*) '             ..........'
            WRITE (IMPFCH,10003) NBCOEF,'derniers'  
            WRITE (IMPFCH,10002) (RST(I),I=ADRTRM-NBCOEF+1,ADRTRM)
         ENDIF
      ELSE 
         IF (NIVIMP.GE.10.OR.2*NBCOEF.GE.LGTERM) THEN
            WRITE (IMPFCH,10004) (CST(I),I=ADRTRM,ADRTRM+LGTERM-1)
         ELSE  
            WRITE (IMPFCH,10003) NBCOEF,'premiers'  
            WRITE (IMPFCH,10004) (CST(I),I=ADRTRM,ADRTRM+NBCOEF-1)  
            ADRTRM=ADRTRM+LGTERM-1
            WRITE (IMPFCH,*) '             ..........'
            WRITE (IMPFCH,10003) NBCOEF,'derniers'  
            WRITE (IMPFCH,10004) (CST(I),I=ADRTRM-NBCOEF+1,ADRTRM)  
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T14,A)
10002 FORMAT((T14,10(E10.4,' '))) 
10004 FORMAT((T14,5(SS,E10.4,SP,E10.4,'*i ')))
10003 FORMAT(T14,I5,' ',A,' coefficients')
                                                                    END !Prnotr
