*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNUGL (BLOKEL,NBBBLK,NU1BLK,NBTEL,INTERP  
     &                  ,NBNEEX,NGNEEL,IMPSDR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)  
* Derniere modification : D.Martin (05 Decembre 2001)
* Version 1.0.4
*  
* Impression des numeros globaux des noeuds du maillage, element par element
* pour une interpolation donnee
*  
*-- Arguments --  
* BLOKEL tableau de description des elements par blocs
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type d'element du 1er bloc (utilise si 1 seul bloc)
* NBTEL  nombre total d'elements du maillage
* INTERP numero de l'interpolation
* NBNEEX nombre maximum de noeuds dans un element   
* NGNEEL tableau des numeros globaux des noeuds element par element  
* IMPSDR unite logique d''impression secondaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER        BLOKEL(*),NBBBLK,NU1BLK,NBTEL,INTERP,NBNEEX
     &              ,NGNEEL(*),IMPSDR
*
      CHARACTER PRFXAF*8
      INTEGER   L,IANUMG,NUTGEO,NBELBK,LGEBLK,PTRBLK,NUBBLK,NUELBK,LAG
     &         ,KCL,NBSOMT,NBARET,NBFACE,NBNE,NBPTS,NBNF,NBPTSF,NBNA
     &         ,NBPTSA,I
*-----------------------------------------------------------------------
      WRITE (IMPSDR,10000) PRFXAF ( ),INTERP,(I,I=1,NBNEEX)
      L      = 0  
      IANUMG = 0 
      NUTGEO = NU1BLK
      NBELBK = NBTEL 
      IF (NBBBLK.GT.1) THEN 
         LGEBLK = BLOKEL(1)  
         NBELBK = BLOKEL(LGEBLK+1)
         PTRBLK = LGEBLK+BLOKEL(3)+1
      ENDIF
      DO 10 NUBBLK = 1,NBBBLK  
         CALL ELEMNB (INTERP+100*(NUTGEO/100),LAG,KCL,NBSOMT,NBARET
     &               ,NBFACE,NBNE,NBPTS,NBNA,NBPTSA,NBNF,NBPTSF)        !Ef3d
         DO 9 NUELBK = 1,NBELBK 
            L = L+1  
            WRITE (IMPSDR,10002) L,(NGNEEL(I),I = IANUMG+1,IANUMG+NBNE)
            IANUMG = IANUMG+NBNEEX
9        CONTINUE  
         IF (NBBBLK.GT.1) THEN  
            NBELBK = BLOKEL(PTRBLK)
            NUTGEO = BLOKEL(PTRBLK+1)  
            PTRBLK = PTRBLK+BLOKEL(3)
         ENDIF
10    CONTINUE 
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,'>*PrNugl* Numerotation  des noeuds pour l''interpo'
     &,'lation #',I3,/T3,'Element',T11,20(' noeud',I4,:)
     &,/(T7,'... ',20('/noeud',I4,:)))
10002 FORMAT(I8,T11,20I10,:/('     ...',(T11,20I10,:)))
                                                                    END !PrNugl
