*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNUML (STRUCT,COMEN1,NOMTRM,NIVTRM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)  
* Derniere modification : D.Martin (13 Fevrier 1998)
*  
* Impression d'une structure 'Nume-L' pour un terme  
*  
*-- Arguments --  
* STRUCT tableau contenant la structure 'Nume-l' 
* COMEN1 commentaire (chaine de caracteres)
* NOMTRM nom du terme (chaine de caracteres)
* NIVTRM son niveau
* NIVIMP niveau d'impression du terme 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) COMEN1,NOMTRM 
      INTEGER       STRUCT(*),NIVTRM,NIVIMP,IMPFCH
*
      CHARACTER     PRFXAF*8,THETR1*16
      INTEGER       NBLIGN,NBCOLO,MCADPR,MCNUCO,LGNUML
     &             ,NBLIMP,IADFIN,IADDEB,I,J,NCATR1
*-----------------------------------------------------------------------
      CALL EXNUML (1,STRUCT,NBLIGN,NBCOLO,MCADPR,MCNUCO,LGNUML)         !sdexplo
      CALL PRNTRM (NOMTRM,NIVTRM,THETR1,NCATR1)
*
      WRITE (IMPFCH,10000) PRFXAF ( ),COMEN1,THETR1(1:NCATR1)
      WRITE (IMPFCH,10001) NBLIGN,NBCOLO,LGNUML
      WRITE (IMPFCH,10005) NIVIMP
      IF (NBCOLO.LE.120) THEN
*
         CALL VINL  (NBLIGN,NBCOLO,STRUCT(MCADPR),STRUCT(MCNUCO),IMPFCH)!prsd
*
      ELSE
*
         NBLIMP=MAX (10*NIVIMP,NBLIGN)
         IF (NIVIMP.GE.10) NBLIMP=NBLIGN
         WRITE (IMPFCH,10002)
         IADFIN=0
         DO 1 I=1,NBLIMP
            IADDEB=IADFIN+1
            IADFIN=STRUCT(MCADPR+I)
            WRITE (IMPFCH,10003) IADDEB
     &     ,(STRUCT(J),J=MCNUCO-1+IADDEB,MCNUCO-2+IADFIN)
1        CONTINUE
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,'>Prnuml> ',A,' ',A,', ',A) 
10001 FORMAT(T6,'Nb. de lignes de la matrice :',T50,I7/
     &       T6,'Nb. de colonnes de la matrice :',T50,I7/
     &       T6,'Nb. de coeff. de la matrice :',T50,I7)
10005 FORMAT(T6,'--> Impression de niveau ',I3)
10002 FORMAT(T6,'Adresses des 1er coeff. des lignes / Numeros des colonn
     &es') 
10003 FORMAT(T6,I8,'/',(T20,20I5)) 
                                                                    END !PrNuml
