*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRPROF (STRUCT,COMEN1,NOMTRM,NIVTRM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991)  
* Derniere modification : D.Martin (28 Juin 2000)
* Version 1.0.1
*
* Impression d'une structure 'Profil' pour un terme  
*  
*-- Arguments --  
* STRUCT tableau contenant la structure profil
* COMEN1 commentaire (chaine de caracteres)
* NOMTRM nom du terme (chaine de caracteres)
* NIVTRM son niveau
* NIVIMP niveau d'impression du terme
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER COMEN1*(*),NOMTRM*(*)
      INTEGER   STRUCT(*),NIVTRM,NIVIMP,IMPFCH
*
      INTEGER   NBLIGN,MCLENV,LGPROL,NBCOLO,MCUENV,LGPROU,NBLIMP,NCATR1
     &         ,I
      CHARACTER PRFXAS*8,THETR1*16
*-----------------------------------------------------------------------
      CALL EXPROF (1,STRUCT,NBLIGN,MCLENV,LGPROL,NBCOLO,MCUENV,LGPROU)  !utilite
*
      CALL PRNTRM (NOMTRM,NIVTRM,THETR1,NCATR1)
*
      IF (STRUCT(1).EQ.2) THEN
         WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                       ,THETR1(1:NCATR1),'Structure symetrique'
      ELSE
         WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                       ,THETR1(1:NCATR1)
      ENDIF
      WRITE (IMPFCH,10001) NBLIGN,LGPROL
*
      IF (NBCOLO.LE.400) THEN
*
         WRITE (IMPFCH,10005) NIVIMP
         CALL VIPROF (' Ligne ',NBLIGN,NBCOLO,STRUCT(MCLENV),IMPFCH)    !prsd
         IF (NBLIGN.LE.400.AND.STRUCT(1).GT.2) THEN
            WRITE (IMPFCH,10006) NBCOLO,LGPROU
            CALL VIPROF (' Colon.',NBCOLO,NBLIGN,STRUCT(MCUENV),IMPFCH) !prsd
         ENDIF
*
      ELSE
*
         NBLIMP=MIN (10*NIVIMP,NBLIGN)
         IF (NIVIMP.GT.10) NBLIMP=NBLIGN
         WRITE (IMPFCH,10005) NIVIMP,'lignes',NBLIMP
         WRITE (IMPFCH,10002) 'ligne','inferieur'
         WRITE (IMPFCH,10003) 1,(STRUCT(I),I=MCLENV,MCLENV+NBLIMP-1)
         WRITE (IMPFCH,10004) 'colonne','ligne' 
         WRITE (IMPFCH,10003) 1
     &             ,(I-STRUCT(MCLENV-1+I)+STRUCT(MCLENV-2+I),I=2,NBLIMP)
         IF (STRUCT(1).GT.2) THEN
            NBLIMP=MIN (10*NIVIMP,NBCOLO)
            IF (NIVIMP.GT.10) NBLIMP=NBCOLO
            WRITE (IMPFCH,10005) NIVIMP,'colonnes',NBLIMP
            WRITE (IMPFCH,10006) NBCOLO,LGPROU
            WRITE (IMPFCH,10002) 'colonne','superieur' 
            WRITE (IMPFCH,10003) 1,(STRUCT(I),I=MCUENV,MCUENV+NBLIMP-1)
            WRITE (IMPFCH,10004) 'ligne','colonne' 
            WRITE (IMPFCH,10003) 1
     &             ,(I-STRUCT(MCUENV-1+I)+STRUCT(MCUENV-2+I),I=2,NBLIMP)
         ENDIF
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A,'>*PrProf*',A,' ',A,', ',A)
10001 FORMAT(T6,'Nb. de lignes de la matrice :',T50,I7/
     *       T6,'Nb. de coeff. du profil inferieur :',T50,I7)
10006 FORMAT(T6,'Nb. de colonnes de la matrice :',T50,I7/
     *       T6,'Nb. de coeff. du profil superieur :',T50,I7)
10005 FORMAT(T6,'--> Impression de niveau ',I3,:,' : ',A,' de 1 a',I6)
10002 FORMAT(T6,'Adresses des 1er coeff. de ',A,' dans le profil ',A)  
10004 FORMAT(T6,'Numeros de ',A,' de debut de ',A) 
10003 FORMAT(10I10) 
                                                                    END !PrProf
