*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRRGDO (COMMEN,COLLIG,NBELDO,IRGNDO,NIVIMP,IMPNUM)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1990)
* Derniere modification : D.Martin (28 Mai 1999)
* Version 1.0.0
*  
* Impression du tableau #RGNDO en colonne ou en ligne pour un domaine  
*  
*-- Arguments --  
* COMMEN commentaire (nom du s-p appelant)
* COLLIG commentaire ('Colonne' ou 'Ligne')
* NBELDO nombre d'elements du domaine 
* IRGNCO tableau des rangs des noeuds des elements sur le domaine 
* IMPNUM Numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) COMMEN,COLLIG  
      INTEGER       NBELDO,IRGNDO(*),NIVIMP,IMPNUM
*
      CHARACTER     PRFXAF*8
      INTEGER       IAD,L,NBNE,I,NBELPR
*-----------------------------------------------------------------------
      IAD=1
      NBELPR=MIN(10*NIVIMP,NBELDO)
      IF (NIVIMP.GT.10) NBELPR=NBELDO
      WRITE (IMPNUM,10000) PRFXAF ( ),COMMEN,COLLIG,NBELPR
      DO 1 L=1,NBELPR
         NBNE=IRGNDO(IAD)  
         WRITE (IMPNUM,10001) L,(IRGNDO(I),I=IAD+1,IAD+NBNE)
         IAD=IAD+1+NBNE
1     CONTINUE
*-----------------------------------------------------------------------
10000 FORMAT(T2,A8,A,'>*PrRgdo* Tableau des rangs des noeuds en ',A
     &,' (elements 1 a ',I6,')') 
10001 FORMAT(T2,'Elt #',I5,':',(T14,10I9))
                                                                    END !PrRgdo
