*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRTAB (NOMTAB,NIVTAB,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2001)
* Derniere modification : D.Martin (24 Janvier 2001)
* Version 1.0.0
*
* Impression des valeurs du tableau NOMTAB/NIVTAB
*
*-- Argument d'entree --
* NOMTAB nom du tableau
* IMPFCH numero d'unite logique du fichier d'impression
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER NOMTAB*(*)
      INTEGER   NIVTAB,IMPFCH
*
      INCLUDE 'ALLOC'
*
      INTEGER   MCMTAB,ITPTAB,LONTAB,NBCTAB,NB,I,J
      CHARACTER TYPINT*12,PRFXAS*8
      CHARACTER TYPTAB*12,THETAB*16,ERCODE*120,CHAINE*120
      COMMON/FORMAH/ERCODE
      COMMON/ONSEPA/CHAINE
*-----------------------------------------------------------------------
*     Adresse, type et longueur du tableau
      CALL TBRR1  (ERCODE,NOMTAB,NIVTAB,MCMTAB)
      CALL TBAR1  (ERCODE,NOMTAB,NIVTAB,MCMTAB)
      CALL TBTYPE (NOMTAB,NIVTAB,ITPTAB)
      CALL TBARTI (NOMTAB,NIVTAB,LONTAB)
      TYPTAB=TYPINT (ITPTAB)
*
      CALL PRNTRM (NOMTAB,NIVTAB,CHAINE,NB)                         !utilite
      WRITE (IMPFCH,10000) PRFXAS(0),CHAINE(1:NB),TYPTAB
*
      IF (TYPTAB(1:2).EQ.'CA') THEN
*
*        Tableau de chaine de caracteres
*
         NBCTAB=ITPTAB-10
         NB=80/(NBCTAB+2)
         CHAINE='((T20,!!(!!A1,:,'', '')))'
         CALL ENCLER (NB,CHAINE(7:8))                                   !utilite
         CALL ENCLER (NBCTAB,CHAINE(10:11))                             !utilite
         WRITE (IMPFCH,CHAINE)
     &      ((AST(MCMTAB+I*NBCTAB+J),J=0,NBCTAB-1),I=0,LONTAB-1)
*
      ELSEIF (TYPTAB(1:1).EQ.'E') THEN
*
*        Tableau d'entiers
*
         WRITE (IMPFCH,10001) (IST(MCMTAB+I),I=0,LONTAB-1)
      ELSEIF (TYPTAB(1:1).EQ.'R') THEN
*
*        Tableau de reels
*
         WRITE (IMPFCH,10002) (RST(MCMTAB+I),I=0,LONTAB-1)
      ELSEIF (TYPTAB(1:1).EQ.'D') THEN
*
*        Tableau de reels doubles
*
         WRITE (IMPFCH,10002) (DST(MCMTAB+I),I=0,LONTAB-1)
      ELSEIF (TYPTAB(1:1).EQ.'C') THEN
*
*        Tableau de complexes
*
         WRITE (IMPFCH,10004) (CST(MCMTAB+I),I=0,LONTAB-1)
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T2,A8,'>*Prtab * Valeurs du tableau ',A,', ',A)
10001 FORMAT((T16,5I12))
10002 FORMAT((T16,5E12.4))
10003 FORMAT((T16,5D15.7))
10004 FORMAT((T16,3(SS,E12.4,SP,E11.4,'*i')))
                                                                    END !Prtab
