*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VINL (NBLIGN,NBCOLO,ADPRCL,NUMCOL,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1990)
* Derniere modification (D.Martin) le 12 Decembre 1994  
*  
* Visualisation des elements non nuls d'une matrice stockee NUME-L.
*
*-- Arguments --
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
* ADPRCL adresse du 1er coeff. de chaque ligne
* NUMCOL numero de colonne des coeff. des lignes 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBLIGN,NBCOLO,ADPRCL(*),NUMCOL(*),IMPFCH
*  
      CHARACTER     STAR(120)
      COMMON/ONSEPA/STAR
*
      INTEGER       KOLONE,LIGNE,ADNL,ADNXNL,ADNLC
*-----------------------------------------------------------------------
      WRITE (IMPFCH,10000) (KOLONE,KOLONE=1,NBCOLO/10)  
      WRITE (IMPFCH,10001) 'Ligne  ',(MOD(KOLONE,10),KOLONE=1,NBCOLO)
      ADNL=ADPRCL(1)
      DO 10 LIGNE=1,NBLIGN
         ADNXNL=ADPRCL(LIGNE+1) 
         DO 1 KOLONE=1,NBCOLO
1           STAR(KOLONE)='.'
         DO 2 ADNLC=ADNL,ADNXNL-1
            STAR(NUMCOL(ADNLC))='x'
2        CONTINUE
         STAR(LIGNE)='d'
         ADNL=ADNXNL
         WRITE (IMPFCH,10002) LIGNE,(STAR(KOLONE),KOLONE=1,NBCOLO)
10       CONTINUE
      WRITE (IMPFCH,*)
*-----------------------------------------------------------------------
10000 FORMAT(T8,12I10) 
10001 FORMAT(A7,120I1)  
10002 FORMAT(I4,'   ',120A1)
                                                                    END !ViNl
