*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE REDUNI (*)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)
* Derniere modification : D.Martin (26 Avril 2000)
* Version # 1.0.2
*  
* Changement de l'unite de lecture des directives  
*  
*-- Mots-cles --  
*  
* < LECTURE  [< AVEC/SANS > ECHO] SUR <FICHIER/UNITE> &C ]
* / READ[ING] [< WITH/WITHOUT > ECHO] <FROM/ON> <FILE/UNIT> &C ]
* >
*  
* Retour etiquete en cas de reinitialisation du fichier de lecture
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER        TEXTE*80,PRFXAF*8
      INTEGER          KLUNIT
      INTEGER          LECNEW,IECHO,IMPPAL,IMPSDR,IMPMES,NBMESG
     &                ,NFIX,IRE,NER,NCAR,ILU,IOP,LECOLD,LCANTE,NUMOLD
     &                ,NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
     &                ,NCAD
      INTEGER          MOI,NBEUX,NBPROC,I
      DOUBLE PRECISION FLOT
      COMMON/FICHIM/   IMPPAL,IMPSDR,IMPMES,NBMESG
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/REDCA1/   NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDLST/   LECOLD,LCANTE,NUMOLD
*     Pour procedures parallelles
*     MOI numero du processeur courant, NBEUX nombre de processeurs voisins
      COMMON/PARALL/MOI,NBEUX,NBPROC
      LOGICAL          OPNED,JEXIST
*-----------------------------------------------------------------------
      IECHO=0  
      CALL REDLEC (4)
      IF (TEXTE(1:NCAR).EQ.'AVEC'.OR.TEXTE(1:NCAR).EQ.'WITH') THEN
         CALL REDLEC (4)
         IF (TEXTE(1:NCAR).EQ.'ECHO') THEN
            IECHO=1
            CALL REDLEC (4) 
         ENDIF
      ELSEIF (TEXTE(1:NCAR).EQ.'SANS'.OR.TEXTE(1:NCAR).EQ.'WITHOUT')THEN
         CALL REDLEC (4)
         IF (TEXTE(1:NCAR).EQ.'ECHO') THEN
            IECHO=0
            CALL REDLEC (4) 
         ENDIF
      ENDIF
      LECNEW=LEC  
      IF (TEXTE(1:NCAR).EQ.'SUR'.OR.TEXTE(1:NCAR).EQ.'FROM'
     &.OR.TEXTE(1:NCAR).EQ.'ON') THEN
         CALL REDLEC (4)
         IF (.NOT.(TEXTE(1:NCAR).EQ.'FICHIER'.OR.TEXTE(1:4).EQ.'FILE'
     &         .OR.TEXTE(1:4).EQ.'UNIT'))
     &      CALL REDERR (1,'FICHIER / FILE')
*--      Lecture du nom du fichier de lecture des directives
         CALL REDLEC (8)
         NCAD=NCAR
         IF (TEXTE(1:5).NE.'SYSIN'.AND.TEXTE(1:5).NE.'STDIN'
     &     .AND.TEXTE(1:5).NE.'sysin'.AND.TEXTE(1:5).NE.'stdin') THEN
*
            IF (PRFXAF ( ).EQ.'*Lcgeom*'.AND.MOI.GT.0) THEN
*
*              Modification du nom fichier de maillage pour le cas parallele
*              On rajoute le suffix '-0000n' 
*
               TEXTE(NCAR+1:NCAR+1)='-'
               CALL ENCLER (MOI,TEXTE(NCAR+2:NCAR+6))                   !utilite
               DO 10 I=NCAR+2,NCAR+5
                  IF (TEXTE(I:I).EQ.' ') TEXTE(I:I)='0'
10             CONTINUE
               NCAD=NCAR+6
            ENDIF
*
            INQUIRE (FILE=TEXTE(1:NCAD),NUMBER=LECNEW,OPENED=OPNED  
     &              ,EXIST=JEXIST,ERR=90000)
            IF (.NOT.JEXIST) GOTO 90001
            IF (.NOT.OPNED) THEN
               INQUIRE (UNIT=1,OPENED=OPNED)
               LECNEW=1
               IF (OPNED) LECNEW=KLUNIT ()                              !sdexplo
               OPEN (LECNEW,FILE=TEXTE(1:NCAD),ACCESS='SEQUENTIAL'  
     &             ,STATUS='OLD',ERR=90002)
               WRITE (IMPPAL,10000) PRFXAF ( )
     &               ,'Lecture sur le fichier ',TEXTE(1:NCAD)
            ENDIF 
         ENDIF
*  
*--      Reinitialisation du fichier de lecture
         CALL REDINI (LECNEW,IECHO)
         RETURN 1  
      ENDIF
      CALL REDINI (LECNEW,IECHO)
      RETURN
10000 FORMAT(/T2,A8,' ',A,' ','''',A,'''')
*-----------------------------------------------------------------------
90000 CALL BAISE  (' *RedUni* Probleme existenciel avec le fichier : '
     &//TEXTE(1:NCAD))
90001 CALL BAISE  (' *RedUni* Fichier inexistant '//TEXTE(1:NCAD))
90002 CALL BAISE  (' *RedUni* Probleme d''ouverture du fichier : '
     &//TEXTE(1:NCAD))
                                                                    END !RedUni
