*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CHSTOK (NMTRMA,NVTRMA,STONEW,NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (9 octobre 2006)
* Derniere modification : D.Martin (19 octobre 2006)
* Version 0
*
* Changement de type de stockage d'une matrice
* Seuls les changements suivants sont actuellement prevus 
*   PLEIN-L, PLEIN-C vers BIMORSE
*    
*-- Arguments d'entree --
* NMTRMA nom de la matrice originale A
* NMTRMA niveau de la matrice A
* STONEW nouveau type de stockage
*        PLEIN-L ,PLEIN-C ,MORSE-L ,MORSE-C ,BIMORSE ,PROFIL, NUME-L, NUME-C
* NMTRMB nom de la matrice resultat B
* NMTRMB niveau de la matrice B
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRMA,NMTERM,STONEW
      INTEGER NVTRMA,NVTERM
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER STOIND*7,TYPINT*9,STOOLD*7
      INTEGER INDSTO,INDSYM,KLNIVE
      INTEGER LGMTRM,LGDTRM,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &       ,NUTERM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &       ,NUINCC,NVDUMC,NBCOMA,NVNUMC,NUINCL,NVDUML,NBLIMA,NVNUML
     &       ,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVIMP,KLTERM,NVVTRM
     &       ,NVSTRM,MCTRMA,MCTERM,NWADRS,OLADRS,OLADR1,I,J
     &       ,KUCTRM,KVDCRM,KBCOLO,KVNCRM,KULTRM,KVDLRM,KBLIGN,KVNLRM
     &       ,KNDSTR,KVSTRM,IATTRM,ADTERM,LGBMOR,MCBMOR,INSNEW
      LOGICAL CRETRM
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE 
*-------------------------------------------------------------------------------
*
      CALL PRFXMJ (1,'*ChStok*')
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo     
*
*     Caracteristiques de la matrice (A)
*
      NUTERM=KLTERM (NMTRMA,NVTRMA,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMA,NVTRMA)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &            ,NUINCC,NVDUMC,NBCOMA,NVNUMC
     &            ,NUINCL,NVDUML,NBLIMA,NVNUML
     &            ,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVIMP)                  !sdexplo
      STOOLD=STOIND(INDSTK)                                             !utilite
      IF (STONEW(1:7).EQ.STOOLD) THEN
         CALL WARNNG ('La matrice est deja stockee '//STOOLD//' !')     !uitite
         GOTO 90001
      ENDIF
*
*     Creation ou mise a jour des caracteristiques du terme resultat
*
      INSNEW = INDSTO (STONEW)                                          !utilite
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.GT.0) THEN
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &               ,KUCTRM,KVDCRM,KBCOLO,KVNCRM
     &               ,KULTRM,KVDLRM,KBLIGN,KVNLRM
     &               ,KNDSTR,KVSTRM,NVCOOR,IATTRM,NIVIMP)               !sdexplo
      ENDIF
*
      NUKALE=1
      ITYSYM=INDSYM (' ')   
      IF (STONEW(1:7).EQ.'BIMORSE') NVSTRM=KLNIVE()                     !sdexplo
*
      CALL CRTERM (NMTERM,NVTERM,NBLIMA*NBCOMA
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NDFDSM
     &            ,NUINCC,NVDUMC,NBCOMA,NVNUMC
     &            ,NUINCL,NVDUML,NBLIMA,NVNUML
     &            ,INSNEW,NVSTRM,NDFCOR,IATRDO,NIVIMP,.FALSE.,CRETRM)   !sdexplo
*
*     Creation de la structure de stockage cible
*
      IF (STONEW(1:7).EQ.'BIMORSE') THEN
         CALL CRBMOP (NVSTRM,NBLIMA,NBCOMA,IST)                         !sdexplo
      ELSE
         CALL BAISE  ('Pas de transformation vers le stockage '
     &               //STOIND(INSNEW)//' actuellement prevue.')         !utilite
      ENDIF
* 
      CALL TBRR2(ERCODE,NMTRMA,NVTRMA,MCTRMA,NMTERM,NVTERM,MCTERM)      
      CALL TBAR2(ERCODE,NMTRMA,NVTRMA,MCTRMA,NMTERM,NVTERM,MCTERM)
*
*     Transformation de la matrice selon son nouveau stockage
*
      IF (STOOLD(1:7).EQ.'PLEIN-L'.OR.STOOLD(1:7).EQ.'PLEIN-C') THEN
         IF (STONEW(1:7).EQ.'BIMORSE') THEN
            CALL MPL2BM (TYPINT(ITYPTR),NBLIMA,NBCOMA,STOOLD,MCTRMA
     &                  ,MCTERM,RST,CST)                                !morse
*
         ELSE
            CALL BAISE  ('Pas de transformation de '//STOOLD//' a '
     &                 //STOIND(INSNEW)//'.')
         ENDIF
      ELSE
            CALL BAISE  ('Pas de transformation de '//STOOLD//' a '
     &                 //STOIND(INSNEW)//'.')
      ENDIF
*
*     Sauvegarde
*
      CALL TBSAVE(NMTRMA,NVTRMA)
      CALL TBSAVE(NMTERM,NVTERM)
*
90001 CALL PRFXMJ (-1,'*ChStok*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (19 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !ChStok
