*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CNTGDO (NVNUME,NUMERO,NFOUND)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998)
* Derniere modification : D.Martin (31 Mars 1998)
*
* Decompte des domaines de calculs ou des termes dont l'une des numerotations
* de noeuds ou d.l. est definie par le tableau de numerotation 
*'#GNEDO' de niveau NVNUME a l'exclusion du terme numero NUMERO
*
*
*-- Arguments
* NVSTOK niveau du tableau de stockage correspondant
* NUMERO numero du terme exclus
* NFOUND nombre de termes utilisant ce tableau de stockage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NVNUME,NUMERO,NFOUND
*  
      INCLUDE 'ALLOC'
*
      INTEGER MC,LGE,NB,INC,NCH,ADDC,ADDL,ADNC,ADNL,I
      CHARACTER ERCODE*120 
      COMMON/FORMAH/ERCODE
*-------------------------------------------------------------------------------
      NFOUND=0
*
      CALL TBAR1  (ERCODE,'#TERDO',1,MC)
      CALL SDEXDB (IST(MC),LGE,NB,INC,NCH)                              !sdexplo
*
      ADDC=13
      ADDL=22
*     adresse du 1er domaine de calcul dans la structure #TERDO
      MC=MC+LGE
      DO 1 I=1,NB
         IF (IST(MC+ADDC).EQ.NVNUME.OR.IST(MC+ADDL).EQ.NVNUME)
     &      NFOUND=NFOUND+1
*        adresse du domaine de calcul suivant
         MC=MC+INC+IST(MC+INC-2)
1     CONTINUE
*
      CALL TBAR1  (ERCODE,'$SDTRM',1,MC)
      CALL SDEXDB (IST(MC),LGE,NB,INC,NCH)                              !sdexplo
*
      ADDC=8
      ADNC=10
      ADDL=12
      ADNL=14
*     adresse du 1er terme dans la structure $SDTRM
      MC=MC+LGE
      DO 2 I=1,NUMERO-1
         IF (IST(MC+ADDC).EQ.NVNUME.OR.IST(MC+ADNC).EQ.NVNUME.OR.
     &       IST(MC+ADDL).EQ.NVNUME.OR.IST(MC+ADNL).EQ.NVNUME)
     &      NFOUND=NFOUND+1
*        adresse du terme suivant
         MC=MC+INC
2     CONTINUE
*
*     saut pour le terme exclus
      MC=MC+INC
*
      DO 3 I=NUMERO+1,NB
         IF (IST(MC+ADDC).EQ.NVNUME.OR.IST(MC+ADNC).EQ.NVNUME.OR.
     &       IST(MC+ADDL).EQ.NVNUME.OR.IST(MC+ADNL).EQ.NVNUME)
     &      NFOUND=NFOUND+1
*        adresse du terme suivant
         MC=MC+INC
3     CONTINUE
*
                                                                    END !CntGdo
