*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CRBMOP (NVSTOK,NBLIGN,NBCOLO,IST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (16 octobre 2006)
* Derniere modification : D.Martin (16 octobre 2006)
* Version 0
*
* Creation d'un tableau &BMORS trivial pour une matrice Pleine
*
*-- Arguments ---
* NVSTOK niveau du tableau de stockage &BMORS
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NVSTOK,NBLIGN,NBCOLO,IST(*)
*
      CHARACTER ERCODE
      INTEGER LGBMOR,MCBMOR
*-----------------------------------------------------------------------
      ERCODE='!'
      CALL TBRR1  (ERCODE,'&BMORS',NVSTOK,LGBMOR)
      IF (ERCODE.EQ.'C') THEN
*        LGBMOR : 2+NBLIGN+2*(NBLIGN-1)-1, nombre de plages : NBLIGN-1
         LGBMOR = 2+3*(NBLIGN-1)
         IF (NBCOLO.NE.NBLIGN) LGBMOR=LGBMOR+1+3*(NBCOLO-1)
         CALL TBCREE ('&BMORS',NVSTOK,1,LGBMOR,'c')
         CALL TBAR1  (ERCODE,'&BMORS',NVSTOK,MCBMOR)
*        Si le nombre de lignes et de colonnes sont egaux
*        la matrice (carree,pleine) a une structure BIMORSE symetrique
         IST(MCBMOR)=2
         CALL PL2BML (NBLIGN,NBCOLO,IST(MCBMOR+1))                      !morse
         IF (NBCOLO.NE.NBLIGN) THEN
*        Matrice rectangulaire ==> structure BIMORSE non symetrique
         IST(MCBMOR)=2+NBLIGN+2*(NBLIGN-1)
         CALL PL2BML (NBCOLO,NBLIGN,IST(MCBMOR-1+IST(MCBMOR)))          !morse
         ENDIF
      ENDIF
      CALL TBSAVE ('&BMORS',NVSTOK)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (16 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !CrBmoP
