*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CRCOOR (INTRPC,NVNUMC,NVCORC,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1995)  
* Derniere modification : D.Martin (12 juin 2004)
* Version 2
*  
* Creation du tableau des coordonnees des noeuds pour une interpolation et une 
* numerotation globale donnee
*  
*-- Arguments --  
* INTRPC niveau de l'interpolation en colonne sur le domaine
* NVNUMC niveau du tableau de numerotation globale pour le domaine
* NVCORC niveau des tableaux &CORNE sur le domaine 
* NIVIMP niveau d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      INTEGER   INTRPC,NVNUMC,NVCORC,NIVIMP
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER PRFXAS*8
      INTEGER   MCNUMC,MCCORP,MCCORC,NBNOEU,NOEUD,MCCOOR,MCCORN,NCATAB
     &         ,MC
      CHARACTER ERCODE*120,THETAB*16
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CrCoor*')
*
      CALL TBRR2  (ERCODE,'#GNEDO',NVNUMC,MCNUMC,'#ORNOE',INTRPC,MCCORP)
      CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNUMC)
      NBNOEU =IST(MCNUMC+1)
*
*     Creation des tableaux des coordonnees des noeuds
*
      ERCODE(1:1)='!'
      CALL TBRR1  (ERCODE,'&CORNE',NVCORC,MCCORC)
      IF (ERCODE(1:1).EQ.'C'.OR.MCCORC.LT.NDIM*NBNOEU)
     &   CALL TBCREE ('&CORNE',NVCORC,2,NDIM*NBNOEU,'c')
*
      CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC,'#ORNOE',INTRPC,MCCORP
     &                   ,'&CORNE',NVCORC,MCCORC)
      MCCORN=MCCORC
      MCNUMC=MCNUMC+2
      DO 1 NOEUD=1,NBNOEU
         MCCOOR=MCCORP+NDIM*(IST(MCNUMC)-1)-1
         DO 2 MC=MCCOOR+1,MCCOOR+NDIM
            RST(MCCORN)=RST(MC)
            MCCORN=MCCORN+1
2        CONTINUE
         MCNUMC=MCNUMC+1
1     CONTINUE
*
      IF (NIVIMP.GT.5.AND.IMPSDR.GT.0) THEN
         WRITE (IMPSDR,10001) PRFXAS(1),'Coordonnes des noeuds'
         CALL PRCOOR (NDIM,NBNOEU,RST(MCCORC),' Cornoe',NIVIMP,IMPSDR)  !prsd
      ENDIF
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM ('&CORNE',NVCORC,THETAB,NCATAB)                    !utilite
         WRITE (IMPPAL,10002) PRFXAS(1),THETAB(1:NCATAB)
     &                        ,'Coordonnees des noeuds'
      ENDIF

*
      CALL TBSAVE ('#GNEDO',NVNUMC)
      CALL TBSAVE ('&CORNE',NVCORC)
      CALL TBSAVE ('#ORNOE',INTRPC)
      CALL PRFXMJ (-1,'*CrCoor*')
*----------------------------------------------------------------------- 
10001 FORMAT(/T2,A8,' ',A)
10002 FORMAT(T5,A8,' tableau ',A,' ',A)
                                                                    END !CrCoor
