*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DOASTR (NMTERM,NIVTRM,NMDONN,TYDONN,NVDONN,TYPE) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (Janvier 90)
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Association d'une donne de nom donne a un terme  
*  
*-- Arguments d'entree --- 
* NMTERM nom du terme 
* NIVTRM son niveau
* NMDONN nom de la donne a associer au terme  
* TYDONN chaine caract. du type de la donne (CONSTANTE,FONCTION, ...) 
* NVDONN niveau de la donnee si ce n'est pas une constante
* TYPE   chaine caract. de la declaration de la donne (REEL,COMPLEXE, ...)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM,NMDONN,TYDONN,TYPE 
      INTEGER       NIVTRM,NVDONN
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       INTDON,INTTYP,KELCHN,KLCSTE,KLTERM
      INTEGER       NVVDON,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,MCMDON,LGMDON,MCDDON,LGDONN,LGEDON,NBDONN,INCDON
     &             ,NCHDON,NUDONN,LGDONA,LGMDOA,NWCDON,ITYDON,NIVDON
     &             ,ITYPDO,NUTERM
      CHARACTER     DONINT*4,TYPINT*4
      CHARACTER     ERCODE*120,NOMWRK*16,TYPN*12,TYDNNN*12,TYPEDO*12
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (NOMWRK,ERCODE(105:105)),(TYPN,ERCODE(93:93))
     &            ,(TYDNNN,ERCODE(81:81)),(TYPEDO,ERCODE(69:69))
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DoAstr*')
*
      NVVDON=NVDONN
      CALL TBRR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDON',1,LGMDON,'$DONNE',1,LGDONN)
      CALL TBAR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDDON),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
*     Recherche du rang de la donnee si elle existe
*
      NUDONN=KELCHN (NMDONN,AST(MCMDON),NBDONN,NCHDON)                  !utilite
      IF (NUDONN.LE.0) THEN
         LGDONA=LGDONN
         CALL SDAJST ('$DONNE',1,LGDONN,LGEDON,INCDON,NBDONN,1)         !sdexplo
         LGMDOA=LGMDON
         NWCDON=MAX (NCHDON,LEN (NMDONN))
         CALL SDAJST ('#OMDON',1,LGMDON,0,NWCDON,NBDONN,1)              !sdexplo
         IF (LGMDON.GT.LGMDOA.OR.LGDONN.GT.LGDONA)
     &   CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON)
         CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN)                 !utilite
         CALL SDMKDB (IST(MCDDON),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
         IF (TYDONN(1:1).EQ.'C') NVVDON=KLCSTE (TYPE)                   !sdexplo
         NUDONN=NBDONN
      ELSEIF (TYDONN(1:1).EQ.'C') THEN
         CALL SDEXCO (NUDONN,IST(MCDDON),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.EQ.INTDON ('CONSTANTE').AND.INTTYP(TYPE).EQ.ITYPDO) !utilite
     &      THEN
            NVVDON=NIVDON
         ELSE
            NVVDON=KLCSTE (TYPE)                                        !sdexplo
            NOMWRK=NMDONN
            TYPN=TYPE
            TYDNNN=DONINT (ITYDON)                                      !utilite
            TYPEDO=TYPINT (ITYPDO)                                      !utilite
            CALL WARNNG ('Changement de type pour la constante '//NOMWRK
     &                   //' de type '//TYPN//'. C''etait avant un(e) '
     &                                           //TYDNNN//' '//TYPEDO) !utilite
         ENDIF
      ELSEIF (TYDONN(1:4).EQ.'FONC') THEN
         CALL SDEXCO (NUDONN,IST(MCDDON),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.EQ.INTDON ('FONCTION').AND.INTTYP(TYPE).EQ.ITYPDO)  !utilite
     &       NVVDON=NIVDON
      ENDIF
*
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'$DONNE',1,MCDDON)
*
*     Mise a jour du tableau $DONNE
*
      CALL SDMKCO
     &   (NUDONN,IST(MCDDON),INTDON(TYDONN),NVVDON,INTTYP(TYPE))        !utilite
*
*     Mise a jour des caracteristiques du terme (tableau $SDTRM)
*
      NUTERM=KLTERM (NMTERM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NIVTRM)                    !utilite
*  
      IST (MCDTRM+LGETRM+INCTRM*(NUTERM-1)+4)=NUDONN
*
      CALL PRFXMJ (-1,'*DoAstr*')  
                                                                    END !DoAstr
