*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION DOMNIV (DOMAIN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (16 janvier 2008)
* Derniere modification : D.Martin (16 janvier 2008)
* Version 0
*  
* Retourne le niveau du tableau des normales (de nom &NORMA) et des coordonnees
* des noeuds (&CORNE) sur le domaine de nom DOMAIN
*
* Attention : Ne fonctionne que si une unique inconnue est définie sur le domaine
* ---------   (voir aussi ccalgre/calnoy.f)
*
*-- Argument d'entree -- 
* DOMAIN  nom du domaine 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) DOMAIN
      INTEGER       DOMNIV 
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER MCMDOM,MCTRDO,IATRDO,NUDGSI,NUDODO,IGEOME,INDMIX,NUSCHQ
     &       ,INDEC,IDLHC,INTRC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUC
     &       ,INDEL,IDLHL,INTRL,NBNECY,NBNEEY,NBDLEY,NBNEFY,NBDLFY,NVNUL
     &       ,INUTIL,NBTRDO,NIVIMS
*    &       ,MCCORN,MCNORM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DomNiv*')
      CALL TBAR2  (ERCODE,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO)                
*  
*     Caracteristiques du domaine 
*  
      CALL KLDOMN (DOMAIN,0,0,IST(MCTRDO),AST(MCMDOM),NBDOMG
     &            ,NUDODO,IATRDO)                                       !sdexplo
      IATRDO = MCTRDO+IATRDO 
      CALL GETDOM (IST(IATRDO),NUDGSI,NUDODO,IGEOME,INDMIX,NUSCHQ
     &    ,INDEC,IDLHC,INTRC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUC
     &    ,INDEL,IDLHL,INTRL,NBNECY,NBNEEY,NBDLEY,NBNEFY,NBDLFY,NVNUL
     &    ,DOMNIV,INUTIL,NBTRDO,NIVIMS)                                 !sdexplo
*
*     Tableaux des normales
*
*     ERCODE=' '
*     CALL TBRR2  (ERCODE,'&NORMA',DOMNIV,MCNORM,'&CORNE',DOMNIV,MCCORN)
*     IF (ERCODE(1:1).EQ.' ') CALL TBSAVE ('&NORMA',DOMNIV)
*     IF (ERCODE(2:2).EQ.' ') CALL TBSAVE ('&CORNE',DOMNIV)
      CALL PRFXMJ (-1,'*DomNiv*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (16 janvier 2008) creation
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DomNiv
