*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GETTAB (NOMTAB,NIVTAB,KLADRS
     &                  ,TYPTAB,VALEUI,VALEUR,VALEUC,VALEUA) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996) 
* Derniere modification : D.Martin (18 Novembre 1999)
*  
* Fournit la valeur d'un coefficient d'un tableau a une adresse relative donnee
*  
*-- Arguments d'entree -- 
* NOMTAB,NIVTAB nom et niveau du tableau
* KLADRS adresse contenant le coefficient a chercher
*-- Arguments de sortie --
* TYPTAB type du tableau ('ENTIER','REEL','COMPLEXE','CARACTERE','CARACTERE*x')
* VALEUI valeur du coefficient dans le cas entier
* VALEUR valeur du coefficient dans le cas reel
* VALEUC valeur du coefficient dans le cas complexe
* VALEUA valeur du coefficient dans le cas chaine de caractere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTAB,TYPTAB,VALEUA
      INTEGER       NIVTAB,KLADRS,VALEUI
      REAL          VALEUR
      COMPLEX       VALEUC
*
*      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       LGTAB,ITTAB,MCTAB
      CHARACTER     ERCODE*120,TYPINT*12
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GetTab*')
*  
*     Recherche des caracteristiques du tableau
      CALL TBRR1  (ERCODE,NOMTAB,NIVTAB,LGTAB)
      IF (KLADRS.LE.0.OR.KLADRS.GT.LGTAB) GOTO 99990
      CALL TBTYPE (NOMTAB,NIVTAB,ITTAB)
      TYPTAB=TYPINT (ITTAB)                                             !utilite
      CALL TBAR1  (ERCODE,NOMTAB,NIVTAB,MCTAB)
*
      IF (TYPTAB(1:2).EQ.'CA') THEN
         VALEUA=' '
         CALL BAISE  ('Cas d''un tableau de caracteres a prevoir.')
      ELSEIF (TYPTAB(1:1).EQ.'E') THEN
         VALEUI=IST(MCTAB-1+KLADRS)
      ELSEIF (TYPTAB(1:1).EQ.'R') THEN
         VALEUR=RST(MCTAB-1+KLADRS)
      ELSEIF (TYPTAB(1:1).EQ.'C') THEN
         VALEUC=CST(MCTAB-1+KLADRS)
      ENDIF
*
      CALL TBSAVE (NOMTAB,NIVTAB)
      CALL PRFXMJ (-1,'*GetTab*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL ENCLER (KLADRS,ERCODE(1:10))
      CALL ENCLER (LGTAB ,ERCODE(11:20))
      CALL PRNTRM (NOMTAB,NIVTAB,ERCODE(21:),NCATR1)
      CALL BAISE  ('Incompatibilite entre l''adresse '//ERCODE(1:12)
     &//' et la longueur '//ERCODE(13:24)//' du tableau '
     &//ERCODE(21:20+NCATR1)//'.')
                                                                    END !GetTab
