*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GETTRM (ISDTRM,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN
     &                  ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &                  ,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK
     &                  ,NVCORC,IATRDO,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.DeBayser (Avril 1989)
* Derniere modification D.Martin (2 Juillet 1997)
*  
* Recherche des parametres de description d'un terme matriciel dans $SDTRM  
*  
*-- Arguments d'entree -- 
* ISDTRM structure $SDTRM a l'adresse du terme (=MCSDTR+(NUTERM-1)*INCTRM)
*-- Arguments de sortie --
* NIVTRM niveau du tableau contenant le terme 
* ITYPTR indice de type (reel,complexe) du terme  
* ITYCAL type de calcul du terme (ELFINI,VALNOD,C.ESSE,....)
* NUKALE numero du calcul a effectuer (numero d'integrand, de cond. essen....)
* NUDONN numero de donnee associee
* ITYSYM numero de type de symetrie
* NVDSMB numero de la structure d'assemblage multi-inconnue associee
* NUINCC numero de l'inconnue en colonne
* NVDUMC niveau du tableau de numerotation des d.l. en colonne
* NBCOLO nombre de colonnes du terme
* NVNUMC niveau du tableau de numerotation des noeuds en colonne
* NUINCL numero de l'inconnue en ligne
* NVDUML niveau du tableau de numerotation des d.l. en ligne
* NBLIGN nombre de lignes du terme
* NVNUML niveau du tableau de numerotation des noeuds en ligne
* INSTOK numero de type de stockage
* NVSTOK numero du tableau des tables de stokage
* NVCORC numero du tableau des coordonnees des noeuds en colonne
* IATRDO adresse relative du domaine de calcul dans #TERDO si terme primaire  
* NIVIMP niveau d'impression pour le terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ISDTRM(*),NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &       ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML
     &       ,INSTOK,NVSTOK,NVCORC,IATRDO,NIVIMP
*-----------------------------------------------------------------------
      NIVTRM=ISDTRM(1)
      ITYPTR=ISDTRM(2)
      ITYCAL=ISDTRM(3)
      NUKALE=ISDTRM(4)
      NUDONN=ISDTRM(5)
      ITYSYM=ISDTRM(6)
      NVDSMB=ISDTRM(7)
      NUINCC=ISDTRM(8)
      NVDUMC=ISDTRM(9)
      NBCOLO=ISDTRM(10)
      NVNUMC=ISDTRM(11)
      NUINCL=ISDTRM(12)
      NVDUML=ISDTRM(13)
      NBLIGN=ISDTRM(14)
      NVNUML=ISDTRM(15)
      INSTOK=ISDTRM(16)
      NVSTOK=ISDTRM(17)
      NVCORC=ISDTRM(18)
      IATRDO=ISDTRM(19)
      NIVIMP=ISDTRM(20)
                                                                    END !Gettrm
