*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION KLUNIT ( )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1989)
* Derniere modification : D.Martin (30 Juin 1997)
* Version # 1.0.0
*  
* Affectation d'un numero d'unite logique
*  
* Remarque : Le prochain numero d'unite disponible transite intestinalement
*            dans la variable NXTNUF du COMMON/BORDEL/.
*            Le plus haut numero d'unite possible est de meme dans LASNUF. 
*            #Unite,niveau 0 permet d'acceder aux numeros disponibles
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER KLUNIT
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*  
      LOGICAL OPEND
      CHARACTER*120 ERCODE,PRFXAS*8
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL TBAR1  (ERCODE,'#Unite',0,MCFICH) 
      IRET=0
*  
*     Recherche du prochain numero de fichier non affecte. 
*  
1     IF (AST(MCFICH-1+NXTNUF).NE.'%') GOTO 2  
      IF (IRET.EQ.1) THEN
         INQUIRE (UNIT=NXTNUF,OPENED=OPEND) 
         IF (.NOT.OPEND) GOTO 2
      ENDIF
      NXTNUF=NXTNUF+1  
      IF (NXTNUF.GT.LASNUF) GOTO 3 
      GOTO 1  
2     KLUNIT=NXTNUF
      AST(MCFICH-1+NXTNUF)='%' 
      IF (IMPMES.GT.0) WRITE (IMPMES,10) PRFXAS(0),'*KlUnit*',NXTNUF
      RETURN
3     IF (IRET.NE.0)
     &   CALL BAISE  ('*KLUNIT* Plus d''unite logique disponible')
*     On refait un tour a partir de la premiere unite possible 
      NXTNUF=10
*     (Cf ALODYN/TbOpen pour concordance sur "10")
      IRET=1
      GOTO 1
*-----------------------------------------------------------------------
10    FORMAT(T2,A8,'>',A8,'  Affectation du numero de fichier :',I4)  
                                                                    END !KlUnit
