*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NITERM (NMTERM,NVTERM,NIVIMP)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (28 Avril 1998)
* Derniere modification : D.Martin (28 Avril 1998)
* Version 1.0.0
*  
* Modification du niveau d'impression d'un terme
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme
* NVTERM niveau du terme
* NIVIMP nouveau niveau d'impression du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NIVIMP
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER KLTERM
      INTEGER NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &       ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML
     &       ,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVIMR,MCMTRM,NUTERM,MCTERM
     &       ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*NiTerm*')
*  
*     Recherche des caracteristiques du terme source
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
*
      MCTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(MCTERM)  ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN 
     &            ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &            ,NVDUML,NBNELI,NVNUML,INDSTK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMR)                                              !sdexplo
      CALL PUTTRM (IST(MCTERM)  ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN 
     &            ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &            ,NVDUML,NBNELI,NVNUML,INDSTK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMP)                                              !sdexplo

      CALL PRFXMJ (-1,'*NiTerm*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !NiTerm
