*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OUTCST (NUCSTE,ITYPDO,NTIERE,REELLE,COMPLE,CHARAC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser  (Avril 88)  
* Derniere modification : D.Martin (16 Decembre 1998)
*  
* Sous-programme d'affectation de la valeur d'une donnee constante 
*  
*-- Arguments d'entree -- 
* NUCSTE: numero de la constante
* ITYPDO: code entier indiquant le type de la constante
*-- Arguments de sortie --
* NTIERE valeur de la constante entiere
* REELLE valeur de la constante reelle 
* COMPLE valeur de la constante complexe
* CHARAC valeur de la constante chaine de caracteres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHARAC
      INTEGER       NUCSTE,ITYPDO,NTIERE
      REAL          REELLE
      COMPLEX       COMPLE 
*  
      INCLUDE 'ALLOC'
*
      INTEGER   IAD,MCA,MCL,I
      CHARACTER ERCODE*120,TYPINT*12
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*OutCst*')
*  
*     Recherche de la valeur de la constante dans le super-tableau adequat 
*  
      ERCODE(:2)=TYPINT (ITYPDO)                                        !Sdexplo
      IF (ERCODE(:2).EQ.'CA') THEN  
         CALL TBAR2  (ERCODE,'$ACSTE',1,MCA,'$LGCSA',1,MCL)
*        Adresse de la constante caractere recherchee dans AST 
         IAD=MCA
         DO 1 I=1,NUCSTE-1 
            IAD=IAD+IST(MCL+I)
1        CONTINUE
         CALL GETCHN (AST(IAD),IST(MCL+NUCSTE),1,CHARAC)                !Utilite
      ELSEIF (ERCODE(:1).EQ.'E') THEN  
         CALL TBAR1  (ERCODE,'$ECSTE',1,MCL)
         NTIERE=IST(MCL+NUCSTE) 
      ELSEIF (ERCODE(:1).EQ.'R') THEN  
         CALL TBAR1  (ERCODE,'$RCSTE',1,MCL)
         REELLE=RST(MCL+NUCSTE) 
      ELSEIF (ERCODE(:2).EQ.'CO') THEN 
         CALL TBAR1  (ERCODE,'$CCSTE',1,MCL)
         COMPLE=CST(MCL+NUCSTE) 
      ENDIF
      CALL PRFXMJ (-1,'*OutCst*')  
                                                                    END !OutCst
