*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNINC (NUINCO,CHAINE,THEINC,NCAINC)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2001)
* Derniere modification : D.Martin (7 Janvier 2004)
* Version 1.1
*
* Codage du nom d'une inconnue sous la forme NMINCO/CHAINE
*
*-- Arguments d'entree --
* NUINCO numero de l'inconnue
* CHAINE chaine de caracteres annexe
*-- Argument de sortie --
* THEINC chaine de caractere contenant NOM/CHAINE
* NCATRM longueur de la chaine contenant NOM/CHAINE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) CHAINE,THEINC
      INTEGER       NUINCO,NCAINC
*
      INCLUDE 'ALLOC'
*
      CHARACTER     ERTBA2*2
      INTEGER       MCMINC,MCDINC,LGEINC,NCINCO,INCINC,NBCINC
     &             ,NCHDIS,ADINCO,I

*-----------------------------------------------------------------------
      NCHDIS=LEN (THEINC)
*     Adresse du tableau des noms et de description des inconnues
      CALL TBAR2  (ERTBA2,'#OMINC',1,MCMINC,'#NCONU',1,MCDINC)
*     Caracteristiques des inconnues
      CALL SDEXDB (IST(MCDINC),LGEINC,NCINCO,INCINC,NBCINC)             !utilite
*
      ADINCO=MCMINC+NBCINC*(NUINCO-1)
      NCAINC=0
      DO 1 I=1,MIN (NBCINC,NCHDIS)
         IF (AST(ADINCO).NE.' ') THEN
            NCAINC=NCAINC+1
            THEINC(NCAINC:NCAINC)=AST(ADINCO)
            ADINCO=ADINCO+1
         ENDIF
1     CONTINUE
      ADINCO=MIN (LEN (CHAINE),NCHDIS-NCAINC)
      DO 2 I=1,ADINCO
         NCAINC=NCAINC+1
         THEINC(NCAINC:NCAINC)=CHAINE(I:I)
2     CONTINUE
                                                                    END !PrnInc

