*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNTRN (NUTERM,THETRM,NCATRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 2000)
* Derniere modification : D.Martin (9 Juin 2000)
* Version # 1.0.0
*
* Retourne le nom/niveau du terme de numero NUTERM sous la forme (NMTERM,NVTERM)
*-- Arguments d'entree --
* NUTERM numero du terme dans les structures #OMTRM & $SDTRM
*-- Argument de sortie --
* THETRM chaine de caractere contenant les nom/niveau (NMTERM,NVTERM)
* NCATRM longueur de la chaine contenant (NMTERM,NVTERM)
*
*-- Procedures utilisees --
* ENCLER (utiliter), PRNTRM (utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) THETRM
      INTEGER       NUTERM,NCATRM
*
      INCLUDE 'ALLOC'
*
      CHARACTER CHAINE*32
      INTEGER MCDTRM,MCMTRM,LGETRM,NBTERM,INCTRM,NCHTRM
*-----------------------------------------------------------------------
*
*     Adresses des structures $SDTRM et #OMTRM
*
      CALL TBAR2  (CHAINE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Niveau du terme
*
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      NVTERM=IST(ADTERM)
*
*     Nom du terme
*
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,CHAINE)                    !utilite
      NWHTRM=NCHTRM
      DO 1 NCHTRM=NWHTRM,1,-1
         IF (CHAINE(NCHTRM:NCHTRM).NE.' ') GOTO 2
1     CONTINUE
*
2     CALL PRNTRM (CHAINE(1:NCHTRM),NVTERM,THETRM,NCATRM)               !utilite
                                                                    END !PrnTrn