*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FAFINA (NMMATR,NVMATR,INSTOK
     &                  ,NMFACT,NVFACT,TYFACT,NMPROF,NVPROF,NIVIMP) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1998) 
* Derniere modification : D.Martin (30 Janvier 1998)
* Version 1.0.0
*
* Sauvegarde des tableaux apres factorisation et message final
*
* NMMATR nom du tableau contenant la matrice a factoriser 
* NVMATR son niveau
* INSTOK indice de type de stockage de la matrice a factoriser
* NMFACT nom du terme stocke 'Profil' contenant la matrice factorisee
* NVFACT son niveau
* NMPROF nom du tableau de stockage de la matrice factorisee
* NVPROF niveau du ou des tableaux de stockage PROFIL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATR,NMFACT,TYFACT,NMPROF
      INTEGER       NVMATR,INSTOK,NVFACT,NVPROF,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       NCATR1
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FaFina*')
*
      IF (NMMATR.NE.NMFACT.OR.NVMATR.NE.NVFACT) 
     &   CALL TBSAVE (NMMATR,NVMATR)
      CALL TBSAVE (NMFACT,NVFACT)
      CALL TBSAVE (NMPROF,NVPROF)
*
      IF (NIVIMP.GE.0) THEN
*         CALL PRNTRM (NMMATR,NVMATR,ERCODE(1:32),NCATR1)               !utilite
*        WRITE (IMPPAL,10000) PRFXAS (1),TYFACT
*     &                      ,ERCODE(1:NCATR1),STOIND (INSTOK)
         IF (NMMATR.NE.NMFACT.OR.NVMATR.NE.NVFACT) THEN
            CALL PRNTRM (NMFACT,NVFACT,ERCODE(1:32),NCATR1)             !utilite
            WRITE (IMPPAL,10002) ERCODE(1:NCATR1)
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*FaFina*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Factorisation ',A,' de la matrice ',A,' : ',A)
10002 FORMAT(T11,'selon le stockage PROFIL et le nom de terme : ',A)
                                                                    END !FaFina
