*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CHARTY (CARAC,MAJVAL,INDICE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1994)
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2
*  
*-- Arguments d'entree -- 
* CARAC  un caractere du code ASCII
* MAJVAL =1 les minuscules sont transformees en majuscules
*  
*-- Arguments de sortie et Etiquettes de retour --
* CARAC  lettre majuscule associee a CARAC si CARAC est une lettre
* MAJVAL valeur du chiffre si CARAC est un chiffre, 0 sinon
* INDICE indicateur du caractere trouve :
*        =0  separateur (blanc ou # : ; =)      =1 ! ou % ou @             
*        =2  ( ou < ou [ ou {                   =3 ) ou > ou ] ou }
*        =4  ' ou " ou `                        =5 + ou - 
*        =6  . ou ,                             =7 lettre
*        =8  chiffre                            =9 $ (dollar)
*        =10 \ (antislash)                      =11 / (slash)
*        =12 autre caractere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER  CARAC
      INTEGER    MAJVAL,INDICE
*
      INTEGER    ALPHAB,CHIFFR
      INTEGER    NBSEPA,IT,NUMSEP
      PARAMETER (NBSEPA=5) 
      CHARACTER LISEPA(NBSEPA)
      DATA LISEPA/' ','#',':',';','='/
*-----------------------------------------------------------------------
      INDICE=12
      CALL DICCHN (1,NBSEPA,1,LISEPA,CARAC,IT,NUMSEP)                   !Utilite
      IF (NUMSEP.NE.0) THEN
         INDICE=0 
      ELSEIF (ALPHAB (CARAC,MAJVAL).EQ.1) THEN                          !Utilite
         INDICE=7 
      ELSEIF (CHIFFR (CARAC,MAJVAL).EQ.1) THEN                          !Utilite
         INDICE=8
      ELSEIF (CARAC.EQ.'!'.OR.CARAC.EQ.'%'.OR.CARAC.EQ.'@') THEN
         INDICE=1
      ELSEIF (CARAC.EQ.''''.OR.CARAC.EQ.'"'.OR.CARAC.EQ.'`') THEN
         INDICE=4
      ELSEIF (CARAC.EQ.'+'.OR.CARAC.EQ.'-') THEN
         INDICE=5
      ELSEIF (CARAC.EQ.'.'.OR.CARAC.EQ.',') THEN
         INDICE=6
      ELSEIF (CARAC.EQ.'$') THEN
         INDICE=9
      ELSEIF (CARAC.EQ.CHAR(92)) THEN
         INDICE=10
      ELSEIF (CARAC.EQ.'/') THEN
         INDICE=11
      ELSEIF (CARAC.EQ.'('.OR.CARAC.EQ.'<'
     &    .OR.CARAC.EQ.'['.OR.CARAC.EQ.'{') THEN
         INDICE=2 
      ELSEIF (CARAC.EQ.')'.OR.CARAC.EQ.'>'
     &    .OR.CARAC.EQ.']'.OR.CARAC.EQ.'}') THEN
         INDICE=3
      ENDIF
      IF (INDICE.NE.8) MAJVAL=0
                                                                    END !CharTy
