/*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  csystm : executes system call defined by string input_cmd
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Author : D.Martin (May 2002)
  Last Update : D.Martin (7 May 2002)
  Version 1.0.0

 Called in Utiliter/Osarnm
*/

#include <stdlib.h>

#ifdef C_NO_TRAILING_UNDERSCORE
/*
  xlf (IBM compiler) version : AIX-IBM / Mac OS X-Darwin
*/
void csystm (const char *input_cmd  /*input_cmd character string, defines command*/
            ,int *status            /*status    integer, command output status*/
            )
#else
/* 
  g77 (GNU compiler) : Darwin (MacOSX) / Linux / SunOS ...
  f77 (native compiler) SunOS / OSF1-DEC / IRIX-SGI
*/
void csystm_ (const char *input_cmd  /*input_cmd character string, defines command*/
             ,int *status            /*status    integer, command output status*/
             )
#endif

{
   *status=system (input_cmd);
}
