*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DCOCHN (CHAINE,LGCHAI,ARTICL
     &                  ,ARTICH,ARTIDB,ITEMVA,ITEMCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 1995)
* Derniere modification : D.Martin (28 Avril 1999)
*
* Recherche dans la chaine CHAINE de la chaine ARTICL et de sa valeur ITEMVA.
* La chaine est structuree sous la forme d'articles de la forme <ARTICL=ITEMVA>
* separes par des virgules
*
*-- Arguments d'entree --
* CHAINE chaine de caracteres a dechiffrer
* LGCHAI sa longueur (en nombre de caracteres)
* ARTICL nom de l'article dont la valeur est recherche
*-- Arguments de sortie --
* ARTICH nombre de caracteres de l'article i.e. longueur de <ARTICL=ITEMVA,>
*        y compris les blancs precedant ARTICL, de par et d'autre du signe =
*        et precedant la virgule.
* ARTIDB adresse dans CHAINE de la sous-chaine <ARTICL=ITEMVA,>
* ITEMVA valeur de l'article recherche, i.e. la sous-chaine precedee de
*        <ARTICL=> et suivie d'une virgule (blancs terminaux exclus)
* ITEMCH nombre de caracteres de cette chaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE,ARTICL,ITEMVA
      INTEGER       LGCHAI,ARTICH,ITEMDB,ITEMCH
*
      INTEGER       ARTIDB,ARTIFN,IEGAL,IVIRG,I1
*-----------------------------------------------------------------------
      ITEMVA = ' '
      ITEMCH = 0
      ARTICH = 0
      ARTIDB = INDEX (CHAINE,ARTICL)
      IF (ARTIDB.GT.0) THEN
         IEGAL=INDEX(CHAINE(ARTIDB:LGCHAI),'=')
         ITEMDB=IEGAL+ARTIDB
         IVIRG=INDEX(CHAINE(ITEMDB:LGCHAI),',')
         IF (IVIRG.LE.0) THEN
            ARTIFN=LGCHAI
         ELSE
            ARTIFN=IVIRG+ITEMDB-2
         ENDIF
         ARTICH = ARTIFN-ARTIDB+2
         DO 1 I1=ARTIDB-1,1,-1
            IF (CHAINE(I1:I1).NE.' ') GOTO 2
            ARTICH=ARTICH+1
1        CONTINUE
*
*        Prise en compte des blancs precedents
*
*        Suppression des caracteres blancs de debut et de fin
2        DO 10 I1=ITEMDB,ARTIFN
            IF (CHAINE(I1:I1).NE.' ') GOTO 11
10       CONTINUE
11       ITEMDB=I1
         DO 12 I1=ARTIFN,ITEMDB,-1
            IF (CHAINE(I1:I1).NE.' ') GOTO 13
12       CONTINUE
13       ARTIFN  = I1
         ITEMVA = CHAINE(ITEMDB:ARTIFN)
         ITEMCH = ARTIFN-ITEMDB+1
      ENDIF
                                                                    END !DcoChn
