*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERDONN (ERRNUM,NMDONN)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1994) 
* Derniere modification : D.Martin (11 Decembre 1999)
* Version 1.0.1
*  
* Message d'erreurs pour une donnee
*  
*-- Arguments d'entree --
* ERRNUM =  1 Donnee inexistante
* ERRNUM =  2 Donnee non constante
* ERRNUM =  3 Donnee non tableau
* ERRNUM =  4 Donnee non fonction
* ERRNUM =  5 Donnee fonction sans constante associee
* ERRNUM =  6 Donnee fonction sans tableau associee
* ERRNUM = 10 Donnee caractere pas du bon type
* ERRNUM = 11 Donnee entiere pas du bon type
* ERRNUM = 12 Donnee reelle pas du bon type
* ERRNUM = 13 Donnee pas du bon type
* ERRNUM = 14 Donnee complexe pas du bon type
* ERRNUM = 15 Redinition du type de representation de la donnee CONSTANTE
* ERRNUM = 16 Redinition du type de representation de la donnee TABLEAU
* ERRNUM = 17 Redinition du type de representation de la donnee FONCTION
* ERRNUM = 18 Redinition du niveau de la donnee TABLEAU
* ERRNUM = 19 Donnee non CONSTANTE affectee a un terme d'assemblage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMDONN
      INTEGER       ERRNUM
*
      INTEGER       NCHDON,DIXN,NBCARE
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      NCHDON=LEN (NMDONN)
      ERCODE=NMDONN
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ERRNUM.LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(113:112+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(1:NCHDON)
     &   //' n''existe pas dans les structures des donnees?')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(1:NCHDON)
     &   //' n''est pas une constante!')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(1:NCHDON)//' n''est pas un tableau!')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)//' n''est pas une fonction!')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee fonction '//ERCODE(:NCHDON)
     &   //' n''a pas de donnee tableau associe!')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee fonction '//ERCODE(:NCHDON)
     &   //' n''a pas de donnee constante associee!')
      ELSEIF (ERRNUM.EQ.10) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)
     &   //' CARACTERE n''est pas du bon type!')
      ELSEIF (ERRNUM.EQ.11) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)
     &   //' (ENTIERE) n''est pas du bon type!')
      ELSEIF (ERRNUM.EQ.12) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)
     &   //' (REELLE) n''est pas du bon type!')
      ELSEIF (ERRNUM.EQ.13) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)
     &   //' n''est pas du bon type!')
      ELSEIF (ERRNUM.EQ.14) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- La donnee '//ERCODE(:NCHDON)
     &   //' (COMPLEXE) n''est pas du bon type!')
      ELSEIF (ERRNUM.EQ.15) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- Redifinition du type de representation de la donnee '
     &   //ERCODE(:NCHDON)//' CONSTANTE interdite!')
      ELSEIF (ERRNUM.EQ.16) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- Redifinition du type de representation de la donnee '
     &   //ERCODE(:NCHDON)//' TABLEAU interdite!')
      ELSEIF (ERRNUM.EQ.17) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- Redifinition du type de representation de la donnee '
     &   //ERCODE(:NCHDON)//' FONCTION interdite!')
      ELSEIF (ERRNUM.EQ.18) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'- Redifinition du niveau de la donnee TABLEAU '
     &   //ERCODE(:NCHDON)//' interdite!')
      ELSEIF (ERRNUM.EQ.19) THEN
         CALL BAISE  ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //'-  La donnee '//ERCODE(:NCHDON)//' non CONSTANTE'
     &   //' ne peut etre affectee a un terme d''assemblage.')
      ELSE
         CALL WARNNG ('<ErDonn> Code '//ERCODE(113:112+NBCARE)
     &   //' non prevu - Donnee '//ERCODE(1:NCHDON))
      ENDIF
                                                                    END !ErDonn
