*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INCESS (NMCESS)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)  
* Derniere modification : D.Martin (10 Fevrier 1999)
* Version 1.0.0
*
* Codage du type de calcul d'un terme 'Condition Essentielle' par un entier
*  
*-- Argument d'entree --  
* NMCESS chaine de caractere representant le type de condition essentielle
*
*-- Liste des types de termes 'Condition Essentielle' --
* NUKALE  Calcul ou mot-cle Signification
* 1       =g                u=g    (g donne par Fonction ou tableau)
* 2       .n=g              u.n=g  (g donne par Fonction ou tableau)
* 3       ^n=g              u^n=g  (g donne par Fonction ou tableau)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMCESS
      INTEGER       INCESS 
*
      INTEGER       NBCHEN,NBCCHN,KELCHN
      CHARACTER     UPPERC*2
      CHARACTER     CCCHEN*120,TBCHEN(120),NMCESW*2
      COMMON/ONSEPA/CCCHEN 
      EQUIVALENCE  (TBCHEN,CCCHEN)
*-----------------------------------------------------------------------
      NBCHEN=3
      NBCCHN=2
      NMCESW=UPPERC (NMCESS)
      CCCHEN(1:NBCCHN*NBCHEN)='  .N^N'
      INCESS=KELCHN (NMCESW,TBCHEN,NBCHEN,NBCCHN)
*
      IF (INCESS.LE.0) INCESS=1
*      IF (INCESS.GT.0) RETURN
*-----------------------------------------------------------------------
*      WRITE (*,10000)
*      WRITE (*,10001) (K,CCCHEN(1+NBCCHN*(K-1):NBCCHN*K),K=1,NBCHEN)
*10000 FORMAT (/' *InCess* Liste des types de Conditions Essentielles'/)
*10001 FORMAT ((T3,10(I4,'-',A2,' |',:)))
*      K=LEN (NMCESS)
*      CCCHEN(1:K)=NMCESS
*      CALL BAISE  ('*InCess* Type de Condition Essentielle non reconnu :'
*     &//CCCHEN(1:K)//'.')
                                                                    END !InCess
