*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INDSTO (CHAINE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1989)
* Derniere modification : D.Martin (3 Mars 2000)
* Version # 1.0.1
*  
* Codage du type de stockage d'un terme par un entier
* Function reciproque StoInd
*
*-- Argument d'entree --
* CHAINE chaine de caractere representant le type de stockage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE
      INTEGER       INDSTO
*
      INTEGER       NBCHEN,NBCCHN,KELCHN
      PARAMETER    (NBCHEN=9,NBCCHN=7)
      CHARACTER     CCCHEN*120,TBCHEN(NBCHEN*NBCCHN)
      COMMON/ONSEPA/CCCHEN
      EQUIVALENCE  (TBCHEN,CCCHEN)
*-----------------------------------------------------------------------
      CCCHEN(1:NBCHEN*NBCCHN)
     &='PLEIN-LPLEIN-CMORSE-LMORSE-CBIMORSEPROFIL NUME-L NUME-C DIAG   '
*
      INDSTO=KELCHN (CHAINE,TBCHEN,NBCHEN,NBCCHN)                       !Utilite
      IF (INDSTO.LE.0.AND.CHAINE(:5).EQ.'MORSE') INDSTO=3
      IF (INDSTO.LE.0.AND.CHAINE(:5).EQ.'PLEIN') INDSTO=1
                                                                    END !Indsto
