*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LISINC (NBLIS1,LISTE1,NBLIS2,LISTE2,ITEMDB,ITEMFN,*)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 91) 
* Derniere modification (D.Martin) le 6 Decembre 1996 
*  
* Determination de l'inclusion d'une liste LISTE1 dans une liste LISTE2 
*  
*-- Arguments d'entree -- 
* NBLIS1 nombre de nombres de la 1ere liste
* LISTE1  1ere liste
* NBLIS2 nombre de nombres de la 2eme liste
* LISTE2  2eme liste
*-- Arguments de sortie --
* ITEMDB adresse dans LISTE2 du 1er element de LISTE1
* ITEMDB adresse dans LISTE2 du dernier element de LISTE1
* (*)  etiquette de retour en cas d'inclusion de LISTE1 dans LISTE2
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLIS1,LISTE1(*),NBLIS2,LISTE2(*),ITEMDB,ITEMFN
*
      INTEGER INEXT,I,INEXS
*-----------------------------------------------------------------------
      CALL DICOTO (1,NBLIS2,LISTE2,LISTE1(1),ITEMDB,*99999)
      ITEMFN=ITEMDB+NBLIS1-1
      IF (ITEMFN.GT.NBLIS2) GOTO 99999
*
      CALL DICOTO (ITEMDB,NBLIS2,LISTE2,LISTE1(NBLIS1),ITEMFN,*99999)
*
*     Les extremites de LISTE1 sont dans LISTE2
*     LISTE1 est-elle un sous-ensemble d'elements consecutifs de LISTE2 ?
*
      IF ((LISTE2(ITEMDB)+NBLIS1-1.EQ.LISTE2(ITEMFN))
     &    .AND.(ITEMFN-ITEMDB+1.EQ.NBLIS1)           ) RETURN 1
*
*     Sinon est-elle incluse dans LISTE2
*
      INEXT=ITEMDB+1
      DO 2 I=2,NBLIS1-1
         CALL DICOTO (INEXT,NBLIS2,LISTE2,LISTE1(I),INEXS,*99999)
2        INEXT=INEXS+1
*     
      RETURN 1
99999 RETURN
                                                                    END !LisInc
