*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNTRA (NMTERM,NVTERM,THETRM,NCATRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 2000)
* Derniere modification : D.Martin (14 Mai 2001)
* Version 1.0.2
*  
* Codage des nom et niveau d'un terme sous la forme ('NMTERM',NVTERM)
*
* Exemple : Si NMTERM='TOTO', NVTERM=10 et LEN(THETRM) > 8 la procedure
*           retourne THETRM=('TOTO',10) et NCATRM=11
*  
*-- Arguments d'entree --
* NMTERM nom du terme
* NVTERM niveau du terme
*-- Argument de sortie --
* THETRM chaine de caractere contenant (NOM,NIVEAU)
* NCATRM longueur de la chaine contenant (NOM,NIVEAU)
*-- Procedures utilisees --
* ENCLER (utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM,THETRM
      INTEGER       NVTERM,NCATRM
*
      INTEGER       NCHTRM,NCHDIS,NBCARN,NVTERA,DIXN
*-----------------------------------------------------------------------
      NCHDIS=LEN (THETRM)
      NCHTRM=LEN (NMTERM)
      DO 1 NBCARN=NCHTRM,1,-1
         IF (NMTERM(NBCARN:NBCARN).NE.' ') GOTO 2
1     CONTINUE
2     NCHTRM=NBCARN
      THETRM(1:MIN(NCHTRM,NCHDIS))=NMTERM
      NCATRM=MIN(NCHTRM,NCHDIS)
      NVTERA=ABS (NVTERM)
      DIXN=10
      DO 3 NBCARN=1,9
         IF (NVTERA.LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (NVTERM.LT.0) NBCARN=NBCARN+1
*
      IF (NCHDIS.GE.4+NCHTRM) THEN
         THETRM(1:4+NCHTRM)='('//''''//NMTERM(1:NCHTRM)//''''//','
         NCATRM=NCHTRM+4
         IF (NCHDIS.GE.NCHTRM+4+NBCARN) THEN
            CALL ENCLER (NVTERM,THETRM(NCHTRM+5:NCHTRM+4+NBCARN))
            NCATRM=NCATRM+NBCARN
            IF (NCHDIS.GE.NCHTRM+3+NBCARN) THEN
               THETRM(NCHTRM+5+NBCARN:NCHTRM+5+NBCARN)=')'
               NCATRM=NCATRM+1
            ENDIF
         ENDIF
      ENDIF
                                                                    END !PrnTra
