*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELCNE (IMAGE,NOMBRE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Juin 1988) 
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2
*
* Representer la chaine IMAGE composee de caracteres 'chiffres' et comportant 
* eventuellement une signe + ou - sous forme d'une valeur entiere (inverse 
* du sous-programme ENCLER). 
* Si IMAGE contient d'autres caracteres le programme s'arrete (STOP).
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) IMAGE,CARACT*1
*
      INTEGER CHIFFR
      INTEGER NOMBRE,ISIGN,IPUIS,ICAR,ICHIFR
*-----------------------------------------------------------------------
      NOMBRE=0 
      ISIGN=1  
      IPUIS=1  
      DO 1 ICAR=LEN(IMAGE),1,-1
         CARACT=IMAGE(ICAR:ICAR)
         IF (CARACT.EQ.'+') GOTO 2 
         IF (CARACT.EQ.'-') THEN
            ISIGN=-1
            GOTO 2
         ENDIF
*         Les blancs a l'interieur de la chaine sont ignores
         IF (CARACT.EQ.' ') GOTO 1 
         IF (CHIFFR(CARACT,ICHIFR).NE.1) CALL BAISE ('*Relcne* '
     &           //CARACT//' : Caractere impossible a coder en entier') !Utilite
         NOMBRE=NOMBRE+ICHIFR*IPUIS
         IPUIS=IPUIS*10
1     CONTINUE 
2     NOMBRE=ISIGN*NOMBRE  
                                                                    END !Relcne
