*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION STODLN (INDICE, NCPINC, NCPINL)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (8 octobre 2008)
* Derniere modification : D.Martin (30 octobre 2008)
* Version 0
*  
* Nom du tableau de stockage d'une matrice en fonction de son numero de type
* de stockage et des nombres de composantes de ses inconnues
*
*-- Argument d'entree --
* INDICE entier representant le type de stockage
* NCPINC nombre de composante de l'inconnue en colonne
* NCPINL nombre de composante de l'inconnue en ligne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*6 STODLN
      INTEGER     INDICE, NCPINC, NCPINL
*
      INTEGER     NBCHEN,NBCCHN
      PARAMETER   (NBCHEN=9,NBCCHN=6)
      CHARACTER   CCCHEN*120
      COMMON/ONSEPA/CCCHEN
*-----------------------------------------------------------------------
      STODLN = ' '
      CCCHEN(1:NBCHEN*NBCCHN)
     &='PLEINLPLEINC&PLAGE&EGALP&BMORS&PROFL&NUMEL&NUMECDIAG  '
      IF (INDICE.LE.0.OR.INDICE.GT.NBCHEN) RETURN
*
      STODLN = CCCHEN (1+NBCCHN*(INDICE-1):NBCCHN*INDICE)
*
      IF (NCPINC*NCPINL.GT.1) THEN
         IF (INDICE.GT.2.AND.INDICE.LT.7) THEN
            CALL ENCLER(NCPINC,STODLN(NBCCHN-1:NBCCHN-1))
            CALL ENCLER(NCPINL,STODLN(NBCCHN:NBCCHN))
         ELSE
            CALL BAISE  (' Stockage avec d.l. vectoriels non prevu '
     &//' pour le type de stockage (scalaire) '//STODLN//'.')
         ENDIF
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (30 octobre 2008)
*  Ajout d'un baise pour les types de stockage non supportés
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Stodln
