*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TMOINT (NBC,TYP1,MC1,RST1,CST1
     &                      ,TYP2,MC2,RST2,CST2,TYP3,MC3,RST3,CST3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mai 1990)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Soustraction de deux tableaux et resultat dans un 3ieme
*  
*-- Arguments --  
* NBC   nombre de coefficients
* TYPi  type du ieme tableau ('REEL','COMPLEXE') 
* MCi   adresse du ieme tableau dans le tab. reel RSTi ou complexe CSTi  
* RSTi  tableau contenant le ieme tableau (cas reel) 
* CSTi  tableau contenant le ieme tableau (cas complexe) 
*  
* Voir idees d'exemples d'utilisation dans le source de TDANST 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYP3 
      INTEGER       NBC,MC1,MC2,MC3
      REAL          RST1(*),RST2(*),RST3(*)  
      COMPLEX       CST1(*),CST2(*),CST3(*)
*
      INTEGER       MCT1,MCT2,I
*-----------------------------------------------------------------------
      MCT1=MC1 
      MCT2=MC2 
      IF (TYP3(1:1).EQ.'R') THEN
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN  
               DO 11 I=MC3,MC3-1+NBC  
                  RST3(I)=RST1(MCT1)-RST2(MCT2)
                  MCT1=MCT1+1  
11                MCT2=MCT2+1  
            ELSEIF (TYP1(1:1).EQ.'C') THEN 
               DO 12 I=MC3,MC3-1+NBC  
                  RST3(I)=REAL(CST1(MCT1)-CST2(MCT2))
                  MCT1=MCT1+1  
12                MCT2=MCT2+1  
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 13 I=MC3,MC3-1+NBC 
               RST3(I)=RST1(MCT1)-REAL(CST2(MCT2)) 
               MCT1=MCT1+1 
13             MCT2=MCT2+1 
         ELSE  
            DO 14 I=MC3,MC3-1+NBC 
               RST3(I)=REAL(CST1(MCT1))-RST2(MCT2)  
               MCT1=MCT1+1 
14             MCT2=MCT2+1 
         ENDIF
      ELSE 
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN  
               DO 1 I=MC3,MC3-1+NBC
                  CST3(I)=CST1(MCT1)-CST2(MCT2)
                  MCT1=MCT1+1  
1                 MCT2=MCT2+1  
            ELSEIF (TYP1(1:1).EQ.'R') THEN 
               DO 2 I=MC3,MC3-1+NBC
                  CST3(I)=RST1(MCT1)-RST2(MCT2)
                  MCT1=MCT1+1  
2                 MCT2=MCT2+1  
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 3 I=MC3,MC3-1+NBC  
               CST3(I)=RST1(MCT1)-CST2(MCT2)  
               MCT1=MCT1+1 
3              MCT2=MCT2+1 
         ELSE  
            DO 4 I=MC3,MC3-1+NBC  
               CST3(I)=CST1(MCT1)-RST2(MCT2)  
               MCT1=MCT1+1 
4              MCT2=MCT2+1 
         ENDIF
      ENDIF
                                                                    END !TMoinT
