*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TNORMX (NBC,TYPT,MCT,IST,RST,CST,MAXIMU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mai 90)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Calcul de la norme l-infini d'un tableau  
*  
*-- Arguments --  
* NBC    nombre de coefficients du vecteur
* TYPT   type du tableau ('ENTIER','REEL','COMPLEXE')  
* MCT    adresse du tableau dans le tableau du bon type
* IST    tableau contenant le tableau  (cas reel)
* RST    tableau contenant le tableau  (cas reel) 
* CST    tableau contenant le tableau  (cas complexe) 
* MAXIMU norme l-infini du vecteur (reel quel que soit le type du tableau)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPT*(*)
      INTEGER   NBC,MCT,IST(*)
      REAL      RST(*) 
      COMPLEX   CST(*)
*
      INTEGER   ICOEF
      REAL      MAXIMU,RMAX
*-----------------------------------------------------------------------
      MAXIMU=0.
      IF (TYPT(1:2).EQ.'CA') THEN
         GOTO 90001
      ELSEIF (TYPT(1:1).EQ.'E') THEN
         DO 1 ICOEF=MCT,MCT-1+NBC
            RMAX=IST(ICOEF)
            MAXIMU=MAX(MAXIMU,ABS(RMAX))
1        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         DO 2 ICOEF=MCT,MCT-1+NBC  
            MAXIMU=MAX(MAXIMU,ABS(RST(ICOEF)))
2        CONTINUE 
      ELSEIF (TYPT(1:1).EQ.'C') THEN  
         DO 4 ICOEF=MCT,MCT-1+NBC  
            MAXIMU=MAX(MAXIMU,ABS(CST(ICOEF)))
4        CONTINUE 
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE (' Maximum d''un tableau de CARACTERES ???')
                                                                    END !TNormx
