*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TOUTPU (TYPT,MCT,IST,RST,CST
     &                  ,KLADRS,KLVALE,KLVALR,KLVALC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Decembre 1991)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recuperation d'une valeur dans un tableau a une adresse relative donnee  
*  
*-- Arguments d'entree --
* TYPT  : type du tableau ('ENTIER','REEL','COMPLEXE')  
* MCT   : adresse absolue du tableau dans le tableau du bon type
* IST   : tableau contenant le tableau  (cas reel) 
* RST   : tableau contenant le tableau  (cas reel) 
* CST   : tableau contenant le tableau  (cas complexe)
* KLADRS: adresse relative ou recuperer le coefficient
*-- Arguments de sortie --
* KLVALI: valeur du coeff. a recuperer dans le tableau entier
* KLVALR: valeur du coeff. a recuperer dans le tableau reel
* KLVALC: valeur du coeff. a recuperer dans le tableau complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPT*(*)
      INTEGER   MCT,IST(*),KLVALE,KLADRS
      REAL      RST(*),KLVALR  
      COMPLEX   CST(*),KLVALC  
*-----------------------------------------------------------------------
      IF (TYPT(1:1).EQ.'E') THEN
         KLVALE=IST(MCT-1+KLADRS)
      ELSEIF  (TYPT(1:1).EQ.'R') THEN
         KLVALR=RST(MCT-1+KLADRS)
      ELSEIF (TYPT(1:1).EQ.'C') THEN  
         KLVALC=CST(MCT-1+KLADRS)
      ENDIF
                                                                    END !TOutpu
