*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTMOT (NBC,TYP1,MC1,PTR122,TYP2,MC2,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Assemblage de tableaux sous la forme S = S - B connaissant le tableau
* des pointeurs de coefficients de B dans S.
*  
*-- Arguments --
* NBC    longueur du tableau B
* TYP1   type de declaration du tableau a assembler (B)
* MC1    adresse du tableau a assembler dans le tableau RST ou CST
* PTR122 tableau des addresses des coefficients de B dans S
* TYP2   type de declaration du tableau resultat (S)
* MC2    adresse du tableau resultat dans le tableau RST ou CST selon son type
* IST    tableau contenant les arguments entiers (pour la constante) 
* RST    tableau contenant les arguments reels
* CST    tableau contenant les arguments complexes 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2
      INTEGER       NBC,MC1,MC2,PTR122(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MC11,MC22,I
*-----------------------------------------------------------------------
      MC11=MC1
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
         IF (TYP2(1:1).EQ.'R') THEN
            DO 202 I=1,NBC
               MC22=MC2-1+PTR122(I)
               RST(MC22)=RST(MC22)-RST(MC11)
               MC11=MC11+1
202         CONTINUE
         ELSE
            DO 404 I=1,NBC
               MC22=MC2-1+PTR122(I)
               CST(MC22)=CST(MC22)-CST(MC11)
               MC11=MC11+1
404         CONTINUE
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         DO 402 I=1,NBC
           MC22=MC2-1+PTR122(I)
            CST(MC22)=CST(MC22)-RST(MC11)
            MC11=MC11+1
402      CONTINUE
      ENDIF
                                                                    END !TptMot
