*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRI2TB (N,IST1,TYPE,IST2,RST2,CST2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification : D.Martin (20 decembre 1994)
*
* Tri a bulle du tableau d'entier IST1 selon l'ordre croissant,
* les permutations etant aussi effectuees sur l'un des tableaux
* IST2, RST2, CST2 selon la valeur de type
*
*-- Arguments --
* N    nombre d'elements des tableaux IST1, IST2 ,RST2 ou CST2
* IST1 tableau d'entier a trier selon l'ordre croissant
* TYPE type (ENTIER, REEL, COMPLEXE) a trier parallelement
* IST2 tableau ENTIER a trier parallelement
* RST2 tableau REEL a trier parallelement
* CST2 tableau COMPLEXE a trier parallelement
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER N,IST1(*),IST2(*)
      REAL    RST2(*)
      COMPLEX CST2(*)
*
      INTEGER I,J,IAUX1,IAUX2
      REAL    RAUX2
      COMPLEX CAUX2
      LOGICAL PERMUT
*
      I=0
      IF (TYPE(1:1).EQ.'E') THEN
11       PERMUT=.FALSE.
         I=I+1
         DO 12 J=N-1,I,-1
           IF (IST1(J+1).LT.IST1(J)) THEN
             IAUX1    =IST1(J)
             IST1(J)  =IST1(J+1)
             IST1(J+1)=IAUX1
             IAUX2    =IST2(J)
             IST2(J)  =IST2(J+1)
             IST2(J+1)=IAUX2
             PERMUT   =.TRUE.
           ENDIF
12       CONTINUE
         IF (PERMUT) GOTO 11
      ELSEIF (TYPE(1:1).EQ.'R') THEN
21       PERMUT=.FALSE.
         I=I+1
         DO 22 J=N-1,I,-1
           IF (IST1(J+1).LT.IST1(J)) THEN
             IAUX1    =IST1(J)
             IST1(J)  =IST1(J+1)
             IST1(J+1)=IAUX1
             RAUX2    =RST2(J)
             RST2(J)  =RST2(J+1)
             RST2(J+1)=RAUX2
             PERMUT   =.TRUE.
           ENDIF
22       CONTINUE
         IF (PERMUT) GOTO 21
      ELSEIF (TYPE(1:1).EQ.'C') THEN
41       PERMUT=.FALSE.
         I=I+1
         DO 42 J=N-1,I,-1
           IF (IST1(J+1).LT.IST1(J)) THEN
             IAUX1    =IST1(J)
             IST1(J)  =IST1(J+1)
             IST1(J+1)=IAUX1
             CAUX2    =CST2(J)
             CST2(J)  =CST2(J+1)
             CST2(J+1)=CAUX2
             PERMUT   =.TRUE.
           ENDIF
42       CONTINUE
         IF (PERMUT) GOTO 41
      ELSE
51       PERMUT=.FALSE.
         I=I+1
         DO 52 J=N-1,I,-1
           IF (IST1(J+1).LT.IST1(J)) THEN
             IAUX1    =IST1(J)
             IST1(J)  =IST1(J+1)
             IST1(J+1)=IAUX1
             PERMUT   =.TRUE.
           ENDIF
52       CONTINUE
         IF (PERMUT) GOTO 51
      ENDIF
                                                                    END !Tri2Tb   
