*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VANOAT (NUVANO,NDIM,NCPINC,NVALNE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998)
* Derniere modification : D.Martin (2 Mai 2002)
*
* Attributs des termes de type 'Valeurs Nodales'
*
*-- Arguments d'entree --- 
* NUVANO numero de type de termes 'Valeurs Nodales'
* NDIM   dimension d'espace
* NCPINC nombre de composantes de l'inconnue du terme
*-- Arguments de sortie --- 
* NVALNE nombre de valeurs par noeud du terme 'Valeurs Nodales' de type NUVANO 
*
*-- Voir Liste des Types de Valeurs Nodales dans INVANO
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUVANO,NDIM,NCPINC,NVALNE
*
      INTEGER INVANO                                                    !utilite
*-----------------------------------------------------------------------
      NWALNE=NCPINC
      IF (NUVANO.EQ.INVANO ('F').OR.NUVANO.EQ.INVANO ('TABF')) THEN
         IF (NVALNE.GE.4) THEN
*           Terme Matriciel/Tensoriel par noeud
            NWALNE=NCPINC*NCPINC
         ENDIF
      ELSEIF (NUVANO.EQ.INVANO ('N.F')) THEN
         NWALNE=1
      ELSEIF (NUVANO.EQ.INVANO ('N^F').OR.NUVANO.EQ.INVANO ('F^N')
     &    .OR.NUVANO.EQ.INVANO ('N^(N^F)')) THEN
         IF (NDIM.EQ.2.AND.NCPINC.EQ.2) NWALNE=1
      ENDIF
      NVALNE=NWALNE
                                                                    END !VanoAt
