*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WATERS (NMTRM1,NVTRM1,NUINC1,NUINL1,ITYSY1,INDST1,LG1
     &                  ,NMTRM2,NVTRM2,NUINC2,NUINL2,ITYSY2,INDST2,LG2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1994) 
* Derniere modification : D.Martin (30 Mai 2000)
* Version 1
*  
* Tests de compatibilite lors de la combinaison de termes
* (meme(s) inconnue(s),meme type de stockage, meme longueur) ?
*  
*-- Arguments d'entree --
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTRM1,NMTRM2
      INTEGER       NVTRM1,NUINC1,NUINL1,ITYSY1,INDST1,LG1
     &             ,NVTRM2,NUINC2,NUINL2,ITYSY2,INDST2,LG2
*
      CHARACTER     THETR1*32
      INTEGER       NCATR1,NCATR2
*-----------------------------------------------------------------------
      CALL PRNTRA (NMTRM1,NVTRM1,THETR1,NCATR1)
      CALL PRNTRA (NMTRM2,NVTRM2,THETR1(NCATR1+1:),NCATR2)
*
      IF (NUINC1*NUINC2.NE.0.AND.NUINC1.NE.NUINC2) THEN
         CALL WARNNG ('Incompatibilite des inconnues en colonnes'
     &//' lors de la combinaison des termes '
     &//THETR1(1:NCATR1)//' et '//THETR1(NCATR1+1:NCATR1+NCATR2))
      ENDIF
*
      IF (NUINL1*NUINL2.NE.0.AND.NUINL1.NE.NUINL2) THEN
         CALL WARNNG ('Incompatibilite des inconnues en lignes  ' 
     &//' lors de la combinaison des termes '
     &//THETR1(1:NCATR1)//' et '//THETR1(NCATR1+1:NCATR1+NCATR2))
      ENDIF
*
      IF (NUINL1*NUINC1.NE.0.AND.NUINL2*NUINC2.NE.0) THEN
         IF (ITYSY1.NE.ITYSY2.OR.INDST1.NE.INDST2) THEN
         CALL WARNNG ('Incompatibilite des types de stockage    '
     &//' lors de la combinaison des termes '
     &//THETR1(1:NCATR1)//' et '//THETR1(NCATR1+1:NCATR1+NCATR2))
         ENDIF
      ENDIF
*
      IF (LG1.NE.LG2) THEN
         CALL WARNNG ('Incompatibilite des longueurs de termes  '
     &//' lors de la combinaison des termes '
     &//THETR1(1:NCATR1)//' et '//THETR1(NCATR1+1:NCATR1+NCATR2))
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1 : D.Martin (30 mai 2000)
* Version 0 : D.Martin (nov.1994)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !WaTers
