      SUBROUTINE LIRRES (PTS,NBPTS,Z,ZMIN,ZMAX)

C- Fonction : Lire les Z des sommets dans le fichier resultats
C-            On calcule en meme temps ZMIN et ZMAX
C-
C- Entree :
C-    PTS : Nombre de points du fichier considere
C-    NBPTS : Nombre de points *total*
C-
C- Sortie :
C-    Z : Tableau des coordonnees Z des noeuds
C-    ZMIN,ZMAX : Min et max des Z
C-
C- Derniere modif : 16 JAN 2003

      INTEGER PTS,NBPTS,I
      REAL Z(*),ZMIN, ZMAX

C- On saute les 5 premieres lignes
      DO 10 I=1,5
10    READ (21,*) 

      DO 20 I=NBPTS+1,NBPTS+PTS
         READ (21,*) Z(I)
         ZMIN = MIN(ZMIN,Z(I))
         ZMAX = MAX(ZMAX,Z(I))
20    CONTINUE

C- On somme les points
      NBPTS = NBPTS + PTS
      
      END
