      SUBROUTINE MENSOR (FICHRE,ENTREE,SORTIE,PS,NOMSOR)


C- Fonction : Ouverture d'un menu pour l'entree du format et du nom du
C-            fichier de sortie utilise dans FICSOR
C-
C- Entree :
C-    FICHRE : Nom du(es) fichier(s) de resultats
C-    ENTREE : Repertoire contenant les fichiers de donnees
C-    SORTIE : Repertoire contenant les fichiers de sorties
C-
C- Sortie :
C-    PS     : Format PostScript ou GIF
C-    NOMSOR : Nom du fichier de sortie
C-
C- Local :
C-    FENLOC : Fenetre locale
C-    CHOCAS : Choix entre 2 cases
C-    FICHEX : Teste la presence des fichiers
C-    LONNOM : Longueur du nom du fichier de sortie
C-    NOMCRT : Nom court lu i.e sans le chemin
C-    X,Y    : Coordonnees des cases ou cliquer
C- 
C- Derniere modif : 20 JAN 2003

      INTEGER LONNOM,FENLOC,PGOPEN,IBIDON
      CHARACTER*80 FICHRE,ENTREE,SORTIE,NOMCRT,NOMSOR
      LOGICAL PS,FICHEX,CHOCAS
      REAL LARMAX,HAUMAX,X(2,2),Y(2,2)

      DATA LARMAX,HAUMAX / 2.5, 3.5 /

C- Les 2 cases GIF/PostScript et Garder / Changer
      DATA X / 0.0,5.5,4.5,10.0/ 
      DATA Y / 2*2.5, 2*4.5 /

      FENLOC=PGOPEN('/xwin')
*      FENLOC=PGOPEN('/AQT')
      IF (FENLOC.LT.0) CALL BLEME (10) 
      CALL PGASK (.FALSE.)
      CALL PGPAP (LARMAX,HAUMAX/LARMAX)
      CALL PGENV(0.0,10.0,0.0,13.0,2,-2)
      CALL PGSCRN (0,'midnight blue',IBIDON)
      CALL PGSCRN (1,'yellow',IBIDON)   
      CALL NETMEN ()
      CALL PGPTXT (5.0,8.0,0.0,0.5,'Type de sortie : ')
      PS=CHOCAS(X,Y,'PostScript','GIF')

C- On propose le nom du fichier [du premier si ++] de
C- resultats comme nom de sortie suivi de .gif ou .ps      
      CALL CNMSOR (FICHRE,ENTREE,PS,NOMCRT,LONNOM)
10    CALL NETMEN ()
      CALL PGPTXT (5.0,7.5,0.0,0.5,'Nom du fichier de sortie :')
      CALL PGPTXT (5.0,6.0,0.0,0.5,NOMCRT(1:LONNOM))
C- On garde ou pas ?
      IF (CHOCAS(X,Y,'Garder','Changer')) THEN
C- Si le fichier n'existe pas on le garde
         IF (.NOT.FICHEX(2,NOMCRT,SORTIE,NOMSOR)) THEN
            CALL PGCLOS ()
            RETURN
         ENDIF
C- Sinon on fait quoi ?
         CALL NETMEN ()
         CALL PGPTXT (5.0,8.5,0.0,0.5,'Le fichier')
         CALL PGPTXT (5.0,7.5,0.0,0.5,NOMCRT(1:LONNOM))
         CALL PGPTXT (5.0,6.5,0.0,0.5,'existe deja')
C- On garde ?
         IF (CHOCAS(X,Y,'Garder','Changer')) THEN
            CALL PGCLOS ()
            RETURN
         ENDIF
      ENDIF

C- On change            
      CALL NETMEN ()
      CALL PGPTXT (5.0,7.5,0.0,0.5,'Nom du fichier de sortie :')
      CALL LIRCHN (0.0,5.0,NOMCRT,LONNOM)
      CALL NETNOM (NOMCRT)
C- On re-teste      
      GOTO 10

      END
