      SUBROUTINE MENU (NBBUTN,YBUTON,NBFEN,NUMREP,ACTIFS,FENMEN,FENDES)

C- Fonction : Ecriture du menu 
C-
C- Entree : -
C-    NBBUTN : Nombre de boutons du menu
C-    YBUTON : Coordonnees Y des boutons
C-    NBFEN  : Nombre de fenetres
C-    NUMREP : Type de representation
C-    ACTIFS : Choix actifs ou non  
C-    FENMEN : Unite PGPLOT associe a la fenetre de menu
C-    FENDES : Unite PGPLOT associe a la fenetre de dessins
C-
C- Sortie : -
C-   
C- Local :
C-    TEXTE : Texte du menu
C-
C- Derniere modif : 26 FEV 2003

      INTEGER NBBUTN,NBFEN,NUMREP,FENMEN,FENDES,I
      REAL YBUTON(*)
      LOGICAL ACTIFS(*)
      CHARACTER*17 TEXTE(17)
      DATA TEXTE / 'Maillage','Iso. lignes','Iso. pleines',
     &             'Iso. en elevation','Maillage','Multi-fenetrage',
     &             'Zmin   Zmax',' ','-  Zoom   +',' ','-   Phi    +',
     &             ' ','-  Theta   +',' ','Axes  (o/n)','Fichier',
     &             'Quitter' /

C- Selection de la fenetre de menu
      CALL PGSLCT (FENMEN)

C- Nettoyage et presentation
      CALL PGERAS ()
      CALL PGSCI (1)  
      CALL PGSCH (7.0)
      CALL PGSCF (3)
      CALL PGPTXT (4.0,24.0,0.0,0.5,'Grame')
      CALL PGSCH (3.0)
      CALL PGSCF (2)  
      CALL PGMOVE (0.0,23.0)
      CALL PGDRAW (10.0,23.0)
      CALL PGPTXT (4.0,22.0,0.0,0.5,'Representation')
      CALL PGMOVE (0.0,17.0)
      CALL PGDRAW (10.0,17.0)
      CALL PGPTXT (4.0,16.0,0.0,0.5,'Affichage')
      CALL PGMOVE (0.0,13.0)
      CALL PGDRAW (10.0,13.0)
      IF (NUMREP.EQ.1.OR.NBFEN.GT.1) CALL PGSCI (3)
      CALL PGPTXT (4.0,12.0,0.0,0.5,'Couleurs')
      IF (NUMREP.LT.4.OR.NBFEN.GT.1) CALL PGSCI (3)
      CALL PGMOVE (0.0,10.0)
      CALL PGDRAW (10.0,10.0)
      CALL PGPTXT (4.0,9.0,0.0,0.5,'Deplacement 3D')
      CALL PGMOVE (0.0,4.0)
      CALL PGDRAW (10.0,4.0)
      CALL PGMOVE (0.0,2.0)
      CALL PGDRAW (10.0,2.0)            
      CALL PGSCF (1)

C- On descend le texte de 0.2 pour l'aligner sur le point
C- On ecrit en gris les inactifs
      DO 10 I=1,NBBUTN
         CALL PGSCI (3)
         IF (ACTIFS(I)) CALL PGSCI (1)
         IF (I.EQ.6.AND.NBFEN.GT.1) THEN
            CALL PGTEXT (1.75,YBUTON(I)-0.2,'Mono-fenetrage')
      ELSE
            CALL PGTEXT (1.75,YBUTON(I)-0.2,TEXTE(I))
      ENDIF
10    CONTINUE

C- On repasse a la fenetre de  dessin
      CALL PGSLCT (FENDES)

      END
