function affdom(omega,Rext,Rmil,Rint,n,p,k,test)

tt=linspace(0,1,n*k+1);
t=linspace(0,1,2*n*k+1);
plot(Rext*cos(2*omega*t),Rext*sin(2*omega*t),'b');
axis equal
axis off
hold on
text((Rmil+Rext)/2,-Rext/20,'\fontsize{14}\Gamma_1','color','b')
text(Rext*(cos(omega)+1/40),Rext*(sin(omega)+1/40),'\fontsize{14}\Gamma_2','color','b')
text((Rext+Rmil)/2.1*(cos(omega+.1)),(Rext+Rmil)/2.1*(sin(omega+.1)),'\fontsize{14}\Omega','color','b')

plot([Rmil,Rext],[0,0])
if test=='sans'
	plot(Rmil*cos(2*omega*t),Rmil*sin(2*omega*t),'b');
	plot([Rmil*cos(2*omega),Rext*cos(2*omega)],[Rmil*sin(2*omega),Rext*sin(2*omega)],'b')
	text((Rext+Rmil)/2*cos(2*omega+.1),(Rext+Rmil)/2*sin(2*omega+.1),'\fontsize{14}\Gamma_3','color','b')
	text(Rmil*(cos(omega)-1/10),Rmil*(sin(omega)-1/10),'\fontsize{14}\Gamma_4','color','b')
else
	plot(Rmil*cos(omega*tt),Rmil*sin(omega*tt),'b');
	plot([Rint*cos(2*omega),Rext*cos(2*omega)],[Rint*sin(2*omega),Rext*sin(2*omega)],'b')
	plot(Rint*cos(omega+omega*tt),Rint*sin(omega+omega*tt),'b');
	text((Rext+Rint)/2*cos(2*omega+.1),(Rext+Rint)/2*sin(2*omega+.1),'\fontsize{14}\Gamma_3','color','b')
text(Rint*(cos(omega*3/2)-1/7),Rint*(sin(omega*3/2)-1/7),'\fontsize{14}\Gamma_4','color','b')
text((Rint+Rmil)/2*cos(omega-.1),(Rint+Rmil)/2*sin(omega-.1),'\fontsize{14}\Gamma_5','color','b')
text(Rmil*(cos(omega/2)-1/15),Rmil*(sin(omega/2)-1/15),'\fontsize{14}\Gamma_6','color','b')
plot([Rint*cos(omega),Rmil*cos(omega)],[Rint*sin(omega),Rmil*sin(omega)],'b');
end

