function ecrire(omega,Rext,Rmil,Rint,n,p,k,test,COOR)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CALCUL DE LA TRANSFORMATION %
%       DE NUMEROTATION       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if test=='avec'
	nb=3*n*p;
elseif test=='sans'
	nb=2*n*p;
end

nommail=['mail_Q',num2str(k),'_',num2str(nb),'elts.lina'];
quest=questdlg(['Sauvegarder sous ',nommail,' ?'], ...
               'Genie Question', ...
	       'Oui','Non','Annuler','Annuler');      
if quest(1:2)~='An'
if quest(1:2)=='No'
[filename,pathname]=uiputfile('*.lina','Sauvegarde du maillage...');
nommail=[pathname,filename];
end
u=trnum(k,0,k,1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEBUT DU FICHIER DE MAILLAGE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(nommail,'wt');
fprintf(fid,' TITRE 1\n');
fprintf(fid,[' Maillage en ',num2str(nb),' quadrangles\n']);
fprintf(fid,[' FORMAT DE LECTURE DES COORDONNEES''(2E21.15)''\n']);
fprintf(fid,['                   DE LA NUMEROTATION GLOBALE''(1I5)''\n']);
fprintf(fid,'                   SANS COMMENTAIRE\n');
fprintf(fid,' DESCRIPTION GLOBALE DU MAILLAGE\n');
fprintf(fid,'    VARIABLES D''''ESPACE  ''X'' ''Y''\n');
fprintf(fid,['    NOMBRE D''''ELEMENTS  ',num2str(nb),'\n']);
fprintf(fid,[' BLOC DE TYPE GEOMETRIQUE QU0',num2str(k),' : ',num2str(nb),' ELEMENTS\n']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEFINITION DE CHAQUE ELEMENT %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Grande partie

dep=1;
saut=(2*n*k+1);
for j=1:p,
for i=1:2*n,

% Ecriture des coordonnees

for pt=1:(k+1)^2,
	str=' ';
	if COOR(1,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep)<0
		str='';
	end
	fprintf(fid,str);
        str=' ';
	if COOR(2,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep)<0
		str='';
	end
	fprintf(fid,[num2str(COOR(1,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep),'%20.14E'),str]);
     	fprintf(fid,[num2str(COOR(2,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep),'%20.14E'),' ']);
	fprintf(fid,'\n');
end


% Ecriture des numeros
for pt=1:(k+1)^2,
fprintf(fid,[num2str(mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep,'%1.5i')]);
fprintf(fid,'\n');
end
dep=dep+k;
end
dep=dep+saut*(k-1)+1;
end


% Petite partie

if test=='avec'

dep=1+saut*k*p+n*k;
saut=n*k+1;
for j=1:p,
for i=1:n,
% Ecriture des coordonnees

for pt=1:(k+1)^2,
	str=' ';
	if COOR(1,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep)<0
		str='';
	end
	fprintf(fid,str);
        str=' ';
	if COOR(2,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep)<0
		str='';
	end
	fprintf(fid,[num2str(COOR(1,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep),'%20.14E'),str]);
     	fprintf(fid,[num2str(COOR(2,mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep),'%20.14E'),' ']);
	fprintf(fid,'\n');
end

% Ecriture des numeros
for pt=1:(k+1)^2,
fprintf(fid,[num2str(mod(u(pt)+k,k+1)+saut*floor((u(pt)-1)/(k+1))+dep,'%1.4i')]);
fprintf(fid,'\n');
end
dep=dep+k;
end
dep=dep+saut*(k-1)+1;
end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEFINITION DES DOMAINES %
%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Si on a deux couronnes
if test=='avec'
fprintf(fid,' DOMAINE ''Omega''\n');
fprintf(fid,['E 1 / ',num2str(nb),'\n']);

fprintf(fid,'\n DOMAINE ''Gamma1''\n');
for i=1:p,
	fprintf(fid,['E ',num2str(1+(i-1)*2*n),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma2''\n');
for i=1:2*n,
	fprintf(fid,['E ',num2str(i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma3''\n');
for i=1:p,
	fprintf(fid,['E ',num2str(2*i*n),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end
for i=1:p,
	fprintf(fid,['E ',num2str(2*n*p+i*n),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma4''\n');
for i=1:n,
	fprintf(fid,['E ',num2str(3*n*p-i+1),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma5''\n');
for i=1:p,
	fprintf(fid,['E ',num2str(2*n*p+1+(i-1)*n),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma6''\n');
for i=1:n,
	fprintf(fid,['E ',num2str(2*(p-1)*n+i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end


% Si on n'a qu'une couronne
elseif test=='sans'
fprintf(fid,' DOMAINE ''Omega''\n');
fprintf(fid,['E 1 / ',num2str(nb),'\n']);

fprintf(fid,'\n DOMAINE ''Gamma1''\n');
for i=1:p,
	fprintf(fid,['E ',num2str(1+(i-1)*2*n),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,' DOMAINE ''Gamma2''\n');
for i=1:2*n,
	fprintf(fid,['E ',num2str(i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma3''\n');
for i=1:p,
	fprintf(fid,['E ',num2str(2*i*n),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end
fprintf(fid,'\n DOMAINE ''Gamma4''\n');
for i=1:2*n,
	fprintf(fid,['E ',num2str(2*(p-1)*n+i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIN DU FICHIER DE MAILLAGE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(fid,'\n FIN\n');
fclose(fid);
str=['Le maillage est sauve sous le nom "',nommail,'"'];
msgbox(str,'Tache effectuee');
end


