      SUBROUTINE TRAART (CORPTS,NUMART,NBSOMT,NBNEAX)
*-----------------------------------------------------------------------
* TRACE D'UNE ARETE
* Arguments d'entree :
*  CORPTS (real)     :  coordonnes des points de l'element
*  NUMART (integer)  :  numero de l'arete a tracer
*  NBSOMT (integer)  :  nombre de sommets de l'element
*  NBNEAX (integer)  :  nombre maximum de points par arete
*-----------------------------------------------------------------------
      REAL CORPTS(2,*),X(11),Y(11)
      INTEGER NUMART,NBSOMT,NBNEAX,I
* Determination des points sur l'arete      
      DO 1 I=0,NBNEAX-2
            X(I+1)=CORPTS(1,NUMART+NBSOMT*I)
            Y(I+1)=CORPTS(2,NUMART+NBSOMT*I)
1         CONTINUE
          X(NBNEAX)=CORPTS(1,MOD(NUMART,NBSOMT)+1)
          Y(NBNEAX)=CORPTS(2,MOD(NUMART,NBSOMT)+1) 
          CALL PGSLW (10)
* Si l'interpolation est de degre 1, on relie les extremites	  
          IF (NBNEAX.EQ.2) THEN
             CALL PGMOVE (X(1),Y(1))
             CALL PGDRAW (X(2),Y(2))
          ELSE   
* Sinon on interpole	  
            CALL TRAPOL (X,Y,NBNEAX,20)
          ENDIF
	  CALL PGSLW (1)
*            
      END
      
