*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM  (NDIM,POINT,NOMFCT,TYPFCT,NODONA,TYDONA
     &                  ,TYPRAS,MCASSO,IST,RST,CST,RESULT,CESULT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier/Mars 1999)
* Derniere modification : D.Martin (8 Mars 1999)  
*
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,IST(*),MCASSO
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL          NORMAL(2),CALCUL(3)
*----------------------------------------------------------------
      IF (NOMFCT(1:6).EQ.'SOLEXA') THEN
*        Solution exacte
         CALL SOLEXA (POINT,RESULT)
      ELSEIF (NOMFCT(1:5).EQ.'SECMB') THEN
*        Rot_{-Beta}Rot_{Beta} E - Grad_{Beta}Div_{Beta} E + E
         CALL OPERAE (RST(MCASSO),POINT,RESULT)
      ELSEIF (NOMFCT(1:7).EQ.'RotBeta') THEN
*        Rot_{Beta} E
         CALL ROTBTE (RST(MCASSO),POINT,RESULT)
      ELSEIF (NOMFCT(1:7).EQ.'DivBeta') THEN
*        Div_{Beta} E
         CALL DIVBTE (RST(MCASSO),POINT,RESULT(1))
      ELSEIF (NOMFCT(1:3).EQ.'EsN') THEN
**       Uniquement sur le carre [0,1]x[0,1]
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=-1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
            NORMAL(1)=0.
            NORMAL(2)=1.
         ENDIF
         CALL SOLEXA (POINT,CALCUL)
         RESULT(1)=PROSCA(2,CALCUL,NORMAL)
       ELSEIF (NOMFCT(1:3).EQ.'EvN') THEN
**       Uniquement sur le carre [0,1]x[0,1]
         IF (NOMFCT(4:4).EQ.'1') THEN
            NORMAL(1)=-1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'2') THEN
            NORMAL(1)=0.
            NORMAL(2)=-1.
         ELSEIF (NOMFCT(4:4).EQ.'3') THEN
            NORMAL(1)=1.
            NORMAL(2)=0.
         ELSEIF (NOMFCT(4:4).EQ.'4') THEN
            NORMAL(1)=0.
            NORMAL(2)=1.
         ENDIF
         CALL SOLEXA (POINT,RESULT)
      ELSE
         CALL BAISE  ('*Fctrm (Ce2d3comp)* '
     &               //'Nom de fonction inconnue : '//NOMFCT(1:7))
      ENDIF
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SOLEXA (POINT,E)
      REAL POINT(*),E(*)
      E(1)=EXP(POINT(1))
      E(2)=EXP(POINT(2))
      E(3)=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OPERAE (BETA,POINT,F)
      REAL BETA,POINT(*),F(*)
      F(1)= BETA*BETA*EXP(POINT(1))
      F(2)= BETA*BETA*EXP(POINT(2))
      F(3)=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROTBTE (BETA,POINT,ROT)
      REAL BETA,POINT(*),ROT(*)
      ROT(1)=-BETA*EXP(POINT(2))
      ROT(2)= BETA*EXP(POINT(1))
      ROT(3)=0.
      END
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DIVBTE (BETA,POINT,DIV)
      REAL BETA,POINT(*),DIV
      DIV=EXP(POINT(1))+EXP(POINT(2))
      END
