      FUNCTION FICHEX (N,NOMFIC,CHEMIN,NOMABS)

C- Fonction : Apres concatenation CHEMIN//NOMFIC, on teste si 
C- le fichier NOMFIC existe. On recupere le nom concatene uniquement 
C- en entree puisque en sortie on traite differemment le fichier
C-
C- Entree :
C-    N      : 1 pour ENTREE, 2 pour SORTIE
C-    NOMFIC : Nom du fichier    
C-    CHEMIN : ENTREE ou SORTIE
C-
C- Sortie : 
C-    FICHEX : Teste la presence des fichiers
C-    NOMABS : Nom absolu du fichier i.e CHEMIN//NOMFIC
C-
C- Local :
C-    LONCHN : Longueur reelle de CHEMIN
C-    LONGCH : Fonction calculant la longueur reelle d'une chaine
C-    LONNOM : Longueur reelle de NOMFIC
C-
C- Derniere modif : 3 JUL 2001

      LOGICAL FICHEX 
      CHARACTER*80 NOMFIC,CHEMIN,NOMABS
      INTEGER N,LONGCH,LONCHN,LONNOM

      LONNOM=LONGCH(NOMFIC)
      LONCHN=LONGCH(CHEMIN)
      IF (LONNOM+LONCHN.GT.80) CALL BLEME (3+N)
      NOMABS=CHEMIN(1:LONCHN) // NOMFIC(1:LONNOM)     

      INQUIRE (FILE=NOMABS,EXIST=FICHEX)

C- On indique l'erreur en entree seulement
      IF (N.EQ.1 .AND. .NOT.FICHEX) THEN
         CALL BIP ()   
         WRITE (*,*) ' ==> Le fichier ',NOMFIC(1:LONNOM),
     &                  ' est introuvable.'
         WRITE (*,*)
      ENDIF

1001  FORMAT (A)
      END
