Nx=41;
Ny=11;
h=.5/(Ny-1);
dth=pi/2/(Nx-1);
theta=[0:dth:pi/2];
y=[.5:h:1];
nb=(Nx-1)*(Ny-1);

clf



nommail='mail.lina';
fid=fopen(nommail,'wt');
fprintf(fid,' TITRE 1\n');
fprintf(fid,[' Maillage en ',num2str(nb),' quadrangles\n']);
fprintf(fid,[' FORMAT DE LECTURE DES COORDONNEES''(2E21.15)''\n']);
fprintf(fid,['                   DE LA NUMEROTATION GLOBALE''(4I5)''\n']);
fprintf(fid,'                   SANS COMMENTAIRE\n');
fprintf(fid,' DESCRIPTION GLOBALE DU MAILLAGE\n');
fprintf(fid,'    VARIABLES D''''ESPACE  ''X'' ''Y''\n');
fprintf(fid,['    NOMBRE D''''ELEMENTS  ',num2str(nb),'\n']);
fprintf(fid,[' BLOC DE TYPE GEOMETRIQUE QU01 : ',num2str(nb),' ELEMENTS\n']);

i=0;
j=0;

for s=[1-h:-h:.5],
i=i+1;
j=0;
for t=[dth:dth:pi/2],
j=j+1;
x1=[];
x2=[];
     xx=cos(t)*s;
     yy=sin(t)*s;
     fprintf(fid,' ');
     fprintf(fid,[num2str(xx,'%20.14E'),' ']);
     fprintf(fid,[num2str(yy,'%20.14E'),' ']);
     fprintf(fid,'\n');
     x1=[x1,xx];
     x2=[x2,yy];	
     xx=cos(t)*(s+h);
     yy=sin(t)*(s+h);
     fprintf(fid,' ');
     fprintf(fid,[num2str(xx,'%20.14E'),' ']);
     fprintf(fid,[num2str(yy,'%20.14E'),' ']);
     fprintf(fid,'\n');
     x1=[x1,xx];
     x2=[x2,yy];
     xx=cos(t-dth)*(s+h);
     yy=sin(t-dth)*(s+h);
     fprintf(fid,' ');
     fprintf(fid,[num2str(xx,'%20.14E'),' ']);
     fprintf(fid,[num2str(yy,'%20.14E'),' ']);
     fprintf(fid,'\n');
     x1=[x1,xx];
     x2=[x2,yy];
     xx=cos(t-dth)*s;
     yy=sin(t-dth)*s;
     fprintf(fid,' ');
     fprintf(fid,[num2str(xx,'%20.14E'),' ']);
     fprintf(fid,[num2str(yy,'%20.14E'),' ']);
     fprintf(fid,'\n');
     x1=[x1,xx];
     x2=[x2,yy];
     plot(x1,x2,'c-o')
     hold on
    
ood=[Nx+2+(j-1)+Nx*(i-1),2+(j-1)+Nx*(i-1),1+(j-1)+Nx*(i-1),Nx+1+(j-1)+Nx*(i-1)];
fprintf(fid,[' ',num2str(ood,' %1.4i'),'\n']);
     
end    
end

axis square
plot(y,zeros(size(y)),'k--')
plot(zeros(size(y)),y,'k--')
plot(.5*cos(theta),.5*sin(theta),'k--')
plot(cos(theta),sin(theta),'k')
axis off


fprintf(fid,' DOMAINE ''Omegaint''\n');
for i=1:nb/(Ny-1),
for j=1:Ny-1,
fprintf(fid,['E ',num2str((Ny-1)*(i-1)+j),' ']);
end
fprintf(fid,'\n');
end

fprintf(fid,'\n DOMAINE ''Gamma''\n');
for i=1:(Nx-1)/4,
for j=1:4,
fprintf(fid,['E ',num2str(4*(i-1)+j),' A 2 ']);
end
fprintf(fid,'\n');
end

fprintf(fid,'\n FIN\n');
fclose(fid);
