*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CPRSSV (ITYP,IPROFI,IENCOR)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Juil.88)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Realiser les sauvegardes differees, toutes ou en partie
*  
*-- Arguments --
* ITYP    type du super-tableau cible (les deux si : ITYP.EQ.0)
* IPROFI  gain attendu ; si EQ.0 : le maximum possible  
*         (compte en character ou en mots selon ityp, pas de sens si ityp=0)
* IENCOR  indique si il faut comprimer les trous 
*  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITYP,IPROFI,IENCOR
*
      INCLUDE 'ALLOC'
*
      CHARACTER NOMTB*6,PRFXAS*8
      INTEGER  NIP
      LOGICAL TABSCA,COMSCA,ALLSCA,ALLCHA
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)
      ITBNTB=TBDCST(5) 
      IDSCTB=TBDCST(9) 
*  
*     Boucle sur les tableaux  
      ICOMPR=0 
      IENCOR=0 
      MCNMTB=ITBNTB-1
      MCTYTB=IDSCTB
      COMSCA=ITYP.GE.1.AND.ITYP.LE.4 
      DO 2 ITABL=1,TBDCST(4) 
         DO 1 ICAR=1,NBCHNT
            NOMTB(ICAR:ICAR)=AST(MCNMTB+ICAR)
1        CONTINUE
         MCNMTB=MCNMTB+NBCHNT 
*        Si le tableau est un tampon, MCADRS.LT.0 signifie que  
*        ce dernier doit etre sauvegarde avant d'etre reutilise,
*        et non qu'il peut etre sauvegarder pour liberer de la place
*        memoire; on saute donc ...
         IF(NOMTB(1:2).EQ.'BF') GO TO 2
         ITYPTB=IST(MCTYTB)
         MCADRS=IST(MCTYTB+2)  
*  
         IF (MCADRS.LT.0) THEN  
*           La realisation de la sauvegarde differee du tableau courant
*           est souhaitee  
            TABSCA=ITYPTB.GE.1.AND.ITYPTB.LE.4  
            ALLSCA=TABSCA.AND.COMSCA  
            ALLCHA=ITYPTB.GT.10.AND.ITYP.GT.10  
            IF (ITYP.EQ.0.OR.ALLSCA.OR.ALLCHA) THEN
               IF (NOMTB.EQ.'TBDCST'.OR.NOMTB.EQ.'TBNMTB'.OR.
     &            NOMTB.EQ.'TBDCTB') THEN  
                  CALL ERTBAL (9,'*Cprssv*',NOMTB,1)
               ENDIF
               IF (TBDCST(4).EQ.TBDCST(3)) THEN 
*                 On ne pourra pas creer un trou en plus, il faut  
*                 comprimer pour desaturer les tables  
                  IENCOR=1 
                  GO TO 10
               ENDIF
*              Elle est effectuee reellement si la demande est maximale
*              ou si le type du tableau courant est le meme que celui du
*              super-tableau cible.
               CALL SAUVTB(1,NOMTB,ITABL,AST(ITBNTB),IST(IDSCTB)) 
               ICOMPR=ICOMPR+1 
            ENDIF  
         ENDIF 
         IF (ITYP.GT.0.AND.(ALLSCA.AND.IPROFI.LE.TBDCST(10).OR.
     *                      ALLCHA.AND.IPROFI.LE.TBDCST(6))) GOTO 10
2     MCTYTB=MCTYTB+NBPART
*
10    IF (IPRINT.GT.0) THEN 
         IF (ITYP.EQ.0) THEN
            WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                          ,ICOMPR,'RST ET AST'
         ELSEIF (ITYP.GE.1.AND.ITYP.LE.4) THEN
            WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1),ICOMPR,'RST'
         ELSEIF (ITYP.GT.10) THEN
            WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1),ICOMPR,'AST'
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10001 FORMAT(A,A,'<CprsSv Realisation de ',I5
     &,' sauvegardes differees sur ',A)
                                                                    END !CprsSv
