*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DEPLAC
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 88)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Augmentation des possibilites maximum en nombre de tableaux;  
* en fait on agrandit simultanement les tableaux TBNMTB et TBDCTB
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'  
*
      CHARACTER PRFXAS*8
      INTEGER NIP
*----------------------------------------------------------------------
      NBTBMX=TBDCST(3) 
      IPRINT=TBDCST(16)
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
*  
*     Augmentation a priori (une puissance de 2 arbitraire) de NBTBMX  
      NALPHA=128
10    NALPHA=NALPHA/2  
      IF (NALPHA.EQ.0) GOTO 99998
      NTBNEW=NBTBMX+NALPHA 
      NBCAR=NBCHNT*NTBNEW  
      NBMOTS=(NBCAR-1)/NCPMMA+1
      NBCAR=NBMOTS*NCPMMA  
      NBMOTS=NBPART*NTBNEW 
*     Assurance sur la place disponible dans les super tableaux
      ITYP=11  
      CALL ASSURC (ITYP,NBCAR,NBMOTS,*10)
      ITYP=1
      CALL ASSURC (ITYP,NBCAR,NBMOTS,*10)
*     Le nombre de tableaux a eventuellement diminue du fait d'eventuelles 
*     compressions, est-il encore neccessaire de deplacer TBNMTB et TBDCTB ?
      NBTABL=TBDCST(4) 
      NXFRMO=TBDCST(7) 
      NXTADR=TBDCST(11)
      IF ((NBTBMX-NBTABL).LE.NALPHA) THEN
*        On decide de deplacer TBNMTB et TBDCTB car la diminution du nombre
*        de tableaux est insuffisante pour absorber l'augmentation possible
*        calculee plus haut; mais il faut pouvoir enregistrer les 2 trous  
*        supplementaires dans ces memes tableaux
         IF ((NTBNEW-NBTABL).LT.2) GOTO 99999  
         ITBNTB=TBDCST(5)  
         IDSCTB=TBDCST(9)  
*        Rang des tableaux TBNMTB et TBDCTB
         CALL TBRANG ('TBNMTB',1,AST(ITBNTB),IST(IDSCTB),IRNMTB
     &               ,IT,MC,MS,NB)
         CALL TBRANG ('TBDCTB',1,AST(ITBNTB),IST(IDSCTB),IRDCTB
     &               ,IT,MC,MS,NB)
*        Recopie du tableau TBNMTB a la premiere frontiere de mot  
*        disponible dans le super-tableau AST  
         NBCEF=NBCHNT*NBTABL
         ITYP=11
         NWBNTB=NBCHNT*NTBNEW  
         CALL RECOPI (ITYP,NBCAR,NBCEF,NBMOTS,NBM,IRNMTB,ITBNTB,NWBNTB 
     &               ,NXFRMO,IDSCTB)
*        Recopie du tableau TBDCTB a la premiere adresse disponible
*        dans le super-tableau IST. Attention il y a un tableau de plus:
*        le trou cree dans RECOPI. Il y a une correction a prendre en  
*        compte sur la taille tuee et recupere (NBTABL*NBPART mots au  
*        de NBTBMX*NBPART car NBTABL vaut maintenant NBTBMX+1 ) pour
*        le RECOPI suivant.
         NBTABL=TBDCST(4)  
         NBM=NBPART*NBTABL 
         ITYP=1
         NWSCTB=NBMOTS 
         CALL RECOPI (ITYP,NBCAR,NBCEF,NBMOTS,NBM,IRDCTB,IDSCTB,NWSCTB 
     &               ,NXFRMO,NXTADR)
*        Mise a jour de TBDCST 
         TBDCST(5)=NXFRMO  
         TBDCST(9)=NXTADR  
         TBDCST(3)=NTBNEW  
         IF (IPRINT.GT.0)
     &      WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1),NTBNEW,NBTBMX
      ELSE 
         IF (IPRINT.GT.0)
     &      WRITE (IPRINT,10003) (PRFXAS(NIP),NIP=1,0,-1),NBTBMX
      ENDIF
*  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>Deplac')
10002 FORMAT(A,A,'<Deplac Deplacement des tables : '
     &,I5,' tableaux au lieu de ',I5) 
10003 FORMAT(A,A,'<Deplac Deplacement des tables inutiles:',I5,
     &' tableaux restent suffisants')  
99998 CALL BAISE  (' *Deplac* Impossible d''agrandir,'
     &//' super tableau trop petit.')
99999 CALL BAISE  (' *Deplac* Deplacement impossible des tables de '
     &//'description, agrandissement de NBTBMX insuffisant')  
                                                                    END !Deplac
