*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE REDUCT (ITYP,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,IADRS
     &                  ,NWARTI,ATBNTB,ADSCTB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur (O.DeBayser) (1988) 
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Reduction d'un tableau dans le super tableau concerne,  
* complement par un trou et mise a jour des indices de description
*  
*-- Arguments d'entree -- 
* ITYP   Type du super tableau concerne
* NBCAR,NBMOTS Longueur du tableau (en mots ou en caracteres)  
* NBCEF,NBMO  Nombre d'individus a recopier effectivement  
*        (comptes a partir du 1er); au dela le tableau 
*        est rempli de zero ou de blancs sauf si : 
*        NBCEF = NBCAR     ou     NBMO =NBMOTS 
* IRANG  Rang du tableau avant recopie 
* IADRS  Ancienne adresse  
* NWARTI Longueur nouvelle du tableau comptee en articles  
* ATBNTB Adresse du tableau des noms de tableaux
* ADSCTB Adresse du tableau des indices de description des tableaux
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITYP,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,IADRS,NWARTI
     &       ,ATBNTB,ADSCTB
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8
*-----------------------------------------------------------------------
      NBTABL=TBDCST(4) 
      IPRINT=TBDCST(16)
      IDSTAB=ADSCTB+NBPART*(IRANG-1)
*     decalage a droite des descripteurs des tableaux suivants 
      DO 1 IR=ADSCTB-1+NBPART*NBTABL,ADSCTB+NBPART*IRANG,-1
1       IST(IR+NBPART)=IST(IR) 
      IF (ITYP.GE.1.AND.ITYP.LE.4) THEN 
         TBDCST(12)=TBDCST(12)+1
         NIVTRU=TBDCST(12) 
         TBDCST(10)=TBDCST(10)+NBMO-NBMOTS 
         TBDCST(23)=TBDCST(23)+NBMO-NBMOTS 
         IADRS=IADRS+NBMOTS
      ELSEIF (ITYP.GT.10) THEN 
         TBDCST(8)=TBDCST(8)+1 
         NIVTRU=TBDCST(8)  
         TBDCST(6)=TBDCST(6)+NBCEF-NBCAR
         IADRS=IADRS+NBCAR 
      ENDIF
*     Introduction du trou au rang IRANG+1 
      CALL PUTCHN (AST(ATBNTB),TBDCST(4),NBCHNT,IRANG+1,'TROUMC')
      CALL PUTATR (IST(IDSTAB),NIVTRU,IADRS,0,IST(IDSTAB+4)-NWARTI  
     *            ,IST(ADSCTB+NBPART*IRANG))
*  
*     Attention la longueur ne sera plus coherente avec le calculs des 
*     adresses en memoire secondaire. On se resigne a perdre la
*     sauvegarde precedente.
      IF(IST(IDSTAB+3).NE.0.AND.NWARTI.NE.IST(IDSTAB+4))IST(IDSTAB+3)=0
*     Reduction de la taille du tableau
      IST(IDSTAB+4)=NWARTI 
*-----------------------------------------------------------------------
      IF (IPRINT.GT.0) WRITE (IPRINT,10001)(PRFXAS(NIP),NIP=1,0,-1),ITYP
10001 FORMAT(A,A,'<Reduct',T39,', Reduction de type ',I3)
                                                                    END !Reduct
