*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE STIMPR (IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (1988)
* Derniere modification : D.Martin (9 Novembre 2001)
* Version 1.0.1
*  
* Impression de l'etat des super-tableaux
*  
*-- Argument --
* IMPFCH: Numero d'unite logique d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IMPFCH
*
      INCLUDE 'ALLOC'
*  
      INTEGER MOTMXR,NBTABL,ITBNTB,IDSCTB,IPRINT,IMPERR,ISEUIL,I
     &       ,NBIMP,NDBDSC,ITABL,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     &       ,NBMOTS,NBCAR,MCAGE,MCAD,MSAGE,MSAD
      CHARACTER NOMTB*6
*----------------------------------------------------------------------- 
      CALL PRFXMJ (1,'*Stimpr*')
      MOTMXR = TBDCST(2) 
      NBTABL = TBDCST(4) 
      ITBNTB = TBDCST(5) 
      IDSCTB = TBDCST(9) 
      IPRINT = TBDCST(16)
      IMPERR = TBDCST(17)
      ISEUIL = TBDCST(25)
      IF (IMPFCH.EQ.0) THEN 
         IMPFCH=IMPERR 
         IF (IPRINT.GT.0) IMPFCH=IPRINT 
      ENDIF
*  
      WRITE (IMPFCH,10000) (TBDCST(I),I=1,9)
      WRITE (IMPFCH,10001) (TBDCST(I),I=10,14)  
      WRITE (IMPFCH,10002) (TBDCST(I),I=16,17)  
      NBIMP=25 
      IF (ISEUIL.NE.0) NBIMP=32 
      WRITE (IMPFCH,10003) (TBDCST(I),I=25,NBIMP) 
      WRITE (IMPFCH,10011) 'RST'
      WRITE (IMPFCH,10014)  
      NDBDSC=IDSCTB-1  
      DO 10 ITABL=1,NBTABL 
         CALL GETATR (IST(NDBDSC+1),ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI) 
         IF (ITYPTB.GT.10) GOTO 10 
         IF (ITYPTB.LE.0) GOTO 10
         CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
         CALL GETCHN (AST(ITBNTB),NBCHNT,ITABL,NOMTB)
         IF (NOMTB.EQ.'TROUMC') GOTO 10
         MCAGE=0
         MCAD=ABS(MCADRS)  
         IF (MCAD.GT.MOTMXR) THEN
            MCAGE=(MCAD-1)/MOTMXR  
            MCAD=MCAD-MCAGE*MOTMXR 
            MCADRS=SIGN(MCAD,MCADRS)
         ENDIF
         MSAGE=0
         MSAD=ABS(MSADRS)  
         IF (MSAD.GT.MOTMXR
     &     .AND.(NBMOTS.GE.ISEUIL.OR.NOMTB(1:2).EQ.'BF')) THEN
            MSAGE=(MSAD-1)/MOTMXR  
            MSAD=MSAD-MSAGE*MOTMXR 
            MSADRS=SIGN(MSAD,MSADRS)
         ENDIF
         WRITE (IMPFCH,10012) ITABL,NOMTB,NIVETB,ITYPTB,MCADRS,MCAGE
     &                       ,MSADRS,MSAGE,NBARTI
10       NDBDSC=NDBDSC+NBPART
      WRITE (IMPFCH,10014)  
      WRITE (IMPFCH,10011) 'AST'
      WRITE (IMPFCH,10014)  
      NDBDSC=IDSCTB-1  
      DO 20 ITABL=1,NBTABL 
         CALL GETCHN (AST(ITBNTB),NBCHNT,ITABL,NOMTB)
         IF (NOMTB.EQ.'TROUMC') GOTO 20
         CALL GETATR (IST(NDBDSC+1),ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI) 
         IF (ITYPTB.LE.10) GOTO 20 
         CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
         MCAGE=0
         MCAD=ABS(MCADRS)  
         IF (MCAD.GT.MOTMXR) THEN
            MCAGE=(MCAD-1)/MOTMXR  
            MCAD=MCAD-MCAGE*MOTMXR 
            MCADRS=SIGN(MCAD,MCADRS)
         ENDIF
         MSAGE=0
         MSAD=ABS(MSADRS)  
         IF (MSAD.GT.MOTMXR
     &      .AND.(NBMOTS.GE.ISEUIL.OR.NOMTB(1:2).EQ.'BF')) THEN
            MSAGE=(MSAD-1)/MOTMXR  
            MSAD=MSAD-MSAGE*MOTMXR 
            MSADRS=SIGN(MSAD,MSADRS)
         ENDIF
         WRITE (IMPFCH,10012) ITABL,NOMTB,NIVETB,ITYPTB,MCADRS,MCAGE
     &                       ,MSADRS,MSAGE,NBARTI
20       NDBDSC=NDBDSC+NBPART
      WRITE (IMPFCH,10014) 
      CALL PRFXMJ (-1,'*Stimpr*')
      RETURN
*----------------------------------------------------------------------
10000 FORMAT(/T2,'Etat des super-tableaux :'/T2,25('-')/
     &T3,'Nombre de caracteres maximum dans le Super-Tableau AST :'
     &,T65,'NBCHMX = ',I12/
     &T3,'Nombre de mots maximum dans le Super-Tableau RST :' 
     &,T65,'MOTMXR = ',I12/
     &T3,'Nombre de tableaux maximum :'
     &,T65,'NBTBMX = ',I12/
     &T3,'Nombre de tableaux crees :',T65,'NBTABL = ',I12/
     &T3,'Adresse du tableau des noms de tableaux dans AST :' 
     &,T65,'ITBNTB = ',I12/
     &T3,'Nombre de caracteres disponibles dans AST :'
     &,T65,'NCDISP = ',I12/
     &T3,'Prochaine adresse disponible dans AST :'
     &,T65,'NXFRMO = ',I12/
     &T3,'Nombre de trous dans AST :',T65,'NBTRAS = ',I12/
     &T3,'Adresse du tableau de description des tableaux dans RST :'  
     &,T65,'IDSCTB = ',I12)
10001 FORMAT(  
     &T3,'Nombre de mots disponibles dans RST :',:
     &,T65,'LGDISP = ',I12/
     &T3,'Prochaine adresse disponible dans RST :'
     &,T65,'NXTADR = ',I12/
     &T3,'Nombre de trous dans RST :',T65,'NBTRRS = ',I12/
     &T3,'Nombre maximum d''unites logiques d''entrees/sorties :' 
     &,T65,'NBUTMX = ',I12/
     &T3,'Nombre d''unites logiques ouvertes :'
     &,T65,'NBUNIT = ',I12)
10002 FORMAT(  
     &T3,'Unite logique d''impression des messages courants :'
     &,T65,'IMPFCH = ',I12/
     &T3,'Unite    "            "            "     d''erreurs :'  
     &,T65,'IMPERR = ',I12)
10003 FORMAT(  
     &T3,'Seuil au dessus duquel les sauvegardes sont injectives :'
     &,T65,'ISEUIL = ',I12,:/
     &T3,'Prochaine adresse disponible dans le systeme de fichiers :' 
     &,T65,'NXADFI = ',I12/
     &T3,'Taille maximum d''un fichier de ce systeme :'
     &,T65,'NBENRX = ',I12/
     &T3,'Longueur des tableaux tampons :',T65,'LGBUF  = ',I12/
     &T3,'Nombre de tableaux tampons :',T65,'NBBUF  = ',I12/
     &T3,'Age du dernier tampons utilise + 1 :',T65,'IAGBUF = ',I12/
     &T3,'Age maximum possible :',T65,'INTMAX = ',I12/
     &T3,'Nombre effectif de fichiers du systeme (crees ou non) :'
     &,T65,'NBFICH = ',I12)
10004 FORMAT(T3,A)
10011 FORMAT(/T12,82('-')/T5,A3,'    |  Nomtb   | Nivetb | Type |  Mcadr
     &s   | mcage  |  Msadrs   | msage  | NbArticles|')
10012 FORMAT(' | ',I6,'  |  ',A6,'  | ',I6,' | ',I4,' | ',I9,' | '  
     &,2(I6,' | ',I9,' | '))
10014 FORMAT(T2,92('-'))
                                                                    END !Stimpr
