*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.de Bayser (88)
* Derniere modification (O.DeBayser) le 10 Avril 96
*  
* Calcul la longueur d'un tableau en mots et le cas echeant en caracteres  
*  
*-- Arguments --  
* NCPMMA: nombre de caracteres par mot 
* ITYPTB: numero de type du tableau (=1,2,3,4 ou > 10) 
* NBARTI: nombre d'articles du tableau 
* NBMOTS: nombre de mots qu'occupe le tableau  
* NBCAR : nombre de caracteres du tableau qu'occupe le tableau 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR
*-----------------------------------------------------------------------
      NBMOTS=NBARTI
      NBCAR=0  
      IF (ITYPTB.GT.10) THEN
          NBMOTS=1+((ITYPTB-10)*NBARTI-1)/NCPMMA
          NBCAR=NCPMMA*NBMOTS  
      ELSE 
          IF (ITYPTB.GE.3) NBMOTS=NBMOTS+NBMOTS 
      ENDIF
                                                                    END !Tblong
