      SUBROUTINE  ELTQ2D(COO,NG,NUMREG,MCTABG)
C***********************************************************************
C     EVALUATION DE LA FONCTION DE GREEN ET DE SON GRADIENT PAR 
C                     ELEMENTS FINIS Q2
C    
C      COO : TABLEAU DES COORDONNEES DU POINT
C      NG  : TABLEAU CONTENANT LES VALEURS DE LA FONCTION DE GREEN
C             VAGUES PROCHES ET DE SES DERIVEES
C      NUMREG : NUMERO DE LA REGION DE TABULATION
C      MCTABG : ADRESSE DU TABLEAU TABGEN DANS RST (A.D)
C***********************************************************************
C
      INTEGER DR1,DR2,DR3,DA1,DA2,DA3,DB1,DB2,DB3,DDR1,DDR2,DDR3
      INTEGER DDA1,DDA2,DDA3,DDB1,DDB2,DDB3
      PARAMETER (DR1=8,DR2=38,DR3=20,DA1=16,DA2=24,DA3=18,DB1=8,DB2=11)
      PARAMETER (DB3=12,DDR1=11,DDR2=26,DDR3=36,DDA1=11,DDA2=26)
      PARAMETER (DDA3=26,DDB1=11,DDB2=16,DDB3=16)
C
      DIMENSION COO(3),NG(4)
      REAL NG
C
C--- LA COORDONNEE Z DOIT TOUJOURS ETRE NEGATIVE
      COO(3) = - ABS( COO(3) )
C
      IF (NUMREG.EQ.1) THEN
         CALL DOM1Q2(COO,NG,MCTABG)
      ELSE IF (NUMREG.EQ.2) THEN
         CALL DOM2Q2(COO,NG,MCTABG)
      ELSE IF (NUMREG.EQ.3) THEN
         CALL DOM3Q2(COO,NG,MCTABG)
      ELSE
         CALL DOM4Q2(COO,NG)
      ENDIF
C
      END
