

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
        subroutine gwd(coe,wg,met,eta)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*       Calcul du champ lointain de la fonction de green
*       de resistance de vagues 3D
*               D' apres Baar & Price, 87
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*	cas : double et simple precision
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
c       INCLUDE 'OVERFLOW'
         real coe(3),coo(3), wg(6)
	common/kelval/xkel
	parameter (pi=3.1415926535897)

		xjk1= 30.
		xjk2= 80. 
		xyi1= 10.  
		xyi2= 4.    

	met=0

	if (coe(1).le.0) then
		do 10 i=1,4
10		wg(i)=0 
		return
	else

*		eta=0.001 
		emin=0.0005
		dr2=2.828427124

		coo(1)= coe(1)
		coo(2)= abs(coe(2))
		coo(3)=-abs(coe(3))

		d = sqrt(coo(2)*coo(2)+coo(3)*coo(3))
		xsd  = coo(1)/d
		x2sd = coo(1)*xsd

		if 	   (x2sd.lt.xjk1) then
c                               ITYPE = 4
				call gwdjk(coo,wg)
				met=10
		elseif 	   (xsd.gt.xyi1) then
c                               ITYPE = 5
				call gwdyi(coo,wg)
				met=20
		elseif 	   (x2sd.lt.xjk2) then
c                               ITYPE = 6
				call gwdjk(coo,wg)
				met=11
		elseif 	   (xsd.gt.xyi2) then
c                               ITYPE = 7
				call gwdyi(coo,wg)
				met=21
		else
c                               ITYPE = 8
				call gwelb(coo,wg,eta)
				met=30
		endif

c               ITYPE = 9
		z=coo(3)
		usz=1/z
		expz=exp(z)
		f0=4*expz*sqrt(-pi*usz)
		f1=-4*expz*usz
		f2=-usz*0.5*f0

		wrg=f0
		wrgx=f0+f1
		wrgy=f1+f2
		wrgz=f0+f2
		if(abs(wg(1)).gt.wrg .or.abs(wg(2)).gt.wrgx.or.
     *		   abs(wg(3)).gt.wrgy.or.abs(wg(4)).gt.wrgz)	then
c                               ITYPE = 10
				call gwelb(coo,wg,eta)
                                met=32

			if (abs(wg(1)).gt.wrg) then
c                               ITYPE = 11
				wg(1)= gwrog(coo(1),coo(2),coo(3),emin)
				met=33
			if (abs(wg(1)).gt.wrg) then
c                               ITYPE = 12
				wg(1)= sign(wrg,wg(1))
				met=41
			endif
			endif
			if (abs(wg(2)).gt.wrgx) then
c                               ITYPE = 13
				wg(2)= gwrogx(coo(1),coo(2),coo(3),emin)
				met=32
			if (abs(wg(2)).gt.wrgx) then
c                               ITYPE = 14
				wg(2)= sign(wrgx,wg(2))
				met=42
			endif
			endif
			if (abs(wg(3)).gt.wrgy) then
c                               ITYPE = 15
				wg(3)= gwrogy(coo(1),coo(2),coo(3),emin)
				met=33
			if (abs(wg(3)).gt.wrgy) then
c                               ITYPE = 16
				wg(3)= sign(wrgy,wg(3))
				met=43
			endif
			endif
			if (abs(wg(4)).gt.wrgz) then
c                               ITYPE = 17
				wg(4)= gwrogz(coo(1),coo(2),coo(3),emin)
				met=34
			if (abs(wg(4)).gt.wrgz) then
c                               ITYPE = 18
				wg(4)= sign(wrgz,wg(4))
				met=44
			endif
			endif
                                return 
		endif

	endif


	return
	end
