*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMCLI (OPERAT,CHCSTE,TYPCST,NUMCST,TYTRMB,MCTRMB
     &                  ,LGTRMB,TYTRMR,MCTRMR,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1994)
* Derniere modification : D.Martin (22 Avril 2002)
* Version 1.0.1
*
* Assemblage par combinaison lineaire simple de deux termes sous la forme
*                        R(I)=R(I) + c. B(I)
*       (cas ou les 2 matrices ont le meme tableau de stockage)
*
*-- Arguments --
* OPERAT '+' , '-' ou '*'
* CHCSTE nom du tableau du type de la constante
* TYPCST type de la constante de la combinaison lineaire (c)
* NUMCST numero de la constante de la combinaison lineaire
* TYTRMB type du terme a assembler (B)
* MCTRMB son adresse (B)
* LGTRMB sa longueur (B)
* TYTRMR type du terme resultat (R)
* MCTRMR son adresse (B)
* IST,RST,CST super-tableau version reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) OPERAT,CHCSTE,TYPCST
      CHARACTER*(*) TYTRMB,TYTRMR
      INTEGER       NUMCST,LGTRMB,IST(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCCSTE,MCTRMB,MCTRMR
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      IF (OPERAT.EQ.'*') THEN
         CALL TBAR1  (ERCODE,CHCSTE,1,MCCSTE)
         CALL TPLUAT (LGTRMB,TYTRMR,MCTRMR,RST,CST
     &                      ,TYPCST,MCCSTE+NUMCST,IST,RST,CST
     &                      ,TYTRMB,MCTRMB,RST,CST
     &                      ,TYTRMR,MCTRMR,RST,CST)                     !utilite
      ELSEIF (OPERAT.EQ.'+') THEN
         CALL TPLUST (LGTRMB,TYTRMR,MCTRMR,RST,CST
     &                      ,TYTRMB,MCTRMB,RST,CST
     &                      ,TYTRMR,MCTRMR,RST,CST)                     !utilite
      ELSEIF (OPERAT.EQ.'-') THEN  
         CALL TMOINT (LGTRMB,TYTRMR,MCTRMR,RST,CST 
     &                      ,TYTRMB,MCTRMB,RST,CST
     &                      ,TYTRMR,MCTRMR,RST,CST)                     !utilite
      ELSE
         ERCODE(1:1)=OPERAT
         CALL BAISE  ('*Asmcli* Operation: '//ERCODE(1:1)
     &               //' non reconnue')                                 !utilite
      ENDIF 
                                                                    END !Asmcli
