*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMCPT (OPERAT,CHCSTE,TYPCST,NUMCST,NMTRMB,NVTRMB
     &                  ,TYTRMB,LGTRMB,ADTRMB,ADPTRB,NMTRMR,NVTRMR
     &                  ,TYTRMR,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)
* Derniere modification : D.Martin (31 Janvier 1995)
* Version 1.0.0
*
* Assemblage par combinaison lineaire de deux termes, avec table de pointeurs 
* d'indirection pour le second, sous la forme
*                        R(PTR()I)=R(PTR(I)) + c. B(I)
*
*-- Arguments --
* OPERAT '+' , '-' ou '*'
* CHCSTE nom du tableau du type de la constante
* TYPCST type de la constante de la combinaison lineaire (c)
* NUMCST numero de la constante de la combinaison lineaire
* NMTRMB nom du terme (B) a assembler au terme resultat (R)
* NVTRMB son niveau
* ADTRMB translation d'adresse dans le terme (B) (cas BiMorse)
* TYTRMB son type
* LGTRMB sa longueur
* ADTRMB translation d'adresse dans le terme a assembler (B) (cas BiMorse)
* ADPTRB translation d'adresse dans le tableau des pointeurs (cas BiMorse)
* NMTRMB nom du terme resultat (R)
* NVTRMB son niveau
* TYTRMB son type
* RST,CST super-tableau version reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) OPERAT,CHCSTE,TYPCST,NMTRMB,TYTRMB,NMTRMR,TYTRMR
      INTEGER       NUMCST,NVTRMB,ADTRMB,ADPTRB,LGTRMB,NVTRMR,IST(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCCSTE,MCPTRR,MCTRMB,MCTRMR         
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL TBAR3  (ERCODE,NMTRMR,NVTRMR,MCTRMR,NMTRMB,NVTRMB,MCTRMB
     &                   ,'$WORK$',0,MCPTRR)                     
      MCPTRR=MCPTRR+ADPTRB
      MCTRMB=MCTRMB+ADTRMB
*
      IF (OPERAT.EQ.'*') THEN
         CALL TBAR1  (ERCODE,CHCSTE,1,MCCSTE)
         CALL TPTPAT (TYPCST,MCCSTE+NUMCST,LGTRMB
     &               ,TYTRMB,MCTRMB,IST(MCPTRR)
     &               ,TYTRMR,MCTRMR,IST,RST,CST)                        !utilite
      ELSEIF (OPERAT.EQ.'+') THEN
         CALL TPTPLT (LGTRMB
     &               ,TYTRMB,MCTRMB,IST(MCPTRR)
     &               ,TYTRMR,MCTRMR,RST,CST)                            !utilite
      ELSEIF (OPERAT.EQ.'-') THEN 
         CALL TPTMOT (LGTRMB
     &               ,TYTRMB,MCTRMB,IST(MCPTRR)
     &               ,TYTRMR,MCTRMR,RST,CST)                            !utilite
      ELSE
         ERCODE(1:1)=OPERAT
         CALL BAISE  ('*Asmcpt* Operation: '//ERCODE(1:1)
     &               //' non reconnue')                                 !utilite
      ENDIF 
                                                                    END !AsmCPt
