*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMNSY (OPERA,CSTTYP,MCCSTE,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)
* Derniere modification : D.Martin (24 Avril 2002)
* Version 1.0.1
*
* Changement d'operateur ou de signe de la constante pour l'assemblage
* de la partie triangulaire superieure d'un terme antisymetrique,
* autoadjoint ou antisymetrique
*
* OPERA  operateur de combinaison lineaire ('*', '+' ou '-')
* CSTTYP type de la constante de la combinaison lineaire
* MCCSTE adresse de la constante de la combinaison lineaire
* IST,RST,CST super-tableau version entiere, reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) OPERA,CSTTYP
      INTEGER       MCCSTE,IST(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*-----------------------------------------------------------------------
      IF (OPERA(1:1).EQ.'+') THEN
         OPERA='-'
      ELSEIF (OPERA(1:1).EQ.'-') THEN
         OPERA='+'
      ELSE
         IF (CSTTYP(1:1).EQ.'E') THEN
            IST(MCCSTE)=-IST(MCCSTE)
         ELSEIF (CSTTYP(1:1).EQ.'R') THEN
            RST(MCCSTE)=-RST(MCCSTE)
         ELSEIF (CSTTYP(1:1).EQ.'C') THEN
            CST(MCCSTE)=-CST(MCCSTE)
         ENDIF
      ENDIF
                                                                    END !Asmnsy
