*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPTG (INCREL,INCREC,NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIR,NGNLIR,NBNCOR,NGNCOR,NBPTRB,PTRB2R)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : O.DeBayser (3 Avril 1996)
* Version 1.0.0
*  
* Recherche dichotomique ou non du tableau de pointeurs pour l'assemblage
* de la diagonale d'un terme stocke 'Plein' (B) dans un terme stocke'Bi-Morse'
*
*-- Arguments --
* INCREL increment dans les pointeurs lors du changement de ligne dans (B)
* INCREL increment dans les pointeurs lors du changement de colonne dans (B)
* NBNLIB nombre de lignes du terme a assembler (B)
* NGNLIB numerotation en ligne du terme a assembler (B)
* NBNCOB nombre de colonnes du terme a assembler (B)
* NGNCOB numerotation  en colonne du terme a assembler (B)
* NBNLIR nombre de lignes du terme resultat (R)
* NGNLIR numerotation en ligne du terme resultat (R)
* NBNCOR nombre de colonnes du terme resultat (R)
* NGNCOR numerotation  en colonne du terme resultat (R)
*-- Argument de sortie --
* NBPTRB nombre de coefficients de la diagonale de (B)
* PTRB2R tableau de pointeurs d'assemblage d'un vecteur dans un autre.
*        Sa taille est celle du vecteur (B) a assembler dans (R)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER INCREL,INCREC,NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
     &       ,NBNLIR,NGNLIR(*),NBNCOR,NGNCOR(*),NBPTRB,PTRB2R(*)
*
      INTEGER INCREM,LIGNES,NXPTRB,NEXTL,NEXTC,LIGNEB,KOLONB,KOLONS
*-----------------------------------------------------------------------
      INCREM=MAX (INCREL,INCREC)
*
      LIGNES=0
      NXPTRB=0
      NEXTL=1
      DO 10 LIGNEB=1,NBNLIB
         CALL DICOTO (NEXTL,NBNLIR,NGNLIR,NGNLIB(LIGNEB),LIGNES,*8)     !utilite
         NEXTL=LIGNES+1
         IF (NGNCOB(NBNCOB).LT.NGNCOR(LIGNES)) RETURN
         NEXTC=1
         DO 5 KOLONB=1,NBNCOB
*           On cherche la position dans B de la diagonale de S
            CALL DICOTO (NEXTC,NBNCOR,NGNCOR,NGNCOB(KOLONB),KOLONS,*8)  !utilite
            NEXTC=KOLONS+1
            IF (KOLONS.EQ.LIGNES) THEN
               PTRB2R(NXPTRB+KOLONB)=KOLONS
               NBPTRB=NBPTRB+1
               GOTO 8
            ELSEIF (KOLONS.GT.LIGNES) THEN
               GOTO 8
            ENDIF
5        CONTINUE
8        NXPTRB=NXPTRB+INCREM
10    CONTINUE
                                                                    END !AsMPtG
