*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASNUME (NVASMB,COLLIG,NVNUMR,NBNERX,CHANGD,CODERR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.1
*  
* Creation des numerotations des noeuds du terme assemble issu de l'assemblage 
* des termes de la structure d'assemblage $ASMBL de niveau NVASMB
*  
*-- Arguments d'entree -- 
* NVASMB niveau de la structure $ASMBL 
* COLLIG chaine contenant 'COLONNE' ou 'LIGNE' 
* NVNUMR niveau du tableau de numerotation en noeuds du resultat 
* NBNERX majoration du nombre de noeuds en entree, nombre effectif en sortie
* CODERR code de retour en cas de depassement de longueur de la numerotation
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NVASMB,NVNUMR,NBNERX,CODERR
      CHARACTER     CHANGD
      CHARACTER*(*) COLLIG
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      INTEGER       MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &             ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI
     &             ,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO,NIVITR
     &             ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &             ,NVNUM1,LGNEDO,MCNEDO,MCNEDR,IANEDO,NVNUAV,NBNER1
     &             ,NBNERE,NVNUME,ITEMDB,ITEMFN,I
      CHARACTER     ERCODE*120
      CHARACTER     CHCSTE*6,NMSTOK*6,CRWORK,READRE
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(105:105),CHCSTE),(ERCODE(113:113),NMSTOK)
     &            ,(ERCODE(119:119),CRWORK)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsNume*')
      CODERR=0
*  
*     Initialisation du tableau de numerotation reunion par celui du premier
*     (le plus gros) terme de l'assemblage 
*  
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
*
*     Recherche des caracteristiques du premier terme a assembler
      NUTERM=IST(MCASMB+LGETRA)
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &            ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &            ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI
     &            ,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO,NIVITR)           !sdexplo
      NVNUM1=NVNUMC
      IF (COLLIG(1:1).EQ.'L'.AND.NVNUML.NE.NDFNUM) NVNUM1=NVNUML 
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUM1,LGNEDO)
      CALL TBAR2  (ERCODE,'#GNEDO',NVNUM1,MCNEDO,'#GNEDO',NVNUMR,MCNEDR)
      IANEDO=MCNEDO
      DO 1 I=MCNEDR,MCNEDR-1+LGNEDO
         IST(I)=IST(IANEDO)
         IANEDO=IANEDO+1
1     CONTINUE
*
      NVNUAV=NVNUM1
      NBNER1=IST(MCNEDR+1)
      NBNERE=NBNER1
*
      READRE='N'
      DO 3 NUTRAS=2,NBTRAC 
         IF (READRE.EQ.'Y') THEN
            CALL TBAR2 (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB)
            READRE='N'
         ENDIF
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &               ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &               ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI
     &               ,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO,NIVITR)        !sdexplo
         NVNUME=NVNUMC
         IF (COLLIG(1:1).EQ.'L'.AND.NVNUML.NE.NDFNUM) NVNUME=NVNUML 
         IF (NVNUME.EQ.NVNUAV) GOTO 3
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUME,MCNEDO)
         CALL TBAR2  (ERCODE,'#GNEDO',NVNUME,MCNEDO
     &                      ,'#GNEDO',NVNUMR,MCNEDR)
         CALL LISINC (IST(MCNEDO+1),IST(MCNEDO+2),NBNERE,IST(MCNEDR+2)
     &               ,ITEMDB,ITEMFN,*2)                                 !utilite
         CALL LISUNI (NBNERE,IST(MCNEDR+2),IST(MCNEDO+1),IST(MCNEDO+2)
     &               ,.FALSE.,IST(MCNEDO+2),.TRUE.,NBNERX,*99991)       !utilite
2        CALL TBSAVE ('#GNEDO',NVNUME)
         READRE='Y'
         NVNUAV=NVNUME
3     CONTINUE 
*
      IF (NBNERE.EQ.NBNER1) THEN
         CALL TBTUER ('#GNEDO',NVNUMR)
         NVNUMR=NVNUM1
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUMR,MCNEDO)
         CHANGD='N'
      ELSE
         IST(MCNEDR)=0
         IST(MCNEDR+1)=NBNERE
         CALL TBSAVE ('#GNEDO',NVNUM1)
      ENDIF
      NBNERX=NBNERE
*
      CALL PRFXMJ (-1,'*AsNume*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CODERR=1
                                                                    END !AsNume
