*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GETERM (NMTERM,NVTERM,KLADRS,VALEUR,VALEUC) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1991) 
* Derniere modification : D.Martin (1er Fevrier 2002)
* Version 1.0.0
*  
* Fournit la valeur d'un coefficient d'un terme a une adresse relative donnee
*  
*-- Arguments d'entree -- 
* NMTERM,NVTERM Nom et niveau du terme
* KLADRS adresse contenant le coefficient a chercher
*-- Arguments de sortie --
* VALEUR valeur du coefficient dans le cas reel
* VALEUC valeur du coefficient dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,KLADRS
      REAL          VALEUR
      COMPLEX       VALEUC
*
      INCLUDE 'ALLOC'
*
      INTEGER       KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,LGTERM,ITTERM,MCTERM,VALEUI
      CHARACTER*4   ERCODE*120,TYPINT,TYTERM
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(113:113),TYTERM) 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GeTerm*')
*  
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*     Recherche des caracteristiques du terme
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
      CALL TBTYPE (NMTERM,NVTERM,ITTERM)
      TYTERM=TYPINT (ITTERM)                                            !utilite
      IF (TYTERM(1:1).NE.'R'.AND.TYTERM(1:1).NE.'C')
     &   CALL ERTERM (6,NMTERM,NVTERM)                                  !utilite
*
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*
      IF (KLADRS.LE.0.OR.KLADRS.GT.LGTERM) GOTO 99990
      CALL TOUTPU (TYTERM,MCTERM,IST,RST,CST
     &            ,KLADRS,VALEUI,VALEUR,VALEUC)                         !utilite
*
      CALL TBSAVE (NMTERM,NVTERM)
      CALL PRFXMJ (-1,'*GeTerm*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 WRITE (*,*) ' Adresse relative :',KLADRS,' pour un terme de '
     &,'longueur ',LGTERM
      CALL ERTERM (7,NMTERM,NVTERM)                                     !Utilite
                                                                    END !GeTerm
