*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MXTERM (NMTERM,NVTERM,KLADRS,VALMXR,VALMXC) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991) 
* Derniere modification : D.Martin (27 Juin 1997)
* Version 1.0.0
*  
* Recherche de l'adresse relative et de la valeur du coefficient de module
* maximum d'un terme de type reel ou complexe
*  
*-- Arguments d'entree -- 
* NMTERM,NVTERM Nom et niveau du terme
*-- Arguments de sortie --
* KLADRS adresse contenant le coefficient de module maximum
* VALMXR valeur maximum dans le cas reel
* VALMXC valeur maximum dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,KLADRS
      REAL          VALMXR
      COMPLEX       VALMXC
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER    KLTERM
      INTEGER    MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCTERM,LGTERM
     &          ,NUTERM,IADTRM,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM
     &          ,IPTDIR,NUINCC,NVDUCR,NBNECR,NVNUCR,NUINCL,NVDULR,NBNECL
     &          ,NVNULR,INDSTK,NVNUSR,NVCOOR,IATRDO,NIVIMP,VALMXI
      CHARACTER*4   ERCODE*120,TYPINT,TYTERM
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MxTerm*')
*  
      CALL TBRR1  (ERCODE, NMTERM ,NVTERM,LGTERM)
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,NMTERM,NVTERM,MCTERM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !SDexplo
*  
*     Recherche des caracteristiques du terme
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !Sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM )                   !Utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,IPTDIR,NUINCC,NVDUCR,NBNECR,NVNUCR,NUINCL
     &            ,NVDULR,NBNECL,NVNULR,INDSTK,NVNUSR,NVCOOR,IATRDO
     &            ,NIVIMP)                                              !SDexplo
      TYTERM=TYPINT (ITYPTR)                                            !Utilite
      IF (TYTERM(1:2).EQ.'CH') CALL ERTERM (8,NMTERM,NVTERM)            !Utilite
*
      CALL TMAXVA (LGTERM,TYTERM,MCTERM,IST,RST,CST
     &            ,KLADRS,VALMXI,VALMXR,VALMXC)                         !Utilite
*
      CALL TBSAVE (NMTERM,NVTERM)
      CALL PRFXMJ (-1,'*MxTerm*')
                                                                    END !MxTerm
