*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SDEKAM (NMTRMI,NVTRMI,NOMINC,NMTRMS,NVTRMS,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Juillet 1992)
* Derniere modification : D.Martin (22 Mars 2002)
* Version 1.0.1
*  
* Extraction de la partie d'un terme source multi-inconnues pour une inconnue
*  
*-- Arguments d'entree -- 
* NMTRMI,NVTRMI nom et niveau du vecteur source
* NOMINC        nom de l'inconnue pour lequel on veut un resultat
* NMTRMS,NVTRMS nom et niveau du vecteur resultat
* NIVIMP niveau d'impression du vecteur resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTRMI,NMTRMS,NOMINC
      INTEGER       NVTRMI,NVTRMS,NIVIMP
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER     TYPINT                                              !utilite
      INTEGER       INTYKL,INDSTO,KELCHN,KLNIVE,KLTERM                  !utilite
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &             ,NUINCO,NVDUMT,NBNEUT,NVNUMT,NUINCC,NBNEUC,NVNUME
     &             ,NVCORT,INSTOK,NVSTOK
     &             ,IATRDO,NIVDOM,NUTERM,MCMINC,MCCONU,LGEINC,NBINCO
     &             ,INCINC,NCHINC,NCPINC,INTRPC,NBT,NUINCL
     &             ,MCDSMB,LGEDSM,NBRESC,INCDSM,NBRESL,LGRIPP,ADTRMI
     &             ,NUINRC,NUINRL,NVINRL,MCNURL,NBINRL
     &             ,NVNUML,MCNUML,NVDUME,MCDUME,NBNOEU,MCTRMI,MCTRMS
     &             ,INCL,NCATR1,NCATR2
      LOGICAL       CRETRM
      CHARACTER     ERCODE*120,TYPTRM
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Sdekam*')
*
      CALL TBAR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCCONU,'#OMINC',1,MCMINC)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCCONU),LGEINC,NBINCO,INCINC,NCHINC)             !utilite
*
*     Caracteristiques de l'inconnue NOMINC
*
      NUINCL=KELCHN (NOMINC,AST(MCMINC),NBINCO,NCHINC)                  !utilite
      CALL SDEXCO (NUINCL,IST(MCCONU),NCPINC,INTRPC,NBT)                !utilite
*  
*     Caracteristiques du terme NMTRMI, NVTRMI
* 
      NUTERM=KLTERM (NMTRMI,NVTRMI,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMI,NVTRMI)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU,ITYPTR
     &            ,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINCC,NVDUME,NBNEUC,NVNUME
     &            ,NUINCO,NVDUMT,NBNEUT,NVNUMT
     &            ,INSTOK,NVSTOK,NVCORT,IATRDO,NIVDOM)                  !sdexplo
      TYPTRM=TYPINT(ITYPTR)                                             !utilite
      IF (NUINCO.NE.NDFINC.OR.NVDSMB.EQ.NDFDSM)  
     &   CALL ERTERM (13,NMTRMI,NVTRMI)                                 !utilite
      CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
      CALL TBAR2  (ERCODE,'$DSMBL',NVDSMB,MCDSMB,'$SDTRM',1,MCDTRM) 
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBRESC,INCDSM,NBRESL)             !utilite
*
*     Boucle de recherche du terme correspondant a l'inconnue en ligne
*
      LGRIPP=LGEDSM
      ADTRMI=0
      CRETRM=.FALSE.
      DO 10 INCL=1,NBRESC*NBRESL
         NUINRC=IST(MCDSMB+LGRIPP+1)
         NUINRL=IST(MCDSMB+LGRIPP+2)
         NVINRL=IST(MCDSMB+LGRIPP+4)
         CALL TBRR1  (ERCODE,'#GNEDO',NVINRL,MCNURL)
         CALL TBAR1  (ERCODE,'#GNEDO',NVINRL,MCNURL)
         NBINRL=IST(MCNURL+1)
         CALL TBSAVE ('#GNEDO',NVINRL)
         IF (NUINRL.EQ.NUINCL.AND.NUINRC.EQ.NDFINC) GOTO 20
         CALL TBAR2  (ERCODE,'$DSMBL',NVDSMB,MCDSMB,'$SDTRM',1,MCDTRM)
         ADTRMI=ADTRMI+NBINRL
         LGRIPP=LGRIPP+INCDSM
10    CONTINUE
      GOTO 99991
20    CALL TBSAVE ('$DSMBL',NVDSMB)
* 
*     Mise a jour des structures de description pour le vecteur resultat.
*
      NVALNE=1
      NVNUML=NVINRL
      NVDUME=NDFDUM
      NBNOEU=NBINRL
      IF (NCPINC.GT.1) THEN
*        Dans le cas d'un terme en d.l.: NVINRL a le sens
*        d'une numerotation en d.l. On cree la numerotation en noeuds.
         NVNUML=KLNIVE ()
         NVDUME=NVINRL
         NBNOEU=NBINRL/NCPINC
         NVALNE=NCPINC
         CALL TBCREE ('#GNEDO',NVNUML,1,2+NBNOEU,'c')
         CALL TBRR1  (ERCODE,'#GNEDO',NVDUME,MCDUME)
         CALL TBAR2  (ERCODE,'#GNEDO',NVNUML,MCNUML
     &                      ,'#GNEDO',NVDUME,MCDUME)
         CALL DL2NNU (NCPINC,IST(MCDUME+1),IST(MCDUME+2)
     &                      ,IST(MCNUML+1),IST(MCNUML+2))               !sdexplo
         IST(MCNUML)=IST(MCDUME)
         CALL TBSAVE ('#GNEDO',NVNUML)
         CALL TBSAVE ('#GNEDO',NVDUME)
      ENDIF
*
      CALL CRTERM (NMTRMS,NVTRMS,NBINRL,ITYPTR,INTYKL('ASSEMB')
     &            ,1,NDFDON,NVALNE,NDFDSM,NDFINC,NDFDUM,1,NDFNUM
     &            ,NUINCL,NVDUME,NBNOEU,NVNUML,INDSTO('PLEIN-L')
     &            ,NDFSTO,NDFCOR,0,NIVIMP,.FALSE.,CRETRM)               !sdexplo
*  
*     Extraction du terme
*
      CALL TBRR1  (ERCODE,NMTRMI,NVTRMI,MCTRMI)
      CALL TBAR2  (ERCODE,NMTRMI,NVTRMI,MCTRMI,NMTRMS,NVTRMS,MCTRMS)
      CALL TDANST (NBINRL,TYPTRM,MCTRMI+ADTRMI,IST,RST,CST
     &                   ,TYPTRM,MCTRMS       ,IST,RST,CST)             !utilite
*
      IF (NIVIMP.GT.0) CALL PRTERM (NMTRMS,NVTRMS,NIVIMP,IMPSDR)        !prsd
      CALL TBSAVE (NMTRMI,NVTRMI)
      CALL TBSAVE (NMTRMS,NVTRMS)
*
      IF (NIVIMP.GT.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTRMS,NVTRMS,ERCODE,NCATR1)
         CALL PRNTRM (NMTRMI,NVTRMI,ERCODE(NCATR1+1:),NCATR2)
         ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+LEN(NOMINC))=NOMINC
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &        ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+LEN(NOMINC))
     &        ,ERCODE(NCATR1+1:NCATR1+NCATR2)
      ENDIF
      CALL PRFXMJ (-1,'*Sdekam*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*Sdekam* Extraction du terme ',A,' pour l''inconnue '
     &,A,' a partir de ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTRMI,NVTRMI,ERCODE,NCATR1)                         !Utilite
      ERCODE(NCATR1:)=NOMINC
      CALL BAISE ('Impossible d''extraire la partie du terme '
     &//ERCODE(1:NCATR1)//' pour l''inconnue '
     &//ERCODE(NCATR1+1:NCATR1+NCHINC)//
     &'. Elle n''est pas retrouvee dans sa structure d''assemblage.')

                                                                    END !Sdekam
