*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSKMLM (NUDOK ,NBELDO,DIMATE,DIVECC,DIVECL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1995) 
* Derniere modification : D.Martin (27 Juin 1997)
* Version 1.0.0
*  
* Tailles des tableaux 'Matrices elementaires'
*  
*-- Arguments d'entree -- 
* NUDOK  numero du domaine de calcul  
* NBELDO nombre d'elements (de couples element-face) du domaine
* DIMATE taille des termes 'Matrice Elementaire' matriciels
* DIVECC taille des termes 'Matrice Elementaire' vectoriels en colonne
* DIVECL taille des termes 'Matrice Elementaire' vectoriels en ligne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NUDOK,NBELDO,DIMATE,DIVECC,DIVECL
*
      INCLUDE 'ALLOC'  
*
      INTEGER       MCGNDO,MCGOCO,MCGOLI,NBNEUC,NBNEUL,ELEMEN
      CHARACTER     ERCODE*120 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DskMlm*')
*
      DIMATE=0
      DIVECC=0
      DIVECL=0
      CALL TBRR1  (ERCODE,'#RGNDO',NUDOK,MCGNDO)
      CALL TBAR1  (ERCODE,'#RGNDO',NUDOK,MCGNDO)
      MCGOLI=MCGNDO+IST(MCGNDO)-1
      MCGOCO=MCGNDO+1
      DO 1 ELEMEN=1,NBELDO
         NBNEUC = IST(MCGOCO)
         NBNEUL = IST(MCGOLI)
         DIMATE = DIMATE + NBNEUC*NBNEUL
         DIVECC = DIVECC + NBNEUC
         DIVECL = DIVECL + NBNEUL
         MCGOCO = MCGOCO+NBNEUC+1
         MCGOLI = MCGOLI+NBNEUL+1
1     CONTINUE
      CALL PRFXMJ (-1,'*DskMlm*')  
      RETURN
                                                                    END !DskMlm
