*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CENUME (NUINCE,NCPICE,NUKACE,NVNUCE,NVDUCE,MULTIM
     &                  ,NVDSMA,BONDLS,BONNLS,BONDLW,BONNLW
     &                  ,NUINCC,NVNUMC,NEAVCE,MCNECO
     &                  ,NUINCL,NVNUML,NEAVLE,MCNELI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 1989)
* Derniere modification : D.Martin (30 Septembre 2001)
* Version 1.0.1
*
* Recherche des numerotations matricielles pour cdesse
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) MULTIM,BONDLS,BONDLW
      INTEGER       NUINCE,NCPICE,NUKACE,NVNUCE,NVDUCE,NVDSMA
     &             ,MCNECO,MCNELI,NUINCC,NVNUMC,NUINCL,NVNUML
     &             ,BONNLS,BONNLW,NEAVCE,NEAVLE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCNECE,MCDSMM,LGEDSM,NBLOCC,INCDSM,NBLOCL
     &             ,NBNUMC,NBNUML,NULOCC,NULOCL,LGDUCE
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeNume*')
*
      NEAVCE=0
      NEAVLE=0
*
      IF (MULTIM.EQ.'Y') THEN
         IF (NCPICE.GT.1) THEN
*           Cas d'une condition essentielle pour une inconnue vectorielle
            BONNLS=NVDUCE
            CALL TBRR1  (ERCODE,'#GNEDO',NVDUCE,LGDUCE)
            IF (NUKACE.GT.1) THEN
*              Selection des d.l. a bloquer
               BONDLS=BONDLW
               BONNLS=BONNLW
               CALL TBCREE (BONDLS,BONNLS,1,LGDUCE,'c')
               CALL CESLCT (NCPICE,NVDUCE,NUKACE,BONDLS,BONNLS)         !cdesse
               CALL TBSAVE ('#GNEDO',NVDUCE)                     
            ENDIF
         ELSE
            CALL TBRR1  (ERCODE,'#GNEDO',NVNUCE,MCNECE)
         ENDIF
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMA,MCDSMM)
         CALL SDEXDB (IST(MCDSMM),LGEDSM,NBLOCC,INCDSM,NBLOCL)          !sdexplo
         MCDSMM=MCDSMM+LGEDSM
         NEAVCE=0
         DO 2 NULOCC=1,NBLOCC
            NEAVLE=0
            DO 1 NULOCL=1,NBLOCL
*              Inconnues et numerotations
               NUINCC=IST(MCDSMM+1)
               NUINCL=IST(MCDSMM+2)
               NVNUMC=IST(MCDSMM+3)
               NVNUML=IST(MCDSMM+4)
               MCDSMM=MCDSMM+INCDSM
*
               CALL TBRR1  (ERCODE,'#GNEDO',NVNUMC,MCNECO)
               CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNECO)
               NBNUMC=IST(MCNECO+1)
               IF (NVNUML.NE.NVNUMC) THEN
                  CALL TBRR1  (ERCODE,'#GNEDO',NVNUML,MCNELI)
                  CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNELI)
                  NBNUML=IST(MCNELI+1)
               ELSE
                  MCNELI=MCNECO
                  NBNUML=NBNUMC
               ENDIF
               IF (NUINCE.EQ.NUINCC.AND.NUINCE.EQ.NUINCL) GOTO 10000
*
               CALL TBSAVE ('#GNEDO',NVNUMC)
               IF (NVNUML.NE.NVNUMC) CALL TBSAVE ('#GNEDO',NVNUML)
               NEAVLE=NEAVLE+NBNUML
1           CONTINUE
            NEAVCE=NEAVCE+NBNUMC
2        CONTINUE
*
      ELSE
*
         CALL TBRR2  (ERCODE,'#GNEDO',NVNUCE,MCNECE
     &                      ,'#GNEDO',NVNUMC,MCNECO)
         CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNECO)
         IF (NVNUML.NE.NVNUMC) THEN
            CALL TBRR1  (ERCODE,'#GNEDO',NVNUML,MCNELI)
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNELI)
         ELSE
            MCNELI=MCNECO 
         ENDIF
      ENDIF
10000 CALL PRFXMJ (-1,'*CeNume*')
                                                                    END !CeNume
