*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CERONM (NUINCE,NCPICE,NVNUCE,COLLIG,MULTIM,NIVEAU
     &                  ,NMRGDL,NVRGDL,ADRGDL,LGRGDL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998)
* Derniere modification : D.Martin (26 Aout 2000)
* Version 1.0.1
*
* Tableaux des rangs des noeuds de condition essentielle dans un tableau
* de numerotation en ligne/colonne de la matrice
*  
*-- Arguments --
* NUINCE numero d'inconnue de la condition essentielle
* NCPICE nombre de composantes de l'inconnue de la condition essentielle
* NVNUCE niveau de numerotation en d.l. de la condition essentielle
* COLLIG indicateur de tableau resultat en ligne ou colonne
* MULTIM indicateur du caractere multi-inconnue ou non du systeme
* NIVEAU niveau de structure d'assemblage multi-inconnue de la matrice
*        ou niveau de numerotation en noeuds en ligne ou colonne de la matrice
* NBLIGN nombre de lignes de la matrice
* NBCOLO nombre de colonnes de la matrice
* NMRGDL tableau de travail pour les rangs cherches
* NVRGDL son niveau
* ADRGDL pointeur dans le tableau precedent
* LGRGDL longeur du tableau precedent
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) COLLIG,NMRGDL,MULTIM
      INTEGER       NUINCE,NCPICE,NVNUCE,NIVEAU,NVRGDL,ADRGDL,LGRGDL
     &             ,NIVIMP,IMPFCH
*  
      INCLUDE 'ALLOC'
*
      CHARACTER     PRFXAS*8
      INTEGER       MCNUCE,MCRGDL,MMRGDL,NBNUME,NBESSE
     &             ,MCNUME,NUNUME,NEXT,NUNEXT,NWNUME,LGNUME
     &             ,MCDSMA,LGEDSM,INCDSM,NBLOCC,NBLOCL
     &             ,NBOUCL,INCREM,MOINCO,NUINCO,LGRIPP,I
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeroNm*')
*
      CALL TBAR2  (ERCODE,'#GNEDO',NVNUCE,MCNUCE,NMRGDL,NVRGDL,MCRGDL)
      NBESSE=IST(MCNUCE+1)
*
      IF (MULTIM(1:1).EQ.'Y') THEN
         IF (IMPFCH.GT.0.AND.NIVIMP.GT.2)
     &      WRITE (IMPFCH,10000) (PRFXAS(I),I=3,0,-1),COLLIG,'d.l.'
*
         CALL TBAR1  (ERCODE,'$DSMBL',NIVEAU,MCDSMA)
         CALL SDEXDB (IST(MCDSMA),LGEDSM,NBLOCC,INCDSM,NBLOCL)          !sdexplo
*
         IF (COLLIG(1:1).EQ.'C') THEN
            NBOUCL=NBLOCC
            INCREM=INCDSM*NBLOCL
            MOINCO=1
         ELSE
            NBOUCL=NBLOCL
            INCREM=INCDSM
            MOINCO=2
         ENDIF
*
         MMRGDL=MCRGDL+ADRGDL-1
         DO 101 NUNUME=1,LGRGDL
            IST(MMRGDL+NUNUME)=-NUNUME
101      CONTINUE
*
         LGRIPP=LGEDSM
         LGNUME=0
         DO 103 I=1,NBOUCL
            CALL TBAR1  (ERCODE,'$DSMBL',NIVEAU,MCDSMA)
            NUINCO=IST(MCDSMA+LGRIPP+MOINCO)
            NWNUME=IST(MCDSMA+LGRIPP+MOINCO+2)
            CALL TBRR1  (ERCODE,'#GNEDO',NWNUME,MCNUME)
            CALL TBAR1  (ERCODE,'#GNEDO',NWNUME,MCNUME)
            NBNUME=IST(MCNUME+1)
            IF (NUINCE.EQ.NUINCO) THEN
               CALL TBAR3  (ERCODE, NMRGDL ,NVRGDL,MCRGDL
     &                            ,'#GNEDO',NVNUCE,MCNUCE
     &                            ,'#GNEDO',NWNUME,MCNUME)
               MMRGDL=MCRGDL+ADRGDL-1+LGNUME
               NEXT=1
               MCNUME=MCNUME+1
               DO 102 NUNUME=1,NBNUME
                  MCNUME=MCNUME+1
                  MMRGDL=MMRGDL+1
                  CALL DICOTO (NEXT,NBESSE,IST(MCNUCE+2),IST(MCNUME)
     &                        ,NUNEXT,*102)                             !utilite
                  IST(MMRGDL)=NUNEXT
                  NEXT=NUNEXT+1
102            CONTINUE
               CALL TBSAVE ('#GNEDO',NWNUME)                     
               GOTO 99999
            ELSE
               CALL TBSAVE ('#GNEDO',NWNUME)                     
            ENDIF
            LGRIPP=LGRIPP+INCREM
            LGNUME=LGNUME+NBNUME
103      CONTINUE
*
      ELSE
         IF (IMPFCH.GT.0.AND.NIVIMP.GT.2)
     &      WRITE (IMPFCH,10000) (PRFXAS(I),I=3,0,-1),COLLIG,'noeuds'
*
         CALL TBAR1  (ERCODE,'#GNEDO',NIVEAU,MCNUME)
         NBNUME=IST(MCNUME+1)
*
         MMRGDL=MCRGDL+ADRGDL-1
         DO 201 NUNUME=1,NBNUME
            IST(MMRGDL+NUNUME)=-NUNUME
201      CONTINUE
*
         NEXT=1
         MCNUME=MCNUME+1
         DO 202 NUNUME=1,NBNUME
            MCNUME=MCNUME+1
            MMRGDL=MMRGDL+1
            CALL DICOTO (NEXT,NBESSE,IST(MCNUCE+2),IST(MCNUME)
     &                  ,NUNEXT,*202)                                   !utilite
            IST(MMRGDL)=NUNEXT
            NEXT=NUNEXT+1
202      CONTINUE
*
      ENDIF
*
99999 IF (IMPFCH.GT.0.AND.NIVIMP.GT.2) WRITE (IMPFCH,10001)
     &   (IST(NUNUME),NUNUME=MCRGDL+ADRGDL,MCRGDL+ADRGDL+LGRGDL-1)
      CALL PRFXMJ (-1,'*CeroNm*')
*-----------------------------------------------------------------------
10000 FORMAT(T2,A,'>',A,'>',A,'>',A
     &/T10,'Numeros des ',A8,' de ',A,' pour changement de repere')
10001 FORMAT((T10,10I8))
                                                                    END !CeroNm
