*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLFLTR (NBNELI,NGNELI,NULAPL,IPLAGE,ITYPTR
     &                  ,MCTERM,NBNEFR,NGNEFR,MCTRMR,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1989)
* Derniere modification (D.Martin) le 20 septembre 1994  
*
* Constitution d'un terme de relevement compacte MORSE 
* cas de la frontiere de relevement
*  
*-- Arguments d'entree --
* NBNELI nombre de lignes du terme dont on extrait le relevement
* NGNELI numeros globaux des noeuds pour l'interpolation en ligne  
* NULAPL numeros de derniere plage de chaque ligne 
* IPLAGE numeros de colonne de debut de plage et des longueurs cumulees
* ITYPTR Indice de type (REEL ou COMPLEXE) du terme
* MCTERM adresse du terme en m.c. du terme dont on extrait le relevement
* NBNEFR nombre de noeuds de la frontiere de relevement
* NGNEFR numeros globaux des noeuds de la frontiere
* MCTRMR adresse du terme releve en m.c.
* RST,CST super-tableaux version reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBNELI,NGNELI(*),NULAPL(*),IPLAGE(2,*),ITYPTR
     &             ,MCTERM,NBNEFR,NGNEFR(*),MCTRMR  
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      INTEGER       INTTYP
*-----------------------------------------------------------------------
      NEXT=1  
      LGCUAR=MCTRMR
*
      IF (ITYPTR.EQ.INTTYP ('REEL')) THEN
         DO 21 NEFRON=1,NBNEFR
            CALL DICOTO (NEXT,NBNELI,NGNELI,NGNEFR(NEFRON),INELI,*99999)!Utilite
            NEXT=INELI+1
            NDEBPL=1
            LGCUAV=0
            IF (INELI .GT.1) NDEBPL=NULAPL(INELI-1)+1
            IF (NDEBPL.GT.1) LGCUAV=IPLAGE(2,NDEBPL-1)
            NFINPL=NULAPL(INELI)
            LGCUAP=IPLAGE(2,NFINPL)
            DO 20 NUCOEF=MCTERM+LGCUAV,MCTERM+LGCUAP-1  
               RST(LGCUAR)=RST(NUCOEF)
               LGCUAR=LGCUAR+1
20          CONTINUE
21       CONTINUE
      ELSE 
         DO 41 NEFRON=1,NBNEFR
            CALL DICOTO (NEXT,NBNELI,NGNELI,NGNEFR(NEFRON),INELI,*99999)!Utilite
            NEXT=INELI+1
            NDEBPL=1
            LGCUAV=0
            IF (INELI .GT.1) NDEBPL=NULAPL(INELI-1)+1
            IF (NDEBPL.GT.1) LGCUAV=IPLAGE(2,NDEBPL-1)
            NFINPL=NULAPL(INELI)
            LGCUAP=IPLAGE(2,NFINPL)
            DO 40 NUCOEF=MCTERM+LGCUAV,MCTERM+LGCUAP-1  
               CST(LGCUAR)=CST(NUCOEF)
               LGCUAR=LGCUAR+1
40          CONTINUE
41       CONTINUE
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 CALL BAISE  (' *Rlfltr* Le numero global NGNEFR(NEFRON) doit se '    
     &            //'trouver dans la numerotation en ligne ')           !Utilite
                                                                    END !Rlfltr
