*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISXX (TYPE,LAGHER,KCLASS,NBNEEL,NBDLEL
     &                  ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1988)
* Derniere modification : D.Martin (14 juin 2004)
* Version 1
*
* Procedure 'Vide' pour un oubli de procedure de type ElemNB
*
*-- Variable d'entree --
* TYPE numero de type de l'element
*  
*-- Variables de sortie --  
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* KCLASS classe de l'element (Element de classe C^0, C^1,...etc)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBNEAX nombre maximum de noeuds sur une arete
* NBDLAX nombre maximum de d.l. sur une arete
* NBNEFX nombre maximum de noeuds sur une face
* NBDLFX nombre maximum de d.l. sur une face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   TYPE,LAGHER,KCLASS,NBNEEL,NBDLEL
     &         ,NBNEAX,NBDLAX,NBNEFX,NBDLFX
*
      CHARACTER TYNAME*3
*-----------------------------------------------------------------------
      CALL ENCLER (TYPE,TYNAME)
      CALL BAISE  ('*Elemxx* Vous avez oublie d''ecrire la procedure '
     &//'PRISXX pour le type XX='//TYNAME)
                                                                    END !Hexaxx