*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EL000B (KELFCT,NDIM,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1994)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonction de base et derivees - Elements d'ordre 0
*  
*-- Arguments --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base  
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
* P      tableau contenant la valeur de la fonction
* DP         -       -            -     -  derivees premieres 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDIM
      CHARACTER*(*) KELFCT 
      REAL          P(*),DP(NDIM,*)
*
      INTEGER       I
*-----------------------------------------------------------------------
*   Fonctions de base  
*  
      IF (KELFCT(1:1).NE.'N') THEN  
         P(1)=1.
      ENDIF
*  
*   Derivees premieres
*
      IF (KELFCT(2:2).NE.'N') THEN
      DO 1 I=1,NDIM
         DP(I,1)=0.
1     CONTINUE
      ENDIF
                                                                    END !El000B
