*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HE202C (NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Coordonnees des noeuds de l'element de reference pour l'exaedre de Lagrange
* (ordre 2, serendipity) a 20 noeuds
*                    (../../doc_html/ef/numloche.html)
*
*-- Variables d'entree --
* NDIM   dimension d'espace
*  
*-- Arguments en sortie --
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NDIM
      REAL CORLOC(NDIM,*)
*
      INTEGER NUX3SE(3,27),K,KNEW,NOEUDS,I,J
      REAL    CORLO1(3)
*-----------------------------------------------------------------------
*
      K=2
      KNEW=K
*
*     Coordonnees de noeuds dans le segments d'ordre k
*
      CALL SELKCO (K,1,CORLO1)
*
*     Tableau de correspondance entre les noeuds du segment d'ordre k
*     et l'hexaedre d'ordre k
*
      NOEUDS=0
      CALL SEX3SE (KNEW,NDIM,NOEUDS,NUX3SE)
*
*     Coordonnees des noeuds dans l'hexaedre d'ordre k
*
      DO 2 I=1,20
         DO 1 J=1,NDIM
            CORLOC(J,I)=CORLO1(NUX3SE(J,I))
1        CONTINUE
2     CONTINUE
                                                                    END !He22co
