*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PR202C (NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Coordonnees des noeuds de l'element de reference 
* Prisme de Lagrange (ordre 2, serendipity) a 15 noeuds
*
*-- Arguments --
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER I ,L,IP6,IP9,IP12
*-----------------------------------------------------------------------
      CORLOC(1,1)=1.
      CORLOC(2,1)=0.
      CORLOC(3,1)=0.
      CORLOC(1,2)=0.
      CORLOC(2,2)=1.
      CORLOC(3,2)=0.
      CORLOC(1,3)=0.
      CORLOC(2,3)=0.
      CORLOC(3,3)=0.
      CORLOC(1,4)=1.
      CORLOC(2,4)=0.
      CORLOC(3,4)=1.
      CORLOC(1,5)=0.
      CORLOC(2,5)=1.
      CORLOC(3,5)=1.
      CORLOC(1,6)=0.
      CORLOC(2,6)=0.
      CORLOC(3,6)=1.  
      CORLOC(1,7)=.5
      CORLOC(2,7)=.5
      CORLOC(1,8)=.0
      CORLOC(2,8)=.5
      CORLOC(1,9)=.5
      CORLOC(2,9)=.0
      DO 2 I=1,3
         IP12=I+12
         IP9=I+9  
         IP6=I+6  
         CORLOC(3,IP6)=0. 
         CORLOC(3,IP12)=.5
         CORLOC(3,IP9)=1. 
         DO 1 L=1,2
            CORLOC(L,IP12)=CORLOC(L,I)
            CORLOC(L,IP9)=CORLOC(L,IP6)
1        CONTINUE
2     CONTINUE
                                                                    END !Pr22co
