*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRIS (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (26 Avril 2001)
* Version 1.0.2
*  
*-- Variable d'entree --
* TYPE : k < 11 --> Prisme de Lagrange PkxQk a (k+1)(k+1)(k+2)/2 noeud
*        22     --> Prisme de Lagrange Serendipity P2xQ2' a 15 noeuds
*  
*-- Variable en sortie -- Cf. Cartouche de commentaire dans ELemNB
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &       ,NBNEAX,NBDLAX,NBNEFX,NBDLFX
*
      INTEGER     NIVESP
      CHARACTER*8 PREFIX
      COMMON/SPNAME/PREFIX(20) /SPNIVE/NIVESP
*-----------------------------------------------------------------------
      LAGHER=0 
      CLASSE=0
      IF (TYPE.LE.2) THEN
         NBNEAX=TYPE+1
         NBDLAX=NBNEAX
         NBNEFX=NBNEAX*NBNEAX
         NBDLFX=NBNEFX
         NBNEEL=(NBNEAX*NBNEAX*(NBNEAX+1))/2
         NBDLEL=NBNEEL
      ELSEIF (TYPE.EQ.202) THEN
         NBNEEL=15
         NBDLEL=NBNEEL
         NBNEFX=8 
         NBDLFX=NBNEFX
         NBNEAX=3 
         NBDLAX=NBNEAX
      ELSE
         CALL PRISXX (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &               ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
      ENDIF

                                                                    END !Pris
