*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISNE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (18 Novembre 2000)
* Version 1.0.1
*  
*-- Variable d'entree --
* TYPE 0  --> Prisme de Lagrange P0 a 1 noeud
*      1  --> Prisme de Lagrange P1xQ1 a 6 noeuds
*      2  --> Prisme de Lagrange P2xQ2 a 18 noeuds
*      22 --> Prisme de Lagrange Serendipity P2xQ2' a 15 noeuds
*  
*-- Variables en sortie --
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEFACE nombre de noeuds sur les faces non situes sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,NESOME,NEARET,NEFACE,NEINTE
*
*-----------------------------------------------------------------------
      NESOME=6
      NEFACE=0
      NEARET=0
      NEINTE=0
      IF (TYPE.EQ.0) THEN
         NESOME=0
         NEINTE=1
      ELSEIF (TYPE.EQ.1) THEN
         RETURN
      ELSEIF (TYPE.EQ.2) THEN
         NEARET=9
         NEFACE=3
      ELSEIF (TYPE.EQ.202) THEN
         NEARET=9
      ELSE
         CALL ERELEM (14,'*PrisNe*',TYPE)
      ENDIF
                                                                    END !PrisNe
