*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QUADNE (TYPE,NESOME,NEARET,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
*-- Variable d'entree --
* TYPE numero de type de l'element   
*   k= 0 a 19 --> Quadrangle de Lagrange Qk a (k+1)^2 noeuds treillis regulier
*   k=30 a 49 --> Quadrangle de Lagrange Qk a (k+1)^2 noeuds de Gauss-Lobatto
*   k=22      --> Quadrangle de Lagrange Q2 Serendipity a 8 noeuds
*
*-- Variables de sortie --
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,NESOME,NEARET,NEINTE
*
      INTEGER TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      NESOME=4
      NEARET=0
      NEINTE=0
*
      IF (TYPE.EQ.0) THEN
         NESOME=0
         NEINTE=1
      ELSEIF (TYPNEW.LE.LAGDMX) THEN
         NEARET=(TYPNEW-1)
         NEINTE=NEARET*NEARET
         NEARET=4*NEARET
      ELSEIF (TYPE.EQ.202) THEN
         NEARET=4
      ELSE
         CALL ERELEM (11,'*Quadne*',TYPE)
      ENDIF
                                                                    END !QuadNe
