*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SEGM (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBDLSX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
*-- Variable d'entree --
* TYPE numero de type de l'element   
*-- Variables de sortie --  
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* CLASSE classe de l'element (Element de classe C^0, C^1,...etc)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBDLSX =1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBDLSX
*
      INTEGER TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      LAGHER = 0 
      CLASSE = 0 
*
      IF (TYPNEW.LE.LAGDMX) THEN
         NBNEEL = TYPNEW+1
         NBDLEL = NBNEEL
         NBDLSX = 1
      ELSEIF (TYPE.EQ.200) THEN
         NBNEEL = 2 
         NBDLEL = 4 
         NBDLSX = 1 
         LAGHER = 1
      ELSEIF (TYPE.EQ.202) THEN
         NBNEEL = 3
         NBDLEL = NBNEEL
         NBDLSX = 1
      ELSE
         CALL SEGMXX (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBDLSX)
      ENDIF
                                                                    END !Segm
