*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR200A (NUARET,NUTYAR,NBNEAR,NUNEAR,NBDLAR,NUDLAR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Numerotation locale des noeuds d'une arete de l'element de reference 
* Triangle de Hermite (ordre 1) a 4 noeuds et 10 d.l.
*
*-- Arguments --
* NUARET numero de l'arete
* NUTYAR numero de type de l'arete (numero de type de l'elt 1d associe)
* NBNEAR nombre de noeuds de l'arete
* NUNEAR tableau des numeros locaux des noeuds de l'arete
* NBDLAR nombre de d.l. de l'arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUARET,NUTYAR,NBNEAR,NUNEAR(*),NBDLAR,NUDLAR(*)
*
      INTEGER I,J,NTYPFO
      PARAMETER (NTYPFO = 1000)
*---------------------------------------------------------------------
      NBNEAR=2 
      NUTYAR=10*NTYPFO+20
      NBDLAR=4
      NUNEAR(1)=NUARET 
      NUNEAR(2)=NUARET+1
      IF (NUARET.EQ.3) NUNEAR(2)=1
      I=1+3*(NUARET-1) 
      NUDLAR(1)=I  
      I=I+1
      DO 1 J=2,4
         I=I+1 
        NUDLAR(J)=MOD(I,10)+1
1     CONTINUE
                                                                    END !Tr20ar
