*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR200C (NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Coordonnees des noeuds de l'element de reference 
* Triangle de Hermite (ordre 1) a 4 noeuds et 10 d.l.
*
*-- Arguments --
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM
      REAL    CORLOC(NDIM,*)

      REAL TIERS
*---------------------------------------------------------------------
      TIERS=1./3.
      CORLOC(1,1)=1.
      CORLOC(2,1)=0.
      CORLOC(1,2)=0.
      CORLOC(2,2)=1.
      CORLOC(1,3)=0.
      CORLOC(2,3)=0. 
      CORLOC(1,4)=TIERS
      CORLOC(2,4)=TIERS
                                                                    END !Tr200C
