*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRIANE (TYPE,NESOME,NEARET,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
*-- Variable d'entree --
* TYPE   k < 100 --> Triangle de Lagrange Pk a (k+1)(k+2)/2 noeud(s)
*       200      --> Triangle  d'Hermite  P3 a 4 noeuds et 10 d.l.
*       201      --> Triangle de Lagrange P1 a 3 noeuds Non Conforme H1
*       202      --> Triangle de Lagrange P2 a 6 noeuds
*       203      --> Triangle de Lagrange P1+bulle P3 a 4 noeuds
*
*-- Variables de sortie --
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,NESOME,NEARET,NEINTE
*
      INTEGER LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      NESOME=3
      NEARET=0
      NEINTE=0
      IF (TYPE.EQ.0) THEN
         NESOME=0 
         NEINTE=1
      ELSEIF (TYPE.LE.LAGDMX) THEN
         NEARET=3*(TYPE-1)
         NEINTE=((TYPE-2)*(TYPE-1))/2
      ELSEIF (TYPE.EQ.200) THEN
         NEINTE=1
      ELSEIF (TYPE.EQ.201) THEN
         NESOME=0
         NEARET=3
      ELSEIF (TYPE.EQ.202) THEN
         NEARET=3
      ELSEIF (TYPE.EQ.203) THEN                                         !06/2004
         NEINTE=1                                                       !06/2004
      ELSE
         CALL ERELEM (12,'*TriaNe*',TYPE)
      ENDIF
                                                                    END !TriaNe
