*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASQLOC (IDLHRM,ITYPTR,MCTERM,MCPLOC,NNEITL,NBNEUL
     &                  ,NBDLDO,NBFDEV,NUNEFA,NDLINL,IRGNDL,NULINE
     &                  ,NCPINL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Avril 1992)
* Derniere modification: O.DeBayser le 2 Avril 1992
*
* Assemblage d'un terme element finis localise
*
*-- Arguments --
* ITYPTR: Type de declaration du terme
* MCTERM: Adresse du terme assemble
* MCPLOC: Adresse de la matrice elementaire
* COLLIG: Indicateur de rangement dans le terme assemble
* NBNEFA: Nombre de d.l. par face d'element
* NBDLDO: Nombre de d.l. element finis du terme
* NBFDEV: nombre de d.l. spectraux du terme
* NUNEFA: Correspondance noeud de face , noeud dans l'element en ligne
* NDLINL: Nombre de d.l. par noeud dans l'element en ligne
* IRGNDL: tableau des rangs des noeuds en ligne de l'element
* IDLHRM: Indice de presence de d.l. element finis de Hermitte
* NULINE: tableau des numeros des premiers d.l. de chaque noeud
* NCPINL: Nombre de composantes de l'inconnue en ligne
* RST,CST Super tableau habituel
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUNEFA(*),NDLINL(*),IRGNDL(*),NULINE(*)
      COMPLEX CST(*)
      REAL    RST(*)
*
      IACCOF=1
      IF(ITYPTR.EQ.INTTYP('COMPLEXE')) THEN
         DO 2 INEL=1,NNEITL
            INEUL=INEL
            IF(NNEITL.NE.NBNEUL) INEUL=NUNEFA(INEL)
            NBDLIL=1
            IDEB=IRGNDL(INEUL)
            IF(IDLHRM.GT.0) THEN
               NBDLIL=NDLINL(INEUL)
               IDEB=NULINE(IDEB)
            END IF
            DO 2 IDLL=IDEB,IDEB+NBDLIL*NCPINL-1
               IAPLOC=IACCOF
               IATERM=MCTERM+IDLL-1
               DO 1 K=1,NBFDEV
                  CST(IATERM)=CST(IATERM)+CST(IAPLOC)
                  IATERM=IATERM+NBDLDO
1                 IAPLOC=IAPLOC+NNEITL
2              IACCOF=IACCOF+1
      ELSE
         DO 20 INEL=1,NNEITL
            INEUL=INEL
            IF(NNEITL.NE.NBNEUL) INEUL=NUNEFA(INEL)
            NBDLIL=1
            IDEB=IRGNDL(INEUL)
            IF(IDLHRM.GT.0) THEN
               NBDLIL=NDLINL(INEUL)
               IDEB=NULINE(IDEB)
            END IF
            DO 20 IDLL=IDEB,IDEB+NBDLIL*NCPINL-1
               IAPLOC=IACCOF
               IATERM=MCTERM+IDLL-1
               DO 10 K=1,NBFDEV
                  RST(IATERM)=RST(IATERM)+RST(IAPLOC)
                  IATERM=IATERM+NBDLDO
10                IAPLOC=IAPLOC+NNEITL
20             IACCOF=IACCOF+1
      ENDIF
                                                                    END !Asqloc
