*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLBAND (NBTPTG,ADVOIS,NEVOIS,LBAND,LPROFI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (30 juin 2002)
* Version 2.0.0
*
* Evaluation de la largeur de bande et du nombre de coefficients du profil
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBTPTG,ADVOIS(*),NEVOIS(*),LBAND,LPROFI
*
      INTEGER NGI,NGJ,ADRVOI,ADNEXT,NBCOEF,LBANDI
*-----------------------------------------------------------------------
      LBAND=0
      LPROFI=0
      DO 2 NGI=1,NBTPTG
         NBCOEF=0
         ADRVOI=ADVOIS(NGI)
         DO 1 ADNEXT=ADRVOI+1,ADRVOI+NEVOIS(ADRVOI)
           NGJ=NEVOIS(ADNEXT)
           LBANDI=ABS (NGJ-NGI)
           NBCOEF=MAX (NBCOEF,NGI-NGJ)
           IF (LBANDI.GT.LBAND) LBAND=LBANDI
1        CONTINUE
         LPROFI=LPROFI+NBCOEF
2     CONTINUE
                                                                    END !RlBand
