*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M2UENR (NOMINT,COMENT,COMPOS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : M.Lenoir & F.Mahe (1992)
* Derniere modification : D.Martin (3 Juillet 1997)
*
* Ecriture de l'entete d'un resultat de dessin pour Unighn
*
*-- Arguments d'entree --
* NOMINT nom de la donnee chaine de caractere caracterisant le nom des 
*        fichiers resultats (nom interne du fichier) (cf. M2UOUV)
* COMENT chaine de commentaire apparaissant dans l'entete du resultat
* COMPOS chaine indiquant les composantes du resultat a tracer
*       =(' ','1','2','3','12','21','23','32','13','31',
*       = '123',312','231','132','321','213')
*       ' ' defaut : toutes les composantes du vecteur
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINT,COMENT,COMPOS
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER   DIMRES,AD1DOM,NUNITR
     &         ,LGENDS,NBDESS,LGCHAR,NBCARD,INCNDS,INCNDO
      INTEGER   KELCHN,INTTYP
      LOGICAL   OUVERT,EXISTE
      REAL      RBID
      COMPLEX   CBID
      CHARACTER NOMEXT*72,ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'<M2uEnr>')
*
      NOMEXT=' '
      CALL GETCST (NOMINT,ERCODE,NLONG,RBID,CBID,NOMEXT)                !Sdexplo
      NLONG=INDEX (NOMEXT,' ')-1
      INQUIRE (FILE=NOMEXT(1:NLONG)
     &        ,NUMBER=NUNITR,EXIST=EXISTE,OPENED=OUVERT)
      IF (.NOT.EXISTE.OR..NOT.OUVERT) GOTO 99990
*
*     Structure de donnees
*
      CALL TBAR2  (ERCODE,'$NomDS',1,MCNMDS,'$InfDS',1,MCINDS)
      LGENDS=IST(MCINDS)
      NBDESS=IST(MCINDS+1)
      LGCHAR=IST(MCINDS+2)
      NBCARD=IST(MCINDS+3)
      INCNDS=IST(MCINDS+4)
      INCNDO=IST(MCINDS+5)
      NBCHN =NBCARD*NBDESS
      NUMCHN=KELCHN (NOMINT,AST(MCNMDS),NBCHN,LGCHAR)                   !Utilite
      NUMDES=1+NUMCHN/NBCARD
      AD1DOM=MCINDS+LGENDS+INCNDS*(NUMDES-1)
      IST(AD1DOM+1)=IST(AD1DOM+1)+1
*
*     Stockage des numeros des composantes du vecteur resultat
*
      CALL TBCREE ('$DimRS',NUMDES,INTTYP('ENTIER'),4,'c')
      CALL TBAR1  (ERCODE,'$DimRS',NUMDES,MCDIRS)
      IF (COMPOS(1:1).EQ.' ') THEN
         DIMRES=1
         IST(MCDIRS+1)=1
      ELSE
         DO 1 DIMRES=LEN(COMPOS),1,-1
            IF (COMPOS(DIMRES:DIMRES).NE.' ') GOTO 2
1        CONTINUE
2        IF(DIMRES.GT.3) GOTO 99991
         DO 3 I=1,DIMRES
            CALL RELCNE (COMPOS(I:I),NUMERO)                            !Utilite
            IF (NUMERO.GT.3.OR.NUMERO.LT.1) GOTO 99992
            IST(MCDIRS+I)=NUMERO
3        CONTINUE
      ENDIF
      IST(MCDIRS)=DIMRES
*
      WRITE (NUNITR,*)'RES'
      ERCODE=COMENT
      LG   =MIN (LEN (ERCODE),LEN (COMENT))
      WRITE (NUNITR,*)'NOM ',''''//ERCODE(:LG)//''''
      CALL ENCLER (DIMRES,ERCODE(1:1))
      ERCODE(2:2)='D'
      WRITE (NUNITR,*) ERCODE(1:2)
      WRITE (NUNITR,*)'REFGEO ','''GE'//NOMEXT(:NLONG)//''''
      WRITE (NUNITR,*)'VAL'
*
      CALL PRFXMJ (-1,'<M2uEnr>')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 ERCODE=NOMEXT
      CALL BAISE  (' Ouvrir prealablement (avec M2UOUV) le fichier '
     & //ERCODE(1:NLONG)//'!')                                          !Utilite
99991 ERCODE=COMPOS
      CALL BAISE  (' Chaine '//ERCODE(1:LEN(COMPOS))//' impossible')    !Utilite
99992 ERCODE=COMPOS(I:I)
      CALL BAISE  (' Numero de composante '//ERCODE(1:1)//' inconu')    !Utilite
                                                                    END !M2uEnr                               
