*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ITRATR (NUINTG,NDIM,KDERIC,INDEXC,KDERIL,INDEXL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998)
* Derniere modification : D.Martin (24 avril 1998)
*  
* Recherche des attributs d'un interpolant :  
*     - rangs des derivees en colonne et ligne 
*     - indices d'extension en colonne et ligne 
* et verification de la coherence avec la dimension 
*  
*-- Argument d'entree --  
* NUINTG numero d'interpolant
* NDIM   dimension d'espace
*  
*-- Arguments de sortie --
* KDERIC rang de la derivee en colonne (=-1 pour un terme unicolonne)
* INDEXC indice d'extension en colonne  
* KDERIL rang de la derivee en ligne (=-1 pour un terme uniligne)
* INDEXL indice d'extension en colonne  
*-- Liste des interpolants --
*Integrand U  D1U D2U D3U DNU 
*Numero    1    2   3   4   5
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER     NUINTG,NDIM,KDERIC,INDEXC,KDERIL,INDEXL
*
      CHARACTER   ERRCAR*4
*-----------------------------------------------------------------------
      KDERIC=0 
      INDEXC=0
      KDERIL=0 
      INDEXL=0
*
      IF (NUINTG.LE.5) THEN
*        Integrands U  D1U D2U D3U DNU
*        Numeros    1    2   3   4   5
         KDERIL=-1 
         IF (NUINTG.GT.1) THEN  
            KDERIC=1
            INDEXC=1
            IF (NUINTG.LE.4.AND.NUINTG.GT.NDIM+1) GOTO 90000
         ENDIF
      ELSE 
         CALL ENCLER (NUINTG,ERRCAR)                                    !utilite
         CALL BAISE  (' *ItrAtr* Interpolant '//ERRCAR//' non prevu')   !utilite
      ENDIF
      RETURN
*-----------------------------------------------------------------------
90000 IF (NDIM.LE.0) RETURN
      CALL ENCLER (NUINTG,ERRCAR)                                       !utilite
      CALL BAISE  (' *ItrAtr* Interpolant numero '//ERRCAR              !utilite
     &//' impossible en dimension '//CHAR(NDIM+48))
                                                                    END !ItrAtr
