*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION ITRGKL (NMITRG)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998)
* Derniere modification : D.Martin (13 mai 1998)
*  
* Recherche du numero de l'interpolant de nom NMITRG 
*  
*-- Arguments --  
* NMITRG chaine de caractere representant le nom de l'interpolant
*-- Definitions --
* NBINXX nombre de groupe d'interpolants
* NBINLI nombre d'interpolants dans un groupe
* NBCALI nombre de caracteres des noms d'interpolants du groupe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMITRG
      INTEGER       ITRGKL
*
      CHARACTER     CPLOUC*120,TPLOUC,ITRNLI*120
      INTEGER       NBINTA,NBINTG,NBCAR,KELCHN,KLI,K,NBINXX,NBINTK
      PARAMETER    (NBINXX=1)
      INTEGER       NBINLI(NBINXX),NBCALI(NBINXX)
      COMMON/ONSEPA/CPLOUC 
      EQUIVALENCE  (CPLOUC,TPLOUC)
      DATA NBINLI  /5/
      DATA NBCALI  /3/
*-----------------------------------------------------------------------
      NBINTA=0
      DO 1 KLI=1,NBINXX
         NBINTG=NBINLI(KLI)
         NBCAR =NBCALI(KLI)
         NBINTK=NBINTA+NBINTG
         CPLOUC=ITRNLI (NBINTK)
         ITRGKL=KELCHN (NMITRG,TPLOUC,NBINTG,NBCAR)                     !utilite
         IF (ITRGKL.GT.0) THEN 
            ITRGKL=ITRGKL+NBINTA  
            RETURN
         ENDIF
         NBINTA=NBINTK
1     CONTINUE
*----------------------------------------------------------------------
      WRITE(*,10000)
      NBINTA=0
      DO 2 KLI=1,NBINXX
         NBINTG=NBINLI(KLI)
         NBCAR =NBCALI(KLI)
         NBINTK=NBINTA+NBINTG
         CPLOUC=ITRNLI (NBINTK)
         WRITE(*,10001) 
     &      (K+NBINTA,CPLOUC(1+NBCAR*(K-1):NBCAR*K),K=1,NBINTG)
         NBINTA=NBINTK
2     CONTINUE
*
10000 FORMAT(/' *ItrgKl* --- Liste des interpolants ---'/)
10001 FORMAT((T3,3(I4,'-',A20,' |')))
      K=LEN(NMITRG)
      CPLOUC(:K)=NMITRG
      CALL BAISE  (' *ItrgKl* Interpolant non reconnu : '//CPLOUC(:K))  !Utilite
                                                                    END !ItrgKl
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION ITRNLI (NUMERO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998)
* Derniere modification : D.Martin (24 avril 1998)
*
* Retourne la liste des noms des interpolants de numero <= NUMERO
*
*Integrand U  D1U D2U D3U DNU
*Numeros   1  2   3   4   5
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) ITRNLI
      INTEGER       NUMERO
*-----------------------------------------------------------------------
      IF (NUMERO.LE.5) THEN
         ITRNLI=
*Numeros 1  2  3  4  5
     &  'U  D1UD2UD3UDNU'
      ENDIF
                                                                    END !ItrNli

