*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCCADO (ITYDON,NIVDON,ITYPDO,LUCARA,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1989)
* Derniere modification : D.Martin (30 Mai 2000)
* Version # 1.0.2
*  
* LeCture des CAracteristiques d'une DOnnee 
*  
*-- Arguments d'entree --
* NIVIMP niveau d'impression dans la procedure 
* IMPMES unite de sortie des messages 
*-- Arguments de sortie --
* ITYDON indice de type de donnee 
* NIVDON numero ou niveau de la donnee
* ITYPDO indicateur du type de la donnee (entier,reel,d. precision,complexe,...)
* LUCARA indicateur de caracteristiques effectivement lu
*-- Directives --
*   voir description dans LcDONN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    LUCARA
      INTEGER          ITYDON,NIVDON,ITYPDO,NIVIMP,IMPMES
*  
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80
      INTEGER          INTDON,INTTYP,KLUNIT
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
     &                ,INTCON,INTFON,INTFIC,INTTAB
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Lccado*')
      LUCARA='N'
      INTCON=INTDON ('CONSTANTE')
      INTFON=INTDON ('FONCTION')
      INTTAB=INTDON ('TABLEAU')
      INTFIC=INTDON ('FICHIER')
*
1     IF (IRE.NE.3) GOTO 99999 
      IF (TEXTE(1:4).EQ.'TYPE') CALL REDLE
*
      IF (TEXTE(1:8).EQ.'CONSTANT'
     &.OR.TEXTE(1:NCAR).EQ.'FICHIER' .OR.TEXTE(1:NCAR).EQ.'FILE'
     &.OR.TEXTE(1:NCAR).EQ.'FONCTION'.OR.TEXTE(1:NCAR).EQ.'FUNCTION'
     &.OR.TEXTE(1:NCAR).EQ.'TABLEAU' .OR.TEXTE(1:NCAR).EQ.'ARRAY')
     &   THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.4) 
     &      WRITE (IMPMES,10003) '*Lccado*',TEXTE(1:NCAR)
         LUCARA='Y'
         ITYDON=INTDON (TEXTE(1:NCAR))                                  !utilite
*
         IF (ITYDON.EQ.INTFIC) THEN 
*           Donnee FICHIER : affectation d'un numero d'unite logique 
            NIVDON=KLUNIT ()                                            !sdexplo
         ELSEIF (ITYDON.EQ.INTTAB) THEN
*           Donnee TABLEAU : NIVEAU =1 par defaut
            NIVDON=1
         ENDIF
*
      ELSEIF (TEXTE(1:NCAR).EQ.'NIVEAU'
     &    .OR.TEXTE(1:NCAR).EQ.'LEVEL') THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.4) 
     &      WRITE (IMPMES,10003) '*Lccado*',TEXTE(1:NCAR)
         IF (ITYDON.NE.INTTAB) CALL REDERR (2,'NIVEAU')
         CALL REDLE
         IF (IRE.NE.1) CALL REDERR (11,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.4) 
     &      WRITE (IMPMES,10001) '*Lccado*',NFIX
         NIVDON=NFIX
*
      ELSE
        IF (TEXTE(1:NCAR).EQ.'REELLE') TEXTE(1:NCAR)='REEL'
        IF (TEXTE(1:NCAR).EQ.'ENTIERE') TEXTE(1:NCAR)='ENTIER'
*
        IF (TEXTE(1:9).EQ.'CARACTERE'.OR.TEXTE(1:9).EQ.'CHARACTER'
     &  .OR.TEXTE(1:6).EQ.'DOUBLE'.OR.TEXTE(1:7).EQ.'COMPLEX'
     &  .OR.TEXTE(1:6).EQ.'ENTIER'.OR.TEXTE(1:7).EQ.'INTEGER'
     &  .OR.TEXTE(1:4).EQ.'REEL'.OR.TEXTE(1:4).EQ.'REAL') THEN
            IF (IMPMES.GT.0.AND.NIVIMP.GT.4)
     &         WRITE (IMPMES,10003) '*Lccado*',TEXTE(1:NCAR)
*
            LUCARA='Y'
            ITYPDO=INTTYP (TEXTE(1:NCAR))                               !utilite
            IF (TEXTE(1:6).EQ.'DOUBLE') THEN
               CALL REDLE
               IF (IRE.NE.3.OR.TEXTE(1:9).NE.'PRECISION') GOTO 1
            ENDIF
         ELSE
           GOTO 99999
         ENDIF
      ENDIF
100   CALL REDLE
      GOTO 1  
*  
*     Par defaut la donnee est une constante
99999 IF (ITYDON.LT.0) ITYDON=INTDON ('CONSTANTE')                      !utilite
*     Par defaut la donnee nouvelle est reelle 
      IF (ITYPDO.LE.0) ITYPDO=INTTYP ('REEL')                           !utilite
*
      CALL PRFXMJ (-1,'*Lccado*')
*-----------------------------------------------------------------------
10003 FORMAT(T14,A8,T56,' , suivi du mot : ',A)
10001 FORMAT(T14,A8,T56,' , suivi du nombre :',I12)
                                                                    END !Lccado
