*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCCSTE (NIVDON,ITYPDO,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser  (Avril 1988)  
* Derniere modification : D.Martin (29 Juin 1997)  
*  
* Sous-programme de Lecture de la valeur d'une donnee constante
*  
*-- Arguments d'entree --
* NIVDON numero de la constante
* ITYPDO code entier du type de la constante  
* NIVIMP indicateur d'impression des donnees
* IMPMES unite de sortie des messages   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NIVDON,ITYPDO,NIVIMP,IMPMES
*  
      LOGICAL          ALIRE
      CHARACTER        ERCODE*120,TEXTE*80,TYPDON*12,TYPINT*12  
      INTEGER          INTTYP,KLCSTE
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/FORMAH/   ERCODE  
      INTEGER          NICAPL(2)
      REAL             RICAPL(2)
      COMPLEX          CAPLOP  
      EQUIVALENCE     (ERCODE(101:101),TYPDON) 
     &               ,(CAPLOP,RICAPL(1),NICAPL(1)) 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcCste*')
*  
      ALIRE=.TRUE. 
      TYPDON=TYPINT (ITYPDO)                                            !utilite
*  
*     Lecture de la valeur d'une constante (on a un REDLE d'avance)
*  
      IF (TYPDON(1:2).EQ.'CA') THEN 
         IF (IRE.EQ.1) THEN 
            ERCODE(1:7)='ENTIERE'  
            GOTO 90001
         ELSEIF (IRE.EQ.2) THEN
            ERCODE(1:6)='REELLE'
            GOTO 90001
         ENDIF
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10010) '*LcCste*',NCAR,TEXTE(1:NCAR)
         ALIRE=.FALSE. 
      ELSEIF (TYPDON(1:1).EQ.'E') THEN 
         IF (IRE.EQ.2) THEN 
            ERCODE(1:6)='REELLE'
            GOTO 90001
         ELSEIF (IRE.EQ.3.OR.IRE.EQ.4) THEN
            ERCODE(1:9)='CARACTERE'
            GOTO 90001
         ENDIF
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10001) '*LcCste*',NFIX  
         NICAPL(1)=NFIX
      ELSEIF (TYPDON(1:1).EQ.'R') THEN 
         IF (IRE.EQ.3.OR.IRE.EQ.4) THEN 
            ERCODE(1:9)='CARACTERE'
            GOTO 90001
         ENDIF
         RICAPL(1)=FLOT
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10003) '*LcCste*',RICAPL(1) 
      ELSEIF (TYPDON(1:1).EQ.'C') THEN 
         CAPLOP=0. 
         IF (IRE.EQ.1) THEN 
            RICAPL(1)=NFIX 
         ELSEIF (IRE.EQ.2) THEN
            RICAPL(1)=FLOT 
         ELSEIF (IRE.EQ.3.OR.IRE.EQ.4) THEN
            ERCODE(1:9)='CARACTERE'
            GOTO 90001
         ENDIF
         CALL REDLE                                                     !Redlec
         IF (IRE.EQ.1) THEN 
            RICAPL(2)=NFIX 
         ELSEIF (IRE.EQ.2) THEN
            RICAPL(2)=FLOT 
         ELSE  
            ALIRE=.FALSE.  
         ENDIF
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10003) '*LcCste*',CAPLOP
      ELSE 
         CALL ENCLER (ITYPDO,ERCODE(:4))                                !utilite
         CALL BAISE  ('Type de donnee non prevu : ITYPDO='//ERCODE(:4)) !utilite
      ENDIF
*  
      IF (ALIRE) THEN
         CALL REDLE                                                     !Redlec
         IF (TYPDON(1:1).EQ.'R'.AND.IRE.EQ.2) THEN  
            RICAPL(2)=FLOT 
            ITYPDO=INTTYP ('COMPLEXE')                                  !utilite
            TYPDON=TYPINT (ITYPDO)                                      !utilite
            CALL REDLE 
         ENDIF 
      ENDIF
*  
*     Introduction de la valeur de la constante dans le tableau
*     des constantes du bon type.  
*  
      IF (NIVDON.LE.0) NIVDON=KLCSTE (TYPDON)
      CALL INCST  (NIVDON,ITYPDO,NICAPL(1),RICAPL(1),CAPLOP
     &            ,TEXTE(1:NCAR))                                       !sdexplo
*     dans le cas caractere on a pas de REDLE d'avance ..
      IF (TYPDON(1:2).EQ.'CA'.OR.TYPDON(1:2).EQ.'CH') CALL REDLE
*  
      CALL PRFXMJ (-1,'*LcCste*')  
      RETURN
*-----------------------------------------------------------------------
10001 FORMAT(T8,A8,T56,' , suivi du nombre :',I9)  
10003 FORMAT(T8,A8,T56,' , suivi du nombre :'  
     &,E12.5,:,SP,E11.5,'*i')
10010 FORMAT(T8,A8,T56,' , suivi de la chaine (*',I2,') : ',A) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE  (' Incompatibilite entre type de la donnee ('//TYPDON
     &//') et celui de la valeur lue ('//ERCODE(:10)//')')
                                                                    END !LcCste
