*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCITRG (NUINTG,NIVIMP,IMPMES)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Avril 1998) 
* Derniere modification : D.Martin (24 Avril 1998)
* Version # 1.0.0
*
* LeCture du nom de l'interpolant pour un terme INTERPOLE
*  
*-- Arguments d'entree -- 
* NIVIMP niveau d'impression des directives
* IMPMES unite d'impression des messages  
*-- Argument de sortie -- 
* NUINTG numero de l'interpolant
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NUINTG,NIVIMP,IMPMES
*  
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80
      INTEGER          ITRGKL
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Lcitrg*')
*  
1     CALL REDLE
      IF (TEXTE(1:4).EQ.'TYPE') GOTO 1
      IF (IRE.NE.4) CALL REDERR (14,' ')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &   WRITE (IMPMES,10004) '*Lcitrg*',NCAR,TEXTE(1:NCAR)
      NUINTG=ITRGKL (TEXTE(1:NCAR))                                     !calkit
      CALL REDLE
*  
      CALL PRFXMJ (-1,'*Lcitrg*')  
*-----------------------------------------------------------------------
10004 FORMAT(T12,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
                                                                    END !Lcitrg
