*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCNONE (NBCHEN,NCCHEN,TBCHEN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & L.Anne (Mai 1997)
* Derniere modification : D.Martin (9 Fevrier 2000)
* Version # 1
*  
* Lecture a vide d'un ensemble de d'articles de donnees, jusqu'a lecture
* d'un article figurant dans une liste.
*
* NBCHEN nombre de 'chaines' de TBCHEN
* NCCHEN longueur des sous-chaines de la liste
* TBCHEN tableau de caracteres isomorphe a un tableau de chaines de longueur
*        NCCHEN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NBCHEN,NCCHEN
      CHARACTER TBCHEN(*)
*
      CHARACTER        TEXTE*80
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP, NU,NB
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*----------------------------------------------------------------------
1     CALL REDLE
*
*     Si l'article lu n'est pas un mot, on oublie et on passe au suivant
      IF (IRE.NE.3) GOTO 1
*
*     Recherche dichotomique dans la liste des mots
      CALL DICCHN (1,NBCHEN,NCCHEN,TBCHEN,TEXTE(1:NCAR),NU,NB)
*
*     Si le mot trouve est dans la liste, on reprend la lecture officielle
      IF (NB.GT.0) RETURN
*
*     Si l'article est un mot ne figurant pas dans la liste, on passe au suivant
      GOTO 1
      END
      
      
