*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCFORM (FORMAC,FORMAN,COMENT,NIVIMP,IMPMES)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)
* Derniere modification : D.Martin (30 Juin 1997) 
*  
* Lecture des formats de lecture des coordonnees et des numerotation
*  
*-- Arguments --  
* FORMAC Format de lecture des coordonnees 
* FORMAN Format de lecture des numeros globaux des points  
* COMENT Lecture des coordonnees et numeros globauxavec ou sans commentaire
*        (cf. RdELEM, RdCOOR, RdNUGL)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FORMAC,FORMAN
      LOGICAL       COMENT
      INTEGER       NIVIMP,IMPMES
*  
      CHARACTER        TEXT*4,TEXTE*80
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   /REDCOM/TEXT(20)
      EQUIVALENCE     (TEXTE,TEXT(1))  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcForm*')
*  
1     CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (TEXT(1).EQ.'SANS') THEN
         CALL REDLE
         IF (TEXT(1).NE.'COMM') CALL REDERR (14,'COMMENTAIRE')
         COMENT=.FALSE.
         GOTO 1
      ELSEIF (TEXT(1).EQ.'NUME') THEN
2        IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &      WRITE(IMPMES,10001) '*LcForm*',TEXTE(1:NCAR) 
3        CALL REDLE
         IF (TEXT(1).EQ.'GLOB') GOTO 3 
         IF (IRE.NE.4) CALL REDERR (14,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &      WRITE(IMPMES,10002) '*LcForm*',NCAR,TEXTE(1:NCAR)
         IF (NCAR.GT.50) CALL ERREUR (2,1,NCAR,' ','FORMAT')
         FORMAN(2:NCAR+1)=TEXTE(1:NCAR)
         FORMAN(1:1)='('
         FORMAN(NCAR+2:)=')'
         GOTO 1
      ELSEIF (TEXT(1).EQ.'COOR') THEN 
         IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &      WRITE(IMPMES,10001) '*LcForm*',TEXTE(1:NCAR) 
         CALL REDLE
         IF (IRE.NE.4) CALL REDERR (14,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &      WRITE(IMPMES,10002) '*LcForm*',NCAR,TEXTE(1:NCAR)
         IF (NCAR.GT.50) CALL ERREUR (2,1,NCAR,' ','FORMAT')
         FORMAC(2:NCAR+1)=TEXTE(1:NCAR)
         FORMAC(1:1)='('
         FORMAC(NCAR+2:)=')'
         GOTO 1
      ENDIF
      CALL PRFXMJ (-1,'*LcForm*')
*-----------------------------------------------------------------------  
10001 FORMAT(T6,A8,T56,' , suivi du mot : ',A) 
10002 FORMAT(T6,A8,T56,' , suivi de la chaine(*',I2,') : ',A)  
                                                                    END !LcForm
