*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCNOMD (NCHDOM,NOMDOM,LGMDOM,NBDOMG
     &                  ,COMBAK,NUDOMG,NBCARG,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)  
* Derniere modification : D.Martin (1er Juillet 2000)
* Version 1.0.1
*  
* Lecture d'un (nouveau) nom de domaine geometrique
*  
*-- Arguments --  
* NCHDOM nombre de caracteres par nom de domaine (variable)
* NOMDOM tableau des noms de domaine = structure (#OMDOM,1)
* LGMDON longueur du tableau des noms de domaine  
* NBDOMG nombre de domaines geometriques deja definis
* COMBAK caractere indiquant la necessite d'agrandir le tableau (#OMDOM,1)
* NUDOMG numero du domaine geometrique si le domaine existe deja
*        0 sinon
* NBCARG nombre de caracteres dans le nom de domaine lu
* NIVIMP niveau d'impression lors de la lecture du maillage
* IMPMES unite logique d'impression des messages  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    NOMDOM(*),COMBAK
      INTEGER          NCHDOM,LGMDOM,NBDOMG,NUDOMG,NBCARG,NIVIMP,IMPMES
*  
      CHARACTER        TEXTE*80
      INTEGER          KELCHN
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,LGMDOW
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*-----------------------------------------------------------------------
      IF (COMBAK.EQ.' ') THEN
*  
         CALL PRFXMJ (1,'*LcNomd*')
*        Lecture du nom de domaine (donne par l'utilisateur)
         CALL REDLE
         IF (IRE.NE.4) CALL REDERR (14,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &      WRITE(IMPMES,10005) '*LcNomd*',NCAR,TEXTE(1:NCAR)
         NBCARG=NCAR
*
         NUDOMG=0
         IF (NBDOMG.NE.0)
     &      NUDOMG=KELCHN (TEXTE(1:NCAR),NOMDOM,NBDOMG,NCHDOM)          !utilite
*
         IF (NUDOMG.EQ.0) THEN
*           Le nom de domaine n'existe pas dans (#OMDOM,1) :
*           verification de la longueur de (#OMDOM,1)
            LGMDOW=(NBDOMG+1)*MAX (NCHDOM,NCAR)
            IF (LGMDOW.GT.LGMDOM) THEN
               LGMDOM=LGMDOW
               COMBAK='#'
               RETURN
            ENDIF
         ENDIF
      ENDIF
*  
      COMBAK=' '
*
*     Introduction du nouveau nom de domaine dans (#OMDOM,1)
*
      IF (NUDOMG.EQ.0) CALL RIPCHN (NOMDOM,NBDOMG,NCHDOM,TEXTE(1:NCAR)) !utilite
      CALL PRFXMJ (-1,'*LcNomd*')
*-----------------------------------------------------------------------
10005 FORMAT(T6,A8,T56,' , suivi de la chaine(*',I2,') : ',A)
                                                                    END !LcNomd
