*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDNUGL (ULMAIL,FORMAN,NBPTS,L,NUGPTL,NBTPTG,COMENT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1987)  
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Lecture de la numerotation globale par element 
*  
*-- Arguments d'entree -- 
* ULMAIL unite de lecture du maillage
* FORMAN format variable de lecture de la numerotation globale
* NBPTS  nombre de numeros a lire dans l'element 
* COMENT lecture ou non du commentaire precedant les numeros globaux  
*-- Argument de sortie -- 
* NUGPTL tableau des numeros globaux des points de l'element 
* NBTPTG max. des numeros globaux rencontres (en fait le nb. tot. de points) 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FORMAN  
      INTEGER       ULMAIL,NBPTS,L,NUGPTL(*),NBTPTG
      LOGICAL       COMENT
*
      INTEGER       I
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdNugl*')
*  
*     Lecture eventuelle d'une ligne commentaire
      IF (COMENT) READ (ULMAIL,*)
*
      IF (FORMAN(1:3).EQ.'(*)'.OR.FORMAN(1:1).EQ.'*') THEN  
         READ (ULMAIL,*,ERR=10,END=11) (NUGPTL(I),I=1,NBPTS)
      ELSE 
         READ(UNIT=ULMAIL,FMT=FORMAN,ERR=10,END=11)(NUGPTL(I),I=1,NBPTS)
      ENDIF
*
*     Calcul du plus haut numero global rencontre  
      DO 7 I=1,NBPTS
7        NBTPTG=MAX (NBTPTG,NUGPTL(I))  
      CALL PRFXMJ (-1,'*RdNugl*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10    CALL ENCLER (L,FORMAN(1:5))
      CALL ENCLER (ULMAIL,FORMAN(6:10))
      CALL ENCLER (NBPTS,FORMAN(11:12))
      CALL BAISE  (' Erreur de lecture des numeros globaux de'
     &//' l''element '//FORMAN(1:5)//'('//FORMAN(11:12)
     &//' points) sur l''unite '//FORMAN(6:10))
11    CALL ENCLER (L,FORMAN(1:5))
      CALL ENCLER (ULMAIL,FORMAN(6:10))
      CALL BAISE (' Fin de fichier atteinte dans la lecture des numeros'
     &//' globaux de l''element '//FORMAN(1:5)//' sur l''unite ' 
     &//FORMAN(6:10))
                                                                    END !RdNugl
