*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTPRO (NDIM,POINT,NBFPRO,NOMFCT,TYPFCT
     &                  ,NOMTAB,TYPTAB,MCATAB,IST,RST,CST
     &                  ,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 2002)
* Derniere modification : D.Martin (12 Novembre 2002)
*
* Calcul des fonctions propres de la methode des elements finis localises
* avec integration numerique en un point de coordonnees donne.
*  
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeurs:
*        POINT(i)= ieme coordonnee du point (i=1,..,NDIM)
* NBFPRO nombre de fonctions propres du developpement
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NOMTAB nom de la donnee 'Tableau' associee a la donnee 'Fonction'
* TYPTAB type de declaration de la donnee 'Tableau' associee a la 'Fonction' 
*        ('REEL','COMPLEXE',...)
* MCATAB adresse absolue de la donnee 'Tableau' associee a la donnee 'Fonction'
*        dans le super-tableau du bon type (donne par TYPTAB)
* IST    super-tableau version entiere (inutilise ici ?)
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NOMTAB,TYPTAB
      INTEGER       NDIM,MCATAB,IST(*)
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      INTEGER       LG
      CHARACTER*120 ONSEPA
      COMMON/ONSEPA/ONSEPA
*-----------------------------------------------------------------------
      LG=INDEX (NOMFCT,' ')-1
      IF (LG.LE.0) LG=LEN (NOMFCT)
      ONSEPA=NOMFCT
      ONSEPA(LG+1:)=TYPFCT
      CALL BAISE  (' <Modeles/fctpro> Vous avez oublie de fournir la'
     &//' procedure ''utilisateur'' :   ''FCTPRO'', appelee pour'
     &//' la donnee ''fonction'' '//ONSEPA(1:LG)
     &//' de type '//ONSEPA(LG+1:LG+12))
                                                                    END !FctPro
