*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ME2LNO (NDIM  ,NBSOMT,NBNE,NUMERO,DEJAVU,NGNEME
     &                  ,COORME,NBTPTG,NGNEMO,COORMO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*   
* Assure la traduction pour les noeuds d'un element
*        des tableaux de type  MELINA : NGNEME et COORME
*     en les tableaux de type  MODULEF: NGNEMO et COORMO 
*
*-- Arguments --
* NDIM   dimension d'espace
* NBSOMT nombre de sommets de l'element
* NBNE   nombre de noeuds de l'element
* NUMERO tableau de correspondance des numerotations locales
* DEJAVU tableau de travail pour reperer les noeuds 'deja vus'
* NGNEME tableau des numeros globaux des points de l'element Melina
* COORME tableau des coordonnees des points de l'element Melina
* NGNEMO tableau des numeros globaux des points de Modulef
* COORMO tableau des coordonnees des points de Modulef
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NBSOMT,NBNE,NUMERO(*),DEJAVU(*),NGNEME(*),NBTPTG
     &       ,NGNEMO(*)
      REAL    COORMO(NDIM,*),COORME(NDIM,*)
*
      INTEGER IDLME,IDLMO,NUGLO,IDEJA,IDIM
*-----------------------------------------------------------------------
      DO 1 IDLME=1,NBSOMT
         IDLMO        =NUMERO(IDLME)
         NGNEMO(IDLMO)=NGNEME(IDLME)
1     CONTINUE
*
      DO 3 IDLME=1,NBNE
         NUGLO =NGNEME(IDLME) 
         IDEJA =DEJAVU(NUGLO)   
         IF (IDEJA.EQ.0) THEN
            NBTPTG=NBTPTG+1 
            DO 2 IDIM=1,NDIM
              COORMO(IDIM,NUGLO)=COORME(IDIM,IDLME)
2           CONTINUE
            DEJAVU(NUGLO)=IDEJA+1  
         ENDIF 
3     CONTINUE
                                                                    END !Me2lNo
