*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MELI2B (M,RM,LM,NUFIN,NUFOUT) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (1993)  
* Derniere modification : D.Martin (2 juin 1994)
* Version 1.0.0
*   
* Creer une structure de donnees B de Modulef a partir d'un fichier
* de resultats Melina
*   
*-- Entrees -- 
* M      super-tableau entier de l'allocation dynamique Modulef
* RM     super-tableau reel de l'allocation dynamique Modulef
* NUFIN  numero d'unite logique du fichier de resultats Melina
* NUFOUT numero d'unite logique du fichier  de la SD B
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER      M(*),LM,NUFIN,NUFOUT
      REAL         RM(*)
*   
*     Initialisation de l'allocation dynamique de Modulef
      CALL INITIS (M,LM,0,0)
*
*     Lecture du fichier contenant le terme 'Melina'
*
      READ (NUFIN,*)
      READ (NUFIN,*) NBDLNE,NBTODL,ITYPTR 
      ICMPLX=ITYPTR/2  
      CALL READRE (2,'RESU',MCRESU,ICMPLX*NBDLNE*NBTODL,M,NRRESU)
      READ (NUFIN,*) (RM(J),J=MCRESU,MCRESU-1+ICMPLX*NBDLNE*NBTODL)
*
*     Creation de la structure B
*
      IF (ICMPLX.EQ.1) THEN
         CALL TROUVE (ITYPMO,'RESU',MCRESU,LGRESU,NUMC,M)
         MCREEL=MCRESU
         MCIMAG=1
      ELSE
         CALL READRE (2,'REEL',MCREEL,NBDLNE*NBTODL,M,NRREEL)
         CALL READRE (2,'IMAG',MCIMAG,NBDLNE*NBTODL,M,NRIMAG)
         CALL TROUVE (ITYPMO,'RESU',MCRESU,LGRESU,NUMC,M)
         WRITE(*,*)
     &  'Donnees complexes - voulez-vous une representation: '
         WRITE(*,*) '  1 - partie reel, partie imaginaire ?'
         WRITE(*,*) '  2 - module,phase ?'
         READ*,IMODE
         CALL READRE (2,'REEL',MCREEL,NBDLNE*NBTODL,M,NRREEL)
         CALL READRE (2,'IMAG',MCIMAG,NBDLNE*NBTODL,M,NRIMAG)
         CALL TROUVE (ITYPMO,'RESU',MCRESU,LGRESU,NUMC,M)
         IF (IMODE.EQ.1) THEN
            IAREEL=MCREEL
            IAIMAG=MCIMAG
            DO 60 IARESU=MCRESU,MCRESU-1+NBDLNE*NBTODL,ICMPLX
               RM(IAREEL)=RM(IARESU)
               RM(IAIMAG)=RM(IARESU+1)  
               IAREEL=IAREEL+1
               IAIMAG=IAIMAG+1
60             CONTINUE
         ELSE
            IAREEL=MCREEL
            IAIMAG=MCIMAG
            DO 70 IARESU=MCRESU,MCRESU-1+NBDLNE*NBTODL,ICMPLX
               PHIR=RM(IARESU)
               PHII=RM(IARESU+1)
               RM(IAREEL)=SQRT(PHIR*PHIR+PHII*PHII)
               RM(IAIMAG)=ATAN2(PHII,PHIR)
               IAREEL=IAREEL+1
               IAIMAG=IAIMAG+1
70             CONTINUE
         ENDIF
      ENDIF 
      NTABAS=0  
*
      CALL COSDB  (M,ICMPLX,RM(MCREEL),RM(MCIMAG),NBTODL,NBDLNE 
     &           ,NUFOUT,1,NTABAS)
*
      CLOSE(NUFOUT,STATUS='KEEP')
                                                                    END !Meli2B
