*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDFICH (NUMFIC,CHAINE,STAT,FORMA,FICIN)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1990)
* Derniere modification : D.Martin (28 Aout 2000)
* Version 1.0.4
*
* Lecture des noms et ouverture de fichiers
*
*-- Arguments d'entree --
* NUMFIC numero d'unite logique du fichier a ouvrir
* CHAINE message pour impression (definissant le fichier)
* STAT   'OLD' ou 'NEW'
* FORMA  'FORMATTED' ou UNFORMATTED'
*-- Argument de sortie --
* FICIN  nom du fichier a ouvrir
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NUMFIC
      CHARACTER*(*) CHAINE,STAT,FORMA,FICIN
*
      INTEGER       LENFIC
      CHARACTER     NWSTAT*3,AXES*9,FORMAW*11,REPONS
      LOGICAL       JEXIST
*-----------------------------------------------------------------------
      NWSTAT=STAT
1     WRITE (*,10000) '> Nom du fichier contenant',CHAINE
     &               ,'? (''Return'' pour finir)'
      READ (*,'(A)') FICIN
      IF (FICIN(1:1).EQ.' ')
     &STOP 'Arret demande (le nom du fichier commence par un blanc).'
*
      DO 10 LENFIC=LEN(FICIN),1,-1
         IF (FICIN(LENFIC:LENFIC).NE.' ') GOTO 11
10    CONTINUE
*
*     Test de l'existence du fichier
*
11    IF (STAT(1:3).EQ.'NEW') THEN
         INQUIRE (FILE=FICIN(1:LENFIC),EXIST=JEXIST)
         IF (JEXIST) THEN
           WRITE (*,*) '*RdFich* Le fichier ',FICIN(1:LENFIC),' existe.'
           WRITE (*,*) '*RdFich* Voulez-vous l''ecraser ? (N/o/y)'
           READ (*,'(A)') REPONS
           IF (.NOT.(REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &           .OR.REPONS(1:1).EQ.'Y'.OR.REPONS(1:1).EQ.'y')) GOTO 1
           NWSTAT='OLD'
         ENDIF
      ENDIF
*
*     Ouverture du fichier
*
      OPEN (UNIT=NUMFIC,FILE=FICIN(1:LENFIC),ACCESS='SEQUENTIAL'
     &     ,STATUS=NWSTAT,FORM=FORMA,ERR=2)
      RETURN
*
*     En cas d'erreur a l'ouverture
*
2     INQUIRE (FILE=FICIN(1:LENFIC),EXIST=JEXIST,ACCESS=AXES
     &        ,FORM=FORMAW)
      IF (.NOT.JEXIST) THEN
         WRITE(*,10000) '*RdFich* Fichier',FICIN(1:LENFIC)
     &                 ,'non retrouve.'
         GOTO 1
      ELSE
         WRITE (*,*) '  Access = ',AXES,'  Form = ',FORMAW
         WRITE (*,*) ' Probleme a l''ouverture du fichier '
     &              ,FICIN(1:LENFIC)
         WRITE (*,*) ' --------------------------------- '
      ENDIF
      GOTO 1
*-----------------------------------------------------------------------
10000 FORMAT (A,' ',A,:,' ',A)
                                                                    END !RdFich
