*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDNMVE (NTACOO,NDIM,VARIAB,NBCNVE,LGNMVE,IMPPAL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (3 Juillet 2000)
* Version 1.0.1
*
* Remplissage du tableau des noms de variables
*
* NTACOO type des variables d'espace selon Modulef
* NDIM   dimension d'espace
* VARIAB tableau des noms de variables d'espace
* NBCNVE nombre de caracteres par nom de variable d'espace
* LGNMVE longueur du tableau des noms de variables d'espace
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NTACOO,NDIM,NBCNVE,LGNMVE,IMPPAL
      CHARACTER     VARIAB(*)
*
      INTEGER       NBVARE,NBCARE
      CHARACTER*80  REPONS
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdNmve*')
      NBVARE=0
      NBCNVE=0
      IF (NTACOO.LE.1) THEN
         CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'X')                         !utilite
         IF (NDIM.GE.2) CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'Y')          !utilite
         IF (NDIM.GE.3) CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'Z')          !utilite
      ELSEIF (NTACOO.LE.3) THEN
         CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'RHO')
         IF (NDIM.GE.2) CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'THETA')      !utilite
         IF (NDIM.GE.3) THEN 
            IF (NTACOO.LE.2) CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'Z')     !utilite
            IF (NTACOO.EQ.3) CALL RIPCHN (VARIAB,NBVARE,NBCNVE,'PHI')   !utilite
         ENDIF
      ENDIF
      CALL PRNOMS ('#ARIAB',1,NBCNVE,NBVARE,IMPPAL)                     !prsd
      WRITE(*,*) '> Modifier les noms des variables d''espace ? (N/y/o)'
      READ (*,'(A)') REPONS
      IF (REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &.OR.REPONS(1:1).EQ.'y') REPONS='Y'
      IF (REPONS(1:1).EQ.'Y') THEN
         NBCNVE=0
         NBVARE=0
         WRITE (*,*) '> Nom de la premiere variable ?'
         READ (*,'(A)') REPONS
         DO 11 NBCARE=80,1,-1
            IF (REPONS(NBCARE:NBCARE).NE.' ') GOTO 12
11       CONTINUE
12       CALL RIPCHN (VARIAB,NBVARE,NBCNVE,REPONS(1:NBCARE))            !utilite
         IF (NDIM.GT.1) THEN
            WRITE(*,*) '> Nom de la deuxieme variable ?'
            READ (*,'(A)') REPONS
            DO 21 NBCARE=80,1,-1
               IF (REPONS(NBCARE:NBCARE).NE.' ') GOTO 22
21          CONTINUE
22          CALL RIPCHN (VARIAB,NBVARE,NBCNVE,REPONS(1:NBCARE))         !utilite
            IF (NDIM.GT.2) THEN
               WRITE(*,*) '> Nom de la troisieme variable ?'
               READ (*,'(A)') REPONS
               DO 31 NBCARE=80,1,-1
                  IF (REPONS(NBCARE:NBCARE).NE.' ') GOTO 32
31             CONTINUE
32             CALL RIPCHN (VARIAB,NBVARE,NBCNVE,REPONS(1:NBCARE))      !utilite
            ENDIF
         ENDIF
      ENDIF
      IF (NDIM*NBCNVE.GT.LGNMVE) THEN
         CALL ENCLER (LGNMVE,REPONS(:3))                                !utilite
         CALL ENCLER (NDIM*NBCNVE,REPONS(4:7))                          !utilite
         CALL BAISE  (' Longueur sous-estimee ('//REPONS(:3)//
     &                ' pour le tableau #ARIAB. Prevoir au moins '
     &                //REPONS(4:7)//' caracteres')                     !utilite
      ENDIF
      CALL PRFXMJ (-1,'*RdNmve*')
                                                                    END !RdNmve
