*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M D 2 P L(TYPMAT,NBNELI,NBNECO,MCTBML,MCTPLE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 92)  
* Derniere modification (O.DeBayser) le 15 Mai 1992
*  
*     Transformation d'une matrice stockee compactee bimorse  en une  
*     matrice pleine (i.e. dans son stockage 'naturel' : decompactage) 
*            BMD2PL -> BiMorse 'to' Diagonale PLein
*  
*** Arguments ***  
* TYPMAT: Type de declaration de la matrice
* NBNELI: Nombre de noeuds 'en ligne' de la matrice
* NBNECO: Nombre de noeuds 'en colonne' de la matrice 
* MCTBML: Adresse dde L(inf) de la matrice stockee sous forme 'BiMorse'  
* MCTPLE: Adresse de la matrice decompactee
* RST,CST Super-tableaux habituels
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPMAT
      REAL RST(*)
      COMPLEX CST(*)
* 
      MCP=MCTPLE
*
      IF(TYPMAT(1:1).EQ.'C') THEN
*        Parcours des noeuds 'en ligne' de la matrice 
         DO 11 MCB=MCTBML,MCTBML-1+NBNELI  
            CST(MCP)=CST(MCB)
11          MCP=MCP+NBNECO+1
      ELSE
         DO 21 MCB=MCTBML,MCTBML-1+NBNELI  
            RST(MCP)=RST(MCB)
21          MCP=MCP+NBNECO+1
      ENDIF
                                                                    END *BmD2Pl*
