*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BMU2PL (TYPMAT,NBNELI,NBNECO,NULAPU,IPLAGU,MCTBMU
     &                  ,MCTPLE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 92)  
* Derniere modification (D.Martin) le 8 Decembre 1994
*  
* Transformation d'une matrice stockee compactee bimorse  en une  
* matrice pleine (i.e. dans son stockage 'naturel' : decompactage) 
*       BMU2PL -> BiMorse U(triangle superieur) 'to'  PLein
*  
*-- Arguments --  
* TYPMAT: Type de declaration de la matrice
* NBNELI: Nombre de noeuds 'en ligne' de la matrice
* NBNECO: Nombre de noeuds 'en colonne' de la matrice 
* NULAPU: tableau des numeros de derniere des lignes
* IPLAGU: tableau des numeros de debut de plage et des longueurs cumulees  
* MCTBMU: Adresse dde L(inf) de la matrice stockee sous forme 'BiMorse'  
* MCTPLE: Adresse de la matrice decompactee
* RST,CST Super-tableaux habituels
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPMAT
      INTEGER       NULAPU(*),IPLAGU(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*-----------------------------------------------------------------------
      NUDRPU=0 
      LIOUC1=1
      LGCUMU=0
      MCBB=MCTBMU
      MCPP=MCTPLE+1
*
      IF(TYPMAT(1:1).EQ.'C') THEN
         DO 11 LIOUCO=2,NBNECO  
            NUPRPU=NUDRPU+1
            NUDRPU=NULAPU(LIOUC1)
            DO 10 NUPLA=NUPRPU,NUDRPU
               LIGDEB=IPLAGU(1,NUPLA)
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGU(2,NUPLA)
               LIGFIN=LIGDEB+LGCUMU-LGCUAV
               MCP   =MCPP+(LIGDEB-1)*NBNECO
               DO 10 LIGNE=LIGDEB,LIGFIN
                  CST(MCP)=CST(MCBB)
                  MCBB=MCBB+1
10                MCP=MCP+NBNECO
            MCPP=MCPP+1
11          LIOUC1=LIOUCO
      ELSE
         DO 21 LIOUCO=2,NBNECO  
            NUPRPU=NUDRPU+1
            NUDRPU=NULAPU(LIOUC1)
            DO 20 NUPLA=NUPRPU,NUDRPU
               LIGDEB=IPLAGU(1,NUPLA)
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGU(2,NUPLA)
               LIGFIN=LIGDEB+LGCUMU-LGCUAV
               MCP   =MCPP+(LIGDEB-1)*NBNECO
               DO 20 LIGNE=LIGDEB,LIGFIN
                  RST(MCP)=RST(MCBB)
                  MCBB=MCBB+1
20                MCP=MCP+NBNECO
            MCPP=MCPP+1
21          LIOUC1=LIOUCO
      ENDIF
                                                                    END !BmU2Pl
