*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE C M 2 L B M (NBLIGN,NBCOLO,NULAPM,IPLAGM
     *                                                   ,NULAPL,IPLAGL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)
* Derniere modification (D.Martin) le 5 Dec. 91
*
*  Passage du compactage Morse ligne standard au compactage Bi-Morse inferieur
*  Les pointeurs de la struct. Bi-Morse inferieure sont ceux d'une struct. 
*  Morse standard pour les coeff. de la partie triangulaire inferieure stricte
*  a compter de la ligne 2. 
*          (CM2LBM --> Compactage Morse 'to' Lower BiMorse)
*
*** Arguments d'entree ***
* NBLIGN nombre de lignes
* NBCOLO nombre de lignes
* NULAPM numeros des dernieres plages de chaque ligne de la struct. Morse
* IPLAGM numeros colonnes de debut de plage et adresses des derniers coeff.
*        de chaque plage de la struct. Morse
*** Arguments d'entree ***
* NULAPL numeros des dernieres plages de chaque ligne de la struct. Bi-Morse
* IPLAGL numeros de colonnes de debut de plage et adresses des derniers coeff.
*        de chaque plage de la structure biMorse inferieure
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPM(*),IPLAGM(2,*),NULAPL(*),IPLAGL(2,*)
*
*     On ne commence qu'a la seconde ligne de la matrice initiale
*
      NUDRPM=NULAPM(1)
      LGCUAM=IPLAGM(2,NUDRPM)
*
      NUMPLL=0
      LGCUML=0
      LIGNM1=1
      DO 20 LIGNE=2,NBLIGN
         NUPRPM=NUDRPM+1
         NUDRPM=NULAPM(LIGNE)
         DO 10 NUMPLM=NUPRPM,NUDRPM
            KOLDEB=IPLAGM(1,NUMPLM)
*
*           Passage de la diagonale de A et a la ligne suivante
            IF(KOLDEB.GE.LIGNE) GO TO 15
*
            LGCUMA=IPLAGM(2,NUMPLM)
            LGPLAG=LGCUMA-LGCUAM
            KOLFIN=KOLDEB+LGPLAG-1
            LGCUAM=LGCUMA
            NUMPLL=NUMPLL+1
            IPLAGL(1,NUMPLL)=KOLDEB
            IF(KOLFIN.LT.MIN(LIGNE,NBCOLO+1)) THEN
*
*              La plage est entierement sous-diagonale : on la conserve
               LGCUML=LGCUML+LGPLAG
               IPLAGL(2,NUMPLL)=LGCUML
            ELSE
*
*              La plage contient le coefficient diagonal : on n'en 
*              conserve que la zone strictement sous-diagonale
               LGCUML=LGCUML+LIGNE-KOLDEB
               IPLAGL(2,NUMPLL)=LGCUML
               GO TO 15
            END IF
10          CONTINUE
*        Dans le cas d'une ligne vide, son numero de derniere plage
*        est le meme que celui de la precedente ou 0 pour la ligne 2
15       NULAPL(LIGNM1)=NUMPLL
         LIGNM1=LIGNE
         LGCUAM=IPLAGM(2,NUDRPM)
20       CONTINUE
                                                                    END *Cm2LBm*
