*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE D2NL (NBLIGN,ADPRCL,NUMCOL,ADSUCL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification (D.Martin) le 17 Mars 1995  
*  
* Calcul des pointeurs des coefficients diagonaux d'une matrice BiMorse dans 
* une structure NUME-L non-ordonnee.
*
*-- Arguments d'entree --
* NBLIGN nombre de lignes
*-- Arguments modifies en sortie
* ADPRCL adresses des 1ers coeff. de chaque ligne (longueur NBLIGN+1)
* NUMCOL numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBLIGN,ADPRCL(*),NUMCOL(*),ADSUCL(*)
*
      INTEGER       LIGNE,LASTAD,NXTADR,ADPRLI
*-----------------------------------------------------------------------
      LASTAD=ADPRCL(NBLIGN+1)
      DO 4 LIGNE=1,NBLIGN
         ADPRLI=ADPRCL(LIGNE)
*
         IF (ADPRLI.LE.0) THEN
*           Cas d'une ligne vide
            ADPRCL(LIGNE)=LASTAD
         ELSE
1           NXTADR=ADPRLI
*           Cas d'une ligne non vide
            ADPRLI=ADSUCL(NXTADR)
            IF (ADPRLI.GT.0) GOTO 1
            ADSUCL(NXTADR)= LASTAD
         ENDIF
*
         NUMCOL(LASTAD)= LIGNE
         ADSUCL(LASTAD)= 0
         LASTAD        = LASTAD+1
         ADPRL1=ADPRLI
4     CONTINUE
      ADPRCL(NBLIGN+1)=LASTAD
                                                                    END !D2Nl
