*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NLNO2O (NBLIGN,NBCOLO,TYPE,ADPRCL,NUMCOL,ADSUCL
     &                  ,MCDORO,NUMCOO,MCORDO,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification (D.Martin) le 13 Janvier 1995  
*  
* Transformation d'une matrice stockee selon une structure NUME-L non-ordonnee
* en la matrice stockee selon une structure NUME-L ordonnee
*
*-- Arguments d'entree --
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
* TYPE   type (REEL ou COMPLEXE) de la matrice
* ADPRCL adresses des 1ers coeff. de chaque ligne (longueur NBLIGN+1)
* NUMCOL numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
* MCDORO adresse de matrice NUME-L non ordonnee
* NUMCOO numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
* MCORDO adresse de la matrice transformee en structure NUME-L ordonnee
* RST,CST super-tableau versions reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLIGN,NBCOLO,ADPRCL(*),NUMCOL(*),ADSUCL(*)
     &             ,MCDORO,NUMCOO(*),MCORDO
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LIGNE,KOLONE,ADNUML,ADLMUN,MCNUML
*-----------------------------------------------------------------------
      ADNUML=1
      MCNUML=MCORDO
      IF (TYPE(1:1).EQ.'R') THEN
         DO 21 LIGNE=1,NBLIGN
            ADLMUN=ADPRCL(LIGNE)
            ADPRCL(LIGNE)=ADNUML
11          IF (ADLMUN.GT.0) THEN
               KOLONE=NUMCOL(ADLMUN)
               RST(MCNUML)=RST(MCDORO-1+ADLMUN)
               ADLMUN=ADSUCL(ADLMUN)
               NUMCOO(ADNUML)=KOLONE
               ADNUML=ADNUML+1
               MCNUML=MCNUML+1
               GOTO 11
            ENDIF
21       CONTINUE
      ELSE
         DO 41 LIGNE=1,NBLIGN
            ADLMUN=ADPRCL(LIGNE)
            ADPRCL(LIGNE)=ADNUML
31          IF (ADLMUN.GT.0) THEN
               KOLONE=NUMCOL(ADLMUN)
               CST(MCNUML)=CST(MCDORO-1+ADLMUN)
               ADLMUN=ADSUCL(ADLMUN)
               NUMCOO(ADNUML)=KOLONE
               ADNUML=ADNUML+1
               MCNUML=MCNUML+1
               GOTO 31
            ENDIF
41       CONTINUE
      END IF
      ADPRCL(NBLIGN+1)=ADNUML
*-----------------------------------------------------------------------
                                                                    END !Nlno2O
