*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRL2NL (NBLIGN,LENV,ADPRCL,NUMCOL,ADSUCL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1995)
* Derniere modification (D.Martin) le 27 Juin 1995  
*  
* Calcul des pointeurs des coefficients sous-diagonaux d'une matrice Profil ou
* dans une structure NUME-L
*
*-- Arguments d'entree --
* NBLIGN nombre de lignes
* LENV   numeros de derniere plage de chaque ligne (longueur NBLIGN)
*-- Arguments remplis en sortie
* ADPRCL adresses des 1ers coeff. de chaque ligne (longueur NBLIGN+1)
* NUMCOL numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLIGN,LENV(*),ADPRCL(*),NUMCOL(*),ADSUCL(*)
*
      INTEGER KOLDEB,LIGNE,KOLONE,IAD,IADNXT
     &       ,LASTAD,LASTKP,LINU
*-----------------------------------------------------------------------
      LASTAD=ADPRCL(NBLIGN+1)
      LINU  =1
      IAD=LENV(1)
      DO 3 LIGNE=2,NBLIGN
         IADNXT=LENV(LIGNE)
         ADPRCL(LIGNE) =LASTAD
         LASTKP=LASTAD
         KOLDEB=LIGNE-IADNXT+IAD
         DO 1 KOLONE=KOLDEB,NBLIGN-1
            NUMCOL(LASTAD)=KOLONE
            ADSUCL(LASTAD)=LASTAD+1
            LASTKP        =LASTAD
            LASTAD        =LASTAD+1
1        CONTINUE
         ADSUCL(LASTKP)=0
3     CONTINUE
      ADPRCL(NBLIGN+1)=LASTAD
                                                                    END !Prl2Nl
