*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE P R A L V C (NBLINE,NBCOLO,LENV,TYMATR,MCL
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov 91
*  
*   Produit L*xV de l'adjointe d'une matrice L strictement triangulaire
*   inferieure stockee sous forme 'Profil' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.  
*  
*** Arguments d'entree *** 
* NBLINE: nombre de lignes de la matrice L
* LENV  : tableau des pointeurs du profil inferieur de L
* TYMATR: Type (reel ou complexe) de la matrice
* MCL   : adresse dans le super-tab. de type   "   de la partie sous-diagonale 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       LENV(*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF
*
      IF(TYMATR(1:1).EQ.'R') THEN
*
         CALL PRUVC (NBCOLO,NBLINE,LENV,TYMATR,MCL
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
      ELSE
*
         IF(TYRESU(1:1).EQ.'R') GO TO 90001
         MC=MCL
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=2,NBLINE 
               CCOEFF=CST(MCVECT-1+LIGNE)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCR1=MCRESU+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 443 MCRR=MCR1,MCR1+NBCOF-1
                     CST(MCRR)=CST(MCRR)+CONJG(CST(MC))*CCOEFF
443                  MC=MC+1                
               END IF
444            CONTINUE
         ELSE
            DO 424 LIGNE=2,NBLINE 
               RCOEFF=RST(MCVECT-1+LIGNE)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCR1=MCRESU+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 423 MCRR=MCR1,MCR1+NBCOF-1
                     CST(MCRR)=CST(MCRR)+CONJG(CST(MC))*RCOEFF
423                  MC=MC+1                
               END IF
424            CONTINUE  
         END IF
      END IF
      RETURN
90001 CALL BAISE('*PraLVc* Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *PraLVc*
