*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRDCST (TYPCST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1990)
* Derniere modification : D.Martin (30 Aout 1998)
* Version 1.0.1
*  
* Impression d'un ou des tableaux des constantes
*  
*-- Argument d'entree --  
* TYPCST type du tableau de constantes a imprimer (tous si TYPCST(1:1)=' ')
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPCST
      INTEGER       IMPFCH
*  
      INCLUDE 'ALLOC'
*
      INTEGER       NBCSTE,MCL,MC,IAD,NBCHAR,I,J
      CHARACTER ERCODE*120,PRFXAF*8
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      IF (TYPCST(1:2).EQ.'CA'.OR.TYPCST(1:1).EQ.' ') THEN
         CALL TBAR1  (ERCODE,'$LGCSA',1,MCL)
         NBCSTE=IST(MCL)
         IF (NBCSTE.GT.0) THEN
            WRITE (IMPFCH,10000) PRFXAF ( ),'Caracteres'
            CALL TBAR1  (ERCODE,'$ACSTE',1,MC)
            IAD=MC
            DO 1 I=1,NBCSTE
               NBCHAR=IST(MCL+I)
               WRITE (IMPFCH,10010) I,(AST(J),J=IAD,IAD+NBCHAR-1)
               IAD=IAD+NBCHAR
1           CONTINUE
         ENDIF
      ENDIF
      IF (TYPCST(1:1).EQ.'E'.OR.TYPCST(1:1).EQ.' ') THEN 
         CALL TBAR1  (ERCODE,'$ECSTE',1,MC)
         IF (IST(MC).GT.0) THEN
            WRITE (IMPFCH,10000) PRFXAF ( ),'Entieres'
            WRITE (IMPFCH,10001) (I,IST(MC+I),I=1,IST(MC))  
         ENDIF
      ENDIF
      IF (TYPCST(1:1).EQ.'R'.OR.TYPCST(1:1).EQ.' ') THEN
         CALL TBAR1  (ERCODE,'$RCSTE',1,MC)
         IF (IST(MC).GT.0) THEN
            WRITE (IMPFCH,10000) PRFXAF ( ),'Reelles'
            WRITE (IMPFCH,10002) (I,RST(MC+I),I=1,IST(MC)) 
         ENDIF
      ENDIF
      IF (TYPCST(:1).EQ.'D'.OR.TYPCST(1:1).EQ.' ') THEN
         CALL TBAR1  (ERCODE,'$DCSTE',1,MC)
         IF (IST(2*MC-1).GT.0) THEN
            WRITE (IMPFCH,10000) PRFXAF ( ),'Double Precision'
            WRITE (IMPFCH,10003) (I,DST(MC+I),I=1,IST(2*MC-1)) 
         ENDIF
      ENDIF
      IF (TYPCST(1:2).EQ.'CO'.OR.TYPCST(1:1).EQ.' ') THEN
         CALL TBAR1  (ERCODE,'$CCSTE',1,MC)
         IF (IST(2*MC-1).GT.0) THEN
            WRITE (IMPFCH,10000) PRFXAF ( ),'Complexes'
            WRITE (IMPFCH,10004) (I,CST(MC+I),I=1,IST(2*MC-1)) 
         ENDIF
      ENDIF
*-----------------------------------------------------------------------  
10000 FORMAT(T2,A8,'>*PrdCst*  Valeur des constantes ',A)
10001 FORMAT((T21,I3,'|',I12))
10002 FORMAT((T21,I3,'|',E15.7))
10003 FORMAT((T21,I3,'|',D15.7))
10004 FORMAT((T21,SS,I3,'|',SS,E15.7,SP,E14.7,'*i'))
10010 FORMAT(T21,I3,'|',50A1)
                                                                    END !Prdcst

