*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLINL (LIOUCO,L1,L2,IADFIN,ADPRCL,NUMCOL,TYPE,MCA
     &                  ,RST,CST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification (D.Martin) le 6 Janvier 1995
*
* Impression d'un groupe de lignes/colonnes d'une matrice 'Nume-L/C'
*
*-- Arguments --
* LIOUCO 'Lig.' ou 'Col.'
* L1,L2  premiere et derniere ligne (resp. colonne) du groupe
* IADFIN adresse relative precedent la ligne/colonne L1 (=0 si L1=1)
* ADPRCL pointeurs des debut de lignes/colonnes
* NUMCOL tableau des numeros de colonnes
* TYPE   type REEL ou COMPLEXE de la matrice
* MCD    adresse de la diagonale de la matrice dans RST ou CST
* MCA    adresse de la matrice
* RST,CST,IMPFCH colifichets omnipresents
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIOUCO*4,TYPE
      INTEGER       L1,L2,IADFIN,ADPRCL(*),NUMCOL(*),MCA,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       IADDEB,I,LIGNE
*----------------------------------------------------------------------
      IF(TYPE(1:1).EQ.'R') THEN
         DO 20 LIGNE=L1,L2
            IADDEB=IADFIN+1
            IADFIN=ADPRCL(LIGNE+1)-1
            WRITE(IMPFCH,201) LIOUCO,LIGNE,IADDEB,IADFIN
            WRITE(IMPFCH,202) (NUMCOL(I),I=IADDEB,IADFIN)
            WRITE(IMPFCH,203) (RST(I),I=MCA+IADDEB-1,MCA+IADFIN-1)
20       CONTINUE
      ELSE
         DO 40 LIGNE=L1,L2
            IADDEB=IADFIN+1
            IADFIN=ADPRCL(LIGNE+1)-1
            WRITE(IMPFCH,201) LIOUCO,LIGNE,IADDEB,IADFIN
            WRITE(IMPFCH,202) (NUMCOL(I),I=IADDEB,IADFIN)
            WRITE(IMPFCH,403) (CST(I),I=MCA+IADDEB-1,MCA+IADFIN-1)
40       CONTINUE
      END IF
*-----------------------------------------------------------------------
201   FORMAT(T14,A4,I6,' (nu. de colonnes et adresses ',I6,' a ',I6,')')
202   FORMAT((T14,20(I5)))
203   FORMAT((T14,10(E10.4,' ')))
403   FORMAT(((T14,5(SS,E10.4,SP,E10.4,'*i '))))
                                                                    END *PrLiNl*
