*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLIPR (LIOUCO,L1,L2,NBCOLO,IADFIN
     &                  ,ENV,TYPE,MCD,MCL,RST,CST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991)
* Derniere modification : D.Martin (22 Mars 1999)
* Version 1.0.0
*
* Impression d'un groupe de lignes d'une matrice 'Profil' inf. ou sup.
*
*-- Arguments --
* LIOUCO indicateur de ligne ('Lig.') ou colonne ('Col.')
* L1,L2  premiere et derniere plage du groupe
* NUDRPL numero de la derniere plage precedent la ligne/colonne L1
* NBCOLO numero de colonne/ligne a ne pas depasser
* IADFIN adresse relative precedent la ligne/colonne L1 (=-1 si L1=1)
* ENV    pointeurs du profil inf./sup.
* TYPE   type REEL ou COMPLEXE de la matrice
* MCD    adresse de la diagonale de la matrice dans RST ou CST
* MCL    adresse de la partie triang. inf/sup. de la matrice
* RST,CST,IMPFCH colifichets omnipresents
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIOUCO*4,TYPE
      INTEGER       L1,L2,NBCOLO,IADFIN,ENV(*),MCD,MCL,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LIGNE,IADDEB,I,LL1
*-----------------------------------------------------------------------
      LIGNE=L1
      LL1=L1
      IF (TYPE(1:1).EQ.'R') THEN
         IF (L1.EQ.1) THEN
            LL1=L1+1
            WRITE (IMPFCH,10001) LIOUCO,LIGNE
            WRITE (IMPFCH,10020) RST(MCD)
         ENDIF
         DO 21 LIGNE=LL1,L2
            IADDEB=IADFIN+1
            IADFIN=ENV(LIGNE)-2
            IF (LIGNE.LE.NBCOLO) THEN
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1,'et diag'
               WRITE (IMPFCH,10020) (RST(I),I=MCL+IADDEB,MCL+IADFIN)
     &                              ,RST(MCD-1+LIGNE)
            ELSE
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1
               WRITE (IMPFCH,10020) (RST(I),I=MCL+IADDEB,MCL+IADFIN)
            ENDIF
21       CONTINUE
      ELSE
         IF (L1.EQ.1) THEN
            LL1=L1+1
            WRITE (IMPFCH,10001) LIOUCO,LIGNE
            WRITE (IMPFCH,10040) CST(MCD)
         ENDIF
         DO 41 LIGNE=LL1+1,L2
            IADDEB=IADFIN+1
            IADFIN=ENV(LIGNE)-2
            IF (LIGNE.LE.NBCOLO) THEN
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1,'et diag'
               WRITE (IMPFCH,10040) (CST(I),I=MCL+IADDEB,MCL+IADFIN)
     &                             ,CST(MCD-1+LIGNE)
            ELSE
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1
               WRITE (IMPFCH,10040) (CST(I),I=MCL+IADDEB,MCL+IADFIN)
            ENDIF
41       CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10001 FORMAT(T14,A4,I6,:,' '
     &,'(adresses ',I10,' a ',I10,') ',:,A)
10002 FORMAT(T14,A4,I6,:,', noeud',I6,:,' '
     &,'(adresses ',I10,' a ',I10,') ',:,A)
10020 FORMAT((T14,10(E10.4,' ')))
10040 FORMAT((T14,5(SS,E10.4,SP,E10.4,'*i ')))
                                                                    END !PrLiPr
