*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMAPR (PROFIL,ITYSYM,TYPE,MCA,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)
* Derniere modification : D.Martin (22 Mars 1999)
*
* Impression d'une matrice stockee sous forme 'Profil'
*
*-- Arguments --
* PROFIL structure definissant le 'Profil' de la matrice
* ITYSYM indicateur de matrice symetrique (=1) ou non
* TYPE   type REEL ou COMPLEXE de la matrice
* MCA    adresse de la matrice dans le super-tableau de type TYPE
* RST,CST super-tableau version REELLE et COMPLEXE
* NIVIMP niveau d'impression du terme
*        NIVIMP = I, 0 < I < 10 ==> impression de la diagonale et
*        des NIVIMP premieres et dernieres lignes et colonnes
*        NIVIMP > 9 ==> impression de la diagonale et des parties
*        sous- et sur-diagonale en totalite
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       PROFIL(*),ITYSYM,MCA,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBLIGN,IAL,LGL,NBCOLO,IAU,MCL,MCU,NBPRL1,MCAFIN
     &             ,NBPRL2
*-----------------------------------------------------------------------
      IF(IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
      NBLIGN=PROFIL(2)
      IAL   =3
      LGL   =PROFIL(NBLIGN+2)-1
      NBCOLO=PROFIL(PROFIL(1))
      IAU   =NBLIGN+4
      IF (PROFIL(1).EQ.2) IAU=IAL
*
      MCL=MCA+MIN (NBLIGN,NBCOLO)
      MCU=MCL+LGL
      WRITE (IMPFCH,10000) PRFXAF ( ),'>*PrMaPr*'
      WRITE (IMPFCH,10000) '   Profil inferieur et diagonale'
      NBPRL1=NBLIGN
      IF (NIVIMP.LE.9) NBPRL1=MIN (NIVIMP,NBPRL1)
      MCAFIN=-1
      CALL PRLIPR ('Lig.',1,NBPRL1,NBCOLO,MCAFIN,PROFIL(IAL)
     &            ,TYPE,MCA,MCL,RST,CST,IMPFCH)
      NBPRL2=MAX (NBPRL1,NBLIGN-NBPRL1)+1
      IF (NBPRL1.LT.NBLIGN.AND.NBPRL2.GT.NBPRL1+1) THEN
         WRITE (IMPFCH,10000) '   ..........'
         MCAFIN=PROFIL(IAL+NBPRL2-2)-2
         CALL PRLIPR ('Lig.',NBPRL2,NBLIGN,NBCOLO,MCAFIN,PROFIL(IAL)
     &               ,TYPE,MCA,MCL,RST,CST,IMPFCH)
      ENDIF
*
      IF (ITYSYM.EQ.0) THEN
         WRITE (IMPFCH,10000) '   Profil superieur et diagonale'
         NBPRL1=NBCOLO
         IF (NIVIMP.LE.9) NBPRL1=MIN (NIVIMP,NBPRL1)
         MCAFIN=-1
         CALL PRLIPR ('Col.',1,NBPRL1,NBLIGN,MCAFIN,PROFIL(IAU)
     &               ,TYPE,MCA,MCU,RST,CST,IMPFCH)
         NBPRL2=MAX(NBPRL1,NBCOLO-NBPRL1)+1
         IF (NBPRL1.LT.NBCOLO.AND.NBPRL2.GT.NBPRL1+1) THEN
            WRITE (IMPFCH,10000) '  ..........'
            MCAFIN=PROFIL(IAU+NBPRL2-2)-2
            CALL PRLIPR ('Col.',NBPRL2,NBCOLO,NBLIGN,MCAFIN,PROFIL(IAU)
     &                  ,TYPE,MCA,MCU,RST,CST,IMPFCH)
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,A)
                                                                    END !PrMaPr
