*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNEDO (COMEN1,COMEN2,NGNEDO,IMPFCH) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)  
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*  
* Impression d'un tableau de numerotation (#GNEDO) 
*  
*-- Arguments --
* COMEN1 commentaire (nom de la procedure appelant) 
* COMEN2 commentaire (description : 'ligne', 'colonne', etc...)
* NGNEDO tableau de numerotation sur le domaine
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) COMEN1,COMEN2  
      INTEGER       NGNEDO(*),IMPFCH
*
      INTEGER NB,NUD,NUF
*-----------------------------------------------------------------------
      NB =NGNEDO(2)
      NUD=NGNEDO(3)
      NUF=NGNEDO(NB+2)
      WRITE (IMPFCH,*) 
      IF (NUF-NUD+1.EQ.NB) THEN
         WRITE (IMPFCH,10000) COMEN1,COMEN2,NUD,NUF
      ELSE
         WRITE (IMPFCH,10001) COMEN1,COMEN2,NB,(NGNEDO(NUD),NUD=3,NB+2)
      ENDIF
      IF (NGNEDO(1).NE.0) 
     &   WRITE(IMPFCH,10002) NGNEDO(NB+3),(NGNEDO(NUD),NUD=NB+4,2*NB+3)
*-----------------------------------------------------------------------
10000 FORMAT(T2,A,'>*PrNedo* Numerotation (',A,') triviale de ',I6
     &,' a ',I6)
10001 FORMAT(T2,A,'>*PrNedo* Numerotation (',A,'), ',I6,' articles :'
     &,/(T14,10I9))
10002 FORMAT(T9,'Nombre de d.l. :',I6/T9,'No de 1er d.l.des noeuds :'
     &,/(T14,10I9))
                                                                    END !PrNedo
