*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRPLAG (PLAGE,NCHDOM,COMEN1,NOMDOM,COMEN2
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988)
* Derniere modification : D.Martin (28 Juin 2000)
* Version 1.0.1
*  
* Impression des tableaux de stockage 'Morse L' ou 'Morse-C' d'un domaine
*  
*-- Arguments --  
* PLAGE  tableau de compactage pour le domaine
* NCHDOM nombre de caracteres par nom de domaine
* COMEN1 commentaire
* NOMDOM nom du domaine
* COMEN2 commentaire  
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) COMEN1,COMEN2  
      CHARACTER     NOMDOM(*)  
      INTEGER       PLAGE(*),NCHDOM,NIVIMP,IMPFCH
*
      INTEGER       NBLIGN,I,K,N1,N2,NBLIMP
      CHARACTER PRFXAS*8
*-----------------------------------------------------------------------
      NBLIGN=PLAGE(1)
      WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                    ,(NOMDOM(I),I=1,NCHDOM)
      WRITE (IMPFCH,10001) NBLIGN,PLAGE(3),PLAGE(4),COMEN2
*
      IF (PLAGE(2).LE.400) THEN
         CALL VIPLAG (' Ligne ',NBLIGN,PLAGE(2),PLAGE(5),PLAGE(5+NBLIGN)
     &              ,IMPFCH)
      ELSE
         WRITE (IMPFCH,10002)'       ','Derniere',' ','  Ligne',' plage'
     &                 ,'Numeros de colonne de debut de plage(longueur)'
         WRITE (IMPFCH,10003) 1,PLAGE(5),PLAGE(5+NBLIGN),PLAGE(6+NBLIGN)
     &     ,(PLAGE(3+NBLIGN+2*K),PLAGE(4+NBLIGN+2*K)-PLAGE(2+NBLIGN+2*K)
     &                                                    ,K=2,PLAGE(5))
         N1=1+PLAGE(5)
         NBLIMP=MIN (10*NIVIMP,NBLIGN)
         IF (NIVIMP.GT.10) NBLIMP=NBLIGN
         WRITE (IMPFCH,10005) NIVIMP,'lignes',NBLIMP
         DO 1 I=2,NBLIMP
            N2=PLAGE(I+4)
            WRITE (IMPFCH,10003) I,N2,(PLAGE(3+NBLIGN+2*K)
     &        ,PLAGE(4+NBLIGN+2*K)-PLAGE(2+NBLIGN+2*K),K=N1,N2)
            N1=N2+1
1        CONTINUE
         WRITE (IMPFCH,10002) '  Ligne','      '
     &                       ,'Longueurs cumulees des plages'
         N1=1
         DO 2 I=1,NBLIMP
            N2=PLAGE(I+4)
            WRITE(IMPFCH,10004) I,(PLAGE(4+NBLIGN+2*K),K=N1,N2)
         N1=N2+1
2        CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A,'>*PrPlag*',A,50(A1))
10001 FORMAT(T6,'Nb. de lignes de la matrice :',T55,I7/
     &       T6,'Nb. de plages de la matrice :',T55,I7/ 
     & T6,'Nb. de coeff. de la matrice compactee :',T55,I7,' ',A)
10002 FORMAT(A,TR3,A:,TR3,A)
10003 FORMAT(2(I6,TR3),(T23,9(I4,'(',I4,') ')))
10004 FORMAT(I6,(T18,10I10))
10005 FORMAT(T6,'--> Impression de niveau ',I3,:,' : ',A,' de 1 a',I6)
                                                                    END !Prplag
