*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRPTPL (NBLINE,NBCOLO,NCPINC,NCPINL,INCRC,INCRL
     &                  ,MCA,IST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 1994)
* Derniere modification : O.DeBayser (19 Mai 1994)
*  
* Impression ligne par ligne des pointeurs  pour l'essemblage d'une
* matrice pleine rangee ligne par ligne dans une matrice 'Bimorse'
*
*-- Arguments --
* NBLINE nombre de ligne de la matrice
* NBCOLO nombre de colonne de la matrice
* NCPINC nombre de composantes de l'inconnue en colonne
* NCPINL nombre de composantes de l'inconnue en ligne
* INCRC  increment pour changer de ligne
* INCRL  increment pour changer de colonne dans la ligne
* MCA,IST adresse et super-tableau
* NIVIMP niveau d'impression (impression partielle du terme)
*        NIVIMP < 10 impression des NIVIMP premieres lignes
*                    et des NIVIMP dernieres lignes de la matrice
*        NIVIMP > 9 impression de toutes les lignes de la matrice
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLINE,NBCOLO,NCPINC,NCPINL,INCRC,INCRL,MCA,IST(*)
     &       ,NIVIMP,IMPFCH
*
      INTEGER NBPRL1,NBPRL2,LIGNE,MCFIRS,MCLAST,LONGUE,I
*------------------------------------------------------------------------
      IF(NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
*
      NBPRL1=NBLINE
      IF (NIVIMP.LE.9) NBPRL1=MIN(NIVIMP,NBPRL1)
      MCFIRS=MCA
      LONGUE=NBCOLO*NCPINC*INCRL
      WRITE (IMPFCH,200) '-> *PrPtPl* Pointeurs d''assemblage'
*
         DO 20 LIGNE=1,NBPRL1*NCPINL
            MCLAST=MCFIRS-INCRL+LONGUE
            WRITE (IMPFCH,200) 'Ligne',LIGNE
            WRITE (IMPFCH,201) (IST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
20       CONTINUE
         NBPRL2=MAX(NBPRL1,NBLINE-NBPRL1)
         IF (NBPRL1.LT.NBLINE.AND.NBPRL2.GT.NBPRL1+1)
     &      WRITE (IMPFCH,200) '..........'
         MCFIRS=MCA+NBPRL2*NCPINL*INCRC  
         DO 21 LIGNE=NBPRL2*NCPINL+1,NBLINE*NCPINL
            MCLAST=MCFIRS-INCRL+LONGUE
            WRITE (IMPFCH,200) 'Ligne',LIGNE
            WRITE (IMPFCH,201) (IST(I),I=MCFIRS,MCLAST,INCRL)
            MCFIRS=MCFIRS+INCRC
21       CONTINUE
*------------------------------------------------------------------------
200   FORMAT(T14,A,I6)
201   FORMAT((T14,10(I10,' ')))
                                                                    END !PrPtPl
