*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  VIPROF (LIOUCO,NBLIGN,NBCOLO,PROFIL,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)
* Derniere modification : D.Martin (28 Juin 2000)
* Version 1.0.1
*  
* Visualisation des elements non nuls d'une matrice a l'aide  
* des tableaux de pointeurs 'Profil'.
*
*-- Arguments --
* LIOUCO ' Ligne ' ou ' Colon.'
* NBLIGN nombre de lignes (colonnes)
* NBCOLO nombre de colonnes (lignes)
* PROFIL tableau des pointeurs de 1ers coeff. des lignes (colonnes) 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER LIOUCO*7
      INTEGER   NBLIGN,NBCOLO,PROFIL(*),IMPFCH
*
      INTEGER   ADNL,ADNXNL,KOLONE,LIGNE,KOLDEB
      CHARACTER STAR(400)
*-----------------------------------------------------------------------
      IF (NBCOLO.GT.20) WRITE(IMPFCH,10000) (KOLONE,KOLONE=1,NBCOLO/10)
      WRITE(IMPFCH,10001) (MOD(KOLONE,10),KOLONE=1,NBCOLO)
      WRITE(IMPFCH,10002) 1,'d'
      ADNL=PROFIL(1) 
      DO 10 LIGNE=2,NBLIGN
         ADNXNL=PROFIL(LIGNE)
         KOLDEB=LIGNE-ADNXNL+ADNL
         DO 1 KOLONE=1,KOLDEB-1
           STAR(KOLONE)='.'
1        CONTINUE
         STAR(KOLDEB)='*'
         DO 2 KOLONE=KOLDEB+1,MIN (NBCOLO,LIGNE-1)
            STAR(KOLONE)='x'
2        CONTINUE
         IF (LIGNE.LE.NBCOLO) STAR(LIGNE)='d'
         WRITE (IMPFCH,10002) LIGNE
     &                       ,(STAR(KOLONE),KOLONE=1,MIN(LIGNE,NBCOLO))
         ADNL=ADNXNL
10    CONTINUE
      WRITE(IMPFCH,10001) (MOD(KOLONE,10),KOLONE=1,NBCOLO)
      IF (NBCOLO.GT.20) WRITE(IMPFCH,10000) (KOLONE,KOLONE=1,NBCOLO/10)
      WRITE(IMPFCH,*)
*-----------------------------------------------------------------------
10000 FORMAT(T8,40I10)
10001 FORMAT(T8,400I1)
10002 FORMAT(I4,'   ',400A1)
                                                                    END !ViProf
