*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERREUR (ICODE,ISTOP,RVAL,CVAL,VARIAB) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1982)
* Derniere modification : D.Martin (9 Juillet 1997)
*  
* Detection et impression des valeurs de donnees erronees
*  
*-- Arguments --  
* ICODE  type de la donnee erronee ( 2 ENTIER , 3 REEL , 4 MOT )  
* ISTOP  sTOP apres detection si ISTOP.GT.0
* VAL    valeur erronee scalaire
* CVAL   valeur erronee 'chaine de caractere'
* VARIAB variable pour laquelle l'erreur est detectee
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    CVAL,VARIAB
      INTEGER          ICODE,ISTOP
      REAL             RVAL
*
      CHARACTER*8   PRFXAF
*-----------------------------------------------------------------------   
      IF (ICODE.EQ.2) THEN
         WRITE (*,200) PRFXAF ( ),VARIAB,INT(RVAL)   
      ELSEIF (ICODE.EQ.3) THEN
         WRITE (*,300) PRFXAF ( ),VARIAB,RVAL    
      ELSEIF (ICODE.EQ.4) THEN
         WRITE (*,400) PRFXAF ( ),VARIAB,CVAL  
      ENDIF
      IF (ICODE.EQ.1.OR.ISTOP.GT.0) THEN
         WRITE (*,100) PRFXAF ( )  
         CALL BAISE  (' STOP   *Erreur*/Lib-Redlec ')
      ENDIF
*-----------------------------------------------------------------------
  100 FORMAT(T15,'* Arret du programme en erreur dans ',A8,'  ',16('*'))
  200 FORMAT(T2,A8,'-> *Erreur*'
     &/T15,'La variable ',A,' ne peut prendre la valeur',I12)  
  300 FORMAT(T2,A8,'-> *Erreur*'
     &/T15,'La variable ',A,' ne peut prendre la valeur',G12.6)
  400 FORMAT(T2,A8,'-> *Erreur*'
     &/T15,'La variable ',A,' ne peut prendre la valeur ',A)
                                                                    END !Erreur
