*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE REDOPE (TEXTE,RANGD,RANGF)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1996)
* Derniere modification : D.Martin (20 Mai 1996)
*  
* Recherche d'un operateur ('+', '-', '*', '/', '**' ou '^')
* dans une chaine de caracteres ASCII 
*
*-- Argument d'entree --
* TEXTE  chaine de caractere "expression mathematique"
* RANGD  dans la chaine du premier caractere de l'operateur
* RANGD  dans la chaine du dernier caractere de l'operateur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TEXTE
      INTEGER       RANGD,RANGF
*
      INTEGER       NDEB,NFIN,RANG
*-----------------------------------------------------------------------
      NDEB  =1
      NFIN  =LEN (TEXTE)
      RANGD=0
      RANGF=0
*
*     Exponentation
*
      RANG = INDEX (TEXTE,'**')
      IF (RANG.GT.1) THEN
         RANGD=RANG
         RANGF=RANGD+1
         RETURN
      ENDIF
      RANG=INDEX (TEXTE,'^')
      IF (RANG.GT.1) THEN
         RANGD=RANG
         RANGF=RANGD
         RETURN
      ENDIF
*
*     Division
*
      RANG=INDEX (TEXTE,'/')
      IF (RANG.GT.1) THEN
         RANGD=RANG
         RANGF=RANGD
         RETURN
      ENDIF
*
*     Multiplication
*
      RANG=INDEX (TEXTE,'*')
      IF (RANG.GT.1) THEN
         RANGD=RANG
         RANGF=RANGD
         RETURN
      ENDIF
*
*     Addition
*
10    RANG=INDEX (TEXTE(NDEB:),'+')
      IF (RANG.GT.1) THEN
         RANG=RANG+NDEB-2
*        Pour ne pas tenir compte du signe + dans 1.E+6 ou LOG(+2)
         IF (TEXTE(RANG:RANG).NE.'E'
     &  .AND.TEXTE(RANG:RANG).NE.'D'
     &  .AND.TEXTE(RANG:RANG).NE.'(') THEN
            RANGD=RANG+1
            RANGF=RANGD
            RETURN
         ENDIF
         NDEB=RANG+2
         IF (NDEB.LT.NFIN) GOTO 10
      ENDIF
*
*     Soustraction
*
20    RANG=INDEX (TEXTE(NDEB:),'-')
      IF (RANG.GT.1) THEN
         RANG=RANG+NDEB-2
*        Pour ne pas tenir compte du signe + dans 1.E+6 ou LOG(+2)
         IF (TEXTE(RANG:RANG).NE.'E'
     &  .AND.TEXTE(RANG:RANG).NE.'D'
     &  .AND.TEXTE(RANG:RANG).NE.'(') THEN
            RANGD=RANG+1
            RANGF=RANGD
            RETURN
         ENDIF
         NDEB=RANG+2
         IF (NDEB.LT.NFIN) GOTO 20
      ENDIF
                                                                    END !RedOpe
