*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CRINCO (NMINCO,NCPINC,INTINC,NBTNEU,NUINCO)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1995) 
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Creation d'une nouvelle inconnue (voir par exemple CoTerm)
*  
*-- Arguments d'entree -- 
* NMINCO nom de la nouvelle inconnue
* NCPINC nombre de composantes de l'inconnue
* INTINC type d'interpolation pour une inconnue Valeurs Nodales
*        -1                   pour une inconnue Supplementaire ou Spectrale
* NBTNEU nb de noeuds pour une inconnue Valeurs Nodales
*        =1000000*NBTFON+NBFDEV pour une inconnue Spectrale
*        =nombre de composantes pour une inconnue Supplementaire
*-- Arguments de sortie --
* NUINCO numero de l'inconnue
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMINCO
      INTEGER       NCPINC,INTINC,NBTNEU,NUINCO
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       KELCHN
      INTEGER       LGMINC,MCMINC,LGINCO,MCINCO,LGEINC,NBINCO,INCINC
     &             ,NCHINC,NWHINC,NCPIN1,INTIN1,NBTNE1
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CrInco*')
*  
      CALL TBRR2  (ERCODE,'#OMINC',1,LGMINC,'#NCONU',1,LGINCO)
      CALL TBAR2  (ERCODE,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)             !utilite
*
*     Creation (si necessaire) de l'inconnue
*
      NUINCO=0
      NWHINC=LEN (NMINCO)
      IF (NWHINC.LE.NCHINC)
     &   NUINCO=KELCHN (NMINCO,AST(MCMINC),NBINCO,NCHINC)               !sdexplo
      IF (NUINCO.LE.0) THEN
*        L'inconnue  n'existe pas. On la cree et on l'introduit dans
*        les tableaux de descriptions des inconnues #OMINC et #NCONU
         NWHINC=MAX (NCHINC,NWHINC)
         CALL SDAJST ('#OMINC',1,LGMINC,0     ,NWHINC,NBINCO,1)         !sdexplo
         CALL SDAJST ('#NCONU',1,LGINCO,LGEINC,INCINC,NBINCO,1)         !sdexplo
         CALL TBAR2  (ERCODE,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO)
         CALL RIPCHN (AST(MCMINC),NBINCO,NCHINC,NMINCO)                 !utilite
         CALL SDMKDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)          !utilite
         NUINCO=NBINCO
      ELSE
*        L'inconnue existe on verifie ses attributs
         CALL SDEXCO (NUINCO,IST(MCINCO),NCPIN1,INTIN1,NBTNE1)          !utilite
         IF (NCPIN1.NE.NCPINC.OR.INTINC.NE.INTIN1) GOTO 99991
         IF (NBTNEU.LE.0) NBTNEU=NBTNE1
      ENDIF
*
      CALL SDMKCO (NUINCO,IST(MCINCO),NCPINC,INTINC,NBTNEU)             !utilite
      CALL PRFXMJ (-1,'*CrInco*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 ERCODE(1:NCHINC)=NMINCO
      WRITE (*,99981) ERCODE(:NCHINC),NCPIN1,INTIN1,NBTNE1,NCPINC,INTINC
     &               ,NBTNEU
99981 FORMAT(' L''inconnue ',A,' existe avec des attributs differents de 
     &ceux que vous voulez lui donner :',/
     &,'  Anciens : NCPINC =',I6,'   INTINC =',I6,'   NBTNEU =',I6,/
     &,'  Nouveaux:         ',I6,'           ',I6,'           ',I6)
      CALL BAISE  ('Revoir la copie.')
                                                                    END !CrInco
