*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DOASFC (NMFONC,NMASSO,TYDOAS,NVDOAS,TYPEAS)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991)
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Association d'une donnee constante de nom donne a une donnee fonction
*  
*-- Arguments d'entree -- 
* NMFONC nom de la donnee fonction
* NMASSO nom de la donne a associer a la fonction
* TYDOAS chaine caract. du type de la donne (Constante,Fonction, ...)
* NVDOAS civeau de la donnee si ce n'est pas une constante
* TYPEAS chaine caract. de la declaration de la donne (reelle,complexe, ...)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMFONC,NMASSO,TYDOAS,TYPEAS
      INTEGER       NVDOAS
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*  
      LOGICAL   READRS
      CHARACTER DONINT*4,TYPINT*4 
      CHARACTER ERCODE*120,NOMWRK*16,TYPE*12,TYDONN*12,TYPEDO*12
      INTEGER   INTDON,INTTYP,KELCHN,KLCSTE
      INTEGER   LGMDON,MCMDON,LGDDON,MCDDON,LGEDON,NBDONN,INCDON,NCHDON
     &         ,NUDONN,ITYDON,NIVDON,ITYPDO,NVVDON,LGDONA,LGMDOA,NWHDON
     &         ,NUFONC,ITFONC,NVFONC,ITYPFO
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (NOMWRK,ERCODE(105:105)),(TYPE,ERCODE(93:93))
     &           ,(TYDONN,ERCODE(81:81)),(TYPEDO,ERCODE(69:69))
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DoAsfc*')
*  
      READRS=.FALSE.
      NVVDON=NVDOAS
      CALL TBRR2  (ERCODE,'#OMDON',1,LGMDON,'$DONNE',1,LGDDON)
      CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON)
      CALL SDEXDB (IST(MCDDON),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*  
*-    Recherche du rang de la donnee fonction
*  
      NUFONC=KELCHN (NMFONC,AST(MCMDON),NBDONN,NCHDON)                  !utilite
      IF (NUFONC.LE.0) CALL ERDONN (1,NMFONC)                           !utilite
      CALL SDEXCO (NUFONC,IST(MCDDON),ITFONC,NVFONC,ITYPFO)             !utilite
      IF (ITFONC.NE.INTDON ('FONCTION')) CALL ERDONN (4,NMFONC)         !utilite
*  
      NUDONN=KELCHN (NMASSO,AST(MCMDON),NBDONN,NCHDON)                  !utilite
      IF (NUDONN.LE.0) THEN 
         LGDONA=LGDDON 
         CALL SDAJST ('$DONNE',1,LGDDON,LGEDON,INCDON,NBDONN,1)         !sdexplo
         LGMDOA=LGMDON 
         NWHDON=MAX (NCHDON,LEN (NMASSO))
         CALL SDAJST ('#OMDON',1,LGMDON,0,NWHDON,NBDONN,1)              !sdexplo
         IF (LGMDON.GT.LGMDOA.OR.LGDDON.GT.LGDONA)  
     &   CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON)
         CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMASSO)                 !utilite
         CALL SDMKDB (IST(MCDDON),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
         IF (TYDOAS(1:1).EQ.'C') THEN
            NVVDON=KLCSTE (TYPEAS)                                      !sdexplo
            READRS=.TRUE.  
         END IF
         NUDONN=NBDONN 
      ELSEIF (TYDOAS(1:2).EQ.'CO') THEN 
         CALL SDEXCO (NUDONN,IST(MCDDON),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.EQ.INTDON ('CONSTANTE')
     &  .AND.INTTYP (TYPEAS).EQ.ITYPDO) THEN                            !utilite
            NVVDON=NIVDON  
         ELSE  
            NVVDON=KLCSTE (TYPEAS)                                      !sdexplo
            READRS=.TRUE.  
            NOMWRK=NMASSO  
            TYPE=TYPEAS
            TYDONN=DONINT (ITYDON)  
            TYPEDO=TYPINT (ITYPDO)  
            CALL WARNNG ('Changement de type pour la constante '
     &                  //NOMWRK//' de type '//TYPE
     &                  //'. C''etait un(e) '//TYDONN//' '//TYPEDO)     !utilite
         END IF
      ELSEIF (TYDOAS(1:2).EQ.'FO') THEN  
         CALL SDEXCO (NUDONN,IST(MCDDON),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.EQ.INTDON ('FONCTION')
     &  .AND.INTTYP (TYPEAS).EQ.ITYPDO) THEN                            !utilite
            NVVDON=NIVDON  
         ELSE  
            GOTO 99994
         END IF
      END IF
*  
*     -> KLCSTE est susceptible de modifier l'allocation dynamique 
      IF (READRS)
     &   CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON)
*  
*-    Mise a jour du tableau $DONNE
      CALL SDMKCO (NUDONN,IST(MCDDON),INTDON(TYDOAS),NVVDON
     &            ,INTTYP(TYPEAS))                                      !utilite
      CALL SDMKCO (NUFONC,IST(MCDDON),ITFONC,NUDONN,ITYPFO)             !utilite
*  
      CALL PRFXMJ (-1,'*DoAsfc*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99994 NOMWRK=NMASSO  
      TYPE=TYPEAS
      TYDONN=DONINT(ITYDON)  
      TYPEDO=TYPINT(ITYPDO)  
      CALL BAISE  ('Changement de type interdit pour la fonction'
     & //NOMWRK//' de type '//TYPE//'. C''etait '
     & //' un(e) '//TYDONN//' '//TYPEDO)
                                                                    END !DoAsfc
