*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXBLOK (L,BLOKEL,NUTGEO) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.de Bayser (Mai 1988)
* Derniere modification : D.Martin (10 Juillet 1996)
* Version 1.0.0
*  
* Recherche du type geometrique de l'element L dans la structure #LOKEL
*  
*-- Arguments d'entree -- 
* L      numero de l'element dont cherche le type
* BLOKEL tableau de description des types d'elements par bloc
*-- Argument de sortie -- 
* NUTGEO numero de type geometrique de l'element L
*  
*-- Structure du tableau BLOKEL --
*  BLOKEL(1) longueur de l'en-tete du tableau 
*  BLOKEL(2) nombre de blocs  
*  BLOKEL(3) increment de parcours dans le tableau (pour le passage d'un bloc 
*            au suivant
*  BLOKEL(BLOKEL(1)+1+(K-1)*BLOKEL(3)) Nombre d'elements du bloc K
*  BLOKEL(BLOKEL(1)+2+(K-1)*BLOKEL(3)) Numeros de type des elements du bloc K
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER L,BLOKEL(*),NUTGEO
*  
      INCLUDE 'CONTEX'
*
      INTEGER NBELBK,NBEL,LGDBLK,INIT
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
*     Initialisation
*     (et retour si le tableau BLOKEL n'existe pas : NBBBLK=1)
      NBELBK=NBTEL
      NUTGEO=NU1BLK
      IF (NBBBLK.EQ.1) RETURN
*
      NBEL=0
      LGDBLK=BLOKEL(1) 
      INIT=1+LGDBLK
      DO 1 K=1,BLOKEL(2)
         NBEL=NBEL+BLOKEL(INIT)
         NUTGEO=BLOKEL(INIT+1)
         IF (L.LE.NBEL) RETURN
         INIT=INIT+BLOKEL(LGDBLK)
1     CONTINUE
*-----------------------------------------------------------------------
      CALL ENCLER (L,ERCODE)
      CALL BAISE  ('*ExBlok* L''element de numero'//ERCODE(1:12)//
     &' n''est pas retrouve dans la structure #LOKEL')
                                                                    END !Exblok
