*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXNUVC (NBNOLD,NGNOLD,TYPOLD,MCVOLD,NBVECT
     &                  ,NBNNEW,NGNNEW,TYPNEW,MCVNEW,RST,CST) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Juin 1990)
* Derniere modification : D.Martin (22 Mai 1997)
*  
* Extension de vecteurs de meme numerotation selon une numerotation
* globale plus 'grosse',et avec eventuel changement de type.
*  
*-- Arguments --  
* NBNOLD nombre de noeuds du vecteur de depart
* NGNOLD numerotation globale pour le vecteur de depart
* TYPOLD type 'REEL' ou 'COMPLEXE' du vecteur de depart
* MCVOLD adresse du vecteur original dans le super-tableau adequat
* NBVECT nombre de vecteur identiques consecutifs en memoire  
* NBNNEW nombre de noeuds du vecteur renumerote
* NGNNEW numerotation globale pour le vecteur renumerote  
* TYPNEW type du vecteur renumerote  
* MCVNEW adresse du vecteur renumerote dans le super-tableau adequat  
* RST,CST super-tableau version reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPOLD,TYPNEW  
      INTEGER       NBNOLD,NGNOLD(*),MCVOLD,NBNNEW,NGNNEW(*),MCVNEW
     &             ,NBVECT
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      INTEGER       ADVOLD,ADVOL2,ADVNEW,ADVNE2,NXRANG,NURANG,NUGLOW,I,J
*-----------------------------------------------------------------------
      NXRANG=1
      ADVNEW=MCVNEW
      ADVOLD=MCVOLD-1
*
      IF (TYPOLD.EQ.TYPNEW) THEN
         IF (TYPOLD(1:1).EQ.'R') THEN
            DO 15 I=1,NBNNEW
               ADVNE2=ADVNEW
               NUGLOW=NGNNEW(I) 
               CALL DICOTO (NXRANG,NBNOLD,NGNOLD,NUGLOW,NURANG,*13)     !Utilite
               NXRANG=NURANG+1  
               ADVOL2=ADVOLD+NURANG 
               DO 12 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
                  RST(J)=RST(ADVOL2)
12                ADVOL2=ADVOL2+NBNOLD 
                  GO TO 15 
13             DO 14 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
14                RST(J)=0.
15          ADVNEW=ADVNEW+1
         ELSE  
            DO 25 I=1,NBNNEW
               ADVNE2=ADVNEW
               NUGLOW=NGNNEW(I) 
                CALL DICOTO (NXRANG,NBNOLD,NGNOLD,NUGLOW,NURANG,*23)    !Utilite
               NXRANG=NURANG+1  
               ADVOL2=ADVOLD+NURANG 
               DO 22 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
                  CST(J)=CST(ADVOL2)
22                ADVOL2=ADVOL2+NBNOLD 
               GO TO 25
23             DO 24 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
24                CST(J)=0.
25          ADVNEW=ADVNEW+1
         ENDIF 
      ELSE IF(TYPOLD(1:1).EQ.'R') THEN 
         DO 35 I=1,NBNNEW  
            ADVNE2=ADVNEW  
            NUGLOW=NGNNEW(I)
             CALL DICOTO (NXRANG,NBNOLD,NGNOLD,NUGLOW,NURANG,*33)       !Utilite
            NXRANG=NURANG+1 
            ADVOL2=ADVOLD+NURANG
            DO 32 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
               CST(J)=RST(ADVOL2)  
32             ADVOL2=ADVOL2+NBNOLD
               GO TO 35
33          DO 34 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
34             CST(J)=0.
35       ADVNEW=ADVNEW+1
      ELSE 
         DO 45 I=1,NBNNEW  
            ADVNE2=ADVNEW  
            NUGLOW=NGNNEW(I)
             CALL DICOTO (NXRANG,NBNOLD,NGNOLD,NUGLOW,NURANG,*43)       !Utilite
            NXRANG=NURANG+1 
            ADVOL2=ADVOLD+NURANG
            DO 42 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
               RST(J)=CST(ADVOL2)  
42             ADVOL2=ADVOL2+NBNOLD
               GO TO 45
43          DO 44 J=ADVNE2,ADVNE2+(NBNNEW*(NBVECT-1)),NBNNEW
44             RST(J)=0.
45       ADVNEW=ADVNEW+1
      END IF
                                                                    END !ExNuVc
