*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FETERM (NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1994)
* Derniere modification : D.Martin (6 Juillet 2000)
* Version # 1.0.1
*
* Fermeture du fichier NMTERM//.//'NVTERM'
*
*-- Arguments d'entree --
* NMTERM nom du/des terme(s) contenu(s) sur le fichier
* NVTERM niveau du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM
*
      INCLUDE 'ALLOC'
*
      LOGICAL       OPNED,JEXIST
      INTEGER       NOUNIT,LENFIC,LENTRM,MCFICH
      CHARACTER     ERCODE*120,NOMFIC*32
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FeTerm*')
*
      LENTRM=LEN (NMTERM)
      LENFIC=LENTRM
*
*     Nom du fichier a fermer
      NOMFIC=NMTERM//'.'
      DO 1 LENFIC=LENTRM+2,LEN (NOMFIC)
         CALL ENCLER (NVTERM,NOMFIC(LENTRM+2:LENFIC))                   !utilite
         IF (NOMFIC(LENTRM+2:LENTRM+2).NE.'+')  GOTO 2
1     CONTINUE
      GOTO 99903
*
*     Fermeture du fichier
*
2     INQUIRE (FILE=NOMFIC(:LENFIC),NUMBER=NOUNIT,OPENED=OPNED
     &        ,EXIST=JEXIST,ERR=99900)
      IF ((.NOT.JEXIST)) THEN
         GOTO 99902
      ELSEIF (JEXIST.AND..NOT.OPNED) THEN
         GOTO 99904
      ENDIF
*
      CALL TBAR1  (ERCODE,'#Unite',0,MCFICH)                            !utilite
      AST(MCFICH-1+NOUNIT)=' '
      CLOSE (UNIT=NOUNIT,STATUS='KEEP')
      CALL PRFXMJ (-1,'*FeTerm*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99900 CALL BAISE  ('Probleme sur ''Inquire'' avec le fichier'
     &//NOMFIC(1:LENFIC))
99902 CALL BAISE  ('Le fichier '//NOMFIC(1:LENFIC)//' n''existe pas!')
99903 CALL BAISE  ('Chaine de caracteres de longueur insuffisante'
     &//' pour definir le nom du fichier.')
99904 CALL BAISE  ('Le fichier '//NOMFIC(1:LENFIC)
     &//' n''est pas ouvert!')
                                                                    END !FeTerm
