*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INCST (NUCSTE,ITYPDO,NTIERE,REELLE,COMPLE,CHARAC) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 88)  
* Derniere modification : D.Martin (30 Juin 1997)
*  
* Sous-programme d'affectation de la valeur d'une donnee constante 
*  
*-- Arguments d'entree -- 
* NUCSTE: numero de la constante
* ITYPDO: code entier indiquant le type de la constante
* NTIERE valeur de la constante entiere
* REELLE valeur de la constante reelle 
* COMPLE valeur de la constante complexe
* CHARAC valeur de la constante chaine de caracteres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHARAC 
      COMPLEX       COMPLE 
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*  
      CHARACTER ERCODE*120,TYPINT*2
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*InCst *')                                        !Utilite
*  
      ERCODE(:2)=TYPINT (ITYPDO)                                        !Utilite
      IF (ERCODE(:2).EQ.'CA') THEN  
         CALL TBAR2  (ERCODE,'$ACSTE',1,MC,'$LGCSA',1,MCL)
         LENOLD=IST(MCL+NUCSTE)
         LENCHA=LEN (CHARAC)
         IAD=MC
         DO 1 I=1,NUCSTE-1 
1           IAD=IAD+IST(MCL+I) 
         IF (LENOLD.NE.LENCHA) THEN 
            IADX=IAD
            DO 3 I=NUCSTE,IST(MCL) 
3              IADX=IADX+IST(MCL+I)
            IF (LENCHA.GT.LENOLD) THEN  
               DO 4 I=IADX,IAD+LENOLD,-1
4                 AST(I+LENCHA-LENOLD)=AST(I)  
            ELSE
               DO 5 I=IAD+LENOLD,IADX  
5                 AST(I+LENCHA-LENOLD)=AST(I)  
            ENDIF 
         END IF
         DO 10 I=1,LENCHA  
10          AST(IAD-1+I)=CHARAC(I:I)
         IST(MCL+NUCSTE)=LENCHA
         ITYPDO=10+LENCHA  
      ELSEIF (ERCODE(:1).EQ.'E') THEN  
         CALL TBAR1  (ERCODE,'$ECSTE',1,MC)
         IST(MC+NUCSTE)=NTIERE 
      ELSEIF (ERCODE(:1).EQ.'R') THEN  
         CALL TBAR1  (ERCODE,'$RCSTE',1,MC)
         RST(MC+NUCSTE)=REELLE 
      ELSEIF (ERCODE(:1).EQ.'C') THEN  
         CALL TBAR1  (ERCODE,'$CCSTE',1,MC)
         CST(MC+NUCSTE)=COMPLE 
      ENDIF
      CALL PRFXMJ (-1,'*InCst *')                                       !Utilite
                                                                    END !InCst
