*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION KLCSTE (TYPE)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1990)  
* Derniere modification : D.Martin (30 Juin 1997)
*  
* Recherche du prochain numero de constante disponible dans le tableau des 
* constantes du type adequat.  
*  
*-- Argument d'entree --  
* TYPE  type de la constante pour lequel on cherche un numero
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       KLCSTE
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       LGCSTE,MCCSTE
      CHARACTER     ERCODE*120 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*KlCste*')
*  
      IF (TYPE(1:2).EQ.'CA') THEN
         CALL TBRR1  (ERCODE,'$LGCSA',1,LGCSTE)
         CALL TBAR1  (ERCODE,'$LGCSA',1,MCCSTE)
         KLCSTE=IST(MCCSTE)
         IST(MCCSTE)=KLCSTE+1  
         IF (LGCSTE.LT.KLCSTE+2)
     &      CALL SDAJST ('$LGCSA',1,LGCSTE,1,1,KLCSTE,5)                !SDexplo
*  
      ELSEIF (TYPE(1:1).EQ.'E') THEN
         CALL TBRR1  (ERCODE,'$ECSTE',1,LGCSTE)
         CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
         KLCSTE=IST(MCCSTE)
         IST(MCCSTE)=KLCSTE+1  
         IF (LGCSTE.LT.KLCSTE+2)
     &      CALL SDAJST ('$ECSTE',1,LGCSTE,1,1,KLCSTE,5)                !SDexplo
*  
      ELSEIF (TYPE(1:1).EQ.'R') THEN
         CALL TBRR1  (ERCODE,'$RCSTE',1,LGCSTE)
         CALL TBAR1  (ERCODE,'$RCSTE',1,MCCSTE)
         KLCSTE=IST(MCCSTE)
         IST(MCCSTE)=KLCSTE+1  
         IF(LGCSTE.LT.KLCSTE+2)
     &      CALL SDAJST ('$RCSTE',1,LGCSTE,1,1,KLCSTE,5)                !SDexplo
*  
      ELSEIF (TYPE(1:1).EQ.'C') THEN
         CALL TBRR1  (ERCODE,'$CCSTE',1,LGCSTE)
         CALL TBAR1  (ERCODE,'$CCSTE',1,MCCSTE)
         KLCSTE=IST(2*MCCSTE-1)
         IST(2*MCCSTE-1)=KLCSTE+1  
         IF (LGCSTE.LT.KLCSTE+2)
     &      CALL SDAJST ('$CCSTE',1,LGCSTE,1,1,KLCSTE,5)                !SDexplo
*  
      ENDIF
      KLCSTE=KLCSTE+1
      CALL PRFXMJ (-1,'*KlCste*')  
                                                                    END !KlCste
