*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE KLDOMN (NODOMA,INDEXC,INDEXL,ITERDO,NOMDOM,NBDOMG 
     &                  ,NUDOMK,IATRDO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1989)
* Derniere modification (D.Martin) le 24 Juin 1996
*  
* Recherche de l'adresse dans #TERDO d'un domaine de nom donne et
* d'indices d'extensions donnes .
*  
*-- Arguments d'entree -- 
* NODOMA nom du domaine
* INDEXC indice d'extension recherche en colonne (negatif si sans importance) 
* INDEXL indice d'extension recherche en ligne (negatif si sans importance)
* ITERDO structure #TERDO a l'adresse 1
* NOMDOM tableau #OMDOM des noms de domaine
* NBDOMG nombre de domaine geometriques
*-- Arguments de sortie --
* NUDOMK numero du domaine de calcul cherche  
* IATRDO adresse relative du domaine dans la structure #TERDO 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NODOMA 
      CHARACTER     NOMDOM(*)  
      INTEGER       INDEXC,INDEXL,ITERDO(*),NBDOMG,NUDOMK,IATRDO
*
      INTEGER       KELCHN
      INTEGER       LGERDO,NBDOMK,INCRDO,NCHDOM,NUDOMG,NDEBMX
     &             ,NDEBDO,NWDOMG,IGEOME,INDMIX,NUSCHQ,JNDEXC,IDLHRC
     &             ,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC
     &             ,JNDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &             ,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM
      CHARACTER ERCODE*120 
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL SDEXDB (ITERDO,LGERDO,NBDOMK,INCRDO,NCHDOM)                  !sdexplo
      NUDOMG=KELCHN (NODOMA,NOMDOM,NBDOMG,NCHDOM)                       !utilite
      IF (NUDOMG.EQ.0) CALL ERDOMA (1,NODOMA)                           !utilite
      NDEBMX=LGERDO+1  
      DO 1 NUDOMK=1,NBDOMK
         NBTRDO=ITERDO(NDEBMX+INCRDO-2)
         NDEBMX=NDEBMX+INCRDO+NBTRDO
1     CONTINUE
      NDEBMX=NDEBMX-1  
      NBTRDO=0 
      NDEBDO=LGERDO+1-INCRDO
2     NDEBDO=NDEBDO+INCRDO+NBTRDO 
      IF (NDEBDO.GT.NDEBMX) GOTO 99992 
      NWDOMG=ITERDO(NDEBDO) 
      IF (NUDOMG.EQ.NWDOMG) THEN 
*        On a trouve un domaine geometrique portant le bon nom
         CALL GETDOM (ITERDO(NDEBDO),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &               ,JNDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &               ,NBDLFX,NVNUMC
     &               ,JNDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &               ,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM)        !sdexplo
         IF ((INDEXC.EQ.JNDEXC.AND.INDEXL.EQ.JNDEXL)
     &   .OR.(INDEXC.LT.0.AND.JNDEXL.EQ.INDEXL) 
     &   .OR.(INDEXL.LT.0.AND.JNDEXC.EQ.INDEXC)
     &   .OR.(INDEXC.LT.0.AND.INDEXL.LT.0)) THEN  
            IATRDO=NDEBDO-1
            RETURN 
         ENDIF
      ELSE 
         NBTRDO=ITERDO(NDEBDO+INCRDO-2)
      ENDIF
      GOTO 2  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99992 ERCODE=NODOMA
      CALL BAISE  ('*KlDomn* Impossible de trouver le domaine '
     &//ERCODE(:NCHDOM)//' avec les bons indices d''extension')
                                                                    END !KlDomn
