*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE N2DLNU (NCPINC,NBNEDO,NGNEDO,NBLIDL,NGDLDO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1992)  
* Derniere modification (O.DeBayser) le 3 Novembre 1992  
*  
*  Creation de la numerotation en d.l. pour une inconnue vectorielle
*  a partir de la numerotation en noeud
*  
*** Arguments d'entree ***
* NCPINC nombre de composantes de l'inconnue vectorielle en un noeud
* NBNEDO nombre de lignes en noeud
* NGNEDO tableau complet de numerotation en noeuds
* NBLIDL nombre de lignes en d.l.
* NGDLDO tableau complet de numerotation en d.l.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NGNEDO(*),NGDLDO(*)  
*
      NBLIDL=0
      DO 1 NOEUD=1,NBNEDO
         NGNOEU=NGNEDO(NOEUD)
         NGDL=NCPINC*(NGNOEU-1)
         DO 2 ICPINC=1,NCPINC
            NBLIDL=NBLIDL+1
            NGDL=NGDL+1
            NGDLDO(NBLIDL)=NGDL
2        CONTINUE
1     CONTINUE
                                                                    END *N2DlNu*
