*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUM2DL (NCPINC,NVNUME,NVDUME,NBDUME,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Fevrier 1995)  
* Derniere modification : D.Martin (3 Juillet 1997)
*  
* Calcul des tables #GNEDO pour inconnue vectorielle
*  
*-- Arguments d'entree -- 
* NCPINC nombre de d.l. de l'inconnue vectorielle par noeuds
* NVNUME niveau de la numerotation en noeuds
* NVDUME niveau de la numerotation pour inconnue vectorielle a creer
* NBDUME nombre de d.l.
* NIVIMP niveau d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPINC,NVNUME,NVDUME,NBDUME,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCNUME,MCDUME
      CHARACTER     ERCODE*120,PRFXAS*8
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Num2dl*')                                        !utilite
*
      IF (NVNUME.EQ.NDFNUM) GOTO 99991
      IF (NVDUME.EQ.NDFDUM) GOTO 99992
      ERCODE(1:1)='!'
      CALL TBRR1  (ERCODE,'#GNEDO',NVDUME,MCDUME)
      IF (ERCODE(1:1).NE.' ') THEN
         CALL TBCREE ('#GNEDO',NVDUME,1,2+NBDUME,'c')
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUME,MCNUME)
         CALL TBAR2  (ERCODE,'#GNEDO',NVNUME,MCNUME
     &                      ,'#GNEDO',NVDUME,MCDUME)
         CALL N2DLNU (NCPINC,IST(MCNUME+1),IST(MCNUME+2)
     &                      ,IST(MCDUME+1),IST(MCDUME+2))               !sdexplo
         IST(MCDUME)=IST(MCNUME)
         IF (NIVIMP.GT.5)
     &      CALL PRNEDO (PRFXAS (1)//'>'//PRFXAS (0),' d.l.'
     &                  ,IST(MCDUME),IMPSDR)
         CALL TBSAVE ('#GNEDO',NVNUME)
      ENDIF
      CALL TBSAVE ('#GNEDO',NVDUME)
      CALL PRFXMJ (-1,'*Num2dl*')                                       !utilite
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL ENCLER (NDFNUM,ERCODE(1:12))
      CALL BAISE  ('Niveau de numerotation de noeuds : '//ERCODE(1:12)
     &//' non autorise')
99992 CALL ENCLER (NDFDUM,ERCODE(1:12))
      CALL BAISE  ('Niveau de numerotation de noeuds pour '
     &//' inconnue vectorielle : '//ERCODE(1:12)//' non autorise')
                                                                    END !Num2dl
