*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PUTTAB (NOMTAB,NIVTAB,KLADRS
     &                  ,TYPTAB,VALEUI,VALEUR,VALEUC,VALEUA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996) 
* Derniere modification : D.Martin (18 Novembre 1999)
* Version 1.0.0
*  
* Affecte la valeur du coefficient d'un tableau a une adresse relative donnee
*  
*-- Arguments d'entree -- 
* NOMTAB,NIVTAB nom et niveau du tableau
* KLADRS adresse contenant le coefficient a chercher
* TYPTAB type du tableau ('ENTIER','REEL','COMPLEXE','CARACTERE','CARACTERE*x')
*-- Arguments de sortie --
* VALEUI valeur du coefficient dans le cas entier
* VALEUR valeur du coefficient dans le cas reel
* VALEUC valeur du coefficient dans le cas complexe
* VALEUA valeur du coefficient dans le cas chaine de caractere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTAB,TYPTAB,VALEUA
      INTEGER       NIVTAB,KLADRS,VALEUI
      REAL          VALEUR
      COMPLEX       VALEUC
*
      INCLUDE 'ALLOC'
*      INCLUDE 'CONTEX'
*
      INTEGER       INTTYP
      INTEGER       LGTAB,ITTAB,MCTAB,ITYTAB,NCATR1
      CHARACTER     ERCODE*120,TYPINT*12
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PutTab*')
*  
*     Recherche des caracteristiques du tableau
      CALL TBRR1  (ERCODE,NOMTAB,NIVTAB,LGTAB)
      IF (KLADRS.LE.0.OR.KLADRS.GT.LGTAB) GOTO 99990
      CALL TBTYPE (NOMTAB,NIVTAB,ITTAB)
      ITYTAB=INTTYP (TYPTAB)                                            !utilite
      IF (ITTAB.NE.ITYTAB) GOTO 99991
      CALL TBAR1  (ERCODE,NOMTAB,NIVTAB,MCTAB)
*
      IF (TYPTAB(1:2).EQ.'CA') THEN
         CALL BAISE  ('Cas d''un tableau de caracteres a prevoir.')
      ELSEIF (TYPTAB(1:1).EQ.'E') THEN
         IST(MCTAB-1+KLADRS)=VALEUI
      ELSEIF (TYPTAB(1:1).EQ.'R') THEN
         RST(MCTAB-1+KLADRS)=VALEUR
      ELSEIF (TYPTAB(1:1).EQ.'C') THEN
         CST(MCTAB-1+KLADRS)=VALEUC
      ENDIF
*
      CALL TBSAVE (NOMTAB,NIVTAB)
      CALL PRFXMJ (-1,'*PutTab*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL ENCLER (KLADRS,ERCODE(1:10))
      CALL ENCLER (LGTAB ,ERCODE(11:20))
      CALL PRNTRM (NOMTAB,NIVTAB,ERCODE(21:),NCATR1)
      CALL BAISE  ('Incompatibilite entre l''adresse '//ERCODE(1:10)
     &//' et la longueur '//ERCODE(11:20)//' du tableau '
     &//ERCODE(21:20+NCATR1)//'.')
99991 CALL PRNTRM (NOMTAB,NIVTAB,ERCODE,NCATR1)
      CALL BAISE  ('Incompatibilite entre le type '//TYPINT(ITTAB)
     &//' du tableau '//ERCODE(1:NCATR1)//' et de l''argument 4 :'
     &//TYPINT(ITYTAB)//'.')
                                                                    END !PutTab
