*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PUTTRM (ISDTRM,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN
     &                  ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &                  ,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK
     &                  ,NVCORC,IATRDO,NIVIMP)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.DeBayser (Avril 1989)
* Derniere modification : D.Martin (16 Decembre 1998)
* Version 1.0.0
*  
* Mise a jour la structure $SDTRM pour un terme
*  
*-- Arguments d'entree -- 
* ISDTRM structure $SDTRM a l'adresse correspondant au terme en cours 
* NIVTRM niveau du tableau contenant le terme 
* ITYPTR numero de type (reel,complexe) du terme  
* ITYCAL type de calcul du terme (ELFINI,VALNOD,C.ESSE,....)  
* NUKALE numero du calcul (numero d'integrand, de valeur nodale, de cond. ess.)
* NUDONN numero de donnee associee
* ITYSYM numero de type de symetrie
* NVDSMB niveau de la structure $DSMBL asociee
* NUINCC numero de l'inconnue en colonne, 
* NVDUMC niveau du tableau de numerotation des d.l. en colonne  
* NBCOLO nombre de colonnes du terme 
* NVNUMC niveau du tableau de numerotation des noeuds en colonne 
* NUINCL numero de l'inconnue en ligne
* NVDUML niveau du tableau de numerotation des d.l. en ligne
* NBLIGN nombre de lignes du terme
* NVNUML niveau du tableau de numerotation des noeuds en ligne
* INSTOK numero de type de stockage
* NVSTOK numero du tableau des tables de stokage  
* NVCORC numero du tableau des coordonnees des noeuds  
* IATRDO adresse relative du domaine de calcul dans #TERDO si terme primaire  
* NIVIMP niveau d'impression pour le domaine  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ISDTRM(*),NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM
     &       ,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &       ,NVNUML,INSTOK,NVSTOK,NVCORC,IATRDO,NIVIMP,NDFNUM
*----------------------------------------------------------------------
      NDFNUM=-999999999
      ISDTRM(1) =NIVTRM
      ISDTRM(2) =ITYPTR
      ISDTRM(3) =ITYCAL
      ISDTRM(4) =NUKALE
      ISDTRM(5) =NUDONN
      ISDTRM(6) =ITYSYM
      ISDTRM(7) =NVDSMB
      ISDTRM(8) =NUINCC
      ISDTRM(9) =NVDUMC
      ISDTRM(10)=NBCOLO
      ISDTRM(11)=NVNUMC
      ISDTRM(12)=NUINCL
      ISDTRM(13)=NVDUML
      ISDTRM(14)=NBLIGN
      ISDTRM(15)=NVNUML
      ISDTRM(16)=INSTOK
      ISDTRM(17)=NVSTOK
      ISDTRM(18)=NVCORC
      ISDTRM(19)=IATRDO
      ISDTRM(20)=NIVIMP
                                                                    END !Puttrm
