*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RKGEOM
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & G.Michel-Belmiloudi (Avril 1993) 
* Derniere modification (D.Martin) le 23 Fevrier 1995
*
* Actualisation de la structure #TERDO pour prendre en compte 
* un maillage dont les coordonnees des points ont ete modifiees.
* Les coordonnees des noeuds, les normales et les termes doivent etre
* recalcules sur tous les domaines.
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*
      INTEGER MCTRDO,LGERDO,NBDOMK,INCRDO,NCHDOM,IDTRDO,NBTRDO
     &       ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,IDOMK,ITERM,IADKAL
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RkGeom*')
*
      CALL TBAR2  (ERCODE,'#TERDO',1,MCTRDO,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !sdexplo
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*
      IDTRDO=MCTRDO+LGERDO
      DO 10 IDOMK=1,NBDOMK
*
*        On redresse les signes des indices de calcul des termes (INDMIX)
*        et de calcul de la geometrie sur le domaine  (IGEOME)
*
         IST(IDTRDO+2)=ABS(IST(IDTRDO+2))
         IST(IDTRDO+3)=ABS(IST(IDTRDO+3))
         IDTRDO       =IDTRDO+INCRDO
         NBTRDO       =IST(IDTRDO-2)
         IF (NBTRDO.GT.0) THEN
*
*           On redresse le signe du numero de type de calcul (NUKALE)
*           des termes calcules sur le domaine 
*
            DO 5 ITERM=1,NBTRDO
               IADKAL=MCDTRM+LGETRM+INCTRM*(IST(IDTRDO)-1)+3
               IST(IADKAL)=ABS(IST(IADKAL))
               IDTRDO=IDTRDO+1
5           CONTINUE
         ENDIF
10    CONTINUE
      CALL PRFXMJ (-1,'*RkGeom*')
                                                                    END !RkGeom
