*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RKTERM (NOMTRM,NIVTRM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1990)  
* Derniere modification : D.Martin (2 Juillet 1997)  
*  
* Mise a jour des tableaux #TERDO et $SDTRM pour le recalcul d'un terme  
* sans modification de ses indices de description (sauf eventuellement NUDONN)
*
* La donnee associee au terme peut etre changee par DOASTR
* La valeur de la donnee associee au terme peut etre changee par PUTCST  
*  
*-- Arguments d'entree -- 
* NOMTRM nom du terme 
* NIVTRM niveau du (tableau contenant le) terme  
* NIVIMP indice de niveau d'impression du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NOMTRM*(*)
      INTEGER   NIVTRM,NIVIMP 
*  
      INCLUDE 'ALLOC'
*
      INTEGER   KLTERM
      INTEGER   MCTRDO,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &         ,NUTERM,IADTRM,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &         ,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &         ,NVDUML,NBNELI,NVNUML,INDSTK,NVNUMS,NVCORC
     &         ,NDEBDO,NIVOLD
      CHARACTER ERCODE*120,NOMWRK*16,NIVWRK*8  
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (ERCODE(97:97),NOMWRK),(ERCODE(113:113),NIVWRK)  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RkTerm*')
*  
      CALL TBAR3  (ERCODE,'#TERDO',1,MCTRDO
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
*     Le terme existe-t-il ?
*   
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NOMTRM,NIVTRM)                    !utilite
*  
      IADTRM=MCDTRM+LGETRM+(NUTERM-1)*INCTRM
      CALL GETTRM (IST(IADTRM),NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &            ,NVDUML,NBNELI,NVNUML,INDSTK,NVNUMS,NVCORC
     &            ,NDEBDO,NIVOLD)                                       !sdexplo
*  
*     Mise a jour de la structure #TERDO (mettre INDMIX positif)
*  
      IST(MCTRDO+NDEBDO+2)=ABS(IST(MCTRDO+NDEBDO+2))
*  
*     Mise a jour de la structure $SDTRM pour le terme 
*  
      CALL PUTTRM (IST(IADTRM),NIVTRM,ITYPTR,ITYCAL,ABS(NUKALE),NUDONN
     &            ,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &            ,NVDUML,NBNELI,NVNUML,INDSTK,NVNUMS,NVCORC
     &            ,NDEBDO,NIVIMP)                                       !sdexplo
      CALL PRFXMJ (-1,'*RkTerm*')  
                                                                    END !RkTerm
