*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ALFANU (MAXCAR,CHAINE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1990) 
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2
*
* Verification de la longueur et du contenu alphanumerique d'une chaine  
*  
*-- Arguments --  
* MAXCAR nombre maximum de caracteres de la chaine 
* CHAINE chaine de caracteres  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE
      INTEGER       MAXCAR
*
      INTEGER       ALPHAB, NCAR,ITCHAR,ICAR,MAJVAL
      CHARACTER*120 ERCODE 
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      NCAR=LEN(CHAINE) 
*  
*     Verification de la longueur de la chaine
      IF (NCAR.LE.0) CALL BAISE  (' *Alfanu* Chaine de longueur nulle') !Utilite
      IF (NCAR.GT.MAXCAR) THEN  
         ERCODE(:NCAR)=CHAINE  
         CALL ENCLER (NCAR,ERCODE(NCAR+1:NCAR+3))                       !Utilite
         CALL ENCLER (MAXCAR,ERCODE(NCAR+4:NCAR+6))                     !Utilite
         CALL BAISE  (' *Alfanu* Longueur de la chaine '//ERCODE(:NCAR)
     &                //' non autorisee : '//ERCODE(NCAR+1:NCAR+3)
     &                //' ,maximum :' //ERCODE(NCAR+4:NCAR+6))          !Utilite
      ENDIF
*  
*     L'initiale de la chaine doit etre une lettre  
      IF (ALPHAB (CHAINE(1:1),0).NE.1) THEN                             !Utilite
         ERCODE(:NCAR)=CHAINE  
         CALL BAISE  (' *Alfanu* Initiale non autorisee pour la chaine '
     &                //ERCODE(:NCAR))                                  !Utilite
      ENDIF
*  
*     On verifie si les autres caracteres sont alphanumeriques
      DO 2 ICAR=2,NCAR
         MAJVAL=0
         CALL CHARTY (CHAINE(ICAR:ICAR),MAJVAL,ITCHAR)                  !Utilite
         IF (ITCHAR.NE.5.AND.ITCHAR.NE.7.AND.ITCHAR.NE.8) THEN
            ERCODE(:NCAR)=CHAINE  
            CALL ENCLER (ICAR,ERCODE(NCAR+1:NCAR+2))                    !Utilite
            CALL BAISE  (' *Alfanu* Caractere #'//ERCODE(NCAR+1:NCAR+2)
     &     //' illegal :'//ERCODE(ICAR:ICAR)
     &     //' dans la chaine '//ERCODE(:NCAR))                         !Utilite
         ENDIF
2     CONTINUE 
                                                                    END !Alfanu
