*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER FUNCTION ALPHAB (CARAC,MAJUS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1982)
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2
*
* Fonction de reconnaissance de caractere alphabetique
* ATTENTION fonction a effet de bord
*
*-- Arguments d'entree -- 
* CARAC : un caractere du code ASCII . 
* MAJUS : =1 ==> Les minuscules sont transformees en majuscules
*-- En sortie --  
* ALPHAB = 1 si CARAC est une lettre, 0 sinon  
* CARAC  = Lettre Majuscule associee a CARAC si CARAC est une Lettre
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER CARAC
      INTEGER   MAJUS
*----------------------------------------------------------------------
      ALPHAB = 0
      IF (LLT (CARAC,'A').OR.LGT (CARAC,'z'))   RETURN
      IF (LGE (CARAC,'a')) THEN  
          IF (MAJUS.EQ.1) CARAC=CHAR(ICHAR(CARAC)-32)
      ELSE 
          IF (LGT (CARAC,'Z'))  RETURN
      ENDIF
      ALPHAB = 1
                                                                    END !Alphab
