*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CHLCHN (TBCHEN,NBCHEN,NBCCHN,NBCNEW) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1989)
* Derniere modification (D.Martin) le 6 Decembre 1996  
*  
* Changement de la longueur des sous-tableaux d'un tableau de caracteres :
* Transformation d'un tableau contenant des sous-tableaux de caracteres
* de longueur NBCCHN, en tableau de sous-tableaux de longueurs NBCNEW 
*  
*-- Arguments -- 
* TBCHEN tableau des sous-tableaux de caracteres de longueur NBCCHN en entree 
* NBCHEN nombre de sous-tableaux en entree
* NBCCHN longueur effective des sous-tableaux (=NBCNEW en sortie) 
* NBCNEW nouvelle longueur des sous-tableaux  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TBCHEN(*) 
      INTEGER   NBCHEN,NBCCHN,NBCNEW
*
      INTEGER   OLDPOS,NEWPOS,I,J
*-----------------------------------------------------------------------
      IF (NBCCHN.LT.NBCNEW) THEN
*        Si la nouvelle longueur est plus grande que l'actuelle,
*        les chaines du tableau sont completees de blancs a droite
         NEWPOS=1+NBCNEW*NBCHEN
         OLDPOS=NBCCHN*NBCHEN+1
         DO 3 I=NBCHEN,1,-1
            DO 1 J=NBCNEW,NBCCHN+1,-1  
               NEWPOS        =NEWPOS-1 
               TBCHEN(NEWPOS)=' ' 
1           CONTINUE
            DO 2 J=NBCCHN,1,-1 
               NEWPOS        =NEWPOS-1 
               OLDPOS        =OLDPOS-1 
               TBCHEN(NEWPOS)=TBCHEN(OLDPOS)
2           CONTINUE
3        CONTINUE
      ELSEIF (NBCCHN.GT.NBCNEW) THEN
*        Si le nouvelle longueur est inferieure a la longueur actuelle 
*        les caracteres en surnombre des chaines sont oublies
         NEWPOS=NBCNEW 
         OLDPOS=NBCCHN 
         DO 11 I=2,NBCHEN  
            DO 10 J=1,NBCNEW
               NEWPOS        =NEWPOS+1 
               OLDPOS        =OLDPOS+1 
               TBCHEN(NEWPOS)=TBCHEN(OLDPOS)
10          CONTINUE
            OLDPOS=OLDPOS+NBCCHN-NBCNEW
11        CONTINUE 
      ENDIF
      NBCCHN=NBCNEW
                                                                    END !Chlchn
