*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CHRONO (COMMEN,IMPPAL) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1989)
* Derniere modification : D.Martin (08 Mars 2002)
* Version 1.0.2
*
* Cette procedure fournit le temps en secondes ecoule entre deux appels
* et l'imprime sur l'unite IMPPAL precede du commentaire COMMEN. 
*
*-- Arguments d'entree --
* COMMEN commentaire imprime
* IMPPAL numero d'unite logique
*
*-- Procedure appelee --
* ctemps_ function C retournant le temps ecoule en secondes depuis
*         le 01/01/1970 00:00 TU a la microseconde pres.
*         Le resultat est reel double precision.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) COMMEN
      INTEGER       IMPPAL
*
      INTEGER          LASAPL
*     For memory alignement in case of -r8 compiler option
      REAL*8 NTIME,OTIME
      COMMON/LASAPL/LASAPL /CLOCK/OTIME
*-----------------------------------------------------------------------
      CALL CTEMPS (NTIME)
      IF (IMPPAL.GT.0.AND.LASAPL.GT.0) THEN
*
         WRITE (IMPPAL,10) REAL(NTIME-OTIME),COMMEN
*
      ENDIF
      OTIME=NTIME
      LASAPL=LASAPL+1
*-----------------------------------------------------------------------
10    FORMAT(T2,F8.2,'s.> ',A)
                                                                    END !Chrono
