*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INDASS (CHAINE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)  
* Derniere modification : D.Martin (3 mars 2000)
* Version # 1.0.1
*  
* Codage du type d'assemblage d'un terme par un entier
* Function reciproque ASSIND
*  
*-- Argument d'entree --  
* CHAINE chaine de caractere representant le type d'assemblage
*        1-COMPOSE
*        2-COMBINAISON
*        3-COPIE
*        4-SOMME
*        5-DIFFERENCE
*        6-MULTIPLICATION
*        7-MULTI-INCONNUE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE 
      INTEGER       INDASS
*
      INTEGER       NBCHEN,NBCCHN,LENMAX,KELCHN
      PARAMETER    (NBCHEN=7,NBCCHN=14)
      CHARACTER     CCCHEN*120,TBCHEN(NBCCHN*NBCHEN)
      COMMON/ONSEPA/CCCHEN 
      EQUIVALENCE  (TBCHEN,CCCHEN) 
*-----------------------------------------------------------------------
      LENMAX=MIN (NBCCHN,LEN (CHAINE))
      CCCHEN(1:NBCCHN*NBCHEN)='COMPOSE       COMBINAISON   COPIE       '
     &//'  SOMME         DIFFERENCE    MULTIPLICATIONMULTI-INCONNUE'
      INDASS=KELCHN (CHAINE(:LENMAX),TBCHEN,NBCHEN,NBCCHN)              !utilite
      IF (INDASS.EQ.0) INDASS=1  
                                                                    END !IndAss
