*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INDSYM (CHAINE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1992)  
* Derniere modification: D.Martin (28 Avril 2000)
* Version # 1.0.3
*  
* Codage du type de symetrie d'un terme par un entier
* Function reciproque Symind
*  
*-- Argument d'entree --  
* CHAINE chaine de caractere representant le type de symetrie  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE
      INTEGER       INDSYM
*
      INTEGER       LENMAX,NBCHEN,NBCCHN,KELCHN
      PARAMETER    (NBCHEN=5,NBCCHN=14)
      CHARACTER     CCCHEN*120,TBCHEN(NBCCHN*NBCHEN)
      COMMON/ONSEPA/CCCHEN 
      EQUIVALENCE  (TBCHEN,CCCHEN) 
*-----------------------------------------------------------------------
      LENMAX=MIN (NBCCHN,LEN (CHAINE))
* 
      CCCHEN(1:NBCCHN*NBCHEN)=
     &'ANTIADJOINTE  ANTISYMETRIQUESANS SYMETRIE SYMETRIQUE    '//
     &'AUTOADJOINTE  '
      IF (CHAINE(1:1).EQ.' ') THEN
         INDSYM=0
      ELSE
         INDSYM=KELCHN (CHAINE(1:LENMAX),TBCHEN,NBCHEN,NBCCHN)
         IF (INDSYM.EQ.0) THEN
            CCCHEN(1:NBCCHN*NBCHEN)=
     &'SKEWADJOINT   SKEWSYMMETRIC NO SYMMETRY   SYMMETRIC     '//
     &'SELFADJOINT   '
            INDSYM=KELCHN (CHAINE(1:LENMAX),TBCHEN,NBCHEN,NBCCHN)
         ENDIF
         INDSYM=INDSYM-3
      ENDIF
                                                                    END !IndSym
