*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LISUNI (NBLIST,LISTE,NBADJ,LISADJ,INDRCT,NUMAUT  
     &                  ,ORDLIS,NBLISX,*)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1989)  
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Adjonction dans une liste de nombres ordonnee,par recherche dichotomique
* d'une liste de nombres quelconque, ou d'une sous-liste redirigee par une
* table d'indirection .
*  
*-- Arguments --  
* NBLIST: Nombre de numeros de la liste ordonnee (reevalue en sortie)  
* LISTE : Liste ordonnee (valeurs modifiees en sortie) 
* NBADJ : Nombre de nombres dans la liste a adjoindre  
* INDRCT: Indice d'indirection des rang dans la liste a adjoindre  
* NUMAUT: Table d'indirection pour les nombres de la liste a adjoindre 
* ORDLIS: .TRUE. si la liste a adjoindre est ordonne strictement
* LISADJ: liste a adjoindre
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL INDRCT,ORDLIS
      INTEGER NBLIST,LISTE(*),NBADJ,LISADJ(*),NUMAUT(*),NBLISX
*
      INTEGER NDEB,INEL,INELOC,INEGLO,IRANG,IRIPE,IR
*-----------------------------------------------------------------------
      NDEB=1
      IF (INDRCT) THEN  
         DO 5 INEL=1,NBADJ 
            INELOC=NUMAUT(INEL)
            INEGLO=LISADJ(INELOC)  
*  
*           Recherche dichotomique parmi les numeros deja rencontres
*  
            CALL DICOTO (NDEB,NBLIST,LISTE,INEGLO,IRANG,*2)             !Utilite
*           Succes dans la recherche : le numero est deja present  
            GOTO 5
*           Echec dans la recherche : insertion du nouveau numero  
2           IF (NBLIST.GE.NBLISX) RETURN 1  
            DO 3 IRIPE=NBLIST,IRANG,-1 
               IR=IRIPE+1  
3              LISTE(IR)=LISTE(IRIPE)  
            NBLIST=NBLIST+1
            LISTE(IRANG)=INEGLO
5           IF (ORDLIS) NDEB=IRANG+1
*  
      ELSE 
*  
         DO 15 INEL=1,NBADJ
            INEGLO=LISADJ(INEL)
*  
*           Recherche dichotomique parmi les numeros deja rencontres
*  
            CALL DICOTO (NDEB,NBLIST,LISTE,INEGLO,IRANG,*12)            !Utilite
*           Succes dans la recherche : le numero est deja present  
            GOTO 15
*           Echec dans la recherche : insertion du nouveau numero  
12          IF (NBLIST.GE.NBLISX) RETURN 1  
            DO 13 IRIPE=NBLIST,IRANG,-1
               IR=IRIPE+1  
13             LISTE(IR)=LISTE(IRIPE)  
            NBLIST=NBLIST+1
            LISTE(IRANG)=INEGLO
15          IF (ORDLIS) NDEB=IRANG+1
      ENDIF
*  
                                                                    END !LisUni
