*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OSIOPN (OSARCH,IUNIT,NOMFIC,ETAT,ACCES,LRECL,IMPERR)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin, O.deBayser (1988)
* Derniere modification : D.Martin (19 Decembre 2001)
* Version 1.0.2
*  
* Ouverture d'un fichier a acces direct
*  
*-- Arguments d'entree --
* OSARCH chaine de caractere definissant l'OS / architecture
* IUNIT  numero d'unite logique 
* NOMFIC nom du fichier 
* ETAT   chaine pour la clause 'STATUS' 
* ACCES  chaine pour la clause 'ACCESS' 
* LRECL  longueur d'enregistrement
* IMPERR unite logique d'impression des messages d'erreurs  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) OSARCH,NOMFIC,ETAT,ACCES
      INTEGER       IUNIT,LRECL,IMPERR
*-----------------------------------------------------------------------
      IF (ACCES(1:1).NE.'D')
     &   CALL BAISE  ('*Isiopn* fichier a acces DIRECT seulement.')
*
      IF (OSARCH(1:4).EQ.'IRIX') THEN
*
*        Version Silicon Graphics (IRIX & IRIX64)
*
         MURECL = 1
*
      ELSE
*
*--   Version Darwin (Mac OS X), Linux, SunOS, OSF (DEC alpha), AIX (Ibm)
*
         MURECL = 4
*
      ENDIF
*
      OPEN  (IUNIT,FILE=NOMFIC,STATUS=ETAT,ACCESS=ACCES
     &      ,RECL=MURECL*LRECL,ERR=900)
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
900   CALL BAISE ('*OsIoPn* Ouverture a l''ouverture d''un fichier'
     &          //' a acces direct')
                                                                    END !OsIoPn
