*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PUTCHN (TBCHEN,NBCHEN,NBCCHN,NUCHEN,CHAINE)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)  
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Implantation d'une chaine de caracteres dans un tableau de tableaux  
* de caracteres en tant que NUCHEN-eme tableau.
*  --> Attention si la chaine est plus longue que les sous-tableaux seuls  
*      les NBCCHN premiers caracteres de la chaine sont implantes ; si elle 
*      est plus courte elle est completee de caracteres blancs. 
*  
*-- Arguments --  
* TBCHEN tableau des sous-tableaux
* NBCHEN nombre de sous-tableaux (i.e. de chaines deja presentes) 
* NBCCHN nombre de caracteres des sous-tableaux du tableau
* NUCHEN rang ou implanter la chaine  
* CHAINE chaine a implanter
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TBCHEN(*),CHAINE*(*)
      INTEGER   NBCHEN,NBCCHN,NUCHEN
*
      INTEGER   ITEM,ITOUIL,JTEM
*-----------------------------------------------------------------------
      DO 1 ITEM=NBCCHN*(NBCHEN+1),NUCHEN*NBCCHN+1,-1
         TBCHEN(ITEM)=TBCHEN(ITEM-NBCCHN)
1     CONTINUE
      ITOUIL=NBCCHN*(NUCHEN-1) 
      DO 2 ITEM=1,MIN(NBCCHN,LEN(CHAINE))  
         TBCHEN(ITOUIL+ITEM)=CHAINE(ITEM:ITEM)
2     CONTINUE
      DO 3 JTEM=ITEM,NBCCHN
         TBCHEN(ITOUIL+JTEM)=' ' 
3     CONTINUE 
      NBCHEN=NBCHEN+1  
                                                                    END !Putchn
