*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RIPCHN (TBCHEN,NBCHEN,NBCCHN,CHAINE) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur D.Martin (Janvier 1989) 
* Derniere modification (D.Martin) le 6 decembre 1996  
*  
* Ajouter d'un sous-tableau a la fin du tableau TBCHEN contenant des sous 
* tableaux de longueur NBCCHN, en modifiant la longueur des sous-tableaux
* presents si la longueur du sous-tableau a rajouter est superieure a
* celle des chaines deja presentes (NBCCHN) .
*  
*-- Arguments (tous modifiables) --
* TBCHEN: tableau des sous-tableaux de caracteres de longueur NBCCHN en entree 
* NBCHEN: nombre de sous-tableaux en entree (+1 en sortie) 
* NBCCHN: longueur des sous-tableaux en entree= MAX(NBCCHN,LEN(CHAINE))en sortie
* CHAINE: chaine de caracteres a rajouter, devient le dernier sous-tableau 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TBCHEN(*),CHAINE*(*)
      INTEGER   NBCHEN,NBCCHN
*
      INTEGER   NBWCAR
*
      NBWCAR=LEN (CHAINE)
*
*     Si la longueur de la chaine a rajouter est superieure a la longueur  
*     des sous-tableaux presents dans le tableau, ces sous-tableaux sont
*     sont completes de caracteres blancs a droite a concurrence de la 
*     nouvelle longueur (ceci implique evidement une translation des sous- 
*     tableaux du tableau) 
*  
      IF (NBCCHN.LT.NBWCAR) CALL CHLCHN (TBCHEN,NBCHEN,NBCCHN,NBWCAR)   !Utilite
*  
*     Introduction de la nouvelle chaine
*  
      CALL PUTCHN (TBCHEN,NBCHEN,NBCCHN,NBCHEN+1,CHAINE)                !Utilite
                                                                    END !Ripchn
