*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TABDST (NBCOEF,TYP1,MC1,RST1,CST1,MC2,RST2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Juin 1993)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recopie la valeur absolue d'un terme (reel ou complexe) dans un autre
*  
*-- Arguments --
* NBCOEF: nombre de coefficients a recopier
* TYP1  : type du tableau a recopier ('ENTIER','REEL','COMPLEXE')  
* MC1   : adresse dans le tableau RST1 ou CST1 du tableau a recopier  
* RST1,CST1: tab. contenant le tab. a recopier(cas reel,complexe)  
* MC2,RST2: idem pour le tab. cible 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1
      INTEGER       NBCOEF,MC1,MC2
      REAL          RST1(*),RST2(*)
      COMPLEX       CST1(*)
*
      INTEGER       MCT2,I
* ----------------------------------------------------------------------
      IF (TYP1(1:2).EQ.'CA')
     &CALL BAISE ('*TabdsT non prevu pour les tableaux de caracteres')  !Utilite
      IF (TYP1(1:1).EQ.'E')
     &CALL BAISE ('*TabdsT non prevu pour les tableaux d''entiers')     !Utilite
*
      MCT2=MC2
      IF (TYP1(1:1).EQ.'R') THEN
         DO 22 I=MC1,MC1-1+NBCOEF
            RST2(MCT2)=ABS(RST1(I))  
            MCT2=MCT2+1
22       CONTINUE 
      ELSEIF (TYP1(1:1).EQ.'C') THEN
         DO 44 I=MC1,MC1-1+NBCOEF
            RST2(MCT2)=ABS(CST1(I))  
            MCT2=MCT2+1
44       CONTINUE 
      ELSE  
         CALL BAISE  ('*Tabdst* Type de tableau non reconnu')           !Utilite
      ENDIF
                                                                    END !TabdsT
