*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TAZERO (NBC,TYPT,MCT,ASTT,ISTT,RSTT,CSTT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mai 1990)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Mise a zero ou a blanc d'un tableau
*  
*-- Arguments --
* NBC   nombre de coefficients a mettre a zero  
* TYPT  type du tab. a mettre a zero ('ENTIER','REEL','COMPLEXE','CARACTERE')
* MCT   Adresse du tableau dans le tableau du bon type
* ASTT  tableau contenant le tableau a mettre a blanc (cas caractere)
* ISTT  tableau contenant le tableau a mettre a zero (cas entier)
* RSTT  tableau contenant le tableau a mettre a zero (cas reel)  
* CSTT  tableau contenant le tableau a mettre a zero (cas complexe)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     ASTT(*),TYPT*(*)
      INTEGER       NBC,MCT,ISTT(*)
      REAL          RSTT(*)
      COMPLEX       CSTT(*)
*
      INTEGER       I
*-----------------------------------------------------------------------
      IF (TYPT(1:2).EQ.'CA') THEN
         DO 10 I=MCT,MCT-1+NBC
            ASTT(I)=' '
10       CONTINUE
      ELSEIF (TYPT(1:1).EQ.'E') THEN
         DO 1 I=MCT,MCT-1+NBC
            ISTT(I)=0
1        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         DO 2 I=MCT,MCT-1+NBC
            RSTT(I)=0.
2        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'C') THEN
         DO 4 I=MCT,MCT-1+NBC
            CSTT(I)=0.
4        CONTINUE
      ELSE 
         CALL BAISE  ('*TaZero* Type de tableau non reconnu')           !Utilite
      ENDIF
                                                                    END !TaZero
