*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TINIT (TYPC,MCC,ASTC,ISTC,RSTC,CSTC
     &                 ,NBC,TYPT,MCT,ASTT,ISTT,RSTT,CSTT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Novembre 91)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Creation d'un tableau constant, i.e. rempli a l'aide d'une valeur constante
*  
*-- Arguments --
* TYPC   type de la constante ('ENTIER','REEL','COMPLEXE','CARACTERE')
* MCC    Adresse de la constante dans le tableau du bon type
* ASTC,ISTC,RSTC,CSTC tab. contenant la cste CARACTERE,ENTIERE,REEL,COMPLEXE
* NBC    nombre de coefficients a remplir  
* TYPT   type du tab. a mettre a zero ('ENTIER','REEL','COMPLEXE','CARACTERE')
* MCT    Adresse du tableau dans le tableau du bon type
* ASTT,ISTT,RSTT,CSTT tab. contenant le tab. CARACTERE,ENTIERE,REEL,COMPLEXE  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     ASTC(*),TYPC*(*),ASTT(*),TYPT*(*)
      INTEGER       MCC,NBC,ISTC(*),ISTT(*)
      REAL          RSTC(*),RSTT(*)
      COMPLEX       CSTC(*),CSTT(*)
*
      INTEGER       MCT,I
*-----------------------------------------------------------------------
      IF (TYPT(1:2).EQ.'CA') THEN
         IF (TYPC(1:2).EQ.'CA') THEN
            DO 10 I=MCT,MCT-1+NBC 
10             ASTT(I)=ASTC(MCC)
         ELSE
            GOTO 90010
         ENDIF
      ELSEIF (TYPT(1:1).EQ.'E') THEN
         IF (TYPC(1:2).EQ.'CA') THEN
            GOTO 90011
         ELSEIF (TYPC(1:1).EQ.'E') THEN
            DO 11 I=MCT,MCT-1+NBC  
11             ISTT(I)=ISTC(MCC)
         ELSEIF (TYPC(1:1).EQ.'R') THEN
            DO 12 I=MCT,MCT-1+NBC  
12             ISTT(I)=RSTC(MCC)
         ELSEIF (TYPC(1:1).EQ.'C') THEN
            DO 14 I=MCT,MCT-1+NBC  
14            ISTT(I)=REAL(CSTC(MCC))
         ELSE
            GOTO 90020
         ENDIF  
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         IF (TYPC(1:2).EQ.'CA') THEN
            GOTO 90012
         ELSEIF (TYPC(1:1).EQ.'R') THEN
            DO 22 I=MCT,MCT-1+NBC  
22             RSTT(I)=RSTC(MCC)
         ELSEIF (TYPC(1:1).EQ.'C') THEN
            DO 24 I=MCT,MCT-1+NBC  
24             RSTT(I)=REAL(CSTC(MCC))
         ELSEIF (TYPC(1:1).EQ.'E') THEN
            DO 21 I=MCT,MCT-1+NBC  
21             RSTT(I)=ISTC(MCC)
         ELSE
            GOTO 90020
         ENDIF
      ELSEIF (TYPT(1:1).EQ.'C') THEN
         IF (TYPC(1:2).EQ.'CA') THEN
            GOTO 90014
         ELSEIF (TYPC(1:1).EQ.'C') THEN
            DO 44 I=MCT,MCT-1+NBC  
44             CSTT(I)=CSTC(MCC)
         ELSEIF (TYPC(1:1).EQ.'R') THEN
            DO 42 I=MCT,MCT-1+NBC  
42             CSTT(I)=RSTC(MCC)
         ELSEIF (TYPC(1:1).EQ.'E') THEN
            DO 41 I=MCT,MCT-1+NBC  
41             CSTT(I)=ISTC(MCC)
         ELSE
            GOTO 90020
         ENDIF
      ELSE 
         GOTO 90030
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90010 CALL BAISE  (' *TInit * Tableau de type CARACTERE et type de la'
     &//' constante incompatibles')                                     !Utilite
90011 CALL BAISE  (' *TInit * Type de tableau ENTIER et type CARACTERE'
     &//' de la constante d''initialisation incompatibles')             !Utilite
90012 CALL BAISE  (' *TInit * Type de tableau REEL et type CARACTERE'
     &//' de la constante d''initialisation incompatibles')             !Utilite
90014 CALL BAISE  (' *TInit * Type de tableau COMPLEXE et type'
     &//' CARACTERE de la constante d''initialisation incompatibles')   !Utilite
90020 CALL BAISE  (' *TInit * Constante de type non reconnu')           !Utilite
90030 CALL BAISE  (' *TInit * Type de tableau non reconnu')             !Utilite
                                                                    END !TInit
