*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TMAXVA (NBC,TYPT,MCT,IST,RST,CST
     &                  ,KLADRS,VALMXI,VALMXR,VALMXC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Novembre 1991)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recherche de la valeur maximale dans un tableau  
*  
*-- Arguments d'entree --
* NBC   : nombre de coefficients du tableau
* TYPT  : type du tableau ('REEL','COMPLEXE')  
* MCT   : adresse du tableau dans le tableau du bon type
* IST   : super-tableau contenant le tableau a l'adresse MCT (cas entier) 
* RST   : super-tableau contenant le tableau a l'adresse MCT (cas reel) 
* CST   : super-tableau contenant le tableau a l'adresse MCT (cas complexe)
*-- Arguments de sortie -- 
* KLADRS: adresse contenant le coeff. maximum
* VALMXI: coefficient maximum pour un tableau entier
* VALMXR: coefficient maximum pour un tableau reel
* VALMXC: coefficient maximum pour un tableau complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPT*(*)
      INTEGER   NBC,MCT,IST(*),KLADRS,VALMXI
      REAL      RST(*),VALMXR,MAXIMU 
      COMPLEX   CST(*),VALMXC 
*
      INTEGER   I 
*-----------------------------------------------------------------------
      VALMXI=0
      VALMXR=0.
      VALMXC=0.
      MAXIMU=0.
      KLADRS=MCT
      IF (TYPT(1:1).EQ.'E') THEN
         DO 1 I=MCT,MCT-1+NBC  
            IF (ABS (IST(I)).GT.MAXIMU) THEN
               KLADRS=I
               VALMXI=IST(I)
               MAXIMU=ABS (VALMXI)
            ENDIF
1        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         DO 2 I=MCT,MCT-1+NBC  
            IF (ABS (RST(I)).GT.MAXIMU) THEN
               KLADRS=I
               VALMXR=RST(I)
               MAXIMU=ABS (VALMXR)
            ENDIF
2        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'C') THEN  
         DO 4 I=MCT,MCT-1+NBC  
            IF (ABS (CST(I)).GT.MAXIMU) THEN
               KLADRS=I
               VALMXC=CST(I)
               MAXIMU=ABS (VALMXC)
            ENDIF
4        CONTINUE 
      ENDIF
      KLADRS=KLADRS-MCT+1
                                                                    END !TMaxVa
