*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TMDANT (NBC,TYP1,MC1,RST1,CST1
     &                      ,TYP2,MC2,RST2,CST2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Novembre 91)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Report de l'oppose d'un tableau de type quelconque dans un autre 
*  
*-- Arguments --  
* NBC    nombre de coefficients a reporter
* TYP1   type du tableau a reporter ('REEL','COMPLEXE')
* MC1    adresse du tab. a reporter dans le tab. reel RST1 ou complexe CST1
* RST1   tableau contenant le tableau a reporter (cas reel)
* CST1   tableau contenant le tableau a reporter (cas complexe)
* TYP2   type du tableau cible
* MC2    adresse du tab. cible dans le tab. reel RST1 ou complexe CST1
* RST2   tableau contenant le tableau cible (cas reel)
* CST2   tableau contenant le tableau cible (cas complexe)
*  
*-- Exemples d'utilisation dans le Source de TDANST
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2 
      INTEGER       NBC,MC1,MC2 
      REAL          RST1(*),RST2(*) 
      COMPLEX       CST1(*),CST2(*) 
*
      INTEGER       MCT2,I 
*-----------------------------------------------------------------------
      MCT2=MC2 
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN  
         IF (TYP1(1:1).EQ.'R') THEN 
*  
            DO 1 I=MC1,MC1-1+NBC
               RST2(MCT2)=-RST1(I)  
               MCT2=MCT2+1 
1           CONTINUE
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 2 I=MC1,MC1-1+NBC
               CST2(MCT2)=-CST1(I)
               MCT2=MCT2+1
2           CONTINUE
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         DO 3 I=MC1,MC1-1+NBC
            CST2(MCT2)=-RST1(I) 
            MCT2=MCT2+1
3        CONTINUE
      ELSE 
         DO 4 I=MC1,MC1-1+NBC
            RST2(MCT2)=-REAL(CST1(I))  
            MCT2=MCT2+1
4        CONTINUE
      ENDIF
                                                                    END !TMDanT
