*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TMINVA (NBC,TYPT,MCT,IST,RST,CST
     &                  ,KLADRS,VALMII,VALMIR,VALMIC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* AuteurS: F.Mahe & D.Martin (Janvier 1997)
* Derniere modification (F.Mahe & D.Martin) le 7 fevrier 1997
*  
* Recherche de l'adresse et de la valeur du coefficient de module
* minimal dans un tableau.
*  
*-- Arguments d'entree --
* NBC   : nombre de coefficients du tableau
* TYPT  : type du tableau ('REEL','COMPLEXE')  
* MCT   : adresse du tableau dans le tableau du bon type
* IST   : super-tableau contenant le tableau a l'adresse MCT (cas entier) 
* RST   : super-tableau contenant le tableau a l'adresse MCT (cas reel) 
* CST   : super-tableau contenant le tableau a l'adresse MCT (cas complexe)
*-- Arguments de sortie -- 
* KLADRS: adresse contenant le coeff. de module minimal
* VALMII: coefficient de module minimal pour un tableau entier
* VALMIR: coefficient de module minimal pour un tableau reel
* VALMIC: coefficient de module minimal pour un tableau complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPT*(*)
      INTEGER   NBC,MCT,IST(*),KLADRS,VALMII
      REAL      RST(*),VALMIR,MINIMU 
      COMPLEX   CST(*),VALMIC 
*
      INTEGER   I 
*-----------------------------------------------------------------------
      VALMII=0
      VALMIR=0.
      VALMIC=0.
      KLADRS=MCT
      IF (TYPT(1:1).EQ.'E') THEN
         VALMII=IST(MCT)
         MINIMU=ABS (VALMII)
         DO 1 I=MCT+1,MCT-1+NBC  
            IF (ABS (IST(I)).LT.MINIMU) THEN
               KLADRS=I
               VALMII=IST(I)
               MINIMU=ABS (VALMII)
            ENDIF
1        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         VALMIR=RST(MCT)
         MINIMU=ABS (VALMIR)
         DO 2 I=MCT+1,MCT-1+NBC  
            IF (ABS (RST(I)).LT.MINIMU) THEN
               KLADRS=I
               VALMIR=RST(I)
               MINIMU=ABS (VALMIR)
            ENDIF
2        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'C') THEN
         VALMIC=CST(MCT)
         MINIMU=ABS (VALMIC) 
         DO 4 I=MCT+1,MCT-1+NBC  
            IF (ABS (CST(I)).LT.MINIMU) THEN
               KLADRS=I
               VALMIC=CST(I)
               MINIMU=ABS (VALMIC)
            ENDIF
4        CONTINUE 
      ENDIF
      KLADRS=KLADRS-MCT+1
                                                                    END !TMinVa
