*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTDAT (NBC,TYP1,MC1,IST1,RST1,CST1,PTR122
     &                      ,TYP2,MC2,IST2,RST2,CST2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Mars 1993)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recopie d'un tableau de type scalaire (entier,reel ou complexe) dans un autre
*  
*-- Arguments -- 
* NBC    nombre de coefficients a recopier
* TYP1   type du tableau a recopier ('ENTIER','REEL','COMPLEXE')  
* MC1    adresse dans le tableau IST1,RST1 ou CST1 du tableau a recopier  
* IST1,RST1,CST1 tab. contenant le tab. a recopier(cas entier,reel,complexe)
* PTR122 tableau des addresses des coefficients de 1 dans 2
* TYP2,MC2,IST2,RST2,CST2 idem pour le tab. cible 
*
* voir exemples d'utilisation dans le source de TDANST
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1   ,TYP2
      INTEGER       NBC,MC1,MC2,IST1(*),IST2(*),PTR122(*)
      REAL          RST1(*),RST2(*)
      COMPLEX       CST1(*),CST2(*)
*
      INTEGER       MCT1,MCT2,I
*-----------------------------------------------------------------------
      MCT1=MC1
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN  
         IF (TYP1(1:1).EQ.'E') THEN 
            DO 11 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               IST2(MCT2)=IST1(MCT1)  
11             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'R') THEN
            DO 22 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=RST1(MCT1)  
22             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 33 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=CST1(MCT1)  
33             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*Tptdat* Type de tableau non reconnu')        !Utilite
         ENDIF
*  
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         IF (TYP1(1:1).EQ.'R') THEN 
            DO 44 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=RST1(MCT1)
44             MCT1=MCT1+1  
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 55 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=IST1(MCT1)  
55             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*TptdaT'//
     &           'Tab. 2 complexe incompatible avec le type du tab. 1') !Utilite
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'R') THEN
         IF (TYP1(1:1).EQ.'C') THEN 
            DO 66 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=REAL(CST1(MCT1))  
66             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 77 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=IST1(MCT1)  
77             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*TptdaT'//
     &               'Tab. 2 reel incompatible avec le type du tab. 1') !Utilite
         ENDIF
      ELSE 
         CALL BAISE
     &         ('*TptdaT* Incompatibilite entre les types de tableaux') !Utilite
      ENDIF
                                                                    END !TptdaT
