*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTPAT (TYPC,MCC,NBC,TYP1,MC1,PTR122
     &                               ,TYP2,MC2,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 92)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Assemblage de tableaux sous la forme 2 = 2 + c.1 connaissant le tableau
* des adresses des coefficients de 1 dans 2.
*  
*-- Arguments --
* TYPC   type de declaration de la constante multiplicative si OPER='*'
* MCC    adresse de la constante dans le tableau RST ou CST selon son type
* NBC    longueur du tableau 1
* TYP1   type de declaration du tableau a assembler (1)
* MC1    adresse du tableau a assembler dans le tableau RST ou CST
* PTR122 tableau des addresses des coefficients de B dans 2
* TYP2   type de declaration du tableau resultat (2)
* MC2    adresse du tableau resultat dans le tableau RST ou CST selon son type
* IST    tableau contenant les arguments entiers (pour la constante) 
* RST    tableau contenant les arguments reels
* CST    tableau contenant les arguments complexes 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPC,TYP1,TYP2
      INTEGER       NBC,MC1,MC2,PTR122(*),IST(*)
      REAL          RST(*),RCSTE
      COMPLEX       CST(*),CCSTE
      EQUIVALENCE  (CCSTE,RCSTE)
*
      INTEGER       MCC,MCT1,MCT2,I
*-----------------------------------------------------------------------
      MCT1=MC1
*
      IF (TYPC(1:1).EQ.'C') THEN
*        Cas d'une constante c complexe ==> resultat complexe
         CCSTE=CST(MCC)
         IF (TYP1(1:1).EQ.'C') THEN
            DO 444 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST(MCT2)=CST(MCT2)+CCSTE*CST(MCT1)
               MCT1=MCT1+1
444         CONTINUE
         ELSE
            DO 442 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST(MCT2)=CST(MCT2)+CCSTE*RST(MCT1)
               MCT1=MCT1+1
442         CONTINUE
         ENDIF
      ELSE
*        Cas d'une constante c reelle ou entiere
         IF (TYPC(1:1).EQ.'R') THEN
            RCSTE=RST(MCC)
         ELSEIF (TYPC(1:1).EQ.'E') THEN
            RCSTE=IST(MCC)
         ENDIF
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP2(1:1).EQ.'R') THEN
               DO 222 I=1,NBC
                  MCT2=MC2-1+PTR122(I)
                  RST(MCT2)=RST(MCT2)+RCSTE*RST(MCT1)
                  MCT1=MCT1+1
222            CONTINUE
            ELSE
               DO 424 I=1,NBC
                  MCT2=MC2-1+PTR122(I)
                  CST(MCT2)=CST(MCT2)+RCSTE*CST(MCT1)
                  MCT1=MCT1+1
424            CONTINUE
            ENDIF
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 422 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST(MCT2)=CST(MCT2)+RCSTE*RST(MCT1)
               MCT1=MCT1+1
422         CONTINUE
         ENDIF 
      ENDIF
                                                                    END !TptPat
