*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTPLT (NBC,TYP1,MC1,PTR122,TYP2,MC2,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification: D.Martin (6 Decembre 1996)
* Version 1
*  
* Assemblage de tableaux sous la forme T2 = T2 + T1 connaissant le tableau
* des pointeurs de coeficients de T1 dans T2.
*  
*-- Arguments --
* NBC    longueur du tableau T1
* TYP1   type de declaration du tableau a assembler (T1)
* MC1    adresse du tableau a assembler dans le tableau RST ou CST
* PTR122 tableau des addresses des coefficients de T1 dans T2
* TYP2   type de declaration du tableau resultat (T2)
* MC2    adresse du tableau resultat (T2) dans le tableau RST ou CST
* IST    super tableau version entiere (pour la constante) 
* RST    super tableau version reelle
* CST    super tableau version complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2
      INTEGER       NBC,MC1,MC2,PTR122(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCT1,MCT2,I
*-----------------------------------------------------------------------
      MCT1=MC1
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
         IF (TYP2(1:1).EQ.'R') THEN
            DO 202 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST(MCT2)=RST(MCT2)+RST(MCT1)
               MCT1=MCT1+1
202         CONTINUE
         ELSE
            DO 404 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST(MCT2)=CST(MCT2)+CST(MCT1)
               MCT1=MCT1+1
404         CONTINUE
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         DO 402 I=1,NBC
            MCT2=MC2-1+PTR122(I)
            CST(MCT2)=CST(MCT2)+RST(MCT1)
            MCT1=MCT1+1
402      CONTINUE
      ENDIF
                                                                    END !TptPlt
