*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRI1TB (N,M,IST1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1999)
* Derniere modification : D.Martin (30 Juin 2000)
* Version 1.0.1
*
* Tri a bulle du tableau d'entier IST1 selon l'ordre croissant des elements
* de sa premiere colonne
*
*-- Arguments --
* N    nombre de lignes du tableau IST1
* M    nombre de colonnes du tableau IST1
* IST1 tableau d'entier a trier selon l'ordre croissant
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER N,M
      INTEGER IST1(M,*)
*
      INTEGER I,J,K,IAUX1
      LOGICAL PERMUT
*-----------------------------------------------------------------------
      I=0
11    PERMUT=.FALSE.
      I=I+1
      DO 12 J=N-1,I,-1
        IF (IST1(1,J+1).LT.IST1(1,J)) THEN
          PERMUT=.TRUE.
          DO 13 K=1,M
             IAUX1      =IST1(K,J)
             IST1(K,J)  =IST1(K,J+1)
             IST1(K,J+1)=IAUX1
13        CONTINUE
        ENDIF
12    CONTINUE
      IF (PERMUT) GOTO 11
                                                                    END !Tri1Tb
