*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TSNADT (NBC,TYP1,MC1,IST1,RST1,CST1
     &                      ,TYP2,MC2,IST2,RST2,CST2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Aout 1990)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recopie d'un tableau de type scalaire (entier,reel ou complexe) dans un autre
* en commencant par la fin 
*  
*-- Arguments -- 
* NBC    nombre de coefficients a recopier
* TYP1   type du tableau a recopier ('ENTIER','REEL','COMPLEXE')  
* MC1    adresse dans le tableau IST1,RST1 ou CST1 du tableau a recopier  
* IST1,RST1,CST1 tab. contenant le tab. a recopier(cas entier,reel,complexe)  
* TYP2,MC2,IST2,RST2,CST2 idem pour le tab. cible 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1    ,TYP2  
      INTEGER       NBC,MC1,MC2,IST1(*),IST2(*)
      REAL          RST1(*),RST2(*)
      COMPLEX       CST1(*),CST2(*)
*
      INTEGER       MCT2,I
*-----------------------------------------------------------------------
      IF (TYP1(1:2).EQ.'CA'.OR.TYP2(1:2).EQ.'CA')
     &CALL BAISE ('*TsnadT non prevu pour les tableaux de caracteres')  !Utilite
      MCT2=MC2+NBC-1
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN  
         IF (TYP1(1:1).EQ.'E') THEN 
            DO 11 I=MC1-1+NBC,MC1,-1
               IST2(MCT2)=IST1(I)  
11             MCT2=MCT2-1 
         ELSEIF (TYP1(1:1).EQ.'R') THEN
            DO 22 I=MC1-1+NBC,MC1,-1
               RST2(MCT2)=RST1(I)  
22             MCT2=MCT2-1 
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 44 I=MC1-1+NBC,MC1,-1
               CST2(MCT2)=CST1(I)  
44             MCT2=MCT2-1 
         ELSE  
            CALL BAISE  ('*TsnadT* Type de tableau non reconnu')        !Utilite
         ENDIF
*  
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         IF (TYP1(1:1).EQ.'R') THEN 
           DO 24 I=MC1-1+NBC,MC1,-1 
              CST2(MCT2)=RST1(I)
24            MCT2=MCT2-1  
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 14 I=MC1-1+NBC,MC1,-1
               CST2(MCT2)=IST1(I)  
14             MCT2=MCT2-1 
         ELSE  
            CALL BAISE  ('*TsnadT'//
     &           'Tab. 2 complexe incompatible avec le type du tab. 1') !Utilite
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'R') THEN
         IF (TYP1(1:1).EQ.'C') THEN 
            DO 42 I=MC1-1+NBC,MC1,-1
               RST2(MCT2)=REAL(CST1(I))  
42             MCT2=MCT2-1 
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 12 I=MC1-1+NBC,MC1,-1
               RST2(MCT2)=IST1(I)  
12             MCT2=MCT2-1 
         ELSE  
            CALL BAISE  ('*TsnadT'//
     &           'Tab. 2 reel incompatible avec le type du tab. 1')     !Utilite
         ENDIF
      ELSE 
         CALL BAISE
     &         ('*TsnadT* Incompatibilite entre les types de tableaux') !Utilite
      ENDIF
                                                                    END !TSnadT
