*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION VANOIN (INDICE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998)  
* Derniere modification : D.Martin (3 Mars 2000)
* Version # 1.0.1
*  
* Retrouve le type de calcul d'un terme 'Valeurs Nodales' d'apres le code entier
* Function reciproque InVano
*  
*-- Argument d'entree --  
* INDICE entier representant le type d'assemblage d'apres InVano
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) VANOIN
      INTEGER       INDICE 
*
      INTEGER       NBCHEN,NBCCHN
      PARAMETER    (NBCHEN=12,NBCCHN=7)
      CHARACTER*7   CCCHEN*120,TBCHEN(NBCHEN)
      COMMON/ONSEPA/CCCHEN
      EQUIVALENCE  (CCCHEN,TBCHEN)
*-----------------------------------------------------------------------
      CCCHEN(1:NBCCHN*NBCHEN)='F      F.N    F^N    N^F    DF/DN  '
     & //'TABF   NF     N^(N^F)N(N.F) N1F    N2F    N3F    '
*
      IF (INDICE.LE.NBCHEN) THEN
         VANOIN=TBCHEN(INDICE)
      ELSE
         CALL ENCLER (INDICE,TBCHEN(1))                                 !utilite
         CALL BAISE  (' *VanoIn* Code entier de type Valeurs Nodales'
     &//' fantaisiste :'//TBCHEN(1)//'.')
      ENDIF
                                                                    END !VanoIn
