      FUNCTION CHOSOU (NBBUTN,XBUTON,YBUTON,NUMREP,NBFEN,ACTIFS,FENMEN)

C- Fonction : Choix a la souris. Ya qu'a cliquer sur le mulot :-)
C-
C- Entree :
C-    NBBUTN Nombre de boutons du menu
C-    XBUTON,YBUTON :  Coordonnees X et Y des boutons
C-    NUMREP : Type de representation
C-    NBFEN : Nombre de fenetres
C-    ACTIFS : Choix actifs ou non  
C-    FENMEN : Unite PGPLOT associe a la fenetre de menu
C-
C- Sortie : -
C-
C- Local :
C-    IBIDON  : Variable bidon pour fonctions PGPLOT
C-    PGCURS : Lit la position de la souris
C-    XSOURI,YSOURI : Coordonnnes de la souris
C-    XMIN,XMAX,YMIN,YMAX : Zone de lecture de la souris
C-    CSOURI : Bouton de la souris 
C-
C- Derniere modif : 17 JAN 2003

      INTEGER CHOSOU,NBBUTN,NUMREP,NBFEN,FENMEN,IBIDON,PGCURS,I
      LOGICAL ACTIFS(*)
      REAL XBUTON(*),YBUTON(*),XSOURI,YSOURI,XMIN,XMAX,YMIN,YMAX
      CHARACTER CSOURI

C- Rappel : le bouton gauche renvoie 'A', le milieu 'D' et le droit 'X'

      CALL PGSLCT (FENMEN)
C- On eteint les boutons
C- On ecrit en gris les inactifs
      DO 10 I=1,NBBUTN
         CALL PGSCI (3)
         IF (ACTIFS(I)) CALL PGSCI (1)
10    CALL PGCIRC (XBUTON(I),YBUTON(I),0.32)

C- On passe en rouge pour la suite
      CALL PGSCI (2)

C- On recrit en rouge le bouton correspondant a NUMREP
C- sauf en multi-fenetrage 
      IF (NBFEN.EQ.1) 
     &   CALL PGCIRC (XBUTON(NUMREP),YBUTON(NUMREP),0.26)

C- On choisit un bouton
20    IBIDON=PGCURS(XSOURI,YSOURI,CSOURI)
C-    Sortie de secours
      IF (CSOURI.EQ.'X') STOP
      DO 30 I=1,NBBUTN
         XMIN=XBUTON(I)-0.35
         XMAX=XBUTON(I)+0.35
         YMIN=YBUTON(I)-0.35
         YMAX=YBUTON(I)+0.35
         IF (XSOURI.GE.XMIN.AND.XSOURI.LE.XMAX.AND.
     &       YSOURI.GE.YMIN.AND.YSOURI.LE.YMAX.AND.ACTIFS(I)) THEN
            CHOSOU=I
C- On allume le bouton choisit
            CALL PGCIRC (XBUTON(I),YBUTON(I),0.26)
            RETURN
         ENDIF   
30    CONTINUE
      GOTO 20

      END
