      SUBROUTINE CNMSOR (FICHRE,ENTREE,PS,NOMSOR,LONNOM)


C- Fonction : Creer le nom de sortie a partir du nom de fichier resultat
C-            On recupere les indices de debut et de fin pour affichage
C-
C- Entree :
C-    FICHRE : Nom du(es) fichier(s) de resultats
C-    ENTREE : Repertoire contenant les fichiers de donnees
C-    PS     : Format du fichier de sortie (GIF ou PostScript) 
C-
C- Sortie : 
C-    NOMSOR : Nom du fichier de sortie

C-
C- Local :
C-    LONENT : Longueur de la chaine d'entree
C-    LONGCH : Fonction calculant la longueur reelle d'une chaine
C-    LONNOM : Longueur du nom du fichier de sortie
C- 
C- Derniere modif : 17 JAN 2003

      CHARACTER*80 FICHRE,NOMSOR,ENTREE
      LOGICAL PS
      INTEGER LONGCH,LONENT,LONNOM

      LONENT=LONGCH(ENTREE)
      LONNOM=LONGCH(FICHRE)-LONENT

C- On ajoute le suffixe
      IF (PS) THEN
         NOMSOR = FICHRE(LONENT+1:LONENT+LONNOM) // '.ps'
         LONNOM = LONNOM+3
      ELSE
         NOMSOR = FICHRE(LONENT+1:LONENT+LONNOM) // '.gif'
         LONNOM = LONNOM+4
      ENDIF

      END
