      SUBROUTINE CREARE (NBLMAX,N,I,TRIARE)

C- Fonction : Cree 3 aretes a partir des 3 sommets N(I,1),N(I,2),N(I,3)
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    N      : Tableau contenant les noeuds
C-    I      : Indice de l'element considere
C-
C- Sortie :
C-    TRIARE : 3 fois le debut et la fin d'une arete
C-
C- Derniere modif : 17 JAN 2003

      INTEGER NBLMAX,N(NBLMAX,*),I,TRIARE(*)

C- On trie les 3 sommets dans l'ordre croissant
      CALL TRITRI (N(I,1),N(I,2),N(I,3))

      TRIARE(1)=N(I,1)
      TRIARE(2)=N(I,2)
      TRIARE(3)=N(I,2)
      TRIARE(4)=N(I,3)
      TRIARE(5)=N(I,1)
      TRIARE(6)=N(I,3)
         
      END
