      SUBROUTINE DEFACT (NBBUTN,NUMREP,NBFEN,ACTIFS)

C- Fonction : Quels-sont les choix actifs 
C-
C- Entree :
C-    NBBUTN : Nombre de boutons du menu
C-    NUMREP : Type de representation
C-    NBFEN  : Nombre de fenetres (i.e multifenetrage ou non)
C-
C- Sortie : -
C-    ACTIFS : Choix actifs ou non 
C-
C- Local :
C-
C- Derniere modif : 24 FEV 2003

      INTEGER NBBUTN,NUMREP,NBFEN,I
      LOGICAL ACTIFS(*)

C- Initialisation
      DO 10 I=1,NBBUTN
10    ACTIFS(I)=.TRUE.

C- Couleurs et suppression du maillage vrais si NUMREP > 1
      IF (NUMREP.EQ.1) THEN
         ACTIFS(5)=.FALSE.
         ACTIFS(7)=.FALSE.
         ACTIFS(8)=.FALSE.   
      ENDIF
      
C- Si on est en multi-fenetrage, on a pas peu de choix
C- puisque les 4 NUMREP sont affichees em meme temps
      IF (NBFEN.GT.1) THEN
         DO 20 I=1,15
20       ACTIFS(I)=.FALSE.
         ACTIFS(6)=.TRUE.
         RETURN
      ENDIF

C- Les choix 3D nes ont disponibles qu'en NUMREP=4 et NBFEN=1
      IF (NUMREP.NE.4.OR.NBFEN.NE.1) THEN
         DO 30 I=9,15
30       ACTIFS(I)=.FALSE.
      ENDIF

      END
