      SUBROUTINE MENUZ (Z,IZ)


C- Fonction : Ouverture d'un menu pour modifier ZMIN ou ZMAX
C-
C- Entree : -
C-    Z : ZMIN ou ZMAX a modifier
C-    IZ : Indice : IZ=1 : ZMIN, IZ=2 : ZMAX
C-
C- Sortie :
C-
C- Local :
C-    FENLOC : Fenetre locale
C-    CHAINZ : Valeur de Z ecrite sous forme de chaine de caracteres
C-    CHOCAS : Choix entre 2 cases
C-    X,Y    : Coordonnees des cases ou cliquer
C-    LONCHZ : Longueur de lachaine lue CHAINZ
C-    ZDBLE  : Z decode au format DOUBLE PRECISION dans repcle.f
C- 
C- Derniere modif : 20 JAN 2003

      INTEGER IZ,FENLOC,PGOPEN,IBIDON,LONCHZ
      REAL Z,LARMAX,HAUMAX,X(2,2),Y(2,2)
      CHARACTER*10 CHAINZ
      LOGICAL CHOCAS
      DOUBLE PRECISION ZDBLE

      DATA LARMAX,HAUMAX / 2.5, 3.5 /

C- Les 2 cases Garder / Changer
      DATA X / 0.0,5.5,4.5,10.0/ 
      DATA Y / 2*2.5, 2*4.5 /

      FENLOC=PGOPEN('/xwin')
*     FENLOC=PGOPEN('/AQT')
      IF (FENLOC.LT.0) CALL BLEME (10) 
      CALL PGASK (.FALSE.)
      CALL PGPAP (LARMAX,HAUMAX/LARMAX)
      CALL PGENV(0.0,10.0,0.0,13.0,2,-2)
      CALL PGSCRN (0,'midnight blue',IBIDON)
      CALL PGSCRN (1,'yellow',IBIDON)   
10    CALL NETMEN ()
      IF (IZ.EQ.1) THEN
         CALL PGPTXT (5.0,7.5,0.0,0.5,'Valeur actuelle de ZMIN : ')
      ELSE
         CALL PGPTXT (5.0,7.5,0.0,0.5,'Valeur actuelle de ZMAX : ')
      ENDIF
      WRITE (CHAINZ,'(G8.2)') Z
      CALL PGPTXT (5.0,6.0,0.0,0.5,CHAINZ)

C- On garde ou on change ?
      IF (CHOCAS(X,Y,'Garder','Changer')) THEN
         CALL PGCLOS ()
      ELSE
         CALL NETMEN ()
         IF (IZ.EQ.1) THEN
            CALL PGPTXT (5.0,7.5,0.0,0.5,'Nouvelle valeur de ZMIN : ')
         ELSE
            CALL PGPTXT (5.0,7.5,0.0,0.5,'Nouvelle valeur de ZMAX : ')
         ENDIF
         CALL LIRCHN (0.0,5.0,CHAINZ,LONCHZ)
         CALL RELCRE (CHAINZ,ZDBLE)
         Z=REAL(ZDBLE)
C- On re-teste      
         GOTO 10
      ENDIF   

      END

