      SUBROUTINE PROJEC (X,Y,Z,VALPRJ,XP,YP)
      
C- Fonction : Calcul de la projection du point [X,Y,Z] 
C-
C- Entree :
C-    X,Y,Z : Coordonnees d'un point
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie :
C-    XP,YP : Projection du point [X,Y,Z]
C-
C- Derniere modif : 24 FEV 2003
      
      REAL X,Y,Z,VALPRJ(*),XP,YP

      XP = VALPRJ(8) + VALPRJ(3) * (Y * VALPRJ(4) - X * VALPRJ(5))
      YP = VALPRJ(9) + VALPRJ(3) * (Z * VALPRJ(7) - (X * VALPRJ(4) 
     &   + Y * VALPRJ(5)) * VALPRJ(6))
      
      END

