function ecrire(long,larg,N,P,loc,lac,fico,lof,COOR)


if fico==1
nb=N*P;
elseif fico==2
N2=max(1,floor(N*loc/100));
P2=max(1,floor(P*lac/100));
nb=N*P-N2*P2;
elseif fico==3
nb=N*P;
end

nommail=['mail_',num2str(nb),'elts.lina'];
quest=questdlg(['Sauvegarder sous ',nommail,' ?'], ...
               'Genie Question', ...
	       'Oui','Non','Annuler','Annuler');      
if quest(1:2)~='An'
if quest(1:2)=='No'
[filename,pathname]=uiputfile('*.lina','Sauvegarde du maillage...');
nommail=[pathname,filename];
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEBUT DU FICHIER DE MAILLAGE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fid=fopen(nommail,'wt');
fprintf(fid,' TITRE 1\n');
fprintf(fid,[' Maillage en ',num2str(nb),' quadrangles\n']);
fprintf(fid,[' FORMAT DE LECTURE DES COORDONNEES''(2E21.15)''\n']);
fprintf(fid,['                   DE LA NUMEROTATION GLOBALE''(4I5)''\n']);
fprintf(fid,'                   SANS COMMENTAIRE\n');
fprintf(fid,' DESCRIPTION GLOBALE DU MAILLAGE\n');
fprintf(fid,'    VARIABLES D''''ESPACE  ''X'' ''Y''\n');
fprintf(fid,['    NOMBRE D''''ELEMENTS  ',num2str(nb),'\n']);
fprintf(fid,[' BLOC DE TYPE GEOMETRIQUE QU01 : ',num2str(nb),' ELEMENTS\n']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DEFINITION DE CHAQUE ELEMENT %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Rectangle simple

if fico==1

dec=[P+1,P+2,1,0];

for i=1:N,
for j=1:P,

% Ecriture des coordonnees
for k=1:4,
num=j+(P+1)*(i-1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=j+(P+1)*(i-1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end
end

% Definition des domaines

fprintf(fid,' DOMAINE ''Omega''\n');
fprintf(fid,['E 1 / ',num2str(nb),'\n']);

fprintf(fid,'\n DOMAINE ''Gamma1''\n');
for i=1:N,
	fprintf(fid,['E ',num2str(1+(i-1)*P),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma2''\n');
for i=1:P,
	fprintf(fid,['E ',num2str((N-1)*P+i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma3''\n');
for i=1:N,
	fprintf(fid,['E ',num2str(i*P),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma4''\n');
for i=1:P,
	fprintf(fid,['E ',num2str(i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end



% Rectangle avec coin

elseif fico==2

N1=N-N2;
P1=P-P2;

dec=[P+1,P+2,1,0];

for i=1:N1,
for j=1:P,

% Ecriture des coordonnees
for k=1:4,
num=j+(P+1)*(i-1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=j+(P+1)*(i-1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end
end



for i=1:N2,
for j=1:P1,

% Ecriture des coordonnees
for k=1:4,
num=j+(P+1)*(N1)+(i-1)*(P1+1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=j+(P+1)*(N1)+(i-1)*(P1+1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end
dec=[P1+2,P1+3,2,1];
end

% Definition des domaines

fprintf(fid,' DOMAINE ''Omega''\n');
fprintf(fid,['E 1 / ',num2str(nb),'\n']);

fprintf(fid,'\n DOMAINE ''Gamma1''\n');
for i=1:N1,
	fprintf(fid,['E ',num2str(1+(i-1)*P),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end
for i=1:N2,
        fprintf(fid,['E ',num2str(N1*P+1+(i-1)*P1),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma2''\n');
for i=nb-P1+1:nb,
	fprintf(fid,['E ',num2str(i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma3''\n');
for i=nb-N2*P1+P1:P1:nb,
	fprintf(fid,['E ',num2str(i),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma4''\n');
for i=1:P2,
	fprintf(fid,['E ',num2str(P*(N1-1)+P1+i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma5''\n');
for i=1:N1,
	fprintf(fid,['E ',num2str(i*P),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma6''\n');
for i=1:P,
	fprintf(fid,['E ',num2str(i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end


% Rectangle avec fissure

elseif fico==3

N2=max(1,floor(N*lof/100));N1=N-N2;
P1=max(1,floor(P/2));P2=P-P1;


dec=[0,1,N+2,N+1];

for j=1:P1,
for i=1:N,

% Ecriture des coordonnees

for k=1:4,
num=i+(j-1)*(N+1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=i+(j-1)*(N+1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end
end

dec=[0,1,N+3+N2,N+2+N2];


for i=1:N1,

% Ecriture des coordonnees
for k=1:4,
num=i+(P1)*(N+1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=i+(P1)*(N+1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end

dec=[0,1,N+2,N+1];

for i=1:N2,

% Ecriture des coordonnees
for k=1:4,
num=N+1+i+(P1)*(N+1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=N+1+i+(P1)*(N+1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end

for j=1:P2-1,
for i=1:N,

% Ecriture des coordonnees
for k=1:4,
num=(N+1)*(P1+1)+N2+1+i+(j-1)*(N+1)+dec(k);
X=COOR(1,num);
Y=COOR(2,num);
fprintf(fid,[esp(X),num2str(X,'%20.14E'),esp(Y),num2str(Y,'%20.14E'),'\n']);
end
% Ecriture des numeros
for k=1:4,
num=(N+1)*(P1+1)+N2+1+i+(j-1)*(N+1)+dec(k);
fprintf(fid,[num2str(num,'%1.5i')]);
end
fprintf(fid,'\n');     	

end
end

% Definition des domaines

fprintf(fid,' DOMAINE ''Omega''\n');
fprintf(fid,['E 1 / ',num2str(nb),'\n']);

fprintf(fid,'\n DOMAINE ''Gamma1''\n');
for i=1:N,
	fprintf(fid,['E ',num2str(i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma2''\n');
for i=1:P1,
	fprintf(fid,['E ',num2str(N*i),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma3''\n');
for i=1:N2,
	fprintf(fid,['E ',num2str(N*(P1-1)+N1+i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma4''\n');
for i=1:N2,
	fprintf(fid,['E ',num2str(N*(P1)+N1+i),' A 1 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma5''\n');
for i=P1+1:P,
	fprintf(fid,['E ',num2str(i*N),' A 2 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end

fprintf(fid,'\n DOMAINE ''Gamma6''\n');
for i=nb-N+1:nb,
	fprintf(fid,['E ',num2str(i),' A 3 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end


fprintf(fid,'\n DOMAINE ''Gamma7''\n');
for i=1:P,
	fprintf(fid,['E ',num2str((i-1)*N+1),' A 4 ']);
	if (mod(i,5)==0)
	   fprintf(fid,'\n');
	end
end


end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIN DU FICHIER DE MAILLAGE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(fid,'\n FIN\n');
fclose(fid);
str=['Le maillage est sauve sous le nom "',nommail,'"'];
msgbox(str,'Tache effectuee');
end

