% Ecriture d'une matrice Sparse au format Melina
%
% Auteur : D.Martin (23 Avril 1999)
% Derniere modification : D.Martin (27 Avril 1999)
%
an=input (' Nom de la matrice a ecrire ? ');
if issparse(an) == 0
   error ([':>( La matrice ' an ' n''est pas sparse.']);
end
[m,n]=size(an);
[i,j,s]=find (tril(an));
itype=2;
type='REEL    ';
if isreal(an) == 0
   itype=4;
   type='COMPLEXE';
end
%
file=input (' Nom du fichier ou ecrire la matrice ? ','s');
fid=fopen (file,'w');
% Ecriture de l'entete du fichier
fprintf (fid,['!Terme matris   1 %s SYMETRIQUE\n'],type);
fprintf (fid,'%3.0f %3.0f %4.0f % 2.0f\n',[m n length(s) itype]);
fprintf (fid,'%6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f\n',i);
if rem(length(i),10) ~= 0
   fprintf (fid,'\n',[]); 
end
fprintf (fid,'%6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f %6.0f\n',j);
if rem(length(j),10) ~= 0
   fprintf (fid,'\n',[]);
end
fprintf (fid,'%15.8e\n',s);
fclose(fid);

