      SUBROUTINE FILELT (NUMELT,NBNEEX,NBSOMT,NBNEAX,NBARET,CORPTS)
*-----------------------------------------------------------------------
* REMPLISSAGE D'UN ELEMENT
* Arguments d'entree :
*  NUMELT (integer)      :  numero de l'element
*  NBNEEX (integer)      :  nombre de points maximum par element
*  NBSOMT (integer)      :  nombre de sommets de l'element
*  NBNEAX (integer)      :  nombre maximum de poitns par arete
*  NBARET (integer)      :  nomgre d'aretes de l'element
*  CORPTS (real)         :  coordonnes des points de l'element
*-----------------------------------------------------------------------
      REAL CORPTS(2,*),X(11),Y(11),UX(80),UY(80),T(11),U
      INTEGER NUMELT,NBNEEX,NBSOMT,NBNEAX,NBARET,NUMB,ARETE,I
* Determination des points sur chaque arete    
      NUMB=0 
      DO 1 ARETE=1,NBARET
        DO 2 I=0,NBNEAX-2
	  X(I+1)=CORPTS(1,ARETE+NBSOMT*I)
	  Y(I+1)=CORPTS(2,ARETE+NBSOMT*I)
2       CONTINUE
	X(NBNEAX)=CORPTS(1,MOD(ARETE,NBSOMT)+1)
	Y(NBNEAX)=CORPTS(2,MOD(ARETE,NBSOMT)+1) 
* Calcul du polynome interpolateur qui definit l'arete	
	DO 11 I=1,NBNEAX
11       T(I)=I
        CALL DIFDIV (T,X,NBNEAX)
        CALL DIFDIV (T,Y,NBNEAX)
      U=1.
      DO 3 I=1,20
        NUMB=NUMB+1
        U=U+(1./20)*(NBNEAX-1)
        CALL LAGREVAL (T,X,U,NBNEAX,UX(NUMB))
        CALL LAGREVAL (T,Y,U,NBNEAX,UY(NUMB))
3     CONTINUE
1     CONTINUE
* Remplissage de l'interieur defini par les aretes
      CALL PGPOLY(80,UX,UY)
      END
