      SUBROUTINE INFOS(FENMEN,NBTEL,NBTPTG,INTRPG,NBDOMG)
*-----------------------------------------------------------------------
* AFFICHAGE DES INFOS SUR LE MAILLAGE
* Arguments d'entree :
*  NBTEL (integer)     :  nombre d'elements du maillage
*  NBTPTG (integer)    :  nombre de points du maillage
*  INTRPG (integer)    :  degre d'interpolation
*  NBDOMG (integer)    :  nombre de domaines definis
*-----------------------------------------------------------------------      
      INTEGER NBTEL,NBTPTG,INTRPG,NBDOMG,NC
      CHARACTER*20 STRING
*       
      CALL PGSLCT (FENMEN)
      CALL PGSCI (1)
      CALL PGSCF (2)
      CALL PGSCH (4.)
      CALL PGNUMB(NBTEL,0,1,STRING,NC)
      CALL PGPTXT (0.2,12.,0.,0.,STRING(1:NC)//' elements')
      CALL PGNUMB(NBTPTG,0,1,STRING,NC)
      CALL PGPTXT (0.2,10.,0.,0.,STRING(1:NC)//' points')
      CALL PGNUMB(INTRPG,0,1,STRING,NC)
      CALL PGPTXT (0.2,8.,0.,0.,'Interp. type '//STRING(1:NC))
      CALL PGNUMB(NBDOMG,0,1,STRING,NC)
      CALL PGPTXT (0.2,6.,0.,0.,STRING(1:NC)//' domaines')
*
      END
      
