      SUBROUTINE LAGREVAL (T,V,U,NB,VAL)
*-----------------------------------------------------------------------
*     EVALUATION DU POLYNOME D'INTERPOLATION DE LAGRANGE EN U
*     PAR LA METHODE DE HORNER
* Arguments d'entree :
*     V	(real)     :  DIFFERENCES DIVISEES
*     T	(real)     :  TABLEAU DES NOEUDS D'INTERPOLATION	
*     U	(real)     :  VALEUR DU PARAMETRE
*     NB (integer) :  LONGUEUR DU TABLEAU V
* Argument de sortie :
*     VAL 	VALEUR DU POLYNOME INTERPOLATEUR (SORTIE)
*-----------------------------------------------------------------------
*
      REAL V(*),T(*),U,VAL
      INTEGER I,NB
      VAL=V(NB)
      DO 1 I=1,NB-1
        VAL=VAL*(U-T(NB-I))+V(NB-I)
1     CONTINUE	
* 
      END
