      SUBROUTINE MAXCOR (CORPTS,NBTEL,NBPTEX,XMIN,XMAX,YMIN,YMAX)
*-----------------------------------------------------------------------
* RECHERCHE DES COORDONNES EXTREMALES DU MAILLAGE  
* Arguments d'entree :
*  CORPTS (real)       :  coordonnees des points du maillage
*  NBTEL (integer)     :  nombre d'elements du maillage
*  NBPTEX (integer)    :  nombre de points maximum par element
* Argument de sortie :
*  XMIN (real)         :  minimum des abscisses du maillage
*  XMAX (real)         :  maximum --- --------- -- --------
*  YMIN (real)         :  minumum --- ordonnees -- --------
*  YMAX (real)         :  maxiumu --- --------- -- --------
*-----------------------------------------------------------------------
      REAL CORPTS(*),XMIN,XMAX,YMIN,YMAX,X,Y
      INTEGER NBTEL,NBPTEX,I,J,ADR
* Initialisation      
      XMIN=CORPTS(2)
      YMIN=CORPTS(3)
      XMAX=XMIN
      YMAX=YMIN
* BOUCLE SUR LES ELEMENTS  
      ADR=0
      DO 1 I=1,NBTEL
        DO 2 J=1,NBPTEX	
	  ADR=ADR+2  
          X=CORPTS(ADR)
	  Y=CORPTS(ADR+1)
	  XMIN=MIN(XMIN,X)
	  YMIN=MIN(YMIN,Y)
	  XMAX=MAX(XMAX,X)
	  YMAX=MAX(YMAX,Y)
2       CONTINUE    
        ADR=ADR+1  
1     CONTINUE
*      
      END
