      SUBROUTINE MENU (FENMEN,NBITEM,ITEMS,ACTIFS)
*-----------------------------------------------------------------------
*     AFFICHAGE DU MENU ET ATTENTE D'UN CLICK DE LA SOURIS
* Arguments d'entree :
*     NBITEM (integer)    :  Nombre d'items du menu.
*     ITEMS  (character)  :  Noms des items.
*     ACTIFS (logical)    :  Booleen d'activation des items.    
* Argument de sortie :
*     ACTIFS (logical)    :  Booleen d'activation des items.    
*-----------------------------------------------------------------------
      INTEGER NBITEM
      CHARACTER*8 ITEMS(*)
      LOGICAL ACTIFS(*)
*     VARIABLES LOCALES
      INTEGER I 
      REAL X,Y
      CHARACTER C     
*     AFFICHAGE DES ELEMENTS DU MENU
      CALL PGSLCT (FENMEN)  
      CALL PGSCI(1)
      CALL PGSCF (1)
      CALL PGSCH (4.)
      DO 1 I=1,NBITEM
        CALL PGPTXT (1.7,26-2.*I,0.,0.,ITEMS(I))
*     Effacement des boutons      
      CALL PGSCI (0)
      CALL PGSFS (1)
      CALL PGRECT (0.0,0.6,26.-2.*I,26-2.*I+.6)
        CALL PGSCI (1)
*     Si l'item est actif, on passe en mode remplissage      
      CALL PGSFS(2)
        IF (ACTIFS(I)) CALL PGSFS (1)
*     Ecriture du bouton
        CALL PGRECT (0.0,0.6,26.-2.*I,26-2.*I+.6)
1     CONTINUE      
*     Attente d'un click de la souris      
2     CALL PGCURS (X,Y,C)    
*     Test pour savoir dans quelle case on a clique
      IF (C.NE.'A') GOTO 2
      DO 3 I=1,NBITEM
        IF ((X.LT.0.6).AND.(X.GT.0.0).AND.(Y.LT.26-2.*I+.6)
     &.AND.(Y.GT.26.-2.*I)) THEN
      ACTIFS(I)=.NOT.(ACTIFS(I))
      GOTO 4 
      ENDIF      
3     CONTINUE
      GOTO 2
4     IF (.NOT.(ACTIFS(1))) THEN
        ACTIFS(2)=.false.
      ACTIFS(3)=.false.
      ENDIF
*      
      END
      
      
