      SUBROUTINE NOMGRC (NOMDOM,NCHDOM,CHNOM,LONG) 
*-----------------------------------------------------------------------
* TRANSORMATION EN CHAINE DE CARACTERE DU NOM D'UN DOMAINE
* (on remplace certaines lettres grecques)
* Arguments d'entree :
*  NOMDOM (character)  :  nom du domaine
*  NCHDOM (integer)    :  nombre de caracteres reserves pour les noms
* Arguments de sortie :
*  CHNOM (character)   :  chaine transformee
*  LONG (integer)      :  longueur de CHNOM  
*-----------------------------------------------------------------------
      CHARACTER NOMDOM(*)
      INTEGER NCHDOM,LONG
      CHARACTER*(*) CHNOM
* Variables locales
      CHARACTER*5 OMEGA
      INTEGER I
*
* Test si le nom commence par Omega ou Gamma
      DO 1 I=1,5
        OMEGA(I:I)=NOMDOM(I)
1     CONTINUE
      IF ((OMEGA.EQ.'omega')) THEN
         CHNOM=CHAR(92)//'gw'
         GOTO 11
      ELSEIF ((OMEGA.EQ.'OMEGA').OR.(OMEGA.EQ.'Omega')) THEN
         CHNOM=CHAR(92)//'gW'
         GOTO 11
      ELSEIF ((OMEGA.EQ.'Gamma').OR.(OMEGA.EQ.'GAMMA'))  THEN
         CHNOM=CHAR(92)//'gG'
         GOTO 11
      ELSEIF (OMEGA.EQ.'gamma') THEN
         CHNOM=CHAR(92)//'gg'
         GOTO 11
      ELSEIF ((OMEGA.EQ.'SIGMA').OR.(OMEGA.EQ.'Sigma')) THEN
         CHNOM=CHAR(92)//'gS'
         GOTO 11
      ELSEIF (OMEGA.EQ.'sigma') THEN
         CHNOM=CHAR(92)//'gs'
         GOTO 11
      ENDIF
* Sinon on prend le nom jusqu'au premier espace
      DO 2 I=1,NCHDOM
        IF (NOMDOM(I).EQ.' ') THEN 
        LONG=I-1
        GOTO 22
      ELSEIF (I.EQ.NCHDOM) THEN
        CHNOM(I:I+1)=NOMDOM(I)
        LONG=NCHDOM
        GOTO 22
      ENDIF  
        CHNOM(I:I+1)=NOMDOM(I)
2      CONTINUE 
* Si le nom commence par Omega ou Gamma, on complete avec le reste
11    LONG=3
      DO 3 I=6,NCHDOM
        IF (NOMDOM(I).NE.' ') THEN 
          LONG=LONG+1
          CHNOM(LONG:LONG)=NOMDOM(I)
        ENDIF
3     CONTINUE                     
*      
22    END
      
