      SUBROUTINE TRAMAI (ADRBLK,ADRNGN,ADRCOR,NBBBLK,NU1BLK,NBTEL,NDIM,
     &NBPTEX,IST,RST,ACTIFS)
*-----------------------------------------------------------------------
* TRACE DU MAILLAGE et, eventuellement, des numeros et domaines      
* Variables d'entree
*  ADRBLK (integer)    :  adresse de la structure #LOKEL
*  ADRNGN (integer)    :  adresse de la structure #GNEEL
*  ADRCOR (integer)    :  adresse de la structure #ORPTL
*  NBBBLK (integer)    :  nombre de blocs d'elements de meme type
*  NU1BLK (integer)    :  numero de type du premier bloc
*  NBTEL (integer)     :  nombre d'elements du maillage
*  NDIM (integer)      :  dimension d'espace (ici 2)
*  NBPTEXT (integer)   :  nombre maximum de points par element
*  IST (integer)       :  super-tableau version entiere
*  RST (real)          :  super-tableau version reelle
*  ACTIFS (logical)    :  booleen pour l'affichage des numeros
*-----------------------------------------------------------------------
      INTEGER NBBBLK,NU1BLK,IST(*),NBTEL,NDIM,NBPTEX,NUMELT
     &,ADRBLK,ADRNGN,ADRCOR
      REAL RST(*)
      LOGICAL ACTIFS(*)
*-----------------------------------------------------------------------
* Variables locales
      INTEGER BLOC,NBELBL,TYPEBL,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE
     &,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX,ELET
*
* Boucle sur les blocs d'elements du meme type
      NUMELT=0 
      DO 1 BLOC=1,NBBBLK
*      Nombre d'elements du bloc et type de ces elements
        IF (NBBBLK.GT.1) THEN
        NBELBL = IST(ADRBLK+1+2*BLOC)   
        TYPEBL = IST(ADRBLK+1+2*BLOC+1) 
      ELSE
        NBELBL = NBTEL 
        TYPEBL = NU1BLK
      ENDIF
      CALL ELEMNB (TYPEBL,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE  
     &                  ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
* Boucle sur les elements du bloc 
        DO 2 ELET=1,NBELBL
        NUMELT=NUMELT+1
*         Trace de l'element courant        
        CALL TRAELT (IST(ADRNGN),NUMELT,NBPTEX,NBSOMT,NBNEAX,
     &NBARET,RST(1+ADRCOR+(NDIM*NBPTEX+1)*(NUMELT-1)),NBNEEL,ACTIFS)
2       CONTINUE 
1     CONTINUE 
*      
      END
