      SUBROUTINE TRAPOL (X,Y,NB,NUMPTS)
*-----------------------------------------------------------------------
*     TRACE DU POLYNOME D'INTERPOLATION 2D      
* Arguments d'entree
*  X (real)         :  abscisses des points de l'arete a interpoler
*  Y (real)         :  ordonnees --- ------ -- ------- - ----------
*  NB (integer)     :  nombre de points d'interpolation (= de l'arete)
*  NUMPTS (integer) :  nombre de points pour l'echantillonnage
*-----------------------------------------------------------------------
      INTEGER NB, NUMPTS,I
      REAL X(*),Y(*),T(20),U,UX,UY
* Preparation du vecteur des parametres
      DO 1 I=1,NB
1       T(I)=I
      CALL PGMOVE (X(1),Y(1))
* Calcul des differences divisees
      CALL DIFDIV (T,X,NB)
      CALL DIFDIV (T,Y,NB)
* Trace de chaque point correspondant a la valeur U du parametre
      U=1.
      DO 2 I=1,NUMPTS
        U=U+(1./NUMPTS)*(NB-1)
        CALL LAGREVAL (T,X,U,NB,UX)
	CALL LAGREVAL (T,Y,U,NB,UY)
	CALL PGDRAW(UX,UY)
2     CONTINUE
*      
      END
